<h1><img src="docs/src/assets/logo.png" alt="PythonCall.jl logo" style="width: 100px;"><br>PythonCall &amp;&nbsp;JuliaCall</h1>

[![Project Status: Active – The project has reached a stable, usable state and is being actively developed.](https://www.repostatus.org/badges/latest/active.svg)](https://www.repostatus.org/#active)
[![Stable Documentation](https://img.shields.io/badge/docs-stable-blue.svg)](https://juliapy.github.io/PythonCall.jl/stable)
[![Dev Documentation](https://img.shields.io/badge/docs-dev-blue.svg)](https://juliapy.github.io/PythonCall.jl/dev)
[![Tests](https://github.com/JuliaPy/PythonCall.jl/actions/workflows/tests.yml/badge.svg)](https://github.com/JuliaPy/PythonCall.jl/actions/workflows/tests.yml)
[![Codecov](https://codecov.io/gh/JuliaPy/PythonCall.jl/branch/main/graph/badge.svg?token=A813UUIHGS)](https://codecov.io/gh/JuliaPy/PythonCall.jl)
[![PkgEval](https://juliaci.github.io/NanosoldierReports/pkgeval_badges/P/PythonCall.svg)](https://juliaci.github.io/NanosoldierReports/pkgeval_badges/P/PythonCall.html)

Bringing [**Python®**](https://www.python.org/) and [**Julia**](https://julialang.org/) together in seamless harmony:
- Call Python code from Julia and Julia code from Python via a symmetric interface.
- Simple syntax, so the Python code looks like Python and the Julia code looks like Julia.
- Intuitive and flexible conversions between Julia and Python: anything can be converted, you are in control.
- Fast non-copying conversion of numeric arrays in either direction: modify Python arrays (e.g. `bytes`, `array.array`, `numpy.ndarray`) from Julia or Julia arrays from Python.
- Helpful wrappers: interpret Python sequences, dictionaries, arrays, dataframes and IO streams as their Julia counterparts, and vice versa.
- Beautiful stack-traces.
- Supports modern systems: tested on Windows, MacOS and Linux; 64-bit; Julia 1.10 upwards and Python 3.10 upwards.

⭐ If you like this, a GitHub star would be lovely thank you. ⭐

To get started, read the [documentation](https://juliapy.github.io/PythonCall.jl/stable).

## Example 1: Calling Python from Julia

In this example, we use the Julia module PythonCall from a [Pluto](https://github.com/fonsp/Pluto.jl) notebook to inspect the Iris dataset:
- We load the Iris dataset as a Julia [DataFrame](https://dataframes.juliadata.org/stable/) using [RDatasets](https://github.com/JuliaStats/RDatasets.jl).
- We use `pytable(df)` to convert it to a Python [Pandas DataFrame](https://pandas.pydata.org/).
- We use the Python package [Seaborn](https://seaborn.pydata.org/) to produce a pair-plot, which is automatically displayed.

![Seaborn example screenshot](https://raw.githubusercontent.com/JuliaPy/PythonCall.jl/main/examples/seaborn.png)

## Example 2: Calling Julia from Python

In this example we use the Python module JuliaCall from an IPython notebook to train a simple neural network:
- We generate some random training data using Python's Numpy.
- We construct and train a neural network model using Julia's Flux.
- We plot some sample output from the model using Python's MatPlotLib.

![Flux example screenshot](https://raw.githubusercontent.com/JuliaPy/PythonCall.jl/main/examples/flux.png)

## What about PyCall?

The existing package [PyCall](https://github.com/JuliaPy/PyCall.jl) is another similar interface to Python. Here we note some key differences:.
- PythonCall supports a wider range of conversions between Julia and Python, and the conversion mechanism is extensible.
- PythonCall by default never copies mutable objects when converting, but instead directly wraps the mutable object. This means that modifying the converted object modifies the original, and conversion is faster.
- PythonCall does not usually automatically convert results to Julia values, but leaves them as Python objects. This makes it easier to do Pythonic things with these objects (e.g. accessing methods) and is type-stable.
- PythonCall installs dependencies into a separate Conda environment for each Julia project using [CondaPkg](https://github.com/JuliaPy/CondaPkg.jl). This means each Julia project can have an isolated set of Python dependencies.

const pyjlsettype = pynew()

pyjlset_add(x::AbstractSet, v::Py) =
    (push!(x, pyconvertarg(eltype(x), v, "value")); Py(nothing))

function pyjlset_discard(x::AbstractSet, v_::Py)
    v = @pyconvert(eltype(x), v_, return Py(nothing))
    delete!(x, v)
    Py(nothing)
end

pyjlset_clear(x::AbstractSet) = (empty!(x); Py(nothing))

function pyjlset_pop(x::AbstractSet)
    if isempty(x)
        errset(pybuiltins.KeyError, "pop from an empty set")
        PyNULL
    else
        Py(pop!(x))
    end
end

function pyjlset_remove(x::AbstractSet, v_::Py)
    v = @pyconvert eltype(x) v_ begin
        errset(pybuiltins.KeyError, v_)
        return PyNULL
    end
    if v in x
        delete!(x, v)
        return Py(nothing)
    else
        errset(pybuiltins.KeyError, v_)
        return PyNULL
    end
end

function pyjlset_update(x::AbstractSet, vs_::Py)
    for v_ in vs_
        v = pyconvert(eltype(x), v_)
        push!(x, v)
        pydel!(v_)
    end
    Py(nothing)
end

function pyjlset_difference_update(x::AbstractSet, vs_::Py)
    for v_ in vs_
        v = @pyconvert(eltype(x), v_, continue)
        delete!(x, v)
        pydel!(v_)
    end
    Py(nothing)
end

function pyjlset_intersection_update(x::AbstractSet, vs_::Py)
    vs = Set{eltype(x)}()
    for v_ in vs_
        v = @pyconvert(eltype(x), v_, continue)
        push!(vs, v)
        pydel!(v_)
    end
    intersect!(x, vs)
    Py(nothing)
end

function pyjlset_symmetric_difference_update(x::AbstractSet, vs_::Py)
    vs = Set{eltype(x)}()
    for v_ in vs_
        v = pyconvert(eltype(x), v_)
        push!(vs, v)
        pydel!(v_)
    end
    symdiff!(x, vs)
    Py(nothing)
end

function init_set()
    jl = pyjuliacallmodule
    pybuiltins.exec(
        pybuiltins.compile(
            """
$("\n"^(@__LINE__()-1))
class SetValue(AnyValue):
    __slots__ = ()
    def __bool__(self):
        return bool(len(self))
    def add(self, value):
        return self._jl_callmethod($(pyjl_methodnum(pyjlset_add)), value)
    def discard(self, value):
        return self._jl_callmethod($(pyjl_methodnum(pyjlset_discard)), value)
    def clear(self):
        return self._jl_callmethod($(pyjl_methodnum(pyjlset_clear)))
    def copy(self):
        return self._jl_callmethod($(pyjl_methodnum(Py ∘ copy)))
    def pop(self):
        return self._jl_callmethod($(pyjl_methodnum(pyjlset_pop)))
    def remove(self, value):
        return self._jl_callmethod($(pyjl_methodnum(pyjlset_remove)), value)
    def difference(self, other):
        return set(self).difference(other)
    def intersection(self, other):
        return set(self).intersection(other)
    def symmetric_difference(self, other):
        return set(self).symmetric_difference(other)
    def union(self, other):
        return set(self).union(other)
    def isdisjoint(self, other):
        return set(self).isdisjoint(other)
    def issubset(self, other):
        return set(self).issubset(other)
    def issuperset(self, other):
        return set(self).issuperset(other)
    def difference_update(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlset_difference_update)), other)
    def intersection_update(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlset_intersection_update)), other)
    def symmetric_difference_update(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlset_symmetric_difference_update)), other)
    def update(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlset_update)), other)
import collections.abc
collections.abc.MutableSet.register(SetValue)
del collections
""",
            @__FILE__(),
            "exec",
        ),
        jl.__dict__,
    )
    pycopy!(pyjlsettype, jl.SetValue)
end

pyjltype(::AbstractSet) = pyjlsettype

@testitem "mimes_for" begin
    # this example from https://github.com/JuliaPy/PythonCall.jl/issues/487
    struct Test{T<:Number}
        x::T
    end
    Base.show(io::IO, ::MIME"text/plain", x::Test{T}) where {T} = show(io, x.t)
    Base.show(io::IO, ::MIME"text/x-test", x::Test) = show(io, x.t)

    @testset for x in Any[1, "foo", [], 'z', Test(5)]
        mimes = PythonCall.Utils.mimes_for(x)
        @test mimes isa Vector{String}
        @test "text/plain" in mimes
        @test "text/html" in mimes
        @test ("text/x-test" in mimes) == (x isa Test)
    end
end

@testitem "StaticString length and indexing" begin
    s = PythonCall.Utils.StaticString{UInt32,44}("ababababb")
    @test length(s) == 9
    @test s[1] == 'a'
    @test s[1:2] == "ab"
    @test s[1:2:end] == "aaaab"
end

"""
    mutable struct Context

A handle to a loaded instance of libpython, its interpreter, function pointers, etc.
"""
@kwdef mutable struct Context
    is_embedded::Bool = false
    is_initialized::Bool = false
    is_preinitialized::Bool = false
    lib_ptr::Ptr{Cvoid} = C_NULL
    exe_path::Union{String,Missing} = missing
    lib_path::Union{String,Missing} = missing
    dlopen_flags::UInt32 = RTLD_LAZY | RTLD_DEEPBIND | RTLD_GLOBAL
    pyprogname::Union{String,Missing} = missing
    pyprogname_w::Any = missing
    pyhome::Union{String,Missing} = missing
    pyhome_w::Any = missing
    which::Symbol = :unknown # :CondaPkg, :PyCall, :embedded or :unknown
    version::Union{VersionNumber,Missing} = missing
    is_free_threaded::Bool = false
end

const CTX = Context()

function _atpyexit()
    if CTX.is_initialized && !CTX.is_preinitialized
        @warn "Python exited unexpectedly"
    end
    CTX.is_initialized = false
    return
end


function setup_onfixedthread()
    channel_input = Channel(1)
    channel_output = Channel(1)
    islaunched = Ref(false) # use Ref to avoid closure boxing of variable
    function launch_worker(tid)
        islaunched[] && error("Cannot launch more than once: call setup_onfixedthread again if need be.")
        islaunched[] = true
        worker_task = Task() do
            while true
                f = take!(channel_input)
                ret = try
                    Some(invokelatest(f))
                    # invokelatest is necessary for development and interactive use.
                    # Otherwise, only a method f defined in a world prior to the call of
                    # launch_worker would work.
                catch e
                    e, catch_backtrace()
                end
                put!(channel_output, ret)
            end
        end
        # code adapted from set_task_tid! in StableTasks.jl, itself taken from Dagger.jl
        worker_task.sticky = true
        for _ in 1:100
            # try to fix the task id to tid, retrying up to 100 times
            ret = ccall(:jl_set_task_tid, Cint, (Any, Cint), worker_task, tid-1)
            if ret == 1
                break # success
            elseif ret == 0
                yield()
            else
                error("Unexpected retcode from jl_set_task_tid: $ret")
            end
        end
        if Threads.threadid(worker_task) != tid
            error("Failed setting the thread ID to $tid.")
        end
        schedule(worker_task)
    end
    function onfixedthread(f)
        put!(channel_input, f)
        ret = take!(channel_output)
        if ret isa Tuple
            e, backtrace = ret
            printstyled(stderr, "ERROR: "; color=:red, bold=true)
            showerror(stderr, e)
            Base.show_backtrace(stderr, backtrace)
            println(stderr)
            throw(e) # the stacktrace of the actual error is printed above
        else
            something(ret)
        end
    end
    launch_worker, onfixedthread
end

# launch_on_main_thread is used in init_context(), after which on_main_thread becomes usable
const launch_on_main_thread, on_main_thread = setup_onfixedthread()

"""
    on_main_thread(f)

Execute `f()` on the main thread.

!!! warning
    The value returned by `on_main_thread(f)` cannot be type-inferred by the compiler:
    if necessary, use explicit type annotations such as `on_main_thread(f)::T`, where `T` is
    the expected return type.
"""
on_main_thread


function init_context()

    CTX.is_embedded = haskey(ENV, "__JULIA_PYTHONCALL_EMBEDDED_LIBPTR__")

    if CTX.is_embedded
        # In this case, getting a handle to libpython is easy
        CTX.lib_ptr = Ptr{Cvoid}(parse(UInt, ENV["__JULIA_PYTHONCALL_EMBEDDED_LIBPTR__"]))
        # Delete the env var so subprocesses don't think they are embedded
        delete!(ENV, "__JULIA_PYTHONCALL_EMBEDDED_LIBPTR__")
        # Initialise pointers from libpython
        init_pointers()
        # Check Python is initialized
        Py_IsInitialized() == 0 && error("Python is not already initialized.")
        CTX.is_initialized = true
        CTX.which = :embedded
        exe_path = Utils.getpref_exe()
        if exe_path != ""
            CTX.exe_path = exe_path
            # this ensures PyCall uses the same Python interpreter
            get!(ENV, "PYTHON", exe_path)
        end
    else
        # Find Python executable
        exe_path = Utils.getpref_exe()
        if exe_path == "" || exe_path == "@CondaPkg"
            if CondaPkg.backend() == :Null
                exe_path = Sys.which("python")
                if exe_path === nothing
                    error("CondaPkg is using the Null backend but Python is not installed")
                end
                exe_path::String
            else
                # By default, we use Python installed by CondaPkg.
                exe_path =
                    Sys.iswindows() ? joinpath(CondaPkg.envdir(), "python.exe") :
                    joinpath(CondaPkg.envdir(), "bin", "python")
                # It's not sufficient to only activate the env while Python is initialising,
                # it must also be active when loading extension modules (e.g. numpy). So we
                # activate the environment globally.
                # TODO: is this really necessary?
                CondaPkg.activate!(ENV)
            end
            CTX.which = :CondaPkg
        elseif exe_path == "@PyCall"
            # PyCall compatibility mode
            PyCall = Base.require(PYCALL_PKGID)::Module
            exe_path = PyCall.python::String
            CTX.lib_path = PyCall.libpython::String
            CTX.which = :PyCall
        elseif exe_path == "@venv"
            # load from a .venv in the active project
            exe_path = abspath(dirname(Base.active_project()), ".venv")
            if Sys.iswindows()
                exe_path = abspath(exe_path, "Scripts", "python.exe")::String
            else
                exe_path = abspath(exe_path, "bin", "python")::String
            end
        elseif startswith(exe_path, "@")
            error("invalid exe: $exe_path")
        else
            # Otherwise we use the Python specified
            CTX.which = :unknown
            if isabspath(exe_path)
                # nothing to do
            elseif '/' in exe_path || '\\' in exe_path
                # it's a relative path, interpret it as relative to the current project
                exe_path = abspath(dirname(Base.active_project()), exe_path)::String
            else
                # it's a command, find it in the PATH
                given_exe_path = exe_path
                exe_path = Sys.which(exe_path)
                exe_path === nothing &&
                    error("Python executable $(repr(given_exe_path)) not found.")
                exe_path::String
            end
        end

        CTX.exe_path = exe_path

        # For calling Python with UTF-8 IO
        function python_cmd(args)
            env = copy(ENV)
            env["PYTHONIOENCODING"] = "UTF-8"
            delete!(env, "PYTHONHOME")
            setenv(`$(CTX.exe_path) $args`, env)
        end

        # Find and open Python library
        lib_path = something(
            CTX.lib_path === missing ? nothing : CTX.lib_path,
            Utils.getpref_lib(),
            Some(nothing),
        )
        if lib_path !== nothing
            lib_ptr = dlopen_e(lib_path, CTX.dlopen_flags)
            if lib_ptr == C_NULL
                error("Python library $(repr(lib_path)) could not be opened.")
            else
                CTX.lib_path = lib_path
                CTX.lib_ptr = lib_ptr
            end
        else
            for lib_path in readlines(
                python_cmd([joinpath(@__DIR__, "find_libpython.py"), "--list-all"]),
            )
                lib_ptr = dlopen_e(lib_path, CTX.dlopen_flags)
                if lib_ptr == C_NULL
                    @warn "Python library $(repr(lib_path)) could not be opened."
                else
                    CTX.lib_path = lib_path
                    CTX.lib_ptr = lib_ptr
                    break
                end
            end
            CTX.lib_path === missing && error("""
                Could not find Python library for Python executable $(repr(CTX.exe_path)).

                If you know where the library is, set the 'lib' preference or 'JULIA_PYTHONCALL_LIB' environment variable to its path.
                """)
        end

        # Close the library when Julia exits
        atexit() do
            dlclose(CTX.lib_ptr)
        end

        # Get function pointers from the library
        init_pointers()

        # Initialize the interpreter
        CTX.is_preinitialized = Py_IsInitialized() != 0
        if !CTX.is_preinitialized
            # Find ProgramName and PythonHome
            script = if Sys.iswindows()
                """
                import sys
                print(sys.executable)
                if hasattr(sys, "base_exec_prefix"):
                    sys.stdout.write(sys.base_exec_prefix)
                else:
                    sys.stdout.write(sys.exec_prefix)
                """
            else
                """
                import sys
                print(sys.executable)
                if hasattr(sys, "base_exec_prefix"):
                    sys.stdout.write(sys.base_prefix)
                    sys.stdout.write(":")
                    sys.stdout.write(sys.base_exec_prefix)
                else:
                    sys.stdout.write(sys.prefix)
                    sys.stdout.write(":")
                    sys.stdout.write(sys.exec_prefix)
                """
            end
            CTX.pyprogname, CTX.pyhome = readlines(python_cmd(["-c", script]))

            # Set PythonHome
            CTX.pyhome_w = Base.cconvert(Cwstring, CTX.pyhome)
            Py_SetPythonHome(pointer(CTX.pyhome_w))

            # Set ProgramName
            CTX.pyprogname_w = Base.cconvert(Cwstring, CTX.pyprogname)
            Py_SetProgramName(pointer(CTX.pyprogname_w))

            # Start the interpreter and register exit hooks
            Py_InitializeEx(0)
            atexit() do
                CTX.is_initialized = false
                if Py_FinalizeEx() == -1
                    @warn "Py_FinalizeEx() error"
                end
            end
        end
        CTX.is_initialized = true
        if Py_AtExit(@cfunction(_atpyexit, Cvoid, ())) == -1
            @warn "Py_AtExit() error"
        end
    end

    # HACK: If we are using CondaPkg, prevent child processes from using it by explicitly
    # setting the executable. Our tests sometimes fail on Windows because Aqua launches a
    # child process which causes CondaPkg to re-resolve (should work out why, I assume it's
    # a filesystem timestamp thing) which causes some stdlibs to disappear for a bit.
    #
    # A better solution may be to use some environment variable to "freeze" CondaPkg in
    # child processes.
    # 
    # Only done when CI=true since it's a hack.
    if (get(ENV, "CI", "false") == "true") && (CTX.which === :CondaPkg)
        ENV["JULIA_PYTHONCALL_EXE"] = CTX.exe_path::String
    end

    # Get the python version
    verstr = Base.unsafe_string(Py_GetVersion())
    vermatch = match(r"^[0-9.]+", verstr)
    if vermatch === nothing
        error("Cannot parse version from version string: $(repr(verstr))")
    end
    CTX.version = VersionNumber(vermatch.match)
    v"3.10" ≤ CTX.version < v"4" || error(
        "Only Python 3.10+ is supported, this is Python $(CTX.version) at $(CTX.exe_path===missing ? "unknown location" : CTX.exe_path).",
    )
    CTX.is_free_threaded = occursin("free-threading build", verstr)

    launch_on_main_thread(Threads.threadid()) # makes on_main_thread usable

    @debug "Initialized PythonCall.jl" CTX.is_embedded CTX.is_initialized CTX.exe_path CTX.lib_path CTX.lib_ptr CTX.pyprogname CTX.pyhome CTX.version CTX.is_free_threaded

    return
end

function Base.show(io::IO, ::MIME"text/plain", ctx::Context)
    show(io, typeof(io))
    print(io, ":")
    for k in fieldnames(Context)
        println(io)
        print(io, "  ", k, " = ")
        show(io, getfield(ctx, k))
    end
end

const PYTHONCALL_UUID = Base.UUID("6099a3de-0909-46bc-b1f4-468b9a2dfc0d")
const PYTHONCALL_PKGID = Base.PkgId(PYTHONCALL_UUID, "PythonCall")

const PYCALL_UUID = Base.UUID("438e738f-606a-5dbb-bf0a-cddfbfd45ab0")
const PYCALL_PKGID = Base.PkgId(PYCALL_UUID, "PyCall")

mutable struct Iterator
    val::Any
    st::Any
end
Iterator(x) = Iterator(x, nothing)
Base.length(x::Iterator) = length(x.val)

const pyjlitertype = pynew()

function pyjliter_next(self::Iterator)
    val = self.val
    st = self.st
    if st === nothing
        z = iterate(val)
    else
        z = iterate(val, something(st))
    end
    if z === nothing
        errset(pybuiltins.StopIteration)
        PyNULL
    else
        r, newst = z
        self.st = Some(newst)
        Py(r)
    end
end

function init_iter()
    jl = pyjuliacallmodule
    pybuiltins.exec(
        pybuiltins.compile(
            """
$("\n"^(@__LINE__()-1))
class IteratorValue(AnyValue):
    __slots__ = ()
    def __iter__(self):
        return self
    def __next__(self):
        return self._jl_callmethod($(pyjl_methodnum(pyjliter_next)))
""",
            @__FILE__(),
            "exec",
        ),
        jl.__dict__,
    )
    pycopy!(pyjlitertype, jl.IteratorValue)
end

pyjltype(::Iterator) = pyjlitertype

if Base.VERSION ≥ v"1.11"
    eval(Meta.parse("""
        public
            GC,
            GIL,
            VERSION,

            # C
            python_executable_path,
            python_library_handle,
            python_library_path,
            python_version,

            # Core
            CONFIG,
            getptr,
            pycopy!,
            pydel!,
            pyisnull,
            pynew,
            PyNULL,
            unsafe_pynext,
            
            # Compat
            event_loop_off,
            event_loop_on,
            fix_qt_plugin_path
    """))
end

"""
    module PythonCall.Core

Defines the `Py` type and directly related functions.
"""
module Core

const VERSION = v"0.9.35"
const ROOT_DIR = dirname(dirname(@__DIR__))

using ..PythonCall
using ..C
using ..GC: GC
using ..Utils

using Base: @propagate_inbounds, @kwdef
using Dates:
    Date,
    Time,
    DateTime,
    year,
    month,
    day,
    hour,
    minute,
    second,
    millisecond,
    microsecond,
    nanosecond
using MacroTools: MacroTools, @capture
using Markdown: Markdown

import ..PythonCall:
    @pyconst,
    @pyeval,
    @pyexec,
    getptr,
    ispy,
    Py,
    pyabs,
    pyadd,
    pyall,
    pyand,
    pyany,
    pyascii,
    pybool,
    pybuiltins,
    pybytes,
    pycall,
    pycallable,
    pycollist,
    pycompile,
    pycomplex,
    pycontains,
    pyconvert,
    pycopy!,
    pydate,
    pydatetime,
    pydel!,
    pydelattr,
    pydelitem,
    pydict,
    pydir,
    pydivmod,
    pyeq,
    pyeval,
    PyException,
    pyexec,
    pyfloat,
    pyfloordiv,
    pyfraction,
    pyfrozenset,
    pyge,
    pygetattr,
    pygetitem,
    pygt,
    pyhasattr,
    pyhash,
    pyhasitem,
    pyhelp,
    pyiadd,
    pyiand,
    pyifloordiv,
    pyilshift,
    pyimatmul,
    pyimod,
    pyimport,
    pyimul,
    pyin,
    pyindex,
    pyint,
    pyinv,
    pyior,
    pyipow,
    pyirshift,
    pyis,
    pyisinstance,
    pyisnull,
    pyissubclass,
    pyisub,
    pyiter,
    pyitruediv,
    pyixor,
    pyle,
    pylen,
    pylist,
    pylshift,
    pylt,
    pymatmul,
    pymod,
    pymul,
    pyne,
    pyneg,
    pynew,
    pynext,
    pynot,
    pyor,
    pypos,
    pypow,
    pyprint,
    pyrange,
    pyrepr,
    pyrowlist,
    pyrshift,
    pyset,
    pysetattr,
    pysetitem,
    pyslice,
    pystr,
    pysub,
    pytime,
    pytruediv,
    pytruth,
    pytuple,
    pytype,
    pywith,
    pyxor,
    unsafe_pynext
    
export
    _base_datetime,
    _base_pydatetime,
    @autopy,
    BUILTINS,
    decref,
    errcheck,
    errclear,
    errmatches,
    errset,
    getptr,
    incref,
    iserrset_ambig,
    pybool_asbool,
    pybytes_asUTF8string,
    pybytes_asvector,
    pycallargs,
    pycomplex_ascomplex,
    pycopy!,
    pydatetime_isaware,
    pydatetimetype,
    pydel!,
    pydict_setitem,
    pyfloat_asdouble,
    pyisbytes,
    pyiscomplex,
    pyisFalse,
    pyisfloat,
    pyisint,
    pyisnone,
    pyisnot,
    pyisnull,
    pyisrange,
    pyisslice,
    pyisstr,
    pyisTrue,
    pyistuple,
    pyistype,
    pyjuliacallmodule,
    pyJuliaError,
    pylist_setitem,
    pymodulehooks,
    pynew,
    pynotin,
    PyNULL,
    pynulllist,
    pynulltuple,
    pyosmodule,
    pyset_add,
    pystr_asstring,
    pystr_asUTF8vector,
    pystr_fromUTF8,
    pystr_intern!,
    pysysmodule,
    pythrow,
    pytime_isaware,
    pytuple_getitem,
    pytuple_setitem,
    pytypecheck,
    setptr!,
    unsafe_pynext

include("Py.jl")
include("err.jl")
include("config.jl")
include("consts.jl")
include("builtins.jl")
include("stdlib.jl")
include("juliacall.jl")
include("pyconst_macro.jl")

function __init__()
    init_consts()
    init_datetime()
    init_stdlib()
    init_juliacall()
end

end

using TestItemRunner

@testmodule Setup begin
    using PythonCall
    # test if we are in CI
    ci = get(ENV, "CI", "") == "true"
    # test if we have all dev conda deps
    devdeps = PythonCall.C.CTX.which == :CondaPkg
end

@run_package_tests

@testitem "unlock and lock" begin
    # This calls Python's time.sleep(1) twice concurrently. Since sleep() unlocks the
    # GIL, these can happen in parallel if Julia has at least 2 threads.
    function threaded_sleep()
        PythonCall.GIL.unlock() do
            Threads.@threads for i = 1:2
                PythonCall.GIL.lock() do
                    pyimport("time").sleep(1)
                end
            end
        end
    end
    # one run to ensure it's compiled
    threaded_sleep()
    # now time it
    t = @timed threaded_sleep()
    # if we have at least 2 threads, the sleeps run in parallel and take about a second
    if Threads.nthreads() ≥ 2
        @test 0.9 < t.time < 1.2
    end
end

@testitem "@unlock and @lock" begin
    # This calls Python's time.sleep(1) twice concurrently. Since sleep() unlocks the
    # GIL, these can happen in parallel if Julia has at least 2 threads.
    function threaded_sleep()
        PythonCall.GIL.@unlock Threads.@threads for i = 1:2
            PythonCall.GIL.@lock pyimport("time").sleep(1)
        end
    end
    # one run to ensure it's compiled
    threaded_sleep()
    # now time it
    t = @timed threaded_sleep()
    # if we have at least 2 threads, the sleeps run in parallel and take about a second
    if Threads.nthreads() ≥ 2
        @test 0.9 < t.time < 1.2
    end
end

module CustomDocs

import Base: Docs
import Documenter
import Documenter: DocSystem, Markdown, MarkdownAST, doccat
import Documenter.Selectors: order, matcher, runner

# This is a bit of a hack to let us insert documentation blocks with custom content.
# It means we can document Python things directly in the documentation source, and they
# are searchable.
#
# It's a hack because of the `doccat` overload, requiring a special kind of "signature"
# to embed the information we want.
#
# The first line is of the form "name - category", the rest is Markdown documentation.
# For example:
# ```@customdoc
# foo - Function
# Documentation for `foo`.
# ```
struct CustomCat{cat} end

# help?> Documenter.doccat
#   Returns the category name of the provided Object.
doccat(::Docs.Binding, ::Type{CustomCat{cat}}) where {cat} = string(cat)

abstract type CustomDocExpander <: Documenter.Expanders.ExpanderPipeline end

order(::Type{CustomDocExpander}) = 20.0

function matcher(::Type{CustomDocExpander}, node, page, doc)
    return Documenter.iscode(node, "@customdoc")
end

# source:
# https://github.com/JuliaDocs/Documenter.jl/blob/7d3dc2ceef39a62edf2de7081e2d3aaf9be8d7c3/src/expander_pipeline.jl#L353
function runner(::Type{CustomDocExpander}, node, page, doc)
    @assert node.element isa MarkdownAST.CodeBlock

    block = node.element

    name, cat, body = _parse_docs(block.code)

    binding = DocSystem.binding(Main, name)

    docsnodes = MarkdownAST.Node[]

    object = Documenter.Object(binding, CustomCat{cat})

    docstr = Markdown.parse(body)::Markdown.MD
    result = Docs.docstr(
        body,
        Dict{Symbol,Any}(    # NOTE: Not sure about what to put here.                            
            :module => Main, # This is supposed to be tracking python code.
            :path => "",
            :linenumber => 0,
        ),
    )::Docs.DocStr

    # NOTE: This was modified because the original Documenter.create_docsnode was generating unreachable links
    # Also, the original implementation required docstr, result to be vectors.

    docsnode = _create_docsnode(docstr, result, object, page, doc)

    # Track the order of insertion of objects per-binding.
    push!(get!(doc.internal.bindings, binding, Documenter.Object[]), object)

    doc.internal.objects[object] = docsnode.element

    push!(docsnodes, docsnode)

    node.element = Documenter.DocsNodesBlock(block)

    push!(node.children, docsnode)

    return nothing
end

function _parse_docs(code::AbstractString)
    m = match(r"^(.+?)\s*-\s*(.+?)\s*(\n[\s\S]*)$", strip(code))

    if isnothing(m)
        error("""
              Invalid docstring:
              $(code)
              """)
    end

    name = Symbol(m[1])
    cat = Symbol(m[2])
    body = strip(something(m[3], ""))

    return (name, cat, body)
end

# source:
# https://github.com/JuliaDocs/Documenter.jl/blob/7d3dc2ceef39a62edf2de7081e2d3aaf9be8d7c3/src/expander_pipeline.jl#L959-L960
function _create_docsnode(docstring, result, object, page, doc)
    # Generate a unique name to be used in anchors and links for the docstring.
    # NOTE: The way this is being slugified is causing problems:
    # slug = Documenter.slugify(object) 
    slug = Documenter.slugify(string(object.binding))

    anchor = Documenter.anchor_add!(doc.internal.docs, object, slug, page.build)
    docsnode = Documenter.DocsNode(anchor, object, page)

    # Convert docstring to MarkdownAST, convert Heading elements, and push to DocsNode

    ast = convert(MarkdownAST.Node, docstring)

    doc.user.highlightsig && Documenter.highlightsig!(ast)

    # The following 'for' corresponds to the old dropheaders() function
    for headingnode in ast.children
        headingnode.element isa MarkdownAST.Heading || continue

        boldnode = MarkdownAST.Node(MarkdownAST.Strong())

        for textnode in collect(headingnode.children)
            push!(boldnode.children, textnode)
        end

        headingnode.element = MarkdownAST.Paragraph()

        push!(headingnode.children, boldnode)
    end

    push!(docsnode.mdasts, ast)
    push!(docsnode.results, result)
    push!(docsnode.metas, docstring.meta)

    return MarkdownAST.Node(docsnode)
end

end # module CustomDocs

# TODO:
# - function definition (wrap the function like a pyfunc)
# - class definition (e.g. `struct User <: BaseModel; id::int=0; name::str=""; end`)
# - property syntax (e.g. `classmethod |> function foo(cls); cls(); end`)
# - with syntax (`@with`)
# - bytes literals (`b"..."`)
# - raw string literals (`r"..."` or raw"..."?)
# - regex literals (`re"..."` or `r"..."`?)
# - formatted string literals (`f"..."`)
# - comprehensions (tuples, lists, dicts, sets, generators)
# - generator functions??
# - splatting

"""
    module PythonCall.PyMacro

Provides the `@py` macro.
"""
module PyMacro

using ..PythonCall
using ..Core

import ..PythonCall: @py

using MacroTools: MacroTools, @capture, isexpr

const PY_MACRO_NILOPS = Dict(
    :help => (pyhelp, false),
    :int => (pyint, true),
    :float => (pyfloat, true),
    :complex => (pycomplex, true),
    :tuple => (pytuple, true),
    :list => (pylist, true),
    :dict => (pydict, true),
    :set => (pyset, true),
    :frozenset => (pyfrozenset, true),
)

const PY_MACRO_UNOPS = Dict(
    # operators
    :(+) => (pypos, true),
    :(-) => (pyneg, true),
    :(~) => (pyinv, true),
    # builtins
    :abs => (pyabs, true),
    :all => (pyall, false),
    :any => (pyany, false),
    :ascii => (pyascii, true),
    :bytes => (pybytes, true),
    :bool => (pybool, true),
    :callable => (pycallable, false),
    :complex => (pycomplex, true),
    :dict => (pydict, true),
    :dir => (pydir, true),
    :float => (pyfloat, true),
    :frozenset => (pyfrozenset, true),
    :help => (pyhelp, false),
    :int => (pyint, true),
    :iter => (pyiter, true),
    :list => (pylist, true),
    :next => (pynext, true),
    :range => (pyrange, true),
    :repr => (pyrepr, true),
    :set => (pyset, true),
    :slice => (pyslice, true),
    :str => (pystr, true),
    :tuple => (pytuple, true),
    :type => (pytype, true),
    # builtins converting to julia
    :jlascii => (x -> pyascii(String, x), false),
    :jlbool => (pytruth, false),
    :jlbytes => (x -> pybytes(Base.CodeUnits, x), false),
    :jlhash => (pyhash, false),
    :jllen => (pylen, false),
    :jlrepr => (x -> pyrepr(String, x), false),
    :jlstr => (x -> pystr(String, x), false),
    # jlcomplex
)

const PY_MACRO_BINOPS = Dict(
    # operators
    :(+) => (pyadd, true),
    :(-) => (pysub, true),
    :(*) => (pymul, true),
    :(/) => (pytruediv, true),
    :(÷) => (pyfloordiv, true),
    :(%) => (pymod, true),
    :(^) => (pypow, true),
    :(<<) => (pylshift, true),
    :(>>) => (pyrshift, true),
    :(&) => (pyand, true),
    :(|) => (pyor, true),
    :(⊻) => (pyxor, true),
    :(==) => (pyeq, true),
    :(!=) => (pyne, true),
    :(≠) => (pyne, true),
    :(<=) => (pyle, true),
    :(≤) => (pyle, true),
    :(<) => (pylt, true),
    :(>=) => (pyge, true),
    :(≥) => (pyge, true),
    :(>) => (pygt, true),
    :(===) => (pyis, false),
    :(≡) => (pyis, false),
    :(!==) => (pyisnot, false),
    :(≢) => (pyisnot, false),
    :in => (pyin, false),
    :∈ => (pyin, false),
    :∉ => (pynotin, false),
    # builtins
    :pow => (pypow, true),
    :complex => (pycomplex, true),
    :delattr => (pydelattr, false),
    :divmod => (pydivmod, true),
    :getattr => (pygetattr, true),
    :hasattr => (pyhasattr, false),
    :issubclass => (pyissubclass, false),
    :isinstance => (pyisinstance, false),
    :range => (pyrange, true),
    :slice => (pyslice, true),
    # builtins converting to julia
    # jlcomplex
)

const PY_MACRO_TERNOPS = Dict(
    :pow => (pypow, true),
    :range => (pyrange, true),
    :setattr => (pysetattr, false),
    :slice => (pyslice, true),
)

Base.@kwdef mutable struct PyMacroState
    mod::Module
    src::LineNumberNode
    consts::IdDict{Any,Py} = IdDict{Any,Py}()
    inits::Vector{Any} = []
end

function py_macro_err(st, ex, msg = nothing)
    ex2 = ex isa Expr ? Expr(ex.head, [arg isa Expr ? :__ : arg for arg in ex.args]...) : ex
    message = "@py syntax error: $ex2"
    if msg !== nothing
        message *= ": " * msg
    end
    message *= "\n  at $(st.src.file):$(st.src.line)"
    error(message)
end

py_macro_assign(body, ans, ex) = push!(body, :($ans = $ex))

py_macro_del(body, var, tmp) =
    if tmp
        push!(body, :($pydel!($var)))
    end

ismacroexpr(ex, name) =
    isexpr(ex, :macrocall) &&
    (ex.args[1] === Symbol(name) || ex.args[1] === GlobalRef(Base.Core, Symbol(name)))

function py_macro_lower(st, body, ans, ex; flavour = :expr)

    # scalar literals
    if ex isa Union{
        Nothing,
        String,
        Bool,
        Int8,
        Int16,
        Int32,
        Int64,
        Int128,
        UInt8,
        UInt16,
        UInt32,
        UInt64,
        UInt128,
        BigInt,
        Float16,
        Float32,
        Float64,
    }
        x = get!(pynew, st.consts, ex)
        py_macro_assign(body, ans, x)
        return false

        # Int128 literals
    elseif ismacroexpr(ex, "@int128_str")
        value = parse(Int128, ex.args[3])
        x = get!(pynew, st.consts, value)
        py_macro_assign(body, ans, x)
        return false

        # UInt128 literals
    elseif ismacroexpr(ex, "@uint128_str")
        value = parse(UInt128, ex.args[3])
        x = get!(pynew, st.consts, value)
        py_macro_assign(body, ans, x)
        return false

        # big integer literals
    elseif ismacroexpr(ex, "@big_str")
        value = parse(BigInt, ex.args[3])
        x = get!(pynew, st.consts, value)
        py_macro_assign(body, ans, x)
        return false

        # __file__
    elseif ex === :__file__
        return py_macro_lower(st, body, ans, string(st.src.file))

        # __line__
    elseif ex === :__line__
        return py_macro_lower(st, body, ans, st.src.line)

        # x
    elseif ex isa Symbol
        if ex in BUILTINS
            py_macro_assign(body, ans, :($pybuiltins.$ex))
        else
            py_macro_assign(body, ans, ex)
        end
        return false

        # x:y:z
    elseif flavour == :index && @capture(ex, ax_:ay_:az_)
        @gensym x y z
        tx = py_macro_lower(st, body, x, ax === :_ ? :None : ax)
        ty = py_macro_lower(st, body, y, ay === :_ ? :None : ay)
        tz = py_macro_lower(st, body, z, az === :_ ? :None : az)
        py_macro_assign(body, ans, :($pyslice($x, $y, $z)))
        py_macro_del(body, x, tx)
        py_macro_del(body, y, ty)
        py_macro_del(body, z, tz)
        return true

        # x:y
    elseif flavour == :index && @capture(ex, ax_:ay_)
        @gensym x y
        tx = py_macro_lower(st, body, x, ax === :_ ? :None : ax)
        ty = py_macro_lower(st, body, y, ay === :_ ? :None : ay)
        py_macro_assign(body, ans, :($pyslice($x, $y)))
        py_macro_del(body, x, tx)
        py_macro_del(body, y, ty)
        return true

        # x + y + z + ...
    elseif @capture(ex, +(ax_, ay_, az_, args__))
        return py_macro_lower(
            st,
            body,
            ans,
            foldl((x, y) -> :($x + $y), (ax, ay, az, args...)),
        )

        # x * y * z * ...
    elseif @capture(ex, *(ax_, ay_, az_, args__))
        return py_macro_lower(
            st,
            body,
            ans,
            foldl((x, y) -> :($x * $y), (ax, ay, az, args...)),
        )

        # f(args...; kwargs...)
    elseif isexpr(ex, :call)
        af = ex.args[1]
        # is it a special operator?
        isop = false
        if haskey(PY_MACRO_NILOPS, af)
            isop = true
            if length(ex.args) == 1
                op, t = PY_MACRO_NILOPS[af]
                py_macro_assign(body, ans, :($op()))
                return t
            end
        end
        if haskey(PY_MACRO_UNOPS, af)
            isop = true
            if length(ex.args) == 2
                op, t = PY_MACRO_UNOPS[af]
                ax, = ex.args[2:end]
                @gensym x
                tx = py_macro_lower(st, body, x, ax)
                py_macro_assign(body, ans, :($op($x)))
                py_macro_del(body, x, tx)
                return t
            end
        end
        if haskey(PY_MACRO_BINOPS, af)
            isop = true
            if length(ex.args) == 3
                op, t = PY_MACRO_BINOPS[af]
                ax, ay = ex.args[2:end]
                @gensym x y
                tx = py_macro_lower(st, body, x, ax)
                ty = py_macro_lower(st, body, y, ay)
                py_macro_assign(body, ans, :($op($x, $y)))
                py_macro_del(body, x, tx)
                py_macro_del(body, y, ty)
                return t
            end
        end
        if haskey(PY_MACRO_TERNOPS, af)
            isop = true
            if length(ex.args) == 4
                op, t = PY_MACRO_TERNOPS[af]
                ax, ay, az = ex.args[2:end]
                @gensym x y z
                tx = py_macro_lower(st, body, x, ax)
                ty = py_macro_lower(st, body, y, ay)
                tz = py_macro_lower(st, body, z, az)
                py_macro_assign(body, ans, :($op($x, $y, $z)))
                py_macro_del(body, x, tx)
                py_macro_del(body, y, ty)
                py_macro_del(body, z, tz)
                return t
            end
        end
        # if it's an operator but we get this far, we used the operator wrong
        # if it's also a builtin, we allow calling it as a function
        # otherwise it's a syntax error
        isop && af ∉ BUILTINS && py_macro_err(st, ex)
        # disallow things like calling other julia infix operators like functions
        af isa Symbol && !Base.isidentifier(af) && py_macro_err(st, ex)
        # pycall
        aargs = []
        akwargs = []
        aparams = []
        for a in ex.args[2:end]
            if isexpr(a, :parameters)
                append!(aparams, a.args)
            elseif isexpr(a, :kw)
                push!(akwargs, a)
            else
                push!(aargs, a)
            end
        end
        append!(akwargs, aparams)
        if !isempty(akwargs)
            @gensym f args kwargs
            tf = py_macro_lower(st, body, f, af)
            targs = py_macro_lower(st, body, args, Expr(:tuple, aargs...))
            tkwargs = py_macro_lower(
                st,
                body,
                kwargs,
                Expr(:braces, Expr(:parameters), akwargs...),
            )
            py_macro_assign(body, ans, :($pycallargs($f, $args, $kwargs)))
            py_macro_del(body, f, tf)
            py_macro_del(body, args, targs)
            py_macro_del(body, kwargs, tkwargs)
        elseif !isempty(aargs)
            @gensym f args
            tf = py_macro_lower(st, body, f, af)
            targs = py_macro_lower(st, body, args, Expr(:tuple, aargs...))
            py_macro_assign(body, ans, :($pycallargs($f, $args)))
            py_macro_del(body, f, tf)
            py_macro_del(body, args, targs)
        else
            @gensym f
            tf = py_macro_lower(st, body, f, af)
            py_macro_assign(body, ans, :($pycallargs($f)))
            py_macro_del(body, f, tf)
        end
        if af === :print
            # treat print as a special case since it is variadic
            push!(body, :($pydel!($ans)))
            py_macro_assign(body, ans, nothing)
            return false
        else
            return true
        end

        # (...)
    elseif isexpr(ex, :tuple)
        if any(isexpr(arg, :...) for arg in ex.args)
            py_macro_err(st, ex, "splatting into tuples not implemented")
        else
            py_macro_assign(body, ans, :($pynulltuple($(length(ex.args)))))
            @gensym a
            for (i, aa) in enumerate(ex.args)
                ta = py_macro_lower(
                    st,
                    body,
                    a,
                    aa,
                    flavour = flavour == :index ? :index : :expr,
                )
                push!(body, :($pytuple_setitem($ans, $(i - 1), $a)))
                py_macro_del(body, a, ta)
            end
            return true
        end

        # [...]
    elseif isexpr(ex, :vect)
        if any(isexpr(arg, :...) for arg in ex.args)
            py_macro_err(st, ex, "splatting into tuples not implemented")
        else
            py_macro_assign(body, ans, :($pynulllist($(length(ex.args)))))
            @gensym a
            for (i, aa) in enumerate(ex.args)
                ta = py_macro_lower(st, body, a, aa)
                push!(body, :($pylist_setitem($ans, $(i - 1), $a)))
                py_macro_del(body, a, ta)
            end
            return true
        end

        # {...}
    elseif isexpr(ex, :braces)
        # Like Python, we allow braces to be set or dict literals.
        #
        # The expression is a dict if either:
        # - it is empty ({})
        # - it has a parameters section (e.g. {x,y;})
        # - it has any assignment expressions (e.g. {k=v})
        # - it has any pair expressions (e.g. {k=>v})
        # and otherwise it is a set.
        #
        # e.g. these are sets: {x, y}, {x...}
        # e.g. these are dicts: {}, {x, y;}, {k=x}, {k=>x}
        if isempty(ex.args) || any(
            isexpr(arg, :parameters, :(=), :kw) || @capture(arg, k_:v_) for arg in ex.args
        )
            aargs = []
            for a in ex.args
                if isexpr(a, :parameters)
                    append!(aargs, a.args)
                else
                    push!(aargs, a)
                end
            end
            py_macro_assign(body, ans, :($pydict()))
            @gensym k v
            for aa in aargs
                if isexpr(aa, :...)
                    py_macro_err(st, aa, "splatting into dicts not implemented")
                elseif isexpr(aa, :kw, :(=))
                    ak, av = aa.args
                    ak isa Symbol || py_macro_err(
                        st,
                        aa,
                        "key of `key=value` must be a symbol - did you mean `key:value`?",
                    )
                    tk = py_macro_lower(st, body, k, string(ak))
                    tv = py_macro_lower(st, body, v, av)
                    push!(body, :($pydict_setitem($ans, $k, $v)))
                    py_macro_del(body, k, tk)
                    py_macro_del(body, v, tv)
                elseif @capture(aa, ak_:av_)
                    tk = py_macro_lower(st, body, k, ak)
                    tv = py_macro_lower(st, body, v, av)
                    push!(body, :($pydict_setitem($ans, $k, $v)))
                    py_macro_del(body, k, tk)
                    py_macro_del(body, v, tv)
                else
                    py_macro_err(st, aa, "this kind of dict entry not implemented")
                end
            end
            return true
        else
            py_macro_assign(body, ans, :($pyset()))
            @gensym a
            for aa in ex.args
                if isexpr(aa, :...)
                    py_macro_err(st, ex, "splatting into sets not implemented")
                end
                ta = py_macro_lower(st, body, a, aa)
                push!(body, :($pyset_add($ans, $a)))
                py_macro_del(body, a, ta)
            end
            return true
        end

        # x.k
    elseif isexpr(ex, :.)
        ax, ak = ex.args
        @gensym x k
        tx = py_macro_lower(st, body, x, ax)
        if ak isa QuoteNode && ak.value isa Symbol
            tk = py_macro_lower(st, body, k, string(ak.value))
        else
            tk = py_macro_lower(st, body, k, ak)
        end
        py_macro_assign(body, ans, :($pygetattr($x, $k)))
        py_macro_del(body, x, tx)
        py_macro_del(body, k, tk)
        return true

        # x[k]
    elseif @capture(ex, ax_[ak__])
        @gensym x k
        tx = py_macro_lower(st, body, x, ax)
        if length(ak) == 1
            tk = py_macro_lower(st, body, k, ak[1]; flavour = :index)
        else
            tk = py_macro_lower(st, body, k, Expr(:tuple, ak...); flavour = :index)
        end
        py_macro_assign(body, ans, :($pygetitem($x, $k)))
        py_macro_del(body, x, tx)
        py_macro_del(body, k, tk)
        return true

        # x = y
    elseif @capture(ex, ax_ = ay_)
        ty = py_macro_lower(st, body, ans, ay)
        py_macro_lower_assign(st, body, ax, ans)
        return ty

        # @del x, y, ...
    elseif @capture(ex, @del (args__,))

        for arg in args

            # @del x.k
            if isexpr(arg, :.)
                ax, ak = ex.args
                @gensym x k
                tx = py_macro_lower(st, body, x, ax)
                if ak isa QuoteNode && ak.value isa Symbol
                    tk = py_macro_lower(st, body, k, string(ak.value))
                else
                    tk = py_macro_lower(st, body, k, ak)
                end
                push!(body, :($pydelattr($x, $k)))
                py_macro_del(body, x, tx)
                py_macro_del(body, k, tk)

                # @del x[k]
            elseif @capture(arg, ax_[ak__])
                @gensym x k
                tx = py_macro_lower(st, body, x, ax)
                if length(ak) == 1
                    tk = py_macro_lower(st, body, k, ak[1], flavour = :index)
                else
                    tk = py_macro_lower(st, body, k, Expr(:tuple, ak...), flavour = :index)
                end
                push!(body, :($pydelitem($x, $k)))
                py_macro_del(body, x, tx)
                py_macro_del(body, k, tk)

            else
                py_macro_err(
                    st,
                    ex,
                    "@del argument must be an attribute or indexing expression",
                )
            end
        end
        py_macro_assign(body, ans, nothing)
        return false

        # @del x
    elseif @capture(ex, @del arg_)
        return py_macro_lower(st, body, ans, :(@del ($arg,)))

        # @jl x
    elseif @capture(ex, @jl ax_)
        y = py_macro_lower_jl(st, ax)
        py_macro_assign(body, ans, y)
        return false

        # @compile code mode=mode ...
    elseif @capture(ex, @compile code_String mode = mode_String args__)
        x = pynew()
        args = [isexpr(arg, :(=)) ? Expr(:kw, arg.args...) : arg for arg in args]
        filename = "$(st.src.file):$(st.src.line)"
        push!(
            st.inits,
            :($pycopy!(
                $x,
                $pybuiltins.compile($code, filename = $filename, mode = $mode, $(args...)),
            )),
        )
        py_macro_assign(body, ans, x)
        return false

        # @exec code ...
    elseif @capture(ex, @exec code_String args__)
        args = [isexpr(arg, :(=)) ? Expr(:kw, arg.args...) : arg for arg in args]
        ex2 = Expr(:macrocall, Symbol("@compile"), st.src, code, :(mode = "exec"))
        ex2 = Expr(:call, :exec, ex2, args...)
        @gensym a
        ta = py_macro_lower(st, body, a, ex2)
        py_macro_del(body, a, ta)
        py_macro_assign(body, ans, nothing)
        return false

        # @eval code ...
    elseif @capture(ex, @eval code_String args__)
        args = [isexpr(arg, :(=)) ? Expr(:kw, arg.args...) : arg for arg in args]
        ex2 = Expr(:macrocall, Symbol("@compile"), st.src, code, :(mode = "eval"))
        ex2 = Expr(:call, :eval, ex2, args...)
        return py_macro_lower(st, body, ans, ex2)

        # begin; ...; end
    elseif isexpr(ex, :block)
        if isempty(ex.args)
            py_macro_assign(body, ans, nothing)
            return false
        else
            @gensym a
            for (i, aa) in enumerate(ex.args)
                if aa isa LineNumberNode
                    st.src = aa
                    push!(body, aa)
                    if i == length(ex.args)
                        py_macro_assign(body, ans, nothing)
                        return false
                    end
                elseif i == length(ex.args)
                    ta = py_macro_lower(st, body, ans, aa)
                    return ta
                else
                    ta = py_macro_lower(st, body, a, aa)
                    py_macro_del(body, a, ta)
                end
            end
            @assert false
        end

        # if x; ...; end
    elseif isexpr(ex, :if, :elseif)
        if length(ex.args) == 2
            return py_macro_lower(st, body, ans, Expr(ex.head, ex.args..., nothing))
        elseif length(ex.args) == 3
            ax, ay, az = ex.args
            @gensym x
            py_macro_lower_bool(st, body, x, ax)
            body2 = []
            ty = py_macro_lower(st, body2, ans, ay)
            body3 = []
            tz = py_macro_lower(st, body3, ans, az)
            t = ty || tz
            if t
                ty || push!(body2, :($ans = $pynew($Py($ans))))
                tz || push!(body3, :($ans = $pynew($Py($ans))))
            end
            push!(body, Expr(:if, x, Expr(:block, body2...), Expr(:block, body3...)))
            return t
        end

        # x && y
    elseif isexpr(ex, :&&)
        ax, ay = ex.args
        tx = py_macro_lower(st, body, ans, ax)
        body2 = []
        body3 = []
        tx && push!(body2, :($pydel!($ans)))
        ty = py_macro_lower(st, body2, ans, ay)
        t = tx || ty
        if t
            tx || push!(body3, :($ans = $pynew($Py($ans))))
            ty || push!(body2, :($ans = $pynew($Py($ans))))
        end
        push!(
            body,
            Expr(:if, :($pytruth($ans)), Expr(:block, body2...), Expr(:block, body3...)),
        )
        return t

        # x || y
    elseif isexpr(ex, :||)
        ax, ay = ex.args
        tx = py_macro_lower(st, body, ans, ax)
        body2 = []
        body3 = []
        tx && push!(body3, :($pydel!($ans)))
        ty = py_macro_lower(st, body3, ans, ay)
        t = tx || ty
        if t
            tx || push!(body2, :($ans = $pynew($Py($ans))))
            ty || push!(body3, :($ans = $pynew($Py($ans))))
        end
        push!(
            body,
            Expr(:if, :($pytruth($ans)), Expr(:block, body2...), Expr(:block, body3...)),
        )
        return t

        # while x; ...; end
    elseif isexpr(ex, :while)
        ax, ay = ex.args
        @gensym x y
        body2 = []
        py_macro_lower_bool(st, body2, x, ax)
        push!(body2, Expr(:if, :(!$x), :(break)))
        ty = py_macro_lower(st, body2, y, ay)
        py_macro_del(body2, y, ty)
        push!(body, Expr(:while, true, Expr(:block, body2...)))
        py_macro_assign(body, ans, nothing)
        return false

        # for x in y; ...; end
    elseif @capture(ex, for ax_ in ay_
        az_
    end)
        @gensym y i v z
        ty = py_macro_lower(st, body, y, ay)
        push!(body, :($i = $pyiter($y)))
        py_macro_del(body, y, ty)
        body2 = []
        push!(body2, :($v = $unsafe_pynext($i)))
        push!(body2, Expr(:if, :($pyisnull($v)), Expr(:block, :($pydel!($v)), :(break))))
        py_macro_lower_assign(st, body2, ax, v)
        py_macro_del(body2, v, true)
        tz = py_macro_lower(st, body2, z, az)
        py_macro_del(body2, z, tz)
        push!(body, Expr(:while, true, Expr(:block, body2...)))
        py_macro_del(body, i, true)
        py_macro_assign(body, ans, nothing)
        return false

        # import ...
    elseif isexpr(ex, :import)
        for aa in ex.args
            if isexpr(aa, :as)
                am, av = aa.args
                av isa Symbol || py_macro_err(st, av)
                py_macro_lower_import(st, body, av, am)
            elseif isexpr(aa, :.)
                @gensym m
                if length(aa.args) > 1
                    tm = py_macro_lower_import(st, body, m, aa)
                    py_macro_del(body, m, tm)
                end
                py_macro_lower_import(st, body, aa.args[1], Expr(:., aa.args[1]))
            elseif isexpr(aa, :(:))
                @gensym m
                py_macro_lower_import(st, body, m, aa.args[1])
                for ak in aa.args[2:end]
                    if isexpr(ak, :as)
                        ak, av = ak.args
                        av isa Symbol || py_macro_err(st, av)
                        py_macro_lower_nested_getattr(st, body, av, m, ak)
                    elseif isexpr(ak, :.)
                        py_macro_lower_nested_getattr(st, body, ak.args[end], m, ak)
                    else
                        py_macro_err(st, ak)
                    end
                end
                py_macro_del(body, m, true)
            else
                py_macro_err(st, aa)
            end
        end
        py_macro_assign(body, ans, nothing)
        return false

        # "...$foo..."
    elseif isexpr(ex, :string)
        args = [a isa String ? a : :(str($a)) for a in ex.args]
        return py_macro_lower(st, body, ans, :("".join(($(args...),))))

    end

    py_macro_err(st, ex)
end

function py_macro_lower_nested_getattr(st, body, ans, x, ks)
    @gensym m v
    isexpr(ks, :.) || py_macro_err(st, ks)
    length(ks.args) > 0 || py_macro_err(st, ks)
    py_macro_lower(st, body, ans, :($x.$(ks.args[1])))
    for k in ks.args[2:end]
        py_macro_lower(st, body, v, :($ans.$k))
        py_macro_del(body, ans, true)
        py_macro_assign(body, ans, v)
    end
end

function py_macro_lower_import(st, body, ans, ex)
    @gensym m
    isexpr(ex, :.) || py_macro_err(st, ex)
    tm = py_macro_lower(st, body, m, join(ex.args, "."))
    py_macro_assign(body, ans, :($pyimport($m)))
    py_macro_del(body, m, tm)
end

function py_macro_lower_bool(st, body, ans, ex)
    # TODO: special cases to avoid round-tripping bools from Julia to Python to Julia
    @gensym x
    tx = py_macro_lower(st, body, x, ex)
    py_macro_assign(body, ans, :($pytruth($x)))
    py_macro_del(body, x, tx)
    return
end

function py_macro_lower_assign(st, body, lhs, rhs::Symbol)
    if lhs isa Symbol
        push!(body, :($lhs = $pynew($Py($rhs))))
    elseif @capture(lhs, ax_[ak__])
        @gensym x k
        tx = py_macro_lower(st, body, x, ax)
        if length(ak) == 1
            tk = py_macro_lower(st, body, k, ak[1], flavour = :index)
        else
            tk = py_macro_lower(st, body, k, Expr(:tuple, ak...), flavour = :index)
        end
        push!(body, :($pysetitem($x, $k, $rhs)))
        py_macro_del(body, x, tx)
        py_macro_del(body, k, tk)
    elseif isexpr(lhs, :.)
        ax, ak = lhs.args
        @gensym x k
        tx = py_macro_lower(st, body, x, ax)
        if ak isa QuoteNode && ak.value isa Symbol
            tk = py_macro_lower(st, body, k, string(ak.value))
        else
            tk = py_macro_lower(st, body, k, ak)
        end
        push!(body, :($pysetattr($x, $k, $rhs)))
        py_macro_del(body, x, tx)
        py_macro_del(body, k, tk)
    else
        py_macro_err(st, lhs, "assignment")
    end
    return
end

function py_macro_lower_jl(st, ex)
    # TODO: expand out macros
    if @capture(ex, @py ax_)
        @gensym x
        body = []
        py_macro_lower(st, body, x, ax)
        return Expr(:block, body..., x)
    elseif ex isa Expr
        return Expr(ex.head, [py_macro_lower_jl(st, aa) for aa in ex.args]...)
    else
        return ex
    end
end

function py_macro(ex, mod, src)
    body = []
    @gensym ans
    st = PyMacroState(mod = mod, src = src)
    py_macro_lower(st, body, ans, ex)
    if !isempty(st.consts) || !isempty(st.inits)
        doinit = Ref(true)
        inits = copy(st.inits)
        for (v, x) in st.consts
            if v isa String
                push!(inits, :($pycopy!($x, $pystr_intern!($pystr($v)))))
            else
                push!(inits, :($pycopy!($x, $pynew($Py($v)))))
            end
        end
        push!(inits, :($doinit[] = false))
        pushfirst!(body, Expr(:if, :($doinit[]), Expr(:block, inits...)))
    end
    pushfirst!(body, src)
    Expr(:block, body..., ans)
end

"""
    @py expr

Evaluate `expr` using Python-like syntax and semantics and return the
resulting [`Py`](@ref) object.

Supported syntax includes:

* **Literals and names:** Numeric and string literals, `None`, `True`, `False`,
  containers (`(…)`, `[…]`, `{…}`, `{key:value, …}`) and special
  placeholders such as `__file__` and `__line__`.
* **Calls and operators:** Function calls are translated to `pycall`, unary
  and binary operators are forwarded to the corresponding `py*` helper
  (e.g. `x + y` → `pyadd(x, y)`, `x === y` → `pyis(x, y)`), and chained
  arithmetic or comparison expressions behave like their Python equivalents.
* **Attribute access and indexing:** `obj.attr`, `obj[key]`, and slice syntax
  (`obj[start:stop:step]`) map to `pygetattr`, `pygetitem`, and `pyslice`.
* **Statements:** Assignments, `@del` deletions, `if`/`elseif`/`else`, `while`, `for`,
  short-circuit boolean logic (`&&`/`||`). Import statements
  (`import pkg`, `import pkg as alias`, `import pkg: attr as alias`) are
  also supported.
* **Interop helpers:** Use `@jl expr` to splice the result of a Julia
  expression into the Python evaluation. The auxiliary macros `@compile`,
  `@eval`, and `@exec` work like `compile`/`eval`/`exec` in Python but compile
  the code argument once and reuse it for speed.

Names that match Python builtins are resolved through [`pybuiltins`](@ref); other
identifiers are captured from the surrounding Julia scope.

# Examples

```julia
julia> @py begin
           import math: sqrt
           sqrt(9)
       end
Py(3.0)

julia> factor = 10
julia> @py begin
           data = [1, 2, @jl factor]
           total = 0
           for value in data
               total = total + value
           end
           total
       end
Py(13)

julia> @py begin
           info = {"x": 1, "y": 2}
           @del info["x"]
           info
       end
Py({'y': 2})
```

!!! warning
    This macro is experimental. It may be modified or removed in a future release.
"""
macro py(ex)
    esc(py_macro(ex, __module__, __source__))
end

end

"""
    @pyconst ex

Equivalent to `Py(ex)` but always returns the exact same Julia object.

That is, if `foo() = @pyconst ex` then `foo() === foo()`.

The expression `ex` is evaluated the first time the code is run.

If `ex` is a string literal, the string is interned.

Do not use this macro at the top level of a module. Instead, use `pynew()` and `pycopy!()`.
"""
macro pyconst(ex)
    x = pynew()
    val = esc(ex)
    if ex isa String
        val = :($pystr_intern!($pystr($val)))
    else
        val = :($Py($val))
    end
    :(pyisnull($x) ? pycopy!($x, $val) : $x)
end

const pyjlbasetype = pynew()

_pyjl_getvalue(x) = @autopy x Cjl.PyJuliaValue_GetValue(x_)

_pyjl_setvalue!(x, v) = @autopy x Cjl.PyJuliaValue_SetValue(x_, v)

pyjl(t, v) = pynew(errcheck(@autopy t Cjl.PyJuliaValue_New(t_, v)))

"""
    pyisjl(x)

Test whether `x` is a wrapped Julia value, namely an instance of `juliacall.ValueBase`.
"""
pyisjl(x) = pytypecheck(x, pyjlbasetype)

pyjlisnull(x) = @autopy x begin
    if pyisjl(x_)
        Cjl.PyJuliaValue_IsNull(x_)
    else
        error("Expecting a 'juliacall.ValueBase', got a '$(pytype(x_).__name__)'")
    end
end

"""
    pyjlvalue(x)

Extract the value from the wrapped Julia value `x`.
"""
pyjlvalue(x) = @autopy x begin
    if pyjlisnull(x_)
        error("Julia value is NULL")
    else
        _pyjl_getvalue(x_)
    end
end

function init_base()
    setptr!(pyjlbasetype, incref(Cjl.PyJuliaBase_Type[]))
    pyjuliacallmodule.ValueBase = pyjlbasetype

    # conversion rule
    priority = PYCONVERT_PRIORITY_WRAP
    pyconvert_add_rule("juliacall:ValueBase", Any, pyconvert_rule_jlvalue, priority)
end

pyconvert_rule_jlvalue(::Type{T}, x::Py) where {T} =
    pyconvert_tryconvert(T, _pyjl_getvalue(x))

function Cjl._pyjl_callmethod(f, self_::C.PyPtr, args_::C.PyPtr, nargs::C.Py_ssize_t)
    @nospecialize f
    if Cjl.PyJuliaValue_IsNull(self_)
        errset(pybuiltins.TypeError, "Julia object is NULL")
        return C.PyNULL
    end
    in_f = false
    self = Cjl.PyJuliaValue_GetValue(self_)
    try
        if nargs == 1
            in_f = true
            ans = f(self)::Py
            in_f = false
        elseif nargs == 2
            arg1 = pynew(incref(C.PyTuple_GetItem(args_, 1)))
            in_f = true
            ans = f(self, arg1)::Py
            in_f = false
        elseif nargs == 3
            arg1 = pynew(incref(C.PyTuple_GetItem(args_, 1)))
            arg2 = pynew(incref(C.PyTuple_GetItem(args_, 2)))
            in_f = true
            ans = f(self, arg1, arg2)::Py
            in_f = false
        elseif nargs == 4
            arg1 = pynew(incref(C.PyTuple_GetItem(args_, 1)))
            arg2 = pynew(incref(C.PyTuple_GetItem(args_, 2)))
            arg3 = pynew(incref(C.PyTuple_GetItem(args_, 3)))
            in_f = true
            ans = f(self, arg1, arg2, arg3)::Py
            in_f = false
        else
            errset(
                pybuiltins.NotImplementedError,
                "__jl_callmethod not implemented for this many arguments",
            )
        end
        return getptr(incref(ans))
    catch exc
        if exc isa PyException
            Base.GC.@preserve exc C.PyErr_Restore(
                incref(exc._t),
                incref(exc._v),
                incref(exc._b),
            )
            return C.PyNULL
        else
            try
                if in_f
                    return pyjl_handle_error(f, self, exc)
                else
                    errset(
                        pyJuliaError,
                        pytuple((pyjlraw(exc), pyjlraw(catch_backtrace()))),
                    )
                    return C.PyNULL
                end
            catch
                errset(pyJuliaError, "an error occurred while setting an error")
                return C.PyNULL
            end
        end
    end
end

function pyjl_handle_error(f, self, exc)
    @nospecialize f self exc
    t = pyjl_handle_error_type(f, self, exc)::Py
    if pyisnull(t)
        # NULL => raise JuliaError
        errset(pyJuliaError, pytuple((pyjlraw(exc), pyjlraw(catch_backtrace()))))
        return C.PyNULL
    elseif pyistype(t)
        # Exception type => raise this type of error
        errset(t, string("Julia: ", Py(sprint(showerror, exc))))
        return C.PyNULL
    else
        # Otherwise, return the given object (e.g. NotImplemented)
        return getptr(incref(t))
    end
end

function pyjl_methodnum(f)
    @nospecialize f
    Cjl.PyJulia_MethodNum(f)
end

function pyjl_handle_error_type(f, self, exc)
    @nospecialize f self exc
    PyNULL
end

Py(x) = ispy(x) ? throw(MethodError(Py, (x,))) : pyjl(x)

asptr(x) = Base.unsafe_convert(PyPtr, x)

# Free-threaded CPython builds ("3.14t") currently have different C struct layouts,
# but there is no stable ABI yet. To keep the code manageable, we centralize the
# branching in a single macro that rewrites type names in the expression.
const _FT_TYPE_REPLACEMENTS = Dict{Symbol,Symbol}(
    :PyObject => :PyObjectFT,
    :PyVarObject => :PyVarObjectFT,
    :PyMemoryViewObject => :PyMemoryViewObjectFT,
    :PySimpleObject => :PySimpleObjectFT,
    # Used from JlWrap/C.jl via `C.@ft`.
    :PyJuliaValueObject => :PyJuliaValueObjectFT,
)

function _ft_transform(ex)
    if ex isa Symbol
        return get(_FT_TYPE_REPLACEMENTS, ex, ex)
    elseif ex isa QuoteNode
        return QuoteNode(_ft_transform(ex.value))
    elseif ex isa Expr
        return Expr(ex.head, map(_ft_transform, ex.args)...)
    else
        return ex
    end
end

"""
    @ft expr

Evaluate `expr`, but when `CTX.is_free_threaded` is true (CPython "free-threaded"
builds), rewrite internal type names like `PyObject` → `PyObjectFT` inside the
expression.

This keeps free-threaded branching centralized, so we don't scatter `if
CTX.is_free_threaded` throughout the code.
"""
macro ft(ex)
    ex_ft = _ft_transform(ex)
    m = @__MODULE__
    return esc(:($m.CTX.is_free_threaded ? $ex_ft : $ex))
end

Py_Type(x) = Base.GC.@preserve x @ft PyPtr(UnsafePtr{PyObject}(asptr(x)).type[!])

PyObject_Type(x) = Base.GC.@preserve x (t = Py_Type(asptr(x)); Py_IncRef(t); t)

Py_TypeCheck(o, t) = Base.GC.@preserve o t PyType_IsSubtype(Py_Type(asptr(o)), asptr(t))
Py_TypeCheckFast(o, f::Integer) = Base.GC.@preserve o PyType_IsSubtypeFast(Py_Type(asptr(o)), f)

PyType_IsSubtypeFast(t, f::Integer) =
    Base.GC.@preserve t Cint(!iszero(PyType_GetFlags(asptr(t)) & f))

PyMemoryView_GET_BUFFER(m) = Base.GC.@preserve m @ft Ptr{Py_buffer}(UnsafePtr{PyMemoryViewObject}(asptr(m)).view)

PyType_CheckBuffer(t) = Base.GC.@preserve t begin
    getbuf = PyType_GetSlot(asptr(t), Py_bf_getbuffer)
    return getbuf != C_NULL
end

PyObject_CheckBuffer(o) = Base.GC.@preserve o PyType_CheckBuffer(Py_Type(asptr(o)))

PyObject_GetBuffer(_o, b, flags) = Base.GC.@preserve _o begin
    o = asptr(_o)
    getbuf = PyType_GetSlot(Py_Type(o), Py_bf_getbuffer)
    if getbuf == C_NULL
        # TODO: we can drop this branch and just use PyType_GetName once we stop
        # supporting python 3.10
        msg = if CTX.is_free_threaded
            "a bytes-like object is required"
        else
            "a bytes-like object is required, not '$(String(UnsafePtr{PyTypeObject}(Py_Type(o)).name[]))'"
        end
        PyErr_SetString(POINTERS.PyExc_TypeError, msg)
        return Cint(-1)
    end
    return ccall(getbuf, Cint, (PyPtr, Ptr{Py_buffer}, Cint), o, b, flags)
end

PyBuffer_Release(_b) = begin
    b = UnsafePtr(Base.unsafe_convert(Ptr{Py_buffer}, _b))
    o = b.obj[]
    o == C_NULL && return
    releasebuf = PyType_GetSlot(Py_Type(o), Py_bf_releasebuffer)
    if releasebuf != C_NULL
        ccall(releasebuf, Cvoid, (PyPtr, Ptr{Py_buffer}), o, b)
    end
    b.obj[] = C_NULL
    Py_DecRef(o)
    return
end

function PyOS_SetInputHook(hook::Ptr{Cvoid})
    Base.unsafe_store!(POINTERS.PyOS_InputHookPtr, hook)
    return
end

function PyOS_GetInputHook()
    return Base.unsafe_load(POINTERS.PyOS_InputHookPtr)
end

function PyOS_RunInputHook()
    hook = PyOS_GetInputHook()
    if hook == C_NULL
        return false
    else
        ccall(hook, Cint, ())
        return true
    end
end

function PySimpleObject_GetValue(::Type{T}, o) where {T}
    Base.GC.@preserve o @ft UnsafePtr{PySimpleObject{T}}(asptr(o)).value[!]
end

# FAST REFCOUNTING
#
# _Py_IncRef(o) = ccall(POINTERS.Py_IncRef, Cvoid, (PyPtr,), o)
# _Py_DecRef(o) = ccall(POINTERS.Py_DecRef, Cvoid, (PyPtr,), o)
# const FAST_INCREF = true
# const FAST_DECREF = true
# if FAST_INCREF
#     # This avoids calling the C-API Py_IncRef().
#     # It just needs to increase the reference count.
#     # Assumes Python is not built for debugging reference counts.
#     # Speed up from 2.5ns to 1.3ns.
#     Py_INCREF(o) = GC.@preserve o begin
#         p = UnsafePtr(Base.unsafe_convert(PyPtr, o))
#         p.refcnt[] += 1
#         nothing
#     end
#     Py_IncRef(o) = GC.@preserve o begin
#         p = UnsafePtr(Base.unsafe_convert(PyPtr, o))
#         if p != C_NULL
#             p.refcnt[] += 1
#         end
#         nothing
#     end
# else
#     Py_INCREF(o) = _Py_IncRef(o)
#     Py_IncRef(o) = _Py_IncRef(o)
# end
# if FAST_DECREF
#     # This avoids calling the C-API Py_IncRef() unless the object is about to be deallocated.
#     # It just needs to decrement the reference count.
#     # Assumes Python is not built for debugging reference counts.
#     # Speed up from 2.5ns to 1.8ns in non-deallocating case.
#     Py_DECREF(o) = GC.@preserve o begin
#         p = UnsafePtr(Base.unsafe_convert(PyPtr, o))
#         c = p.refcnt[]
#         if c > 1
#             p.refcnt[] = c - 1
#         else
#             _Py_DecRef(o)
#         end
#         nothing
#     end
#     Py_DecRef(o) = GC.@preserve o begin
#         p = UnsafePtr(Base.unsafe_convert(PyPtr, o))
#         if p != C_NULL
#             c = p.refcnt[]
#             if c > 1
#                 p.refcnt[] = c - 1
#             else
#                 _Py_DecRef(o)
#             end
#         end
#         nothing
#     end
# else
#     Py_DECREF(o) = _Py_DecRef(o)
#     Py_DecRef(o) = _Py_DecRef(o)
# end
# Py_RefCnt(o) = GC.@preserve o UnsafePtr(Base.unsafe_convert(PyPtr, o)).refcnt[]

# Py_DecRef(f::Function, o::Ptr, dflt = PYERR()) =
#     isnull(o) ? dflt : (r = f(o); Py_DecRef(o); r)

const INIT_CONSTS_CODE = []

const INIT_MODULES = Dict(
    :pybuiltinsmodule => "builtins",
    :pysysmodule => "sys",
    :pyosmodule => "os",
    :pynumbersmodule => "numbers",
    :pydatetimemodule => "datetime",
    :pycollectionsabcmodule => "collections.abc",
)

for (j, m) in INIT_MODULES
    @eval const $j = pynew()
    push!(INIT_CONSTS_CODE, :(pycopy!($j, pyimport($m))))
end

const INIT_ATTRS = Dict(
    :pyfractiontype => "fractions" => "Fraction",
    :pydatetype => "datetime" => "date",
    :pytimetype => "datetime" => "time",
    :pydatetimetype => "datetime" => "datetime",
    :pytimedeltatype => "datetime" => "timedelta",
)

for (j, k) in INIT_ATTRS
    @eval const $j = pynew()
    push!(INIT_CONSTS_CODE, :(pycopy!($j, pyimport($k))))
end

const BUILTINS = Set([
    # consts
    :True,
    :False,
    :NotImplemented,
    :None,
    :Ellipsis,
    # classes/functions
    :abs,
    :all,
    :any,
    :ascii,
    :bin,
    :bool,
    :bytes,
    :bytearray,
    :callable,
    :chr,
    :classmethod,
    :compile,
    :complex,
    :delattr,
    :dict,
    :dir,
    :divmod,
    :enumerate,
    :eval,
    :exec,
    :filter,
    :float,
    :format,
    :frozenset,
    :getattr,
    :globals,
    :hasattr,
    :hash,
    :help,
    :hex,
    :id,
    :input,
    :int,
    :isinstance,
    :issubclass,
    :iter,
    :len,
    :list,
    :locals,
    :map,
    :max,
    :memoryview,
    :min,
    :next,
    :object,
    :oct,
    :open,
    :ord,
    :pow,
    :print,
    :property,
    :range,
    :repr,
    :reversed,
    :round,
    :set,
    :setattr,
    :slice,
    :sorted,
    :staticmethod,
    :str,
    :sum,
    :super,
    :tuple,
    :type,
    :vars,
    :zip,
    # exceptions
    :BaseException,
    :Exception,
    :StopIteration,
    :GeneratorExit,
    :ArithmeticError,
    :LookupError,
    :AssertionError,
    :AttributeError,
    :BufferError,
    :EOFError,
    :FloatingPointError,
    :OSError,
    :ImportError,
    :IndexError,
    :KeyError,
    :KeyboardInterrupt,
    :MemoryError,
    :NameError,
    :OverflowError,
    :RuntimeError,
    :RecursionError,
    :NotImplementedError,
    :SyntaxError,
    :IndentationError,
    :TabError,
    :ReferenceError,
    :SystemError,
    :SystemExit,
    :TypeError,
    :UnboundLocalError,
    :UnicodeError,
    :UnicodeEncodeError,
    :UnicodeDecodeError,
    :UnicodeTranslateError,
    :ValueError,
    :ZeroDivisionError,
    :BlockingIOError,
    :BrokenPipeError,
    :ChildProcessError,
    :ConnectionError,
    :ConnectionAbortedError,
    :ConnectionRefusedError,
    :FileExistsError,
    :FileNotFoundError,
    :InterruptedError,
    :IsADirectoryError,
    :NotADirectoryError,
    :PermissionError,
    :ProcessLookupError,
    :TimeoutError,
    :EnvironmentError,
    :IOError,
    :Warning,
    :UserWarning,
    :DeprecationWarning,
    :PendingDeprecationWarning,
    :SyntaxWarning,
    :RuntimeWarning,
    :FutureWarning,
    :ImportWarning,
    :UnicodeWarning,
    :BytesWarning,
    :ResourceWarning,
])

# Populate the pybuiltins module imported from API
@eval pybuiltins begin
$([:(const $k = $pynew()) for k in BUILTINS]...)
end

for k in BUILTINS
    if k == :help
        # help is only available in interactive contexts (imported by the 'site' module)
        # see: https://docs.python.org/3/library/functions.html#help
        # see: https://github.com/JuliaPy/PythonCall.jl/issues/248
        push!(
            INIT_CONSTS_CODE,
            :(pycopy!(
                pybuiltins.$k,
                pygetattr(pybuiltinsmodule, $(string(k)), pybuiltins.None),
            )),
        )
    else
        push!(
            INIT_CONSTS_CODE,
            :(pycopy!(pybuiltins.$k, pygetattr(pybuiltinsmodule, $(string(k))))),
        )
    end
end

@eval function init_consts()
    $(INIT_CONSTS_CODE...)
    return
end

const pymodulehooks = pynew()

function init_stdlib()

    # check word size
    pywordsize = pygt(Bool, pysysmodule.maxsize, Int64(2)^32) ? 64 : 32
    pywordsize == Sys.WORD_SIZE ||
        error("Julia is $(Sys.WORD_SIZE)-bit but Python is $(pywordsize)-bit")

    if C.CTX.is_embedded

        # This uses some internals, but Base._start() gets the state more like Julia
        # is if you call the executable directly, in particular it creates workers when
        # the --procs argument is given.
        push!(Base.Core.ARGS, joinpath(ROOT_DIR, "pysrc", "juliacall", "init.jl"))
        Base._start()
        Base.eval(:(PROGRAM_FILE = ""))

        # if Python is interactive, ensure Julia is too
        if pyhasattr(pysysmodule, "ps1")
            Base.eval(:(is_interactive = true))
            Base.load_InteractiveUtils()
        end

    else

        # set sys.argv
        pysysmodule.argv = pylist([""; ARGS])

        # some modules test for interactivity by checking if sys.ps1 exists
        if isinteractive() && !pyhasattr(pysysmodule, "ps1")
            pysysmodule.ps1 = ">>> "
        end

        # add hook to perform certain actions when certain modules are loaded
        g = pydict()
        pyexec(
            """
     import sys
     class JuliaCompatHooks:
         def __init__(self):
             self.hooks = {}
         def find_spec(self, name, path=None, target=None):
             hs = self.hooks.get(name)
             if hs is not None:
                 for h in hs:
                     h()
         def add_hook(self, name, h):
             if name not in self.hooks:
                 self.hooks[name] = [h]
             else:
                 self.hooks[name].append(h)
             if name in sys.modules:
                 h()
     JULIA_COMPAT_HOOKS = JuliaCompatHooks()
     sys.meta_path.insert(0, JULIA_COMPAT_HOOKS)
     """,
            g,
        )
        pycopy!(pymodulehooks, g["JULIA_COMPAT_HOOKS"])
    end

end

incref(x::C.PyPtr) = (C.Py_IncRef(x); x)
decref(x::C.PyPtr) = (C.Py_DecRef(x); x)

"""
    ispy(x)

True if `x` is a Python object.

This includes `Py` and Python wrapper types such as `PyList`.
"""
ispy(x) = false

"""
    pyisnull(x)

True if the Python object `x` is NULL.
"""
pyisnull(x) = getptr(x) == C.PyNULL

"""
    getptr(x)

Get the underlying pointer from the Python object `x`.
"""
getptr(x) = ispy(x) ? getptr(Py(x)::Py) : throw(MethodError(getptr, (x,)))

py_finalizer(x::Py) = GC.enqueue(getptr(x))

ispy(::Py) = true
getptr(x::Py) = C.PyPtr(getfield(x, :ptr))
pyconvert(::Type{Py}, x::Py) = x

setptr!(x::Py, ptr::C.PyPtr) = (setfield!(x, :ptr, Ptr{Cvoid}(ptr)); x)

incref(x::Py) = Base.GC.@preserve x (incref(getptr(x)); x)
decref(x::Py) = Base.GC.@preserve x (decref(getptr(x)); x)

Base.unsafe_convert(::Type{C.PyPtr}, x::Py) = getptr(x)

"""
    pynew([ptr])

A new `Py` representing the Python object at `ptr` (NULL by default).

If `ptr` is given and non-NULL, this function steals a reference to the Python object it
points at, i.e. the new `Py` object owns a reference.

Note that NULL Python objects are not safe in the sense that most API functions will probably
crash your Julia session if you pass a NULL argument.
"""
pynew() = Py(Val(:new), C.PyNULL)

const PyNULL = pynew()

pynew(ptr::C.PyPtr) = setptr!(pynew(), ptr)

pynew(x::Py) = Base.GC.@preserve x pynew(incref(getptr(x)))

"""
    pycopy!(dst::Py, src)

Copy the Python object `src` into `dst`, so that they both represent the same object.

This function exists to support module-level constant Python objects. It is illegal to call
most PythonCall API functions at the top level of a module (i.e. before `__init__()` has run)
so you cannot do `const x = pything()` at the top level. Instead do `const x = pynew()` at
the top level then `pycopy!(x, pything())` inside `__init__()`.

Assumes `dst` is NULL, otherwise a memory leak will occur.
"""
pycopy!(dst::Py, src) = Base.GC.@preserve src setptr!(dst, incref(getptr(src)))

"""
    pydel!(x::Py)

Delete the Python object `x`.

DANGER! Use this function ONLY IF the Julia object `x` could have been garbage-collected
anyway, i.e. was about to become unreachable. This means you MUST KNOW that no other part of
the program has the Julia object `x`.

This decrements the reference count and sets the pointer to NULL.

Use this to eagerly free a Python object, rather than waiting for Julia's GC to finalize
it at some indeterminate point in the future.
"""
function pydel!(x::Py)
    ptr = getptr(x)
    if ptr != C.PyNULL
        C.Py_DecRef(ptr)
        setptr!(x, C.PyNULL)
    end
    return
end

macro autopy(args...)
    vs = args[1:end-1]
    ts = [Symbol(v, "_") for v in vs]
    body = args[end]
    # ans = gensym("ans")
    esc(quote
        # $([:($t = $ispy($v) ? $v : $Py($v)) for (t, v) in zip(ts, vs)]...)
        # $ans = $body
        # $([:($ispy($v) || $pydel!($t)) for (t, v) in zip(ts, vs)]...)
        # $ans
        $([:($t = $Py($v)) for (t, v) in zip(ts, vs)]...)
        $body
    end)
end

Py(x::Py) = x
Py(x::Nothing) = pybuiltins.None
Py(x::Bool) = x ? pybuiltins.True : pybuiltins.False
Py(x::Union{AbstractString,AbstractChar}) = pystr(x)
Py(x::Base.CodeUnits{UInt8,String}) = pybytes(x)
Py(x::Base.CodeUnits{UInt8,SubString{String}}) = pybytes(x)
Py(x::Tuple) = pytuple_fromiter(x)
Py(x::Pair) = pytuple_fromiter(x)
Py(x::Integer) = pyint(x)
Py(x::Rational{<:Integer}) = pyfraction(x)
Py(x::Union{Float16,Float32,Float64}) = pyfloat(x)
Py(x::Union{Complex{Float16},Complex{Float32},Complex{Float64}}) = pycomplex(x)
Py(x::AbstractRange{<:Integer}) = pyrange_fromrange(x)
Py(x::Date) = pydate(x)
Py(x::Time) = pytime(x)
Py(x::DateTime) = pydatetime(x)

Base.string(x::Py) = pyisnull(x) ? "<py NULL>" : pystr(String, x)
Base.print(io::IO, x::Py) = print(io, string(x))

function Base.show(io::IO, x::Py)
    if get(io, :typeinfo, Any) == Py
        if pyisnull(x)
            print(io, "NULL")
        else
            print(io, pyrepr(String, x))
        end
    else
        if pyisnull(x)
            print(io, "<py NULL>")
        else
            s = pyrepr(String, x)
            if startswith(s, "<") && endswith(s, ">")
                print(io, "<py ", SubString(s, 2))
            else
                print(io, "<py ", s, ">")
            end
        end
    end
end

function Base.show(io::IO, ::MIME"text/plain", o::Py)
    if pyisnull(o)
        str = "NULL"
    else
        str = pyrepr(String, o)
    end
    hasprefix = (get(io, :typeinfo, Any) != Py)::Bool
    compact = get(io, :compact, false)::Bool
    limit = get(io, :limit, true)::Bool
    if compact
        # compact should output a single line, which we force by replacing newline
        # characters with spaces
        str = replace(str, "\n" => " ")
    end
    multiline = '\n' in str
    prefix = !hasprefix ? "" : compact ? "Py: " : multiline ? "Python:\n" : "Python: "
    print(io, prefix)
    h, w = displaysize(io)
    if limit
        # limit: fit the printed text into the display size
        h, w = displaysize(io)
        h = max(h - 3, 5) # use 3 fewer lines to allow for the prompt, but always allow at least 5 lines
        if multiline
            # multiline: we truncate each line to the width of the screen, and skip
            #   middle lines if there are too many for the height
            h -= 1 # for the prefix
            lines = split(str, '\n')
            function printlines(io, lines, w)
                for (i, line) in enumerate(lines)
                    if i > 1
                        println(io)
                    end
                    if length(line) > w
                        print(io, line[1:nextind(line, 0, w - 1)], '…')
                    else
                        print(io, line)
                    end
                end
            end
            if length(lines) ≤ h
                printlines(io, lines, w)
            else
                h0 = cld(h - 1, 2)
                h1 = h - 1 - h0
                i0 = h0
                i1 = length(lines) - h1 + 1
                # this indent computation tries to center the "more lines" message near the
                # middle of the span of non-whitespace in lines
                indent = 0
                for (c0, c1) in zip(lines[i0], lines[i1])
                    if c0 == c1 && isspace(c0)
                        indent += 1
                    else
                        break
                    end
                end
                maxlen = min(w, max(length(lines[i0]), length(lines[i1])))
                msg = "... $(length(lines)-h0-h1) more lines ..."
                indent = max(0, fld(maxlen + indent - length(msg), 2))
                printlines(io, lines[1:h0], w)
                println(io)
                printstyled(io, " "^indent, msg, color = :light_black)
                println(io)
                printlines(io, lines[end-h1+1:end], w)
            end
        elseif compact
            # compact: we print up to one screen width, skipping characters in the
            #    middle if the string is too long for the width
            maxlen = w - length(prefix)
            if length(str) ≤ maxlen
                print(io, str)
            else
                gap = " ... "
                gaplen = length(gap)
                w0 = cld(maxlen - gaplen, 2)
                i0 = nextind(str, 1, w0 - 1)
                i1 = prevind(str, ncodeunits(str), maxlen - gaplen - w0 - 1)
                print(io, str[begin:i0])
                printstyled(io, gap, color = :light_black)
                print(io, str[i1:end])
            end
        else
            # single-line: we print up to one screenfull, skipping characters in the
            #    middle if the string is too long. We skip a whole line of characters.
            maxlen = h * w - length(prefix)
            if length(str) ≤ maxlen
                print(io, str)
            else
                h0 = cld(h - 1, 2)
                i0 = nextind(str, 0, h0 * w - length(prefix))
                h1 = h - 1 - h0
                i1 = prevind(str, ncodeunits(str) + 1, h1 * w)
                println(io, str[1:i0])
                msg = "... $(length(str[nextind(str,i0):prevind(str,i1)])) more chars ..."
                printstyled(
                    io,
                    " "^max(0, fld(w - length(msg), 2)),
                    msg,
                    color = :light_black,
                )
                println(io)
                print(io, str[i1:end])
            end
        end
    else
        print(io, str)
    end
end


Base.showable(::MIME"text/plain", ::Py) = true

Base.getproperty(x::Py, k::Symbol) = pygetattr(x, string(k))
Base.getproperty(x::Py, k::String) = pygetattr(x, k)

Base.hasproperty(x::Py, k::Symbol) = pyhasattr(x, string(k))
Base.hasproperty(x::Py, k::String) = pyhasattr(x, k)

Base.setproperty!(x::Py, k::Symbol, v) = pysetattr(x, string(k), v)
Base.setproperty!(x::Py, k::String, v) = pysetattr(x, k, v)

function _propertynames(x::Py, private::Bool)
    # this follows the logic of rlcompleter.py
    function classmembers(c)
        r = pydir(c)
        if pyhasattr(c, "__bases__")
            for b in c.__bases__
                r = pyiadd(r, classmembers(b))
            end
        end
        return r
    end

    words = pyset(pydir(x::Py))
    words.discard("__builtins__")
    if pyhasattr(x, "__class__")
        words.add("__class__")
        words.update(classmembers(x.__class__))
    end
    return Symbol[Symbol(pystr_asstring(word)) for word in words]
end

function Base.propertynames(x::Py, private::Bool = false)
    if C.PyGILState_Check() == 1
        _propertynames(x, private)
    else
        C.on_main_thread() do
            _propertynames(x, private)
        end::Vector{Symbol}
    end
end

Base.Bool(x::Py) = pytruth(x)

Base.length(x::Py) = pylen(x)

Base.getindex(x::Py, i) = pygetitem(x, i)
Base.getindex(x::Py, i...) = pygetitem(x, i)

Base.setindex!(x::Py, v, i) = (pysetitem(x, i, v); x)
Base.setindex!(x::Py, v, i...) = (pysetitem(x, i, v); x)

Base.delete!(x::Py, i) = (pydelitem(x, i); x)

Base.haskey(x::Py, i) = pyhasitem(x, i)

Base.get(x::Py, i, d) = pygetitem(x, i, d)

function Base.get(f::Base.Callable, x::Py, i)
    v = pygetitem(x, i, nothing)
    v === nothing ? f() : v
end

Base.get!(x::Py, i, d) =
    get(x, i) do
        pysetitem(x, i, d)
        pygetitem(x, i)
    end

Base.get!(f::Base.Callable, x::Py, i) =
    get(x, i) do
        pysetitem(x, i, f())
        pygetitem(x, i)
    end

Base.eltype(::Type{Py}) = Py

Base.IteratorSize(::Type{Py}) = Base.SizeUnknown()

function Base.iterate(x::Py, it::Py = pyiter(x))
    v = unsafe_pynext(it)
    if pyisnull(v)
        pydel!(it)
        nothing
    else
        (v, it)
    end
end

Base.in(v, x::Py) = pycontains(x, v)

Base.hash(x::Py, h::UInt) = reinterpret(UInt, Int(pyhash(x))) - 3h

Base.broadcastable(x::Py) = Ref(x)

(f::Py)(args...; kwargs...) = pycall(f, args...; kwargs...)

# comparisons
Base.:(==)(x::Py, y::Py) = pyeq(x, y)
Base.:(!=)(x::Py, y::Py) = pyne(x, y)
Base.:(<=)(x::Py, y::Py) = pyle(x, y)
Base.:(<)(x::Py, y::Py) = pylt(x, y)
Base.:(>=)(x::Py, y::Py) = pyge(x, y)
Base.:(>)(x::Py, y::Py) = pygt(x, y)
Base.isless(x::Py, y::Py) = pylt(Bool, x, y)
Base.isequal(x::Py, y::Py) = pyeq(Bool, x, y)

# we also allow comparison with numbers
Base.:(==)(x::Py, y::Number) = pyeq(x, y)
Base.:(!=)(x::Py, y::Number) = pyne(x, y)
Base.:(<=)(x::Py, y::Number) = pyle(x, y)
Base.:(<)(x::Py, y::Number) = pylt(x, y)
Base.:(>=)(x::Py, y::Number) = pyge(x, y)
Base.:(>)(x::Py, y::Number) = pygt(x, y)
Base.isless(x::Py, y::Number) = pylt(Bool, x, y)
Base.isequal(x::Py, y::Number) = pyeq(Bool, x, y)

Base.:(==)(x::Number, y::Py) = pyeq(x, y)
Base.:(!=)(x::Number, y::Py) = pyne(x, y)
Base.:(<=)(x::Number, y::Py) = pyle(x, y)
Base.:(<)(x::Number, y::Py) = pylt(x, y)
Base.:(>=)(x::Number, y::Py) = pyge(x, y)
Base.:(>)(x::Number, y::Py) = pygt(x, y)
Base.isless(x::Number, y::Py) = pylt(Bool, x, y)
Base.isequal(x::Number, y::Py) = pyeq(Bool, x, y)

Base.zero(::Type{Py}) = pyint(0)
Base.one(::Type{Py}) = pyint(1)

# unary arithmetic
Base.:(+)(x::Py) = pypos(x)
Base.:(-)(x::Py) = pyneg(x)
Base.abs(x::Py) = pyabs(x)
Base.:(~)(x::Py) = pyinv(x)

# binary arithmetic
Base.:(+)(x::Py, y::Py) = pyadd(x, y)
Base.:(-)(x::Py, y::Py) = pysub(x, y)
Base.:(*)(x::Py, y::Py) = pymul(x, y)
# Base.:(+)(x::Py, y::Py) = pymatmul(x, y)
Base.div(x::Py, y::Py) = pyfloordiv(x, y)
Base.:(/)(x::Py, y::Py) = pytruediv(x, y)
Base.rem(x::Py, y::Py) = pymod(x, y)
# Base.:(+)(x::Py, y::Py) = pydivmod(x, y)
Base.:(<<)(x::Py, y::Py) = pylshift(x, y)
Base.:(>>)(x::Py, y::Py) = pyrshift(x, y)
Base.:(&)(x::Py, y::Py) = pyand(x, y)
Base.xor(x::Py, y::Py) = pyxor(x, y)
Base.:(|)(x::Py, y::Py) = pyor(x, y)
Base.:(^)(x::Py, y::Py) = pypow(x, y)

# also allow binary arithmetic with numbers
Base.:(+)(x::Number, y::Py) = pyadd(x, y)
Base.:(-)(x::Number, y::Py) = pysub(x, y)
Base.:(*)(x::Number, y::Py) = pymul(x, y)
# Base.:(+)(x::Number, y::Py) = pymatmul(x, y)
Base.div(x::Number, y::Py) = pyfloordiv(x, y)
Base.:(/)(x::Number, y::Py) = pytruediv(x, y)
Base.rem(x::Number, y::Py) = pymod(x, y)
# Base.:(+)(x::Number, y::Py) = pydivmod(x, y)
Base.:(<<)(x::Number, y::Py) = pylshift(x, y)
Base.:(>>)(x::Number, y::Py) = pyrshift(x, y)
Base.:(&)(x::Number, y::Py) = pyand(x, y)
Base.xor(x::Number, y::Py) = pyxor(x, y)
Base.:(|)(x::Number, y::Py) = pyor(x, y)
Base.:(^)(x::Number, y::Py) = pypow(x, y)

Base.:(+)(x::Py, y::Number) = pyadd(x, y)
Base.:(-)(x::Py, y::Number) = pysub(x, y)
Base.:(*)(x::Py, y::Number) = pymul(x, y)
# Base.:(+)(x::Py, y::Number) = pymatmul(x, y)
Base.div(x::Py, y::Number) = pyfloordiv(x, y)
Base.:(/)(x::Py, y::Number) = pytruediv(x, y)
Base.rem(x::Py, y::Number) = pymod(x, y)
# Base.:(+)(x::Py, y::Number) = pydivmod(x, y)
Base.:(<<)(x::Py, y::Number) = pylshift(x, y)
Base.:(>>)(x::Py, y::Number) = pyrshift(x, y)
Base.:(&)(x::Py, y::Number) = pyand(x, y)
Base.xor(x::Py, y::Number) = pyxor(x, y)
Base.:(|)(x::Py, y::Number) = pyor(x, y)
Base.:(^)(x::Py, y::Number) = pypow(x, y)

Base.powermod(x::Py, y::Py, z::Py) = pypow(x, y, z)
Base.powermod(x::Number, y::Py, z::Py) = pypow(x, y, z)
Base.powermod(x::Py, y::Number, z::Py) = pypow(x, y, z)
Base.powermod(x::Py, y::Py, z::Number) = pypow(x, y, z)
Base.powermod(x::Number, y::Number, z::Py) = pypow(x, y, z)
Base.powermod(x::Number, y::Py, z::Number) = pypow(x, y, z)
Base.powermod(x::Py, y::Number, z::Number) = pypow(x, y, z)

# documentation
function Base.Docs.getdoc(x::Py, @nospecialize(sig) = Union{})
    pyisnull(x) && return nothing
    parts = []
    inspect = pyimport("inspect")
    # head line
    if pytruth(inspect.ismodule(x))
        desc = pyhasattr(x, "__path__") ? "package" : "module"
        name = "$(x.__name__)"
    elseif pytruth(inspect.isgetsetdescriptor(x))
        desc = "getset descriptor"
        name = "$(x.__objclass__.__name__).$(x.__name__)"
    elseif pytruth(inspect.ismemberdescriptor(x))
        desc = "member descriptor"
        name = "$(x.__objclass__.__name__).$(x.__name__)"
    elseif pytruth(inspect.isclass(x))
        desc = "class"
        name = "$(x.__name__)"
    elseif pytruth(inspect.isfunction(x)) || pytruth(inspect.isbuiltin(x))
        desc = "function"
        name = "$(x.__name__)"
    elseif pytruth(inspect.ismethod(x))
        desc = "method"
        name = "$(x.__name__)"
    else
        desc = "object of type"
        name = "$(pytype(x).__name__)"
    end
    push!(parts, Markdown.Paragraph(["Python $desc ", Markdown.Code(name), "."]))
    # docstring
    doc = pyimport("inspect").getdoc(x)
    if !pyisnone(doc)
        push!(parts, Markdown.Code("text", pystr_asstring(doc)))
    end
    return Markdown.MD(parts)
end
Base.Docs.doc(x::Py, sig::Type = Union{}) = Base.Docs.getdoc(x, sig)
Base.Docs.Binding(x::Py, k::Symbol) = getproperty(x, k)

# C
function python_executable_path end
function python_library_handle end
function python_library_path end
function python_version end

# Core
function getptr end
function ispy end
function pyabs end
function pyadd end
function pyall end
function pyand end
function pyany end
function pyascii end
function pybool end
function pybytes end
function pycall end
function pycallable end
function pycollist end
function pycompile end
function pycomplex end
function pycontains end
function pycopy! end
function pydate end
function pydatetime end
function pydel! end
function pydelattr end
function pydelitem end
function pydict end
function pydir end
function pydivmod end
function pyeq end
function pyeval end
function pyexec end
function pyfloat end
function pyfloordiv end
function pyfraction end
function pyfrozenset end
function pyge end
function pygetattr end
function pygetitem end
function pygt end
function pyhasattr end
function pyhash end
function pyhasitem end
function pyhelp end
function pyiadd end
function pyiand end
function pyifloordiv end
function pyilshift end
function pyimatmul end
function pyimod end
function pyimport end
function pyimul end
function pyin end
function pyindex end
function pyint end
function pyinv end
function pyior end
function pyipow end
function pyirshift end
function pyis end
function pyisinstance end
function pyisnull end
function pyissubclass end
function pyisub end
function pyiter end
function pyitruediv end
function pyixor end
function pyle end
function pylen end
function pylist end
function pylshift end
function pylt end
function pymatmul end
function pymod end
function pymul end
function pyne end
function pyneg end
function pynew end
function pynext end
function pynot end
function pyor end
function pypos end
function pypow end
function pyprint end
function pyrange end
function pyrepr end
function pyrowlist end
function pyrshift end
function pyset end
function pysetattr end
function pysetitem end
function pyslice end
function pystr end
function pysub end
function pytime end
function pytruediv end
function pytruth end
function pytuple end
function pytype end
function pywith end
function pyxor end
function unsafe_pynext end

# Convert
function pyconvert end
function pyconvert_add_rule end
function pyconvert_return end
function pyconvert_unconverted end

# JlWrap
function pybinaryio end
function pyclassmethod end
function pyfunc end
function pyisjl end
function pyjl end
function pyjlraw end
function pyjltype end
function pyjlvalue end
function pyproperty end
function pystaticmethod end
function pytextio end

# Compat
function event_loop_off end
function event_loop_on end
function fix_qt_plugin_path end
function pytable end

"""
    module PythonCall.Compat

Misc bits and bobs for compatibility.
"""
module Compat

using ..PythonCall
using ..Utils
using ..C
using ..Core
using ..Wrap

using Serialization: Serialization, AbstractSerializer, serialize, deserialize
using Tables: Tables

import ..PythonCall: event_loop_on, event_loop_off, fix_qt_plugin_path, pytable

include("gui.jl")
include("ipython.jl")
include("multimedia.jl")
include("serialization.jl")
include("tables.jl")

function __init__()
    init_gui()
    init_pyshow()
end

end

@testitem "gui" setup=[Setup] begin
    @testset "fix_qt_plugin_path" begin
        @test PythonCall.fix_qt_plugin_path() isa Bool
        # second time is a no-op
        @test PythonCall.fix_qt_plugin_path() === false
    end
    @testset "event_loop_on/off" begin
        @testset "$g" for g in [:pyqt4, :pyqt5, :pyside, :pyside2, :pyside6, :gtk, :gtk3, :wx]
            # TODO: actually test the various GUIs somehow?
            if Setup.devdeps && g == :pyside6
                # pyside6 is installed as a dev dependency
                # AND it's a dependency of matplotlib, which is also a dev dependency
                @test PythonCall.event_loop_on(g) isa Timer
            else
                @test_throws PyException PythonCall.event_loop_on(g)
            end
            @test PythonCall.event_loop_off(g) === nothing
        end
    end
    @testset "matplotlib issue 676" begin
        if Setup.devdeps
            plt = pyimport("matplotlib.pyplot")
            @test plt.get_backend() isa Py
        end
    end
end

@testitem "ipython" begin
    @testset "PythonDisplay" begin
        sys = pyimport("sys")
        io = pyimport("io")
        pystdout = sys.stdout
        fp = sys.stdout = io.StringIO()
        try
            d = PythonCall.Compat.PythonDisplay()
            @test display(d, 123) === nothing
            fp.seek(0)
            @test pyconvert(String, fp.read()) == "123\n"
        finally
            sys.stdout = pystdout
        end
    end
    @testset "IPythonDisplay" begin
        # TODO
    end
end

@testitem "multimedia" begin
    # TODO
end

@testitem "PyCall.jl" begin
    if (get(ENV, "CI", "") != "") && (ENV["JULIA_PYTHONCALL_EXE"] == "python") && !PythonCall.C.CTX.is_free_threaded
        # Only run this test when we can guarantee PyCall and PythonCall are using the
        # same Python. Currently this only runs in CI, and if PythonCall is using the
        # system Python installation. Also PyCall is not compatible with free-threaded
        # python so we skip this too.
        using PyCall
        # Check they are indeed using the same Python.
        @test Base.get_extension(PythonCall, :PyCallExt).SAME[]
        # Check we can round-trip and object PythonCall -> PyCall -> PythonCall and
        # have the same identical Python object afterward.
        x1 = pylist()::Py
        x2 = PyCall.PyObject(x1)::PyCall.PyObject
        x3 = Py(x2)::Py
        @test pyis(x3, x1)
    else
        @warn "Skipping PyCall.jl tests."
    end
end

@testitem "Serialization.jl" begin
    using Serialization
    @testset "Py" begin
        for x in Py[
            Py(123),
            Py(1.23),
            Py("hello"),
            pylist([1, 2, 3]),
            pytuple([1, 2, 3]),
            Py(nothing),
            Py([1, 2, 3]),
            Py(:hello),
        ]
            io = IOBuffer()
            serialize(io, x)
            seekstart(io)
            y = deserialize(io)
            @test y isa Py
            @test pyis(pytype(x), pytype(y))
            @test pyeq(Bool, x, y)
        end
    end
    @testset "PyException" begin
        for e in Py[pybuiltins.ValueError("hello")]
            io = IOBuffer()
            x = PyException(e)
            serialize(io, x)
            seekstart(io)
            y = deserialize(io)
            @test y isa PyException
            @test pyeq(Bool, y.t, x.t)
            @test pyeq(Bool, y.v.args, x.v.args)
        end
    end
end

@testitem "Tables.jl" setup=[Setup] begin
    @testset "pytable" begin
        x = (x = [1, 2, 3], y = ["a", "b", "c"])
        # pandas
        if Setup.devdeps
            y = pytable(x, :pandas)
            @test pyeq(Bool, pytype(y), pyimport("pandas").DataFrame)
        end
        # columns
        y = pytable(x, :columns)
        @test pyeq(Bool, y, pydict(x = [1, 2, 3], y = ["a", "b", "c"]))
        # rows
        y = pytable(x, :rows)
        @test pyeq(Bool, y, pylist([(1, "a"), (2, "b"), (3, "c")]))
        @test all(pyisinstance(y.x, pybuiltins.int) for y in y)
        @test all(pyisinstance(y.y, pybuiltins.str) for y in y)
        # rowdicts
        y = pytable(x, :rowdicts)
        @test pyeq(
            Bool,
            y,
            pylist([
                pydict(x = 1, y = "a"),
                pydict(x = 2, y = "b"),
                pydict(x = 3, y = "c"),
            ]),
        )
    end
end

# Core
export @py
export @pyconst
export @pyeval
export @pyexec
export ispy
export Py
export pyabs
export pyadd
export pyall
export pyand
export pyany
export pyascii
export pybool
export pybuiltins
export pybytes
export pycall
export pycallable
export pycollist
export pycompile
export pycomplex
export pycontains
export pydate
export pydatetime
export pydelattr
export pydelitem
export pydict
export pydir
export pydivmod
export pyeq
export pyeval
export PyException
export pyexec
export pyfloat
export pyfloordiv
export pyfraction
export pyfrozenset
export pyge
export pygetattr
export pygetitem
export pygt
export pyhasattr
export pyhash
export pyhasitem
export pyhelp
export pyiadd
export pyiand
export pyifloordiv
export pyilshift
export pyimatmul
export pyimod
export pyimport
export pyimul
export pyin
export pyindex
export pyint
export pyinv
export pyior
export pyipow
export pyirshift
export pyis
export pyisinstance
export pyissubclass
export pyisub
export pyiter
export pyitruediv
export pyixor
export pyle
export pylen
export pylist
export pylshift
export pylt
export pymatmul
export pymod
export pymul
export pyne
export pyneg
export pynext
export pynot
export pyor
export pypos
export pypow
export pyprint
export pyrange
export pyrepr
export pyrowlist
export pyrshift
export pyset
export pysetattr
export pysetitem
export pyslice
export pystr
export pysub
export pytime
export pytruediv
export pytruth
export pytuple
export pytype
export pywith
export pyxor

# Convert
export @pyconvert
export pyconvert
export pyconvert_add_rule
export PYCONVERT_PRIORITY_ARRAY
export PYCONVERT_PRIORITY_CANONICAL
export PYCONVERT_PRIORITY_FALLBACK
export PYCONVERT_PRIORITY_NORMAL
export PYCONVERT_PRIORITY_WRAP
export pyconvert_return
export pyconvert_unconverted

# Wrap
export PyArray
export PyDict
export PyIO
export PyIterable
export PyList
export PyPandasDataFrame
export PySet
export PyTable

# JlWrap
export pybinaryio
export pyclassmethod
export pyfunc
export pyisjl
export pyjl
export pyjlraw
export pyjltype
export pyjlvalue
export PyObjectArray
export PyObjectMatrix
export PyObjectVector
export pyproperty
export pystaticmethod
export pytextio

# Compat
export pytable

const NAT = typemin(Int64)

const NAT_STRINGS = ("NaT", "nat", "NAT", "NaN", "nan", "NAN")

const DatesPeriod = Union{
    Dates.Year,
    Dates.Month,
    Dates.Week,
    Dates.Day,
    Dates.Hour,
    Dates.Minute,
    Dates.Second,
    Dates.Millisecond,
    Dates.Microsecond,
    Dates.Nanosecond,
}

const DatesInstant = Union{Dates.Date,Dates.DateTime}

function add(x::Integer, y::Integer)
    ans, err = Base.Checked.add_with_overflow(Int64(x), Int64(y))
    (err || ans == NAT) && throw(OverflowError("add"))
    ans
end

function sub(x::Integer, y::Integer)
    ans, err = Base.Checked.sub_with_overflow(Int64(x), Int64(y))
    (err || ans == NAT) && throw(OverflowError("sub"))
    ans
end

function mul(x::Integer, y::Integer)
    ans, err = Base.Checked.mul_with_overflow(Int64(x), Int64(y))
    (err || ans == NAT) && throw(OverflowError("mul"))
    ans
end

function convert_and_check(::Type{T}, x) where {T}
    ans = T(x)::T
    x2 = typeof(x)(ans)
    x == x2 || throw(InexactError(:convert, T, x))
    ans
end

# type

"""
    DateTime64(value, [unit])
    DateTime64(value, format, [unit])

Construct an `DateTime64` with the given `value` and [`unit`](@ref Unit).

The unit is stored as a run-time value. If the units in your code are known, using
[`InlineDateTime64{unit}`](@ref InlineDateTime64) may be preferable. The memory layout
is the same as for a `numpy.datetime64`.

The value can be:
- An `Integer`, in which case the `unit` is required.
- A `Dates.Date` or `Dates.DateTime`.
- `"NaT"` or `"NaN"` to make a not-a-time value.
- An `AbstractString`, which is parsed the same as `Dates.DateTime`, with an optional
  `format` string.
"""
struct DateTime64 <: AbstractDateTime64
    value::Int64
    unit::Tuple{Unit,Cint}
    function DateTime64(value::Integer, unit::UnitArg)
        new(Int(value), unitpair(unit))
    end
end

# accessors

Dates.value(d::DateTime64) = d.value

unitpair(d::DateTime64) = d.unit

# constructors

function DateTime64(d::AbstractDateTime64, unit::UnitArg = defaultunit(d))
    unit = unitpair(unit)
    if unit == unitpair(d)
        DateTime64(value(d), unit)
    elseif isnan(d)
        DateTime64(NAT, unit)
    else
        v, _ = rescale(value(d), unitpair(d), unit)
        DateTime64(v, unit)
    end
end

function DateTime64(d::AbstractString, unit::UnitArg = defaultunit(d))
    unit = unitpair(unit)
    if d in NAT_STRINGS
        DateTime64(NAT, unit)
    else
        DateTime64(Dates.DateTime(d), unit)
    end
end

function DateTime64(d::AbstractString, f::Dates.DateFormat, unit::UnitArg = defaultunit(d))
    unit = unitpair(unit)
    if d in NAT_STRINGS
        DateTime64(NAT, unit)
    else
        DateTime64(Dates.DateTime(d, f), unit)
    end
end

function DateTime64(d::Dates.DateTime, unit::UnitArg = defaultunit(d))
    u, _ = unit = unitpair(unit)
    if u == YEARS
        v_yr = sub(Dates.year(d), 1970)
        v, _ = rescale(v_yr, YEARS, unit)
    elseif u == MONTHS
        yr, mn = Dates.yearmonth(d)
        v_mn = add(mul(12, sub(yr, 1970)), sub(mn, 1))
        v, _ = rescale(v_mn, MONTHS, unit)
    else
        v_ms = d - Dates.DateTime(1970)
        v, _ = rescale(value(v_ms), Unit(v_ms), unit)
    end
    DateTime64(v, unit)
end


function DateTime64(d::Dates.Date, unit::UnitArg = defaultunit(d))
    DateTime64(Dates.DateTime(d), unit)
end

# convert

Base.convert(::Type{DateTime64}, x::DateTime64) = x
Base.convert(::Type{DateTime64}, x::AbstractDateTime64) = DateTime64(x)
Base.convert(::Type{DateTime64}, x::DatesInstant) = DateTime64(x)

# show

function Base.show(io::IO, d::DateTime64)
    if get(io, :typeinfo, Any) == typeof(d)
        showvalue(io, d)
    else
        show(io, typeof(d))
        print(io, "(")
        showvalue(io, d)
        print(io, ", ")
        show(io, unitparam(unitpair(d)))
        print(io, ")")
    end
    nothing
end

@testitem "DateTime64 from Date" begin
    using Dates
    using PythonCall: NumpyDates

    # Mapping from NumPy unit symbols to NumpyDates Unit constants
    const UNIT_CONST = Dict(
        :Y => NumpyDates.YEARS,
        :M => NumpyDates.MONTHS,
        :D => NumpyDates.DAYS,
        :h => NumpyDates.HOURS,
        :m => NumpyDates.MINUTES,
        :s => NumpyDates.SECONDS,
        :ms => NumpyDates.MILLISECONDS,
        :us => NumpyDates.MICROSECONDS,
        :ns => NumpyDates.NANOSECONDS,
    )

    # Data generated by: uv run scripts/np_dates_all_units.py
    # Format: (Date, unit_symbol, numpy_int_value)
    cases = [
        (Date(1969, 12, 31), :Y, -1),
        (Date(1969, 12, 31), :M, -1),
        (Date(1969, 12, 31), :D, -1),
        (Date(1969, 12, 31), :h, -24),
        (Date(1969, 12, 31), :m, -1440),
        (Date(1969, 12, 31), :s, -86400),
        (Date(1969, 12, 31), :ms, -86400000),
        (Date(1969, 12, 31), :us, -86400000000),
        (Date(1969, 12, 31), :ns, -86400000000000),
        (Date(1970, 1, 1), :Y, 0),
        (Date(1970, 1, 1), :M, 0),
        (Date(1970, 1, 1), :D, 0),
        (Date(1970, 1, 1), :h, 0),
        (Date(1970, 1, 1), :m, 0),
        (Date(1970, 1, 1), :s, 0),
        (Date(1970, 1, 1), :ms, 0),
        (Date(1970, 1, 1), :us, 0),
        (Date(1970, 1, 1), :ns, 0),
        (Date(1970, 1, 2), :Y, 0),
        (Date(1970, 1, 2), :M, 0),
        (Date(1970, 1, 2), :D, 1),
        (Date(1970, 1, 2), :h, 24),
        (Date(1970, 1, 2), :m, 1440),
        (Date(1970, 1, 2), :s, 86400),
        (Date(1970, 1, 2), :ms, 86400000),
        (Date(1970, 1, 2), :us, 86400000000),
        (Date(1970, 1, 2), :ns, 86400000000000),
        (Date(1999, 12, 31), :Y, 29),
        (Date(1999, 12, 31), :M, 359),
        (Date(1999, 12, 31), :D, 10956),
        (Date(1999, 12, 31), :h, 262944),
        (Date(1999, 12, 31), :m, 15776640),
        (Date(1999, 12, 31), :s, 946598400),
        (Date(1999, 12, 31), :ms, 946598400000),
        (Date(1999, 12, 31), :us, 946598400000000),
        (Date(1999, 12, 31), :ns, 946598400000000000),
        (Date(2000, 2, 29), :Y, 30),
        (Date(2000, 2, 29), :M, 361),
        (Date(2000, 2, 29), :D, 11016),
        (Date(2000, 2, 29), :h, 264384),
        (Date(2000, 2, 29), :m, 15863040),
        (Date(2000, 2, 29), :s, 951782400),
        (Date(2000, 2, 29), :ms, 951782400000),
        (Date(2000, 2, 29), :us, 951782400000000),
        (Date(2000, 2, 29), :ns, 951782400000000000),
        (Date(1900, 1, 1), :Y, -70),
        (Date(1900, 1, 1), :M, -840),
        (Date(1900, 1, 1), :D, -25567),
        (Date(1900, 1, 1), :h, -613608),
        (Date(1900, 1, 1), :m, -36816480),
        (Date(1900, 1, 1), :s, -2208988800),
        (Date(1900, 1, 1), :ms, -2208988800000),
        (Date(1900, 1, 1), :us, -2208988800000000),
        (Date(1900, 1, 1), :ns, -2208988800000000000),
        (Date(2100, 1, 1), :Y, 130),
        (Date(2100, 1, 1), :M, 1560),
        (Date(2100, 1, 1), :D, 47482),
        (Date(2100, 1, 1), :h, 1139568),
        (Date(2100, 1, 1), :m, 68374080),
        (Date(2100, 1, 1), :s, 4102444800),
        (Date(2100, 1, 1), :ms, 4102444800000),
        (Date(2100, 1, 1), :us, 4102444800000000),
        (Date(2100, 1, 1), :ns, 4102444800000000000),
    ]

    @testset "$d $usym" for (d, usym, expected) in cases
        # 1) DateTime64 with UnitArg symbol
        dt64 = NumpyDates.DateTime64(d, usym)
        @test Dates.value(dt64) == expected

        # 2) InlineDateTime64 with type parameter Unit constant
        Uconst = UNIT_CONST[usym]
        inline_typed = NumpyDates.InlineDateTime64{Uconst}(d)
        @test Dates.value(inline_typed) == expected

        # 3) InlineDateTime64 with runtime UnitArg symbol
        inline_dyn = NumpyDates.InlineDateTime64(d, usym)
        @test Dates.value(inline_dyn) == expected
        @test NumpyDates.unitpair(inline_dyn) == NumpyDates.unitpair(usym)
    end
end

@testitem "DateTime64 from String" begin
    using Dates
    using PythonCall: NumpyDates

    # Data generated by: uv run test/scripts/np_dates.py
    # Format: (string_date, unit_symbol, numpy_int_value)
    cases = [
        ("1969-12-31", :Y, -1),
        ("1969-12-31", :M, -1),
        ("1969-12-31", :D, -1),
        ("1969-12-31", :h, -24),
        ("1969-12-31", :m, -1440),
        ("1969-12-31", :s, -86400),
        ("1969-12-31", :ms, -86400000),
        ("1969-12-31", :us, -86400000000),
        ("1969-12-31", :ns, -86400000000000),
        ("1970-01-01", :Y, 0),
        ("1970-01-01", :M, 0),
        ("1970-01-01", :D, 0),
        ("1970-01-01", :h, 0),
        ("1970-01-01", :m, 0),
        ("1970-01-01", :s, 0),
        ("1970-01-01", :ms, 0),
        ("1970-01-01", :us, 0),
        ("1970-01-01", :ns, 0),
        ("1970-01-02", :Y, 0),
        ("1970-01-02", :M, 0),
        ("1970-01-02", :D, 1),
        ("1970-01-02", :h, 24),
        ("1970-01-02", :m, 1440),
        ("1970-01-02", :s, 86400),
        ("1970-01-02", :ms, 86400000),
        ("1970-01-02", :us, 86400000000),
        ("1970-01-02", :ns, 86400000000000),
        ("1999-12-31", :Y, 29),
        ("1999-12-31", :M, 359),
        ("1999-12-31", :D, 10956),
        ("1999-12-31", :h, 262944),
        ("1999-12-31", :m, 15776640),
        ("1999-12-31", :s, 946598400),
        ("1999-12-31", :ms, 946598400000),
        ("1999-12-31", :us, 946598400000000),
        ("1999-12-31", :ns, 946598400000000000),
        ("2000-02-29", :Y, 30),
        ("2000-02-29", :M, 361),
        ("2000-02-29", :D, 11016),
        ("2000-02-29", :h, 264384),
        ("2000-02-29", :m, 15863040),
        ("2000-02-29", :s, 951782400),
        ("2000-02-29", :ms, 951782400000),
        ("2000-02-29", :us, 951782400000000),
        ("2000-02-29", :ns, 951782400000000000),
        ("1900-01-01", :Y, -70),
        ("1900-01-01", :M, -840),
        ("1900-01-01", :D, -25567),
        ("1900-01-01", :h, -613608),
        ("1900-01-01", :m, -36816480),
        ("1900-01-01", :s, -2208988800),
        ("1900-01-01", :ms, -2208988800000),
        ("1900-01-01", :us, -2208988800000000),
        ("1900-01-01", :ns, -2208988800000000000),
        ("2100-01-01", :Y, 130),
        ("2100-01-01", :M, 1560),
        ("2100-01-01", :D, 47482),
        ("2100-01-01", :h, 1139568),
        ("2100-01-01", :m, 68374080),
        ("2100-01-01", :s, 4102444800),
        ("2100-01-01", :ms, 4102444800000),
        ("2100-01-01", :us, 4102444800000000),
        ("2100-01-01", :ns, 4102444800000000000),
    ]

    @testset "$s $usym" for (s, usym, expected) in cases
        # DateTime64 from string
        dt64 = NumpyDates.DateTime64(s, usym)
        @test Dates.value(dt64) == expected

        # Inline typed from string
        Uconst = NumpyDates.Unit(usym)
        inline_typed = NumpyDates.InlineDateTime64{Uconst}(s)
        @test Dates.value(inline_typed) == expected

        # Inline dynamic from string
        inline_dyn = NumpyDates.InlineDateTime64(s, usym)
        @test Dates.value(inline_dyn) == expected
        @test NumpyDates.unitpair(inline_dyn) == NumpyDates.unitpair(usym)
    end

    # NaT string handling (all should produce NaT)
    @testset "$nat" for nat in ("NaT", "nan", "NAN")
        d1 = NumpyDates.DateTime64(nat, :D)
        @test isnan(d1)
        d2 = NumpyDates.InlineDateTime64{NumpyDates.DAYS}(nat)
        @test isnan(d2)
        d3 = NumpyDates.InlineDateTime64(nat, :D)
        @test isnan(d3)
    end
end

@testitem "DateTime64 from String and DateFormat" begin
    using Dates
    using PythonCall: NumpyDates

    # Data based on: uv run test/scripts/np_dates.py and uv run test/scripts/np_datetimes.py
    # We deliberately use formats that differ from the default parser to exercise the (str, format, unit) constructors.
    cases = [
        # date-only with custom format
        ("1999/12/31", DateFormat("yyyy/mm/dd"), :D, 10956),
        ("1999/12/31", DateFormat("yyyy/mm/dd"), :s, 946598400),
        # datetime with custom format
        ("2000-02-29 12:34:56", DateFormat("yyyy-mm-dd HH:MM:SS"), :s, 951_827_696),
        (
            "2000-02-29 12:34:56",
            DateFormat("yyyy-mm-dd HH:MM:SS"),
            :ns,
            951_827_696_000_000_000,
        ),
    ]

    @testset "$s $f $usym" for (s, f, usym, expected) in cases
        # DateTime64 from string + format
        dt64 = NumpyDates.DateTime64(s, f, usym)
        @test Dates.value(dt64) == expected

        # Inline typed from string + format
        Uconst = NumpyDates.Unit(usym)
        inline_typed = NumpyDates.InlineDateTime64{Uconst}(s, f)
        @test Dates.value(inline_typed) == expected

        # NOTE: InlineDateTime64(s, f, u) dynamic constructor is not exercised here
        # because it currently dispatches to InlineTimeDelta64 in the implementation.
        # When fixed, we can add:
        # inline_dyn = NumpyDates.InlineDateTime64(s, f, usym)
        # @test Dates.value(inline_dyn) == expected
    end
end

@testitem "DateTime64 from AbstractDateTime64" begin
    using Dates
    using PythonCall: NumpyDates

    # Pass-through when units match
    d = Date(1970, 1, 2)
    x = NumpyDates.DateTime64(d, :D)  # expected value 1
    y = NumpyDates.DateTime64(x, :D)
    @test Dates.value(y) == 1
    @test NumpyDates.unitpair(y) == NumpyDates.unitpair(:D)

    # NaT changes unit and remains NaT
    nat_d = NumpyDates.DateTime64("NaT", :D)
    z = NumpyDates.DateTime64(nat_d, :s)
    @test isnan(z)
    @test NumpyDates.unitpair(z) == NumpyDates.unitpair(:s)
end

@testitem "DateTime64 from Integer" begin
    using Dates
    using PythonCall: NumpyDates

    # DateTime64(value, unit)
    x = NumpyDates.DateTime64(946_684_799, :s)   # 1999-12-31T23:59:59
    @test Dates.value(x) == 946_684_799
    @test Dates.DateTime(x) == DateTime(1999, 12, 31, 23, 59, 59)

    y = NumpyDates.DateTime64(10_956, :D)        # 1999-12-31
    @test Dates.value(y) == 10_956
    @test Dates.Date(y) == Date(1999, 12, 31)

    # InlineDateTime64{U}(value)
    s1 = NumpyDates.InlineDateTime64{NumpyDates.SECONDS}(3_600) # +1 hour
    @test Dates.value(s1) == 3_600
    @test Dates.DateTime(s1) == DateTime(1970, 1, 1, 1, 0, 0)

    # InlineDateTime64 with multiplier in the unit parameter
    s2 = NumpyDates.InlineDateTime64{(NumpyDates.SECONDS, 2)}(1_800) # 1_800 * 2s = 3_600s
    @test Dates.value(s2) == 1_800
    @test Dates.DateTime(s2) == DateTime(1970, 1, 1, 1, 0, 0)
end

@testitem "DateTime64 from Dates.DateTime" begin
    using Dates
    using PythonCall: NumpyDates

    # Data generated by: uv run test/scripts/np_dates.py
    # Format: (Date, unit_symbol, numpy_int_value)
    cases = [
        (DateTime(1969, 12, 31, 23, 0, 0), :Y, -1),
        (DateTime(1969, 12, 31, 23, 0, 0), :M, -1),
        (DateTime(1969, 12, 31, 23, 0, 0), :D, -1),
        (DateTime(1969, 12, 31, 23, 0, 0), :h, -1),
        (DateTime(1969, 12, 31, 23, 0, 0), :m, -60),
        (DateTime(1969, 12, 31, 23, 0, 0), :s, -3600),
        (DateTime(1969, 12, 31, 23, 0, 0), :ms, -3_600_000),
        (DateTime(1969, 12, 31, 23, 0, 0), :us, -3_600_000_000),
        (DateTime(1969, 12, 31, 23, 0, 0), :ns, -3_600_000_000_000),
        (DateTime(1969, 12, 31, 23, 59, 59), :Y, -1),
        (DateTime(1969, 12, 31, 23, 59, 59), :M, -1),
        (DateTime(1969, 12, 31, 23, 59, 59), :D, -1),
        (DateTime(1969, 12, 31, 23, 59, 59), :h, -1),
        (DateTime(1969, 12, 31, 23, 59, 59), :m, -1),
        (DateTime(1969, 12, 31, 23, 59, 59), :s, -1),
        (DateTime(1969, 12, 31, 23, 59, 59), :ms, -1_000),
        (DateTime(1969, 12, 31, 23, 59, 59), :us, -1_000_000),
        (DateTime(1969, 12, 31, 23, 59, 59), :ns, -1_000_000_000),
        (DateTime(1970, 1, 1, 0, 0, 0), :Y, 0),
        (DateTime(1970, 1, 1, 0, 0, 0), :M, 0),
        (DateTime(1970, 1, 1, 0, 0, 0), :D, 0),
        (DateTime(1970, 1, 1, 0, 0, 0), :h, 0),
        (DateTime(1970, 1, 1, 0, 0, 0), :m, 0),
        (DateTime(1970, 1, 1, 0, 0, 0), :s, 0),
        (DateTime(1970, 1, 1, 0, 0, 0), :ms, 0),
        (DateTime(1970, 1, 1, 0, 0, 0), :us, 0),
        (DateTime(1970, 1, 1, 0, 0, 0), :ns, 0),
        (DateTime(1970, 1, 1, 0, 0, 1), :Y, 0),
        (DateTime(1970, 1, 1, 0, 0, 1), :M, 0),
        (DateTime(1970, 1, 1, 0, 0, 1), :D, 0),
        (DateTime(1970, 1, 1, 0, 0, 1), :h, 0),
        (DateTime(1970, 1, 1, 0, 0, 1), :m, 0),
        (DateTime(1970, 1, 1, 0, 0, 1), :s, 1),
        (DateTime(1970, 1, 1, 0, 0, 1), :ms, 1_000),
        (DateTime(1970, 1, 1, 0, 0, 1), :us, 1_000_000),
        (DateTime(1970, 1, 1, 0, 0, 1), :ns, 1_000_000_000),
        (DateTime(1970, 1, 1, 1, 0, 0), :Y, 0),
        (DateTime(1970, 1, 1, 1, 0, 0), :M, 0),
        (DateTime(1970, 1, 1, 1, 0, 0), :D, 0),
        (DateTime(1970, 1, 1, 1, 0, 0), :h, 1),
        (DateTime(1970, 1, 1, 1, 0, 0), :m, 60),
        (DateTime(1970, 1, 1, 1, 0, 0), :s, 3_600),
        (DateTime(1970, 1, 1, 1, 0, 0), :ms, 3_600_000),
        (DateTime(1970, 1, 1, 1, 0, 0), :us, 3_600_000_000),
        (DateTime(1970, 1, 1, 1, 0, 0), :ns, 3_600_000_000_000),
        (DateTime(1999, 12, 31, 23, 59, 59), :Y, 29),
        (DateTime(1999, 12, 31, 23, 59, 59), :M, 359),
        (DateTime(1999, 12, 31, 23, 59, 59), :D, 10_956),
        (DateTime(1999, 12, 31, 23, 59, 59), :h, 262_967),
        (DateTime(1999, 12, 31, 23, 59, 59), :m, 15_778_079),
        (DateTime(1999, 12, 31, 23, 59, 59), :s, 946_684_799),
        (DateTime(1999, 12, 31, 23, 59, 59), :ms, 946_684_799_000),
        (DateTime(1999, 12, 31, 23, 59, 59), :us, 946_684_799_000_000),
        (DateTime(1999, 12, 31, 23, 59, 59), :ns, 946_684_799_000_000_000),
        (DateTime(2000, 2, 29, 12, 34, 56), :Y, 30),
        (DateTime(2000, 2, 29, 12, 34, 56), :M, 361),
        (DateTime(2000, 2, 29, 12, 34, 56), :D, 11_016),
        (DateTime(2000, 2, 29, 12, 34, 56), :h, 264_396),
        (DateTime(2000, 2, 29, 12, 34, 56), :m, 15_863_794),
        (DateTime(2000, 2, 29, 12, 34, 56), :s, 951_827_696),
        (DateTime(2000, 2, 29, 12, 34, 56), :ms, 951_827_696_000),
        (DateTime(2000, 2, 29, 12, 34, 56), :us, 951_827_696_000_000),
        (DateTime(2000, 2, 29, 12, 34, 56), :ns, 951_827_696_000_000_000),
        (DateTime(1900, 1, 1, 0, 0, 0), :Y, -70),
        (DateTime(1900, 1, 1, 0, 0, 0), :M, -840),
        (DateTime(1900, 1, 1, 0, 0, 0), :D, -25_567),
        (DateTime(1900, 1, 1, 0, 0, 0), :h, -613_608),
        (DateTime(1900, 1, 1, 0, 0, 0), :m, -36_816_480),
        (DateTime(1900, 1, 1, 0, 0, 0), :s, -2_208_988_800),
        (DateTime(1900, 1, 1, 0, 0, 0), :ms, -2_208_988_800_000),
        (DateTime(1900, 1, 1, 0, 0, 0), :us, -2_208_988_800_000_000),
        (DateTime(1900, 1, 1, 0, 0, 0), :ns, -2_208_988_800_000_000_000),
        (DateTime(2100, 1, 1, 0, 0, 0), :Y, 130),
        (DateTime(2100, 1, 1, 0, 0, 0), :M, 1_560),
        (DateTime(2100, 1, 1, 0, 0, 0), :D, 47_482),
        (DateTime(2100, 1, 1, 0, 0, 0), :h, 1_139_568),
        (DateTime(2100, 1, 1, 0, 0, 0), :m, 68_374_080),
        (DateTime(2100, 1, 1, 0, 0, 0), :s, 4_102_444_800),
        (DateTime(2100, 1, 1, 0, 0, 0), :ms, 4_102_444_800_000),
        (DateTime(2100, 1, 1, 0, 0, 0), :us, 4_102_444_800_000_000),
        (DateTime(2100, 1, 1, 0, 0, 0), :ns, 4_102_444_800_000_000_000),
    ]

    @testset "$dt $usym" for (dt, usym, expected) in cases
        # 1) DateTime64 with UnitArg symbol
        dt64 = NumpyDates.DateTime64(dt, usym)
        @test Dates.value(dt64) == expected

        # 2) InlineDateTime64 with type parameter Unit constant
        Uconst = NumpyDates.Unit(usym)
        inline_typed = NumpyDates.InlineDateTime64{Uconst}(dt)
        @test Dates.value(inline_typed) == expected

        # 3) InlineDateTime64 with runtime UnitArg symbol
        inline_dyn = NumpyDates.InlineDateTime64(dt, usym)
        @test Dates.value(inline_dyn) == expected
        @test NumpyDates.unitpair(inline_dyn) == NumpyDates.unitpair(usym)
    end
end

@testitem "DateTime64 show" begin
    using Dates
    using PythonCall: NumpyDates

    # Helper to get "showvalue" form by setting :typeinfo to the concrete type
    function showvalue_string(x)
        io = IOBuffer()
        show(IOContext(io, :typeinfo => typeof(x)), x)
        String(take!(io))
    end

    # Helper to get the default Base.show output (with type wrapper)
    function show_string(x)
        io = IOBuffer()
        show(io, x)
        String(take!(io))
    end

    # Cases: (kind, value, unit_symbol, expected_showvalue_string)
    cases = [
        # 1) Days-aligned: prints Date in value form
        (Date(1999, 12, 31), :D, "\"1999-12-31\"", "DAYS"),

        # 2) Seconds-aligned: prints DateTime in value form
        (DateTime(1999, 12, 31, 23, 59, 59), :s, "\"1999-12-31T23:59:59\"", "SECONDS"),

        # 3) Sub-millisecond units: fall back to raw integer in value form
        (1, :us, "1", "MICROSECONDS"),
        (1, :ns, "1", "NANOSECONDS"),

        # 4) Calendar units (years/months): value form shows truncated Date
        (Date(2000, 2, 29), :Y, "\"2000-01-01\"", "YEARS"),
        (Date(1999, 12, 31), :M, "\"1999-12-01\"", "MONTHS"),

        # 5) NaT
        ("NaT", :D, "\"NaT\"", "DAYS"),
    ]

    @testset "$v $usym" for (v, usym, expected_val, ustr) in cases
        # Construct DateTime64
        x = NumpyDates.DateTime64(v, usym)

        # showvalue checks
        s_val = showvalue_string(x)
        @test s_val == expected_val

        # default show checks
        s_def = show_string(x)
        @test s_def ==
              "PythonCall.NumpyDates.DateTime64($expected_val, PythonCall.NumpyDates.$ustr)"

        # and again with InlineDateTime64
        x2 = NumpyDates.InlineDateTime64(v, usym)
        s_val2 = showvalue_string(x2)
        @test s_val2 == expected_val
        s_def2 = show_string(x2)
        @test s_def2 ==
              "PythonCall.NumpyDates.InlineDateTime64{PythonCall.NumpyDates.$ustr}($expected_val)"
    end
end

@testitem "DateTime64 to Date/DateTime" begin
    using Dates
    using PythonCall: NumpyDates

    # Cases: (value, unit_symbol_or_tuple, expected_DateTime, expected_Date)
    cases = [
        # Day counts (since 1970-01-01)
        (10_956, :D, DateTime(1999, 12, 31, 0, 0, 0), Date(1999, 12, 31)),
        (0, :D, DateTime(1970, 1, 1, 0, 0, 0), Date(1970, 1, 1)),
        (1, :D, DateTime(1970, 1, 2, 0, 0, 0), Date(1970, 1, 2)),

        # Seconds since epoch
        (946_684_799, :s, DateTime(1999, 12, 31, 23, 59, 59), Date(1999, 12, 31)),
        (0, :s, DateTime(1970, 1, 1, 0, 0, 0), Date(1970, 1, 1)),
        (3_600, :s, DateTime(1970, 1, 1, 1, 0, 0), Date(1970, 1, 1)),

        # Hours/minutes (epoch-based)
        (24, :h, DateTime(1970, 1, 2, 0, 0, 0), Date(1970, 1, 2)),
        (60, :m, DateTime(1970, 1, 1, 1, 0, 0), Date(1970, 1, 1)),

        # Years/months (calendar truncation semantics from 1970-01-01)
        (30, :Y, DateTime(2000, 1, 1, 0, 0, 0), Date(2000, 1, 1)),
        (361, :M, DateTime(2000, 2, 1, 0, 0, 0), Date(2000, 2, 1)),
        (359, :M, DateTime(1999, 12, 1, 0, 0, 0), Date(1999, 12, 1)),

        # Weeks
        (1, :W, DateTime(1970, 1, 8, 0, 0, 0), Date(1970, 1, 8)),
        (-1, :W, DateTime(1969, 12, 25, 0, 0, 0), Date(1969, 12, 25)),

        # Sub-nanosecond units: floored to nanoseconds
        (1_500, :ps, DateTime(1970, 1, 1, 0, 0, 0) + Nanosecond(1), Date(1970, 1, 1)),
        (1_500_000, :fs, DateTime(1970, 1, 1, 0, 0, 0) + Nanosecond(1), Date(1970, 1, 1)),
        (
            1_500_000_000,
            :as,
            DateTime(1970, 1, 1, 0, 0, 0) + Nanosecond(1),
            Date(1970, 1, 1),
        ),

        # Multiplier tuple unit: value * multiplier is applied before adding
        (1_800, (:s, 2), DateTime(1970, 1, 1, 1, 0, 0), Date(1970, 1, 1)),
    ]

    @testset "$v $u" for (v, u, expdt, expd) in cases
        # 1) DateTime64(value, unit)
        x = NumpyDates.DateTime64(v, u)
        @test Dates.DateTime(x) == expdt
        @test Dates.Date(x) == expd

        # 2) InlineDateTime64 typed
        Uconst = u isa Tuple ? (NumpyDates.Unit(u[1]), Int(u[2])) : NumpyDates.Unit(u)
        y = NumpyDates.InlineDateTime64{Uconst}(v)
        @test Dates.DateTime(y) == expdt
        @test Dates.Date(y) == expd

        # 3) InlineDateTime64 dynamic
        z = NumpyDates.InlineDateTime64(v, u)
        @test Dates.DateTime(z) == expdt
        @test Dates.Date(z) == expd
    end

    # NaT conversion errors
    for u in (:Y, :M, :W, :D, :h, :m, :s, :ms, :us, :ns, :ps, :fs, :as)
        nat1 = NumpyDates.DateTime64("NaT", u)
        @test_throws Exception Dates.DateTime(nat1)
        @test_throws Exception Dates.Date(nat1)

        Uconst = NumpyDates.Unit(u)
        nat2 = NumpyDates.InlineDateTime64{Uconst}("NaT")
        @test_throws Exception Dates.DateTime(nat2)
        @test_throws Exception Dates.Date(nat2)

        nat3 = NumpyDates.InlineDateTime64("NaT", u)
        @test_throws Exception Dates.DateTime(nat3)
        @test_throws Exception Dates.Date(nat3)
    end
end

@testitem "DateTime64 isnan" begin
    using Dates
    using PythonCall: NumpyDates

    units = (:Y, :M, :W, :D, :h, :m, :s, :ms, :us, :ns, :ps, :fs, :as)

    # Non-NaT examples should be false
    @test !isnan(NumpyDates.DateTime64(Date(1970, 1, 1), :D))
    @test !isnan(NumpyDates.DateTime64(DateTime(1970, 1, 1), :ms))
    @test !isnan(NumpyDates.InlineDateTime64{NumpyDates.SECONDS}(0))
    @test !isnan(NumpyDates.InlineDateTime64(0, :ns))

    # NaT via strings for each unit
    @testset "NaT string -> $u" for u in units
        x = NumpyDates.DateTime64("NaT", u)
        @test isnan(x)
        xi = NumpyDates.InlineDateTime64{NumpyDates.Unit(u)}("NaT")
        @test isnan(xi)
        xid = NumpyDates.InlineDateTime64("NaT", u)
        @test isnan(xid)
    end

    # NaT via sentinel (typemin(Int64))
    @testset "NAT sentinel -> $u" for u in units
        x = NumpyDates.DateTime64(NumpyDates.NAT, u)
        @test isnan(x)
        xi = NumpyDates.InlineDateTime64{NumpyDates.Unit(u)}(NumpyDates.NAT)
        @test isnan(xi)
    end

    # Changing unit on NaT remains NaT
    nat_d = NumpyDates.DateTime64("NaT", :D)
    y = NumpyDates.DateTime64(nat_d, :s)
    @test isnan(y)
end

@testitem "TimeDelta64 from Dates.Period" begin
    using Dates
    using PythonCall: NumpyDates

    # Data generated by: uv run test/scripts/np_timedeltas.py
    # Representative cases drawn from the script output.
    # Each case is: (period, unit_symbol, expected_numpy_integer)
    cases = [
        # negative one day
        (Day(-1), :D, -1),
        (Day(-1), :h, -24),
        (Day(-1), :m, -1440),
        (Day(-1), :s, -86400),
        (Day(-1), :ms, -86400000),
        (Day(-1), :us, -86400000000),
        (Day(-1), :ns, -86400000000000),
        # negative one week
        (Week(-1), :W, -1),
        (Week(-1), :D, -7),
        (Week(-1), :h, -168),
        (Week(-1), :m, -10080),
        (Week(-1), :s, -604800),
        (Week(-1), :ms, -604800000),
        (Week(-1), :us, -604800000000),
        (Week(-1), :ns, -604800000000000),
        # sub-second basis
        (Millisecond(-1000), :s, -1),
        (Microsecond(-1_000_000), :s, -1),
        (Nanosecond(-1_000_000_000), :s, -1),
        (Second(-3600), :h, -1),
        (Minute(-60), :h, -1),
        # positive unit-expansion
        (Second(1), :ms, 1_000),
        (Second(1), :us, 1_000_000),
        (Second(1), :ns, 1_000_000_000),
        (Second(1), :ps, 1_000_000_000_000),
        (Second(1), :fs, 1_000_000_000_000_000),
        (Second(1), :as, 1_000_000_000_000_000_000),
        (Nanosecond(1), :ns, 1),
        (Nanosecond(1), :ps, 1_000),
        (Nanosecond(1), :fs, 1_000_000),
        (Nanosecond(1), :as, 1_000_000_000),
        # mixed scale-ups
        (Millisecond(1_000), :s, 1),
        (Microsecond(1_000_000), :s, 1),
        (Nanosecond(1_000_000_000), :s, 1),
        # calendar-like periods (handled specially)
        (Month(12), :M, 12),
        (Year(1), :Y, 1),
        (Year(2), :M, 24),
    ]

    @testset "$p => $usym" for (p, usym, expected) in cases
        # TimeDelta64 from Dates.Period
        td = NumpyDates.TimeDelta64(p, usym)
        @test Dates.value(td) == expected

        # Inline typed
        Uconst = NumpyDates.Unit(usym)
        inline_typed = NumpyDates.InlineTimeDelta64{Uconst}(p)
        @test Dates.value(inline_typed) == expected

        # Inline dynamic
        inline_dyn = NumpyDates.InlineTimeDelta64(p, usym)
        @test Dates.value(inline_dyn) == expected
        @test NumpyDates.unitpair(inline_dyn) == NumpyDates.unitpair(usym)
    end

    inexact_cases = [(Millisecond(3001), :s), (Day(-1), :W)]

    @testset "$p => $usym" for (p, usym) in inexact_cases
        @test_throws InexactError NumpyDates.TimeDelta64(p, usym)
        @test_throws InexactError NumpyDates.InlineTimeDelta64(p, usym)
        Uconst = NumpyDates.Unit(usym)
        @test_throws InexactError NumpyDates.InlineTimeDelta64{Uconst}(p)
    end
end

@testitem "TimeDelta64 from String" begin
    using Dates
    using PythonCall: NumpyDates

    # Only NaT-like strings are supported for TimeDelta64(string, unit)
    @testset "$nat -> $u" for nat in ("NaT", "nan", "NAN"),
        u in (:W, :D, :h, :m, :s, :ms, :us, :ns, :ps, :fs, :as, :M, :Y)

        x = NumpyDates.TimeDelta64(nat, u)
        @test isnan(x)
        @test NumpyDates.unitpair(x) == NumpyDates.unitpair(u)

        # Inline typed and dynamic also accept NaT strings
        Uconst = NumpyDates.Unit(u)
        xi = NumpyDates.InlineTimeDelta64{Uconst}(nat)
        @test isnan(xi)
        xid = NumpyDates.InlineTimeDelta64(nat, u)
        @test isnan(xid)
        @test NumpyDates.unitpair(xid) == NumpyDates.unitpair(u)
    end
end

@testitem "TimeDelta64 from AbstractTimeDelta64" begin
    using Dates
    using PythonCall: NumpyDates

    # Pass-through when units match
    base = NumpyDates.TimeDelta64(Day(1), :D)
    y = NumpyDates.TimeDelta64(base, :D)
    @test Dates.value(y) == 1
    @test NumpyDates.unitpair(y) == NumpyDates.unitpair(:D)

    # NaT changes unit and remains NaT
    nat_td = NumpyDates.TimeDelta64("NaT", :s)
    z = NumpyDates.TimeDelta64(nat_td, :ns)
    @test isnan(z)
    @test NumpyDates.unitpair(z) == NumpyDates.unitpair(:ns)
end

@testitem "TimeDelta64 from Integer" begin
    using Dates
    using PythonCall: NumpyDates

    # Raw constructor: value and unit
    x = NumpyDates.TimeDelta64(3_600, :s)
    @test Dates.value(x) == 3_600

    # Convert to nanoseconds via Dates to sanity check: 3_600 s -> 3_600_000_000_000 ns
    # Note: TimeDelta64 is a Period; we check only value here and rely on conversion tests above.

    # Inline typed raw value
    s1 = NumpyDates.InlineTimeDelta64{NumpyDates.SECONDS}(3_600)
    @test Dates.value(s1) == 3_600

    # Inline with multiplier in unit parameter
    s2 = NumpyDates.InlineTimeDelta64{(NumpyDates.SECONDS, 2)}(1_800) # 1_800 * 2s = 3_600s
    @test Dates.value(s2) == 1_800
end

@testitem "TimeDelta64 show" begin
    using Dates
    using PythonCall: NumpyDates

    # Helper to get "showvalue" form by setting :typeinfo to the concrete type
    function showvalue_string(x)
        io = IOBuffer()
        show(IOContext(io, :typeinfo => typeof(x)), x)
        String(take!(io))
    end

    # Helper to get the default Base.show output (with type wrapper)
    function show_string(x)
        io = IOBuffer()
        show(io, x)
        String(take!(io))
    end

    # Cases: (value_or_nat, unit_symbol_or_tuple, expected_value_string, expected_unit_string_for_default_show, is_inline_tuple?)
    # - expected_value_string matches showvalue_string output (integers unquoted; NaT quoted)
    # - expected_unit_string_for_default_show is the rhs inside the default show, e.g. "SECONDS" or "(SECONDS, 2)"
    cases = [
        # simple seconds
        (0, :s, "0", "SECONDS", false),
        (3_600, :s, "3600", "SECONDS", false),
        (-86_400, :s, "-86400", "SECONDS", false),

        # micro/nano/pico/femto/atto seconds
        (1, :us, "1", "MICROSECONDS", false),
        (1, :ns, "1", "NANOSECONDS", false),
        (1, :ps, "1", "PICOSECONDS", false),
        (1, :fs, "1", "FEMTOSECONDS", false),
        (1, :as, "1", "ATTOSECONDS", false),

        # minutes/hours/days/weeks
        (60, :m, "60", "MINUTES", false),
        (24, :h, "24", "HOURS", false),
        (7, :D, "7", "DAYS", false),
        (2, :W, "2", "WEEKS", false),

        # calendar units (identity semantics for "value" field)
        (12, :M, "12", "MONTHS", false),
        (1, :Y, "1", "YEARS", false),

        # NaT
        ("NaT", :ns, "\"NaT\"", "NANOSECONDS", false),

        # multiplier tuple unit for TimeDelta64 and InlineTimeDelta64
        (1_800, (:s, 2), "1800", "(SECONDS, 2)", true),
    ]

    @testset "$v $u" for (v, u, expected_val, ustr, is_tuple) in cases
        # Construct TimeDelta64
        td = NumpyDates.TimeDelta64(v, u)

        # showvalue checks (integers unquoted; NaT quoted)
        s_val = showvalue_string(td)
        @test s_val == expected_val

        # default show checks
        s_def = show_string(td)
        @test s_def ==
              "PythonCall.NumpyDates.TimeDelta64($expected_val, $(replace(ustr, r"^(\(?)" => s"\1PythonCall.NumpyDates.")))"

        # InlineTimeDelta64 forms
        # Dynamic (value, unit)
        inline_dyn = NumpyDates.InlineTimeDelta64(v, u)
        s_val2 = showvalue_string(inline_dyn)
        @test s_val2 == expected_val
        s_def2 = show_string(inline_dyn)
        # Inline default show embeds the fully-qualified unit in the type parameter.
        if is_tuple
            @test s_def2 ==
                  "PythonCall.NumpyDates.InlineTimeDelta64{(PythonCall.NumpyDates.SECONDS, 2)}($expected_val)"
        else
            @test s_def2 ==
                  "PythonCall.NumpyDates.InlineTimeDelta64{PythonCall.NumpyDates.$ustr}($expected_val)"
        end

        # Typed Inline
        Uconst = u isa Tuple ? (NumpyDates.Unit(u[1]), u[2]) : NumpyDates.Unit(u)
        inline_typed = NumpyDates.InlineTimeDelta64{Uconst}(v)
        @test showvalue_string(inline_typed) == expected_val
        s_def3 = show_string(inline_typed)
        if is_tuple
            @test s_def3 ==
                  "PythonCall.NumpyDates.InlineTimeDelta64{(PythonCall.NumpyDates.SECONDS, 2)}($expected_val)"
        else
            @test s_def3 ==
                  "PythonCall.NumpyDates.InlineTimeDelta64{PythonCall.NumpyDates.$ustr}($expected_val)"
        end
    end
end

@testitem "TimeDelta64 isnan" begin
    using Dates
    using PythonCall: NumpyDates

    units = (:Y, :M, :W, :D, :h, :m, :s, :ms, :us, :ns, :ps, :fs, :as)

    # Non-NaT examples should be false
    @test !isnan(NumpyDates.TimeDelta64(0, :s))
    @test !isnan(NumpyDates.TimeDelta64(Day(1), :D))
    @test !isnan(NumpyDates.InlineTimeDelta64{NumpyDates.MINUTES}(0))
    @test !isnan(NumpyDates.InlineTimeDelta64(0, :ns))

    # NaT via strings for each unit
    @testset "NaT string -> $u" for u in units
        x = NumpyDates.TimeDelta64("NaT", u)
        @test isnan(x)
        xi = NumpyDates.InlineTimeDelta64{NumpyDates.Unit(u)}("NaT")
        @test isnan(xi)
        xid = NumpyDates.InlineTimeDelta64("NaT", u)
        @test isnan(xid)
    end

    # NaT via sentinel (typemin(Int64))
    @testset "NAT sentinel -> $u" for u in units
        x = NumpyDates.TimeDelta64(NumpyDates.NAT, u)
        @test isnan(x)
        xi = NumpyDates.InlineTimeDelta64{NumpyDates.Unit(u)}(NumpyDates.NAT)
        @test isnan(xi)
    end

    # Changing unit on NaT remains NaT
    nat_td = NumpyDates.TimeDelta64("NaT", :s)
    z = NumpyDates.TimeDelta64(nat_td, :ns)
    @test isnan(z)
end

@testitem "TimeDelta64 to Dates.Period" begin
    using Dates
    using PythonCall: NumpyDates

    # Mapping from unit symbols to Dates.Period constructors
    const PERIOD_CONST = Dict(
        :Y => Dates.Year,
        :M => Dates.Month,
        :D => Dates.Day,
        :h => Dates.Hour,
        :m => Dates.Minute,
        :s => Dates.Second,
        :ms => Dates.Millisecond,
        :us => Dates.Microsecond,
        :ns => Dates.Nanosecond,
    )

    # Test cases: (value, unit_symbol)
    cases = [
        (1, :Y),
        (-1, :Y),
        (1, :M),
        (-12, :M),
        (1, :D),
        (-7, :D),
        (1, :h),
        (-24, :h),
        (1, :m),
        (-60, :m),
        (1, :s),
        (-3600, :s),
        (1, :ms),
        (-1000, :ms),
        (1, :us),
        (-1000000, :us),
        (1, :ns),
        (-1000000000, :ns),
    ]

    @testset "$v $usym" for (v, usym) in cases
        # TimeDelta64
        td = NumpyDates.TimeDelta64(v, usym)
        PeriodType = PERIOD_CONST[usym]
        @test PeriodType(td) == PeriodType(v)

        # InlineTimeDelta64 typed
        Uconst = NumpyDates.Unit(usym)
        inline_typed = NumpyDates.InlineTimeDelta64{Uconst}(v)
        @test PeriodType(inline_typed) == PeriodType(v)

        # InlineTimeDelta64 dynamic
        inline_dyn = NumpyDates.InlineTimeDelta64(v, usym)
        @test PeriodType(inline_dyn) == PeriodType(v)
    end

    # NaT conversion errors
    for usym in keys(PERIOD_CONST)
        nat1 = NumpyDates.TimeDelta64("NaT", usym)
        PeriodType = PERIOD_CONST[usym]
        @test_throws Exception PeriodType(nat1)

        Uconst = NumpyDates.Unit(usym)
        nat2 = NumpyDates.InlineTimeDelta64{Uconst}("NaT")
        @test_throws Exception PeriodType(nat2)

        nat3 = NumpyDates.InlineTimeDelta64("NaT", usym)
        @test_throws Exception PeriodType(nat3)
    end
end

@testitem "defaultunit" begin
    using Dates
    using PythonCall: NumpyDates

    # Helper: normalize any defaultunit result to a unitpair tuple
    norm(u) = NumpyDates.unitpair(u)

    # 1) Primitives and Dates.* types
    cases = [
        # fallback Any (e.g. AbstractString)
        ("hello", :ns),

        # Dates.Date / Dates.DateTime
        (Date(2000, 1, 2), :D),
        (DateTime(2000, 1, 2, 3, 4, 5), :ms),

        # Dates.Periods => exact unit mapping
        (Year(1), :Y),
        (Month(1), :M),
        (Week(1), :W),
        (Day(1), :D),
        (Hour(1), :h),
        (Minute(1), :m),
        (Second(1), :s),
        (Millisecond(1), :ms),
        (Microsecond(1), :us),
        (Nanosecond(1), :ns),
    ]

    @testset "$x -> $u" for (x, u) in cases
        @test norm(NumpyDates.defaultunit(x)) == norm(u)
    end

    # 2) (Inline)DateTime64 should return their own unitpair
    @testset "AbstractDateTime64 instances" begin
        # DateTime64
        dt_s = NumpyDates.DateTime64(0, :s)
        dt_ms = NumpyDates.DateTime64(0, :ms)
        @test norm(NumpyDates.defaultunit(dt_s)) == NumpyDates.unitpair(dt_s)
        @test norm(NumpyDates.defaultunit(dt_ms)) == NumpyDates.unitpair(dt_ms)

        # InlineDateTime64 typed
        idt_typed = NumpyDates.InlineDateTime64{NumpyDates.SECONDS}(0)
        @test norm(NumpyDates.defaultunit(idt_typed)) == NumpyDates.unitpair(idt_typed)

        # InlineDateTime64 dynamic
        idt_dyn = NumpyDates.InlineDateTime64(0, :us)
        @test norm(NumpyDates.defaultunit(idt_dyn)) == NumpyDates.unitpair(idt_dyn)
    end

    # 3) (Inline)TimeDelta64 should return their own unitpair
    @testset "AbstractTimeDelta64 instances" begin
        # TimeDelta64
        td_ns = NumpyDates.TimeDelta64(0, :ns)
        td_ps = NumpyDates.TimeDelta64(0, :ps)
        @test norm(NumpyDates.defaultunit(td_ns)) == NumpyDates.unitpair(td_ns)
        @test norm(NumpyDates.defaultunit(td_ps)) == NumpyDates.unitpair(td_ps)

        # InlineTimeDelta64 typed
        itd_typed = NumpyDates.InlineTimeDelta64{NumpyDates.MINUTES}(0)
        @test norm(NumpyDates.defaultunit(itd_typed)) == NumpyDates.unitpair(itd_typed)

        # InlineTimeDelta64 dynamic
        itd_dyn = NumpyDates.InlineTimeDelta64(0, :as)
        @test norm(NumpyDates.defaultunit(itd_dyn)) == NumpyDates.unitpair(itd_dyn)
    end
end

@testitem "python info" begin
    @testset "python_executable_path" begin
        @test PythonCall.python_executable_path() isa String
        @test occursin("python", PythonCall.python_executable_path())
    end
    @testset "python_library_path" begin
        @test PythonCall.python_library_path() isa String
        @test occursin("python", PythonCall.python_library_path())
    end
    @testset "python_library_handle" begin
        @test PythonCall.python_library_handle() isa Ptr{Cvoid}
        @test PythonCall.python_library_handle() != C_NULL
    end
    @testset "python_version" begin
        @test PythonCall.python_version() isa VersionNumber
        @test PythonCall.python_version().major == 3
    end
end

struct PyConvertRule
    type::Type
    func::Function
    priority::PyConvertPriority
end

const PYCONVERT_RULES = Dict{String,Vector{PyConvertRule}}()
const PYCONVERT_EXTRATYPES = Py[]

"""
    pyconvert_add_rule(tname::String, T::Type, func::Function, priority::PyConvertPriority=PYCONVERT_PRIORITY_NORMAL)

Add a new conversion rule for `pyconvert`.

### Arguments

- `tname` is a string of the form `"__module__:__qualname__"` identifying a Python type `t`,
  such as `"builtins:dict"` or `"sympy.core.symbol:Symbol"`. This rule only applies to
  Python objects of this type.
- `T` is a Julia type, such that this rule only applies when the target type intersects
  with `T`.
- `func` is the function implementing the rule.
- `priority` determines whether to prioritise this rule above others.

When `pyconvert(R, x)` is called, all rules such that `typeintersect(T, R) != Union{}`
and `pyisinstance(x, t)` are considered. These rules are sorted first by priority,
then by the specificity of `t` (e.g. `bool` is more specific than `int` is more specific
than `object`) then by the order they were added. The rules are tried in turn until one
succeeds.

### Implementing `func`

`func` is called as `func(S, x::Py)` for some `S <: T`.

It must return one of:
- `pyconvert_return(ans)` where `ans` is the result of the conversion (and must be an `S`).
- `pyconvert_unconverted()` if the conversion was not possible (e.g. converting a `list` to
  `Vector{Int}` might fail if some of the list items are not integers).

The target type `S` is never a union or the empty type, i.e. it is always a data type or
union-all.

### Priority

Most rules should have priority `PYCONVERT_PRIORITY_NORMAL` (the default) which is for any
reasonable conversion rule.

Use priority `PYCONVERT_PRIORITY_CANONICAL` for **canonical** conversion rules. Immutable
objects may be canonically converted to their corresponding Julia type, such as `int` to
`Integer`. Mutable objects **must** be converted to a wrapper type, such that the original
Python object can be retrieved. For example a `list` is canonically converted to `PyList`
and not to a `Vector`. There should not be more than one canonical conversion rule for a
given Python type.

Other priorities are reserved for internal use.
"""
function pyconvert_add_rule(
    pytypename::String,
    type::Type,
    func::Function,
    priority::PyConvertPriority = PYCONVERT_PRIORITY_NORMAL,
)
    @nospecialize type func
    push!(
        get!(Vector{PyConvertRule}, PYCONVERT_RULES, pytypename),
        PyConvertRule(type, func, priority),
    )
    empty!.(values(PYCONVERT_RULES_CACHE))
    return
end

# Alternative ways to represent the result of conversion.
if true
    # Returns either the result or Unconverted().
    struct Unconverted end
    @inline pyconvert_return(x) = x
    @inline pyconvert_unconverted() = Unconverted()
    @inline pyconvert_returntype(::Type{T}) where {T} = Union{T,Unconverted}
    @inline pyconvert_isunconverted(r) = r === Unconverted()
    @inline pyconvert_result(::Type{T}, r) where {T} = r::T
elseif false
    # Stores the result in PYCONVERT_RESULT.
    # This is global state, probably best avoided.
    const PYCONVERT_RESULT = Ref{Any}(nothing)
    @inline pyconvert_return(x) = (PYCONVERT_RESULT[] = x; true)
    @inline pyconvert_unconverted() = false
    @inline pyconvert_returntype(::Type{T}) where {T} = Bool
    @inline pyconvert_isunconverted(r::Bool) = !r
    @inline pyconvert_result(::Type{T}, r::Bool) where {T} =
        (ans = PYCONVERT_RESULT[]::T; PYCONVERT_RESULT[] = nothing; ans)
else
    # Same as the previous scheme, but with special handling for bits types.
    # This is global state, probably best avoided.
    const PYCONVERT_RESULT = Ref{Any}(nothing)
    const PYCONVERT_RESULT_ISBITS = Ref{Bool}(false)
    const PYCONVERT_RESULT_TYPE = Ref{Type}(Union{})
    const PYCONVERT_RESULT_BITSLEN = 1024
    const PYCONVERT_RESULT_BITS = fill(0x00, PYCONVERT_RESULT_BITSLEN)
    function pyconvert_return(x::T) where {T}
        if isbitstype(T) && sizeof(T) ≤ PYCONVERT_RESULT_BITSLEN
            unsafe_store!(Ptr{T}(pointer(PYCONVERT_RESULT_BITS)), x)
            PYCONVERT_RESULT_ISBITS[] = true
            PYCONVERT_RESULT_TYPE[] = T
        else
            PYCONVERT_RESULT[] = x
            PYCONVERT_RESULT_ISBITS[] = false
        end
        return true
    end
    @inline pyconvert_unconverted() = false
    @inline pyconvert_returntype(::Type{T}) where {T} = Bool
    @inline pyconvert_isunconverted(r::Bool) = !r
    function pyconvert_result(::Type{T}, r::Bool) where {T}
        if isbitstype(T)
            if sizeof(T) ≤ PYCONVERT_RESULT_BITSLEN
                @assert PYCONVERT_RESULT_ISBITS[]
                @assert PYCONVERT_RESULT_TYPE[] == T
                return unsafe_load(Ptr{T}(pointer(PYCONVERT_RESULT_BITS)))::T
            end
        elseif PYCONVERT_RESULT_ISBITS[]
            t = PYCONVERT_RESULT_TYPE[]
            @assert isbitstype(t)
            @assert sizeof(t) ≤ PYCONVERT_RESULT_BITSLEN
            @assert t <: T
            @assert isconcretetype(t)
            return unsafe_load(Ptr{t}(pointer(PYCONVERT_RESULT_BITS)))::T
        end
        # general case
        ans = PYCONVERT_RESULT[]::T
        PYCONVERT_RESULT[] = nothing
        return ans::T
    end
end

pyconvert_result(r) = pyconvert_result(Any, r)

pyconvert_tryconvert(::Type{T}, x::T) where {T} = pyconvert_return(x)
pyconvert_tryconvert(::Type{T}, x) where {T} =
    try
        pyconvert_return(convert(T, x)::T)
    catch
        pyconvert_unconverted()
    end

function pyconvert_typename(t::Py)
    m = pygetattr(t, "__module__", "<unknown>")
    n = pygetattr(t, "__name__", "<name>")
    return "$m:$n"
end

function _pyconvert_get_rules(pytype::Py)
    pyisin(x, ys) = any(pyis(x, y) for y in ys)

    # get the MROs of all base types we are considering
    omro = collect(pytype.__mro__)
    basetypes = Py[pytype]
    basemros = Vector{Py}[omro]
    for xtype in PYCONVERT_EXTRATYPES
        # find the topmost supertype of
        xbase = PyNULL
        for base in omro
            if pyissubclass(base, xtype)
                xbase = base
            end
        end
        if !pyisnull(xbase)
            push!(basetypes, xtype)
            xmro = collect(xtype.__mro__)
            pyisin(xbase, xmro) || pushfirst!(xmro, xbase)
            push!(basemros, xmro)
        end
    end
    for xbase in basetypes[2:end]
        push!(basemros, [xbase])
    end

    # merge the MROs
    # this is a port of the merge() function at the bottom of:
    # https://www.python.org/download/releases/2.3/mro/
    mro = Py[]
    while !isempty(basemros)
        # find the first head not contained in any tail
        ok = false
        b = PyNULL
        for bmro in basemros
            b = bmro[1]
            if all(bmro -> !pyisin(b, bmro[2:end]), basemros)
                ok = true
                break
            end
        end
        ok || error(
            "Fatal inheritance error: could not merge MROs (mro=$mro, basemros=$basemros)",
        )
        # add it to the list
        push!(mro, b)
        # remove it from consideration
        for bmro in basemros
            filter!(t -> !pyis(t, b), bmro)
        end
        # remove empty lists
        filter!(x -> !isempty(x), basemros)
    end
    # check the original MRO is preserved
    omro_ = filter(t -> pyisin(t, omro), mro)
    @assert length(omro) == length(omro_)
    @assert all(pyis(x, y) for (x, y) in zip(omro, omro_))

    # get the names of the types in the MRO of pytype
    xmro = [String[pyconvert_typename(t)] for t in mro]

    # add special names corresponding to certain interfaces
    # these get inserted just above the topmost type satisfying the interface
    for (t, x) in reverse(collect(zip(mro, xmro)))
        if pyhasattr(t, "__array_struct__")
            push!(x, "<arraystruct>")
            break
        end
    end
    for (t, x) in reverse(collect(zip(mro, xmro)))
        if pyhasattr(t, "__array_interface__")
            push!(x, "<arrayinterface>")
            break
        end
    end
    for (t, x) in reverse(collect(zip(mro, xmro)))
        if pyhasattr(t, "__array__")
            push!(x, "<array>")
            break
        end
    end
    for (t, x) in reverse(collect(zip(mro, xmro)))
        if C.PyType_CheckBuffer(t)
            push!(x, "<buffer>")
            break
        end
    end

    # flatten to get the MRO as a list of strings
    mro = String[x for xs in xmro for x in xs]

    # get corresponding rules
    rules = PyConvertRule[
        rule for tname in mro for
        rule in get!(Vector{PyConvertRule}, PYCONVERT_RULES, tname)
    ]

    # order the rules by priority, then by original order
    order = sort(axes(rules, 1), by = i -> (rules[i].priority, -i), rev = true)
    rules = rules[order]

    @debug "pyconvert" pytype mro = join(mro, " ")
    return rules
end

const PYCONVERT_PREFERRED_TYPE = Dict{Py,Type}()

pyconvert_preferred_type(pytype::Py) =
    get!(PYCONVERT_PREFERRED_TYPE, pytype) do
        if pyissubclass(pytype, pybuiltins.int)
            Union{Int,BigInt}
        else
            _pyconvert_get_rules(pytype)[1].type
        end
    end

function pyconvert_get_rules(type::Type, pytype::Py)
    @nospecialize type

    # this could be cached
    rules = _pyconvert_get_rules(pytype)

    # intersect rules with type
    rules = PyConvertRule[
        PyConvertRule(typeintersect(rule.type, type), rule.func, rule.priority) for
        rule in rules
    ]

    # explode out unions
    rules = [
        PyConvertRule(type, rule.func, rule.priority) for rule in rules for
        type in Utils.explode_union(rule.type)
    ]

    # filter out empty rules
    rules = [rule for rule in rules if rule.type != Union{}]

    # filter out repeated rules
    rules = [
        rule for (i, rule) in enumerate(rules) if !any(
            (rule.func === rules[j].func) && ((rule.type) <: (rules[j].type)) for
            j = 1:(i-1)
        )
    ]

    @debug "pyconvert" type rules
    return Function[pyconvert_fix(rule.type, rule.func) for rule in rules]
end

pyconvert_fix(::Type{T}, func) where {T} = x -> func(T, x)

const PYCONVERT_RULES_CACHE = Dict{Type,Dict{C.PyPtr,Vector{Function}}}()

@generated pyconvert_rules_cache(::Type{T}) where {T} =
    get!(Dict{C.PyPtr,Vector{Function}}, PYCONVERT_RULES_CACHE, T)

function pyconvert_rule_fast(::Type{T}, x::Py) where {T}
    if T isa Union
        a = pyconvert_rule_fast(T.a, x)::pyconvert_returntype(T.a)
        pyconvert_isunconverted(a) || return a
        b = pyconvert_rule_fast(T.b, x)::pyconvert_returntype(T.b)
        pyconvert_isunconverted(b) || return b
    elseif (T == Nothing) | (T == Missing)
        pyisnone(x) && return pyconvert_return(T())
    elseif (T == Bool)
        pyisFalse(x) && return pyconvert_return(false)
        pyisTrue(x) && return pyconvert_return(true)
    elseif (T == Int) | (T == BigInt)
        pyisint(x) && return pyconvert_rule_int(T, x)
    elseif (T == Float64)
        pyisfloat(x) && return pyconvert_return(T(pyfloat_asdouble(x)))
    elseif (T == ComplexF64)
        pyiscomplex(x) && return pyconvert_return(T(pycomplex_ascomplex(x)))
    elseif (T == String) | (T == Char) | (T == Symbol)
        pyisstr(x) && return pyconvert_rule_str(T, x)
    elseif (T == Vector{UInt8}) | (T == Base.CodeUnits{UInt8,String})
        pyisbytes(x) && return pyconvert_rule_bytes(T, x)
    elseif (T <: StepRange) | (T <: UnitRange)
        pyisrange(x) && return pyconvert_rule_range(T, x)
    end
    pyconvert_unconverted()
end

function pytryconvert(::Type{T}, x_) where {T}
    # Convert the input to a Py
    x = Py(x_)

    # We can optimize the conversion for some types by overloading pytryconvert_fast.
    # It MUST give the same results as via the slower route using rules.
    ans1 = pyconvert_rule_fast(T, x)::pyconvert_returntype(T)
    pyconvert_isunconverted(ans1) || return ans1

    # get rules from the cache
    # TODO: we should hold weak references and clear the cache if types get deleted
    tptr = C.Py_Type(x)
    trules = pyconvert_rules_cache(T)
    rules = get!(trules, tptr) do
        t = pynew(incref(tptr))
        ans = pyconvert_get_rules(T, t)::Vector{Function}
        pydel!(t)
        ans
    end

    # apply the rules
    for rule in rules
        ans2 = rule(x)::pyconvert_returntype(T)
        pyconvert_isunconverted(ans2) || return ans2
    end

    return pyconvert_unconverted()
end

"""
    @pyconvert(T, x, [onfail])

Convert the Python object `x` to a `T`.

On failure, evaluates to `onfail`, which defaults to `return pyconvert_unconverted()` (mainly useful for writing conversion rules).
"""
macro pyconvert(T, x, onfail = :(return $pyconvert_unconverted()))
    quote
        T = $(esc(T))
        x = $(esc(x))
        ans = pytryconvert(T, x)
        if pyconvert_isunconverted(ans)
            $(esc(onfail))
        else
            pyconvert_result(T, ans)
        end
    end
end

"""
    pyconvert(T, x, [d])

Convert the Python object `x` to a `T`.

If `d` is specified, it is returned on failure instead of throwing an error.
"""
pyconvert(::Type{T}, x) where {T} = @autopy x @pyconvert T x_ error(
    "cannot convert this Python '$(pytype(x_).__name__)' to a Julia '$T'",
)
pyconvert(::Type{T}, x, d) where {T} = @autopy x @pyconvert T x_ d

"""
    pyconvertarg(T, x, name)

Convert the Python object `x` to a `T`.

On failure, throws a Python `TypeError` saying that the argument `name` could not be converted.
"""
pyconvertarg(::Type{T}, x, name) where {T} = @autopy x @pyconvert T x_ begin
    errset(
        pybuiltins.TypeError,
        "Cannot convert argument '$name' to a Julia '$T', got a '$(pytype(x_).__name__)'",
    )
    pythrow()
end

function init_pyconvert()
    push!(PYCONVERT_EXTRATYPES, pyimport("io" => "IOBase"))
    push!(
        PYCONVERT_EXTRATYPES,
        pyimport("numbers" => ("Number", "Complex", "Real", "Rational", "Integral"))...,
    )
    push!(
        PYCONVERT_EXTRATYPES,
        pyimport("collections.abc" => ("Iterable", "Sequence", "Set", "Mapping"))...,
    )

    priority = PYCONVERT_PRIORITY_CANONICAL
    pyconvert_add_rule("builtins:NoneType", Nothing, pyconvert_rule_none, priority)
    pyconvert_add_rule("builtins:bool", Bool, pyconvert_rule_bool, priority)
    pyconvert_add_rule("builtins:float", Float64, pyconvert_rule_float, priority)
    pyconvert_add_rule(
        "builtins:complex",
        Complex{Float64},
        pyconvert_rule_complex,
        priority,
    )
    pyconvert_add_rule("numbers:Integral", Integer, pyconvert_rule_int, priority)
    pyconvert_add_rule("builtins:str", String, pyconvert_rule_str, priority)
    pyconvert_add_rule(
        "builtins:bytes",
        Base.CodeUnits{UInt8,String},
        pyconvert_rule_bytes,
        priority,
    )
    pyconvert_add_rule(
        "builtins:range",
        StepRange{<:Integer,<:Integer},
        pyconvert_rule_range,
        priority,
    )
    pyconvert_add_rule(
        "numbers:Rational",
        Rational{<:Integer},
        pyconvert_rule_fraction,
        priority,
    )
    pyconvert_add_rule("builtins:tuple", NamedTuple, pyconvert_rule_iterable, priority)
    pyconvert_add_rule("builtins:tuple", Tuple, pyconvert_rule_iterable, priority)
    pyconvert_add_rule("datetime:datetime", DateTime, pyconvert_rule_datetime, priority)
    pyconvert_add_rule("datetime:date", Date, pyconvert_rule_date, priority)
    pyconvert_add_rule("datetime:time", Time, pyconvert_rule_time, priority)
    pyconvert_add_rule(
        "datetime:timedelta",
        Microsecond,
        pyconvert_rule_timedelta,
        priority,
    )
    pyconvert_add_rule(
        "builtins:BaseException",
        PyException,
        pyconvert_rule_exception,
        priority,
    )

    priority = PYCONVERT_PRIORITY_NORMAL
    pyconvert_add_rule("builtins:NoneType", Missing, pyconvert_rule_none, priority)
    pyconvert_add_rule("builtins:bool", Number, pyconvert_rule_bool, priority)
    pyconvert_add_rule("numbers:Real", Number, pyconvert_rule_float, priority)
    pyconvert_add_rule("builtins:float", Nothing, pyconvert_rule_float, priority)
    pyconvert_add_rule("builtins:float", Missing, pyconvert_rule_float, priority)
    pyconvert_add_rule("numbers:Complex", Number, pyconvert_rule_complex, priority)
    pyconvert_add_rule("numbers:Integral", Number, pyconvert_rule_int, priority)
    pyconvert_add_rule("builtins:str", Symbol, pyconvert_rule_str, priority)
    pyconvert_add_rule("builtins:str", Char, pyconvert_rule_str, priority)
    pyconvert_add_rule("builtins:bytes", Vector{UInt8}, pyconvert_rule_bytes, priority)
    pyconvert_add_rule(
        "builtins:range",
        UnitRange{<:Integer},
        pyconvert_rule_range,
        priority,
    )
    pyconvert_add_rule("numbers:Rational", Number, pyconvert_rule_fraction, priority)
    pyconvert_add_rule(
        "collections.abc:Iterable",
        Vector,
        pyconvert_rule_iterable,
        priority,
    )
    pyconvert_add_rule("collections.abc:Iterable", Tuple, pyconvert_rule_iterable, priority)
    pyconvert_add_rule("collections.abc:Iterable", Pair, pyconvert_rule_iterable, priority)
    pyconvert_add_rule("collections.abc:Iterable", Set, pyconvert_rule_iterable, priority)
    pyconvert_add_rule(
        "collections.abc:Sequence",
        Vector,
        pyconvert_rule_iterable,
        priority,
    )
    pyconvert_add_rule("collections.abc:Sequence", Tuple, pyconvert_rule_iterable, priority)
    pyconvert_add_rule("collections.abc:Set", Set, pyconvert_rule_iterable, priority)
    pyconvert_add_rule("collections.abc:Mapping", Dict, pyconvert_rule_mapping, priority)
    pyconvert_add_rule(
        "datetime:timedelta",
        Millisecond,
        pyconvert_rule_timedelta,
        priority,
    )
    pyconvert_add_rule("datetime:timedelta", Second, pyconvert_rule_timedelta, priority)
    pyconvert_add_rule("datetime:timedelta", Nanosecond, pyconvert_rule_timedelta, priority)

    priority = PYCONVERT_PRIORITY_FALLBACK
    pyconvert_add_rule("builtins:object", Py, pyconvert_rule_object, priority)
end

"""
    module PythonCall.Wrap

Defines Julia wrappers around Python objects, including `PyList`, `PyDict`, `PyArray` and `PyIO`.
"""
module Wrap

using ..PythonCall
using ..Utils
using ..NumpyDates
using ..C
using ..Core
using ..Convert
using ..PyMacro

import ..PythonCall:
    PyArray, PyDict, PyIO, PyIterable, PyList, PyPandasDataFrame, PySet, PyTable

using Base: @propagate_inbounds
using Tables: Tables
using UnsafePointers: UnsafePtr

import ..Core: Py, ispy

include("PyIterable.jl")
include("PyDict.jl")
include("PyList.jl")
include("PySet.jl")
include("PyArray.jl")
include("PyIO.jl")
include("PyTable.jl")
include("PyPandasDataFrame.jl")

function __init__()
    priority = PYCONVERT_PRIORITY_ARRAY
    pyconvert_add_rule("<arraystruct>", PyArray, pyconvert_rule_array_nocopy, priority)
    pyconvert_add_rule("<arrayinterface>", PyArray, pyconvert_rule_array_nocopy, priority)
    pyconvert_add_rule("<array>", PyArray, pyconvert_rule_array_nocopy, priority)
    pyconvert_add_rule("<buffer>", PyArray, pyconvert_rule_array_nocopy, priority)

    priority = PYCONVERT_PRIORITY_CANONICAL
    pyconvert_add_rule(
        "collections.abc:Iterable",
        PyIterable,
        pyconvert_rule_iterable,
        priority,
    )
    pyconvert_add_rule(
        "collections.abc:Sequence",
        PyList,
        pyconvert_rule_sequence,
        priority,
    )
    pyconvert_add_rule("collections.abc:Set", PySet, pyconvert_rule_set, priority)
    pyconvert_add_rule("collections.abc:Mapping", PyDict, pyconvert_rule_mapping, priority)
    pyconvert_add_rule("io:IOBase", PyIO, pyconvert_rule_io, priority)
    pyconvert_add_rule("_io:_IOBase", PyIO, pyconvert_rule_io, priority)
    for typename in ["pandas.core.frame:DataFrame", "pandas:DataFrame"]
        pyconvert_add_rule(
            typename,
            PyPandasDataFrame,
            pyconvert_rule_pandasdataframe,
            priority,
        )
    end
    for typename in ["pandas.core.arrays.base:ExtensionArray", "pandas.api.extensions:ExtensionArray"]
        pyconvert_add_rule(
            typename,
            PyList,
            pyconvert_rule_sequence,
            priority,
        )
    end

    priority = PYCONVERT_PRIORITY_NORMAL
    pyconvert_add_rule("<arraystruct>", Array, pyconvert_rule_array, priority)
    pyconvert_add_rule("<arrayinterface>", Array, pyconvert_rule_array, priority)
    pyconvert_add_rule("<array>", Array, pyconvert_rule_array, priority)
    pyconvert_add_rule("<buffer>", Array, pyconvert_rule_array, priority)
    pyconvert_add_rule("<arraystruct>", AbstractArray, pyconvert_rule_array, priority)
    pyconvert_add_rule("<arrayinterface>", AbstractArray, pyconvert_rule_array, priority)
    pyconvert_add_rule("<array>", AbstractArray, pyconvert_rule_array, priority)
    pyconvert_add_rule("<buffer>", AbstractArray, pyconvert_rule_array, priority)
end

end

errval(::C.PyPtr) = C.PyNULL
errval(::T) where {T<:Number} = zero(T) - one(T)

iserrval(val) = val == errval(val)

iserrset() = C.PyErr_Occurred() != C.PyNULL
iserrset(val) = val == errval(val)

errcheck() = iserrset() ? pythrow() : nothing
errcheck(val) = iserrset(val) ? pythrow() : val

iserrset_ambig(val) = iserrset(val) && iserrset()

errcheck_ambig(val) = iserrset_ambig(val) ? pythrow() : val

errclear() = C.PyErr_Clear()

errmatches(t) = (@autopy t C.PyErr_ExceptionMatches(t_)) == 1

function errget()
    t = Ref(C.PyNULL)
    v = Ref(C.PyNULL)
    b = Ref(C.PyNULL)
    C.PyErr_Fetch(t, v, b)
    (pynew(t[]), pynew(v[]), pynew(b[]))
end

errset(t::Py) = C.PyErr_SetNone(t)
errset(t::Py, v::Py) = C.PyErr_SetObject(t, v)
errset(t::Py, v::String) = C.PyErr_SetString(t, v)

function errnormalize!(t::Py, v::Py, b::Py)
    tref = Ref(getptr(t))
    vref = Ref(getptr(v))
    bref = Ref(getptr(b))
    C.PyErr_NormalizeException(tref, vref, bref)
    setptr!(t, tref[])
    setptr!(v, vref[])
    setptr!(b, bref[])
    (t, v, b)
end

function PyException(v::Py = pybuiltins.None)
    if pyisnone(v)
        t = b = v
    elseif pyisinstance(v, pybuiltins.BaseException)
        t = pytype(v)
        b = pygetattr(v, "__traceback__", pybuiltins.None)
    else
        throw(ArgumentError("expecting a Python exception"))
    end
    PyException(t, v, b, true)
end

ispy(x::PyException) = true
Py(x::PyException) = x.v

function Base.show(io::IO, x::PyException)
    show(io, typeof(x))
    print(io, "(")
    show(io, x.v)
    print(io, ")")
end

function Base.getproperty(exc::PyException, k::Symbol)
    if k in (:t, :v, :b) && !exc._isnormalized
        errnormalize!(exc._t, exc._v, exc._b)
        pyisnull(exc._t) && pycopy!(exc._t, pybuiltins.None)
        pyisnull(exc._v) && pycopy!(exc._v, pybuiltins.None)
        pyisnull(exc._b) && pycopy!(exc._b, pybuiltins.None)
        pyisnone(exc._v) || (exc._v.__traceback__ = exc._b)
        exc._isnormalized = true
    end
    k == :t ? exc._t : k == :v ? exc._v : k == :b ? exc._b : getfield(exc, k)
end

pythrow() = throw(PyException(errget()..., false))

file_to_pymodule(fname::String) = begin
    isfile(fname) || return nothing
    modules = pyimport("sys").modules
    for (n, m) in modules.items()
        if pyhasattr(m, "__file__")
            fname2 = pystr(String, m.__file__)
            if isfile(fname2) && realpath(fname) == realpath(fname2)
                return pystr(String, n)
            end
        end
    end
end

Base.showerror(io::IO, e::PyException) = _showerror(io, e, nothing, backtrace = false)

Base.showerror(io::IO, e::PyException, bt; backtrace = true) =
    _showerror(io, e, bt; backtrace = backtrace)

function _showerror(io::IO, e::PyException, bt; backtrace = true)
    print(io, "Python: ")

    if pyisnone(e.t)
        print(io, "mysterious error (no error was actually set)")
        if backtrace
            Base.show_backtrace(io, bt)
        end
        return
    end

    if CONFIG.auto_sys_last_traceback
        try
            sys = pyimport("sys")
            sys.last_type = e.t
            sys.last_value = e.v
            sys.last_traceback = e.b
        catch err
            print(io, "<error while setting 'sys.last_traceback': $err>")
        end
    end

    if !pyisnull(pyJuliaError) && pyissubclass(e.t, pyJuliaError)
        # handle Julia exceptions specially
        try
            je, jb = pyconvert(Tuple{Any,Any}, e.v.args)
            print(io, "Julia: ")
            if je isa Exception
                showerror(io, je, jb, backtrace = backtrace && jb !== nothing)
            else
                print(io, je)
                backtrace && jb !== nothing && Base.show_backtrace(io, jb)
            end
        catch err
            println("<error while printing Julia exception inside Python exception: $err>")
        end
    else
        # print the type name
        try
            print(io, e.t.__name__)
        catch err
            print(io, "<error while printing type: $err>")
        end

        # print the error message
        if !pyisnone(e.v)
            print(io, ": ")
            try
                print(io, e.v)
            catch err
                print(io, "<error while printing value: $err>")
            end
        end
    end

    if backtrace
        # print the Python stacktrace
        println(io)
        printstyled(io, "Python stacktrace:")
        if pyisnone(e.b)
            printstyled(io, " none")
        else
            try
                fs = [
                    (
                        pystr(String, x.name),
                        pystr(String, x.filename),
                        pystr(String, x.lineno),
                    ) for x in pyimport("traceback").extract_tb(e.b)
                ]
                mcdict = Dict{String,Symbol}()
                mccyclyer =
                    Iterators.Stateful(Iterators.cycle(Base.STACKTRACE_MODULECOLORS))
                # skip a couple as a basic attempt to make the colours different from the Julia stacktrace
                popfirst!(mccyclyer)
                popfirst!(mccyclyer)
                for (i, (name, fname, lineno)) in enumerate(reverse(fs))
                    println(io)
                    printstyled(io, " [", i, "] ")
                    printstyled(io, name, bold = true)
                    println(io)
                    printstyled(io, "   @ ", color = :light_black)
                    mod = file_to_pymodule(fname)
                    if mod !== nothing
                        # print the module, with colour determined by the top level name
                        tmod = first(split(mod, ".", limit = 2))
                        color = get!(mcdict, tmod) do
                            popfirst!(mccyclyer)
                        end
                        printstyled(io, mod, " ", color = color)
                    end
                    if isfile(fname) &&
                        :stacktrace_contract_userdir in names(Base, all = true) &&
                        Base.stacktrace_contract_userdir()
                        if :replaceuserpath in names(Base, all = true)
                            fname = Base.replaceuserpath(fname)
                        elseif :contractuser in names(Base.Filesystem, all = true)
                            fname = Base.Filesystem.contractuser(fname)
                        end
                    end
                    printstyled(io, fname, ":", lineno, color = :light_black)
                end
            catch err
                print(io, "<error while printing stacktrace: $err>")
            end
        end

        # print the Julia stacktrace
        Base.show_backtrace(io, bt)
    end
end

PyDict{K}(x = pydict()) where {K} = PyDict{K,Py}(x)
PyDict(x = pydict()) = PyDict{Py,Py}(x)

ispy(::PyDict) = true
Py(x::PyDict) = x.py

function pyconvert_rule_mapping(
    ::Type{T},
    x::Py,
    ::Type{T1} = Utils._type_ub(T),
) where {T<:PyDict,T1}
    pyconvert_return(T1(x))
end

Base.length(x::PyDict) = Int(pylen(x))

function Base.iterate(x::PyDict{K,V}, it::Py = pyiter(x)) where {K,V}
    k_ = unsafe_pynext(it)
    pyisnull(k_) && return nothing
    v_ = pygetitem(x, k_)
    k = pyconvert(K, k_)
    v = pyconvert(V, v_)
    return (k => v, it)
end

function Base.iterate(x::Base.KeySet{K,PyDict{K,V}}, it::Py = pyiter(x.dict)) where {K,V}
    k_ = unsafe_pynext(it)
    pyisnull(k_) && return nothing
    k = pyconvert(K, k_)
    return (k, it)
end

function Base.getindex(x::PyDict{K,V}, k) where {K,V}
    k2 = convert(K, k)
    pycontains(x, k2) || throw(KeyError(k))
    return pyconvert(V, pygetitem(x, k2))
end

function Base.setindex!(x::PyDict{K,V}, v, k) where {K,V}
    pysetitem(x, convert(K, k), convert(V, v))
    return x
end

function Base.delete!(x::PyDict{K,V}, k) where {K,V}
    r = pyconvert_tryconvert(K, k)
    if !pyconvert_isunconverted(r)
        k2 = pyconvert_result(K, r)
        pycontains(x, k2) && pydelitem(x, k2)
    end
    return x
end

function Base.empty!(x::PyDict)
    pydel!(@py x.clear())
    return x
end

function Base.copy(x::PyDict{K,V}) where {K,V}
    return PyDict{K,V}(@py x.copy())
end

function Base.haskey(x::PyDict{K,V}, k) where {K,V}
    r = pyconvert_tryconvert(K, k)
    if pyconvert_isunconverted(r)
        return false
    else
        return pycontains(x, pyconvert_result(K, r))
    end
end

function Base.get(x::PyDict, k, d)
    if haskey(x, k)
        return x[k]
    else
        return d
    end
end

function Base.get(f::Union{Function,Type}, x::PyDict, k)
    if haskey(x, k)
        return x[k]
    else
        return f()
    end
end

function Base.get!(x::PyDict{K,V}, k, d) where {K,V}
    if haskey(x, k)
        return x[k]
    else
        return x[k] = convert(V, d)
    end
end

function Base.get!(f::Union{Function,Type}, x::PyDict{K,V}, k) where {K,V}
    if haskey(x, k)
        return x[k]
    else
        return x[k] = convert(V, f())
    end
end

# type

"""
    InlineTimeDelta64{unit}(value)
    InlineTimeDelta64(value, [unit])

Construct an `InlineTimeDelta64` with the given `value` and [`unit`](@ref Unit).

The unit is part of the type, so an instance just consists of one `Int64` for the value.

The value can be:
- An `Integer`, in which case the `unit` is required.
- `"NaT"` or `"NaN"` to make a not-a-time value.
"""
struct InlineTimeDelta64{U} <: AbstractTimeDelta64
    value::Int64
    function InlineTimeDelta64{U}(value::Int64) where {U}
        U isa Unit ||
            U isa Tuple{Unit,Int} ||
            error("U must be a Unit or a Tuple{Unit,Int}")
        new{U}(value)
    end
end

# accessors

unitpair(::InlineTimeDelta64{U}) where {U} = unitpair(U)
unitpair(::Type{InlineTimeDelta64{U}}) where {U} = unitpair(U)

# constructors

function InlineTimeDelta64{U}(v::AbstractTimeDelta64) where {U}
    InlineTimeDelta64{U}(value(TimeDelta64(v, U)))
end

function InlineTimeDelta64{U}(v::AbstractString) where {U}
    InlineTimeDelta64{U}(value(TimeDelta64(v, U)))
end

function InlineTimeDelta64{U}(v::DatesPeriod) where {U}
    InlineTimeDelta64{U}(value(TimeDelta64(v, U)))
end

function InlineTimeDelta64{U}(v::Integer) where {U}
    InlineTimeDelta64{U}(convert(Int, v))
end

function InlineTimeDelta64(v::AbstractTimeDelta64, u::UnitArg = defaultunit(v))
    InlineTimeDelta64{unitparam(u)}(v)
end

function InlineTimeDelta64(v::AbstractString, u::UnitArg = defaultunit(v))
    InlineTimeDelta64{unitparam(u)}(v)
end

function InlineTimeDelta64(v::DatesPeriod, u::UnitArg = defaultunit(v))
    InlineTimeDelta64{unitparam(u)}(v)
end

function InlineTimeDelta64(v::Integer, u::UnitArg)
    InlineTimeDelta64{unitparam(u)}(v)
end

# convert

Base.convert(::Type{InlineTimeDelta64}, p::InlineTimeDelta64) = p
Base.convert(::Type{InlineTimeDelta64}, p::Union{AbstractTimeDelta64,DatesPeriod}) =
    InlineTimeDelta64(p)
Base.convert(::Type{InlineTimeDelta64{U}}, p::InlineTimeDelta64{U}) where {U} = p
Base.convert(
    ::Type{InlineTimeDelta64{U}},
    p::Union{AbstractTimeDelta64,DatesPeriod},
) where {U} = InlineTimeDelta64{U}(p)

# show

function Base.show(io::IO, d::InlineTimeDelta64)
    if get(io, :typeinfo, Any) == typeof(d)
        showvalue(io, d)
    else
        show(io, typeof(d))
        print(io, "(")
        showvalue(io, d)
        print(io, ")")
    end
    nothing
end

Base.show(io::IO, ::MIME"text/plain", d::InlineTimeDelta64) = show(io, d)

@testitem "object" begin
    import Markdown
    @testset "pyis" begin
        x = pylist()
        y = PythonCall.pynew(x)
        z = pylist()
        @test pyis(x, x)
        @test pyis(x, y)
        @test !pyis(x, z)
    end
    @testset "pyrepr" begin
        @test pyrepr(String, pybuiltins.None) == "None"
        @test pyrepr(String, pyint(123)) == "123"
        @test pyrepr(String, "hello") == "'hello'"
    end
    @testset "pyascii" begin
        @test pyascii(String, pybuiltins.None) == "None"
        @test pyascii(String, pyint(234)) == "234"
        @test pyascii(String, "hello") == "'hello'"
    end
    @testset "pyhasattr" begin
        @test pyhasattr(pybuiltins.None, "__class__")
        @test !pyhasattr(pybuiltins.None, "not_an_attr")
    end
    @testset "pygetattr" begin
        @test pyisinstance(pygetattr(pybuiltins.None, "__class__"), pybuiltins.type)
        @test_throws PyException pygetattr(pybuiltins.None, "not_an_attr")
        @test pyisinstance(
            pygetattr(pybuiltins.None, "__class__", pybuiltins.None),
            pybuiltins.type,
        )
        @test pyis(
            pygetattr(pybuiltins.None, "not_an_attr", pybuiltins.None),
            pybuiltins.None,
        )
    end
    @testset "pysetattr" begin
        x = pytype("Foo", (), ())()
        @test_throws PyException pysetattr(pybuiltins.None, "not_an_attr", 123)
        pysetattr(x, "foo", 123)
        @test pyeq(Bool, pygetattr(x, "foo"), 123)
    end
    @testset "pydelattr" begin
        x = pytype("Foo", (), ())()
        @test !pyhasattr(x, "foo")
        pysetattr(x, "foo", 123)
        @test pyhasattr(x, "foo")
        pydelattr(x, "foo")
        @test !pyhasattr(x, "foo")
        @test_throws PyException pydelattr(pybuiltins.None, "__class__")
        @test_throws PyException pydelattr(pybuiltins.None, "not_an_attr")
    end
    @testset "pyissubclass" begin
        @test pyissubclass(pybuiltins.object, pybuiltins.object)
        @test pyissubclass(pybuiltins.int, pybuiltins.object)
        @test pyissubclass(pybuiltins.bool, pybuiltins.object)
        @test pyissubclass(pybuiltins.bool, pybuiltins.int)
        @test !pyissubclass(pybuiltins.int, pybuiltins.bool)
        @test !pyissubclass(pybuiltins.object, pybuiltins.int)
        @test !pyissubclass(pybuiltins.object, pybuiltins.bool)
        @test_throws PyException pyissubclass(pybuiltins.None, pybuiltins.None)
        @test_throws PyException pyissubclass(pybuiltins.object, pybuiltins.None)
        @test_throws PyException pyissubclass(pybuiltins.None, pybuiltins.object)
    end
    @testset "pyisinstance" begin
        o = pybuiltins.object()
        i = pybuiltins.int()
        b = pybuiltins.bool()
        @test pyisinstance(o, pybuiltins.object)
        @test pyisinstance(i, pybuiltins.object)
        @test pyisinstance(b, pybuiltins.object)
        @test pyisinstance(b, pybuiltins.int)
        @test !pyisinstance(i, pybuiltins.bool)
        @test !pyisinstance(o, pybuiltins.int)
        @test !pyisinstance(o, pybuiltins.bool)
        @test_throws PyException pyisinstance(o, pybuiltins.None)
    end
    @testset "pyhash" begin
        @test pyhash(pybuiltins.None) isa Integer
        @test pyhash(pybuiltins.None) == pyhash(pybuiltins.None)
        @test pyhash(pytuple((1, 2, 3))) == pyhash(pytuple((1, 2, 3)))
    end
    @testset "pytruth" begin
        @test !pytruth(pybuiltins.None)
        @test pytruth(pybuiltins.object)
        for n = -2:2
            @test pytruth(pyint(n)) == (n != 0)
        end
        for n = 0:3
            @test pytruth(pylist(zeros(n))) == (n != 0)
        end
    end
    @testset "pynot" begin
        @test pynot(pybuiltins.None)
        @test !pynot(pybuiltins.int)
        for n = -2:2
            @test pynot(pyfloat(n)) == (n == 0)
        end
        for n = 0:3
            @test pynot(pylist(zeros(n))) == (n == 0)
        end
    end
    @testset "pylen" begin
        for n = 0:3
            @test pylen(pytuple(zeros(n))) == n
            @test pylen(pylist(zeros(n))) == n
        end
        @test_throws PyException pylen(pybuiltins.None)
        @test_throws PyException pylen(pyint(0))
    end
    @testset "pygetitem" begin
        x = pyrange(3)
        @test_throws PyException pygetitem(x, pybuiltins.None)
        @test_throws PyException pygetitem(x, 3)
        @test_throws PyException pygetitem(x, -4)
        @test pyeq(Bool, pygetitem(x, 0), 0)
        @test pyeq(Bool, pygetitem(x, 1), 1)
        @test pyeq(Bool, pygetitem(x, 2), 2)
        @test pyeq(Bool, pygetitem(x, -1), 2)
        @test pyeq(Bool, pygetitem(x, -2), 1)
        @test pyeq(Bool, pygetitem(x, -3), 0)
    end
    @testset "pysetitem" begin
        x = pydict()
        @test_throws PyException pygetitem(x, "foo")
        pysetitem(x, "foo", 123)
        @test pyeq(Bool, pygetitem(x, "foo"), 123)
        pysetitem(x, "foo", 0)
        @test pyeq(Bool, pygetitem(x, "foo"), 0)
    end
    @testset "pydelitem" begin
        x = pydict()
        pysetitem(x, "foo", 123)
        @test pylen(x) == 1
        pydelitem(x, "foo")
        @test pylen(x) == 0
    end
    @testset "pydir" begin
        x = pytype("Foo", (), ["foo" => 1, "bar" => 2])()
        d = pydir(x)
        @test pycontains(d, "__class__")
        @test pycontains(d, "foo")
        @test pycontains(d, "bar")
        @test !pycontains(d, "baz")
    end
    @testset "pycall" begin
        @test pyeq(Bool, pycall(pybuiltins.int), 0)
        @test_throws PyException pycall(pybuiltins.None)
        @test pyeq(Bool, pycall(pybuiltins.int, "10"), 10)
        @test_throws PyException pycall(pybuiltins.int, "10", "20")
        @test pyeq(Bool, pycall(pybuiltins.int, "10", base = 16), 16)
        @test_throws PyException pycall(pybuiltins.int, "10", base = "16")
        @test_throws PyException pycall(pybuiltins.int, "10", bad_argument = 0)
    end
    @testset "pyeq" begin
        @test pyis(pyeq(pybuiltins.None, pybuiltins.None), pybuiltins.True)
        @test pyeq(Bool, pybuiltins.None, pybuiltins.None)
        @test pyis(pyeq(pybuiltins.None, pybuiltins.int), pybuiltins.False)
        @test !pyeq(Bool, pybuiltins.None, pybuiltins.int)
    end
    @testset "pyne" begin
        @test pyis(pyne(pybuiltins.None, pybuiltins.None), pybuiltins.False)
        @test !pyne(Bool, pybuiltins.None, pybuiltins.None)
        @test pyis(pyne(pybuiltins.None, pybuiltins.int), pybuiltins.True)
        @test pyne(Bool, pybuiltins.None, pybuiltins.int)
    end
    @testset "pylt" begin
        for a = -1:1
            for b = -1:1
                @test pyis(pylt(pyint(a), pyint(b)), pybool(a < b))
                @test pylt(Bool, pyint(a), pyint(b)) == (a < b)
            end
        end
    end
    @testset "pyle" begin
        for a = -1:1
            for b = -1:1
                @test pyis(pyle(pyint(a), pyint(b)), pybool(a ≤ b))
                @test pyle(Bool, pyint(a), pyint(b)) == (a ≤ b)
            end
        end
    end
    @testset "pygt" begin
        for a = -1:1
            for b = -1:1
                @test pyis(pygt(pyint(a), pyint(b)), pybool(a > b))
                @test pygt(Bool, pyint(a), pyint(b)) == (a > b)
            end
        end
    end
    @testset "pyge" begin
        for a = -1:1
            for b = -1:1
                @test pyis(pyge(pyint(a), pyint(b)), pybool(a ≥ b))
                @test pyge(Bool, pyint(a), pyint(b)) == (a ≥ b)
            end
        end
    end
    @testset "pycontains" begin
        x = pyrange(3)
        @test pycontains(x, 0)
        @test pycontains(x, 1)
        @test pycontains(x, 2)
        @test !pycontains(x, 3)
        @test !pycontains(x, -1)
        @test !pycontains(x, pybuiltins.None)
    end
    @testset "pyin" begin
        x = pyrange(3)
        @test pyin(0, x)
        @test pyin(1, x)
        @test pyin(2, x)
        @test !pyin(3, x)
        @test !pyin(-1, x)
        @test !pyin(pybuiltins.None, x)
    end
    @testset "getdoc" begin
        @test Base.Docs.getdoc(Py(nothing)) isa Markdown.MD
        @test Base.Docs.getdoc(Py(12)) isa Markdown.MD
        @test Base.Docs.getdoc(pybuiltins.int) isa Markdown.MD
        @test Base.Docs.getdoc(PythonCall.PyNULL) === nothing
    end
end

@testitem "iter" begin
    @testset "non-iterables" begin
        @test_throws PyException pyiter(pybuiltins.None)
        @test_throws PyException pyiter(pybuiltins.True)
    end
    @testset "unsafe_pynext" begin
        it = pyiter(pyrange(2))
        x = PythonCall.unsafe_pynext(it)
        @test x isa Py
        @test !PythonCall.pyisnull(x)
        @test pyeq(Bool, x, 0)
        x = PythonCall.unsafe_pynext(it)
        @test x isa Py
        @test !PythonCall.pyisnull(x)
        @test pyeq(Bool, x, 1)
        x = PythonCall.unsafe_pynext(it)
        @test x isa Py
        @test PythonCall.pyisnull(x)
    end
    @testset "pynext" begin
        it = pyiter(pyrange(2))
        x = pynext(it)
        @test x isa Py
        @test pyeq(Bool, x, 0)
        x = pynext(it)
        @test x isa Py
        @test pyeq(Bool, x, 1)
        @test_throws PyException pynext(it)
    end
    @testset "pynext with default" begin
        it = pyiter(pyrange(2))
        x = pynext(it, nothing)
        @test x isa Py
        @test pyeq(Bool, x, 0)
        x = pynext(it, nothing)
        @test x isa Py
        @test pyeq(Bool, x, 1)
        x = pynext(it, nothing)
        @test x === nothing
    end
end

@testitem "number" begin
    @testset "pyneg" begin
        for n = -2:2
            @test pyeq(Bool, pyneg(pyint(n)), pyint(-n))
        end
    end
    @testset "pypos" begin
        for n = -2:2
            @test pyeq(Bool, pypos(pyint(n)), pyint(n))
        end
    end
    @testset "pyabs" begin
        for n = -2:2
            @test pyeq(Bool, pyabs(pyint(n)), pyint(abs(n)))
        end
    end
    @testset "pyinv" begin
        for n = -2:2
            @test pyeq(Bool, pyinv(pyint(n)), pyint(-n - 1))
        end
    end
    @testset "pyindex" begin
        for n = -2:2
            @test pyeq(Bool, pyindex(pyint(n)), pyint(n))
        end
    end
    @testset "pyadd" begin
        for x = -2:2
            for y = -2:2
                @test pyeq(Bool, pyadd(pyint(x), pyint(y)), pyint(x + y))
            end
        end
    end
    @testset "pysub" begin
        for x = -2:2
            for y = -2:2
                @test pyeq(Bool, pysub(pyint(x), pyint(y)), pyint(x - y))
            end
        end
    end
    @testset "pymul" begin
        for x = -2:2
            for y = -2:2
                @test pyeq(Bool, pymul(pyint(x), pyint(y)), pyint(x * y))
            end
        end
    end
    # TODO
    # @testset "pymatmul" begin
    #     for x in -2:2
    #         for y in -2:2
    #             @test pyeq(Bool, pymul(pyint(x), pyint(y)), pyint(x*y))
    #         end
    #     end
    # end
    @testset "pytruediv" begin
        for x = -2:2
            for y = -2:2
                if y == 0
                    @test_throws PyException pytruediv(pyint(x), pyint(y))
                else
                    @test pyeq(Bool, pytruediv(pyint(x), pyint(y)), pyfloat(x / y))
                end
            end
        end
    end
    @testset "pyfloordiv" begin
        for x = -2:2
            for y = -2:2
                if y == 0
                    @test_throws PyException pyfloordiv(pyint(x), pyint(y))
                else
                    @test pyeq(Bool, pyfloordiv(pyint(x), pyint(y)), pyfloat(fld(x, y)))
                end
            end
        end
    end
    @testset "pymod" begin
        for x = -2:2
            for y = -2:2
                if y == 0
                    @test_throws PyException pymod(pyint(x), pyint(y))
                else
                    @test pyeq(Bool, pymod(pyint(x), pyint(y)), pyint(mod(x, y)))
                end
            end
        end
    end
    @testset "pydivmod" begin
        for x = -2:2
            for y = -2:2
                if y == 0
                    @test_throws PyException pydivmod(pyint(x), pyint(y))
                else
                    @test pyeq(Bool, pydivmod(pyint(x), pyint(y)), pytuple(fldmod(x, y)))
                end
            end
        end
    end
    @testset "pylshift" begin
        for n = 0:3
            @test pyeq(Bool, pylshift(pyint(123), pyint(n)), pyint(123 << n))
        end
    end
    @testset "pyrshift" begin
        for n = 0:3
            @test pyeq(Bool, pyrshift(pyint(123), pyint(n)), pyint(123 >> n))
        end
    end
    @testset "pyand" begin
        for x = 0:3
            for y = 0:3
                @test pyeq(Bool, pyand(pyint(x), pyint(y)), pyint(x & y))
            end
        end
    end
    @testset "pyxor" begin
        for x = 0:3
            for y = 0:3
                @test pyeq(Bool, pyxor(pyint(x), pyint(y)), pyint(x ⊻ y))
            end
        end
    end
    @testset "pyor" begin
        for x = 0:3
            for y = 0:3
                @test pyeq(Bool, pyor(pyint(x), pyint(y)), pyint(x | y))
            end
        end
    end
    # TODO: in-place operators
end

@testitem "builtins" begin
    @testset "pyprint" begin
        buf = pyimport("io").StringIO()
        ans = pyprint("hello", 12, file = buf)
        @test ans === nothing
        buf.seek(0)
        @test pyeq(Bool, buf.read().strip(), "hello 12")
    end
    @testset "pyall" begin
        for val in [[true, true], [true, false], [false, false]]
            @test pyall(pylist(val)) === all(val)
        end
    end
    @testset "pyany" begin
        for val in [[true, true], [true, false], [false, false]]
            @test pyany(pylist(val)) === any(val)
        end
    end
    @testset "pycallable" begin
        @test pycallable(pybuiltins.str) === true
        @test pycallable(pybuiltins.any) === true
        @test pycallable(pybuiltins.None) === false
        @test pycallable(pybuiltins.True) === false
        @test pycallable(pybuiltins.object) === true
    end
    @testset "pycompile" begin
        ans = pycompile("3+4", "foo.py", "eval")
        @test pyeq(Bool, ans.co_filename, "foo.py")
        @test pyeq(Bool, pybuiltins.eval(ans, pydict()), 7)
    end
end

@testitem "import" begin
    sys = pyimport("sys")
    os = pyimport("os")
    @test pyeq(Bool, sys.__name__, "sys")
    @test pyeq(Bool, os.__name__, "os")
    sysos = pyimport("sys", "os")
    @test sysos isa Tuple{Py,Py}
    @test pyis(sysos[1], sys)
    @test pyis(sysos[2], os)
    ver = pyimport("sys" => "version")
    @test pyis(ver, sys.version)
    path = pyimport("sys" => "path")
    @test pyis(path, sys.path)
    verpath = pyimport("sys" => ("version", "path"))
    @test verpath isa Tuple{Py,Py}
    @test pyis(verpath[1], ver)
    @test pyis(verpath[2], path)
end

@testitem "consts" begin
    @test pybuiltins.None isa Py
    @test pystr(String, pybuiltins.None) == "None"
end

@testitem "str" begin
    @test pyisinstance(pystr("foo"), pybuiltins.str)
    @test pyeq(Bool, pystr(pystr("foo")), pystr("foo"))
    @test pyeq(Bool, pystr(SubString("foobarbaz", 4:6)), pystr("bar"))
    @test pyeq(Bool, pystr('x'), pystr("x"))
    @test pystr(String, pybuiltins.None) === "None"
    @test pystr(String, pyint(123)) === "123"
    @test pystr(String, pystr("foo")) === "foo"
end

@testitem "bytes" begin
    @test pyisinstance(pybytes(UInt8[1, 2, 3]), pybuiltins.bytes)
    @test pyeq(Bool, pybytes(pylist([1, 2, 3])), pybytes(UInt8[1, 2, 3]))
    @test pyeq(Bool, pybytes(b"foo"), pystr("foo").encode("ascii"))
    @test pyeq(
        Bool,
        pybytes(codeunits(SubString("foobarbaz", 4:6))),
        pystr("bar").encode("ascii"),
    )
    @test pybytes(Vector, pylist([1, 2, 3])) == UInt8[1, 2, 3]
    @test pybytes(Vector{UInt8}, pylist([1, 2, 3])) == UInt8[1, 2, 3]
    @test pybytes(Base.CodeUnits, pystr("foo").encode("ascii")) == b"foo"
    @test pybytes(Base.CodeUnits{UInt8,String}, pystr("bar").encode("ascii")) == b"bar"
end

@testitem "tuple" begin
    z = pytuple()
    @test pyisinstance(z, pybuiltins.tuple)
    @test pylen(z) == 0
    x = pytuple((1, 2, 3))
    @test pyisinstance(x, pybuiltins.tuple)
    @test pylen(x) == 3
    @test pyeq(Bool, pygetitem(x, 0), 1)
    @test pyeq(Bool, pygetitem(x, 1), 2)
    @test pyeq(Bool, pygetitem(x, 2), 3)
    @test pyeq(Bool, pytuple([1, 2, 3]), x)
    @test pyeq(Bool, pytuple(i + 1 for i = 0:10 if i < 3), x)
    @test pyeq(Bool, pytuple(pytuple((1, 2, 3))), x)
    @test pyeq(Bool, pytuple(pylist([1, 2, 3])), x)
end

@testitem "list" begin
    z = pylist()
    @test pyisinstance(z, pybuiltins.list)
    @test pylen(z) == 0
    x = pylist((1, 2, 3))
    @test pyisinstance(x, pybuiltins.list)
    @test pylen(x) == 3
    @test pyeq(Bool, pygetitem(x, 0), 1)
    @test pyeq(Bool, pygetitem(x, 1), 2)
    @test pyeq(Bool, pygetitem(x, 2), 3)
    @test pyeq(Bool, pylist([1, 2, 3]), x)
    @test pyeq(Bool, pylist(i + 1 for i = 0:10 if i < 3), x)
    @test pyeq(Bool, pylist(pylist((1, 2, 3))), x)
    @test pyeq(Bool, pylist(pytuple([1, 2, 3])), x)
    @test pyeq(Bool, pycollist([1, 2, 3]), pylist([1, 2, 3]))
    @test pyeq(Bool, pycollist([1 2; 3 4]), pylist((pylist([1, 3]), pylist([2, 4]))))
    @test pyeq(Bool, pyrowlist([1, 2, 3]), pylist([1, 2, 3]))
    @test pyeq(Bool, pyrowlist([1 2; 3 4]), pylist((pylist([1, 2]), pylist([3, 4]))))
end

@testitem "dict" begin
    z = pydict()
    @test pyisinstance(z, pybuiltins.dict)
    @test pylen(z) == 0
    x = pydict(foo = 1, bar = 2)
    @test pyisinstance(x, pybuiltins.dict)
    @test pylen(x) == 2
    @test pyeq(Bool, pygetitem(x, "foo"), 1)
    @test pyeq(Bool, pygetitem(x, "bar"), 2)
    @test pyeq(Bool, pydict(["foo" => 1, "bar" => 2]), x)
    @test pyeq(Bool, pydict([("foo" => 1), ("bar" => 2)]), x)
    @test pyeq(Bool, pydict(Dict("foo" => 1, "bar" => 2)), x)
    @test pyeq(Bool, pydict((foo = 1, bar = 2)), x)
    @test pyeq(Bool, pydict(x), x)
    @test pyeq(Bool, pydict("foo" => 1, "bar" => 2), x)
end

@testitem "bool" begin
    @test pyis(pybool(), pybuiltins.False)
    @test pyis(pybool(false), pybuiltins.False)
    @test pyis(pybool(true), pybuiltins.True)
    @test pyis(pybool(0.0), pybuiltins.False)
    @test pyis(pybool(-1.2), pybuiltins.True)
    @test pyis(pybool(pybuiltins.None), pybuiltins.False)
    @test pyis(pybool(pylist()), pybuiltins.False)
    @test pyis(pybool(pylist([1, 2, 3])), pybuiltins.True)
end

@testitem "int" begin
    @test pyisinstance(pyint(), pybuiltins.int)
    @test pystr(String, pyint()) == "0"
    x = 123
    y = pyint(x)
    @test pyisinstance(y, pybuiltins.int)
    @test pystr(String, y) == string(x)
    x = BigInt(123) << 200
    y = pyint(x)
    @test pyisinstance(y, pybuiltins.int)
    @test pystr(String, y) == string(x)
    x = UInt(123)
    y = pyint(x)
    @test pyisinstance(y, pybuiltins.int)
    @test pystr(String, y) == string(x)
    x = UInt128(123) << 100
    y = pyint(x)
    @test pyisinstance(y, pybuiltins.int)
    @test pystr(String, y) == string(x)
    @test pyeq(Bool, pyint(pyint(123)), pyint(123))
    @test pyeq(Bool, pyint(pyfloat(12.3)), pyint(12))
end

@testitem "float" begin
    y = pyfloat()
    @test pyisinstance(y, pybuiltins.float)
    @test pyeq(Bool, y, pyint(0))
    x = 123
    y = pyfloat(x)
    @test pyisinstance(y, pybuiltins.float)
    @test pyeq(Bool, y, pyint(x))
    x = 0.25
    y = pyfloat(x)
    @test pyisinstance(y, pybuiltins.float)
    @test pyeq(Bool, y, pytruediv(1, 4))
    x = 1 // 4
    y = pyfloat(x)
    @test pyisinstance(y, pybuiltins.float)
    @test pyeq(Bool, y, pyfloat(float(x)))
    @test pyeq(Bool, pyfloat(pyfloat(12.3)), pyfloat(12.3))
    @test pyeq(Bool, pyfloat(pyint(123)), pyfloat(123))
end

@testitem "complex" begin
    y = pycomplex()
    @test pyisinstance(y, pybuiltins.complex)
    @test pyeq(Bool, y, pyint(0))
    x = 12.3
    y = pycomplex(x)
    @test pyisinstance(y, pybuiltins.complex)
    @test pyeq(Bool, y, pyfloat(x))
    xr, xi = 12, 34
    y = pycomplex(xr, xi)
    @test pyisinstance(y, pybuiltins.complex)
    @test pyeq(Bool, y.real, pyfloat(xr))
    @test pyeq(Bool, y.imag, pyfloat(xi))
    x = Complex(12, 34)
    y = pycomplex(x)
    @test pyisinstance(y, pybuiltins.complex)
    @test pyeq(Bool, y.real, pyfloat(real(x)))
    @test pyeq(Bool, y.imag, pyfloat(imag(x)))
    @test pyeq(Bool, pycomplex(y), y)
    @test pyeq(Bool, pycomplex(pyint(12), pyint(34)), y)
end

@testitem "set" begin
    y = pyset()
    yf = pyfrozenset()
    @test pyisinstance(y, pybuiltins.set)
    @test pylen(y) == 0
    @test pyisinstance(yf, pybuiltins.frozenset)
    @test pylen(yf) == 0
    @test pyeq(Bool, y, yf)
    x = [1, 2, 3, 2, 1]
    y = pyset(x)
    yf = pyfrozenset(x)
    @test pyisinstance(y, pybuiltins.set)
    @test pylen(y) == 3
    @test pycontains(y, 1)
    @test pycontains(y, 2)
    @test pycontains(y, 3)
    @test pyeq(Bool, pyset(y), y)
    @test pyisinstance(yf, pybuiltins.frozenset)
    @test pylen(yf) == 3
    @test pycontains(yf, 1)
    @test pycontains(yf, 2)
    @test pycontains(yf, 3)
    @test pyeq(Bool, pyfrozenset(y), y)
    @test pyeq(Bool, y, yf)
end

@testitem "slice" begin
    x = pyslice(12)
    @test pyisinstance(x, pybuiltins.slice)
    @test pyeq(Bool, x.start, pybuiltins.None)
    @test pyeq(Bool, x.stop, 12)
    @test pyeq(Bool, x.step, pybuiltins.None)
    x = pyslice(12, 34)
    @test pyisinstance(x, pybuiltins.slice)
    @test pyeq(Bool, x.start, 12)
    @test pyeq(Bool, x.stop, 34)
    @test pyeq(Bool, x.step, pybuiltins.None)
    x = pyslice(12, 34, 56)
    @test pyisinstance(x, pybuiltins.slice)
    @test pyeq(Bool, x.start, 12)
    @test pyeq(Bool, x.stop, 34)
    @test pyeq(Bool, x.step, 56)
end

@testitem "range" begin
    x = pyrange(123)
    @test pyisinstance(x, pybuiltins.range)
    @test pyeq(Bool, x.start, 0)
    @test pyeq(Bool, x.stop, 123)
    @test pyeq(Bool, x.step, 1)
    x = pyrange(12, 123)
    @test pyisinstance(x, pybuiltins.range)
    @test pyeq(Bool, x.start, 12)
    @test pyeq(Bool, x.stop, 123)
    @test pyeq(Bool, x.step, 1)
    x = pyrange(12, 123, 3)
    @test pyisinstance(x, pybuiltins.range)
    @test pyeq(Bool, x.start, 12)
    @test pyeq(Bool, x.stop, 123)
    @test pyeq(Bool, x.step, 3)
end

@testitem "none" begin
    # TODO
end

@testitem "type" begin
    x = pytype(pyint())
    @test pyisinstance(x, pybuiltins.type)
    @test pyis(x, pybuiltins.int)
    x = pytype(pybuiltins.type)
    @test pyisinstance(x, pybuiltins.type)
    @test pyis(x, pybuiltins.type)
    x = pytype("Foo", (), ["foo" => 1, "bar" => 2])
    @test pyisinstance(x, pybuiltins.type)
    @test pyeq(Bool, x.__name__, "Foo")
    @test pyeq(Bool, x.foo, 1)
    @test pyeq(Bool, x.bar, 2)
end

@testitem "fraction" begin
    # TODO
end

@testitem "method" begin
    # TODO
end

@testitem "datetime" begin
    using Dates
    dt = pyimport("datetime")
    x1 = pydate(2001, 2, 3)
    @test pyisinstance(x1, dt.date)
    @test pyeq(Bool, x1, dt.date(2001, 2, 3))
    x2 = pydate(Date(2002, 3, 4))
    @test pyisinstance(x2, dt.date)
    @test pyeq(Bool, x2, dt.date(2002, 3, 4))
    x3 = pytime(12, 3, 4, 5)
    @test pyisinstance(x3, dt.time)
    @test pyeq(Bool, x3, dt.time(12, 3, 4, 5))
    x4 = pytime(Time(23, 4, 5, 0, 6))
    @test pyisinstance(x4, dt.time)
    @test pyeq(Bool, x4, dt.time(23, 4, 5, 6))
    x5 = pydatetime(2001, 2, 3, 4, 5, 6, 7)
    @test pyisinstance(x5, dt.datetime)
    @test pyeq(Bool, x5, dt.datetime(2001, 2, 3, 4, 5, 6, 7))
    x6 = pydatetime(Date(2007, 8, 9))
    @test pyisinstance(x6, dt.datetime)
    @test pyeq(Bool, x6, dt.datetime(2007, 8, 9))
    x7 = pydatetime(DateTime(2001, 2, 3, 4, 5, 6, 7))
    @test pyisinstance(x7, dt.datetime)
    @test pyeq(Bool, x7, dt.datetime(2001, 2, 3, 4, 5, 6, 7000))
end

@testitem "code" begin
    # check for ArgumentError when inputs are mixed up
    @test_throws ArgumentError pyeval(Main, "1+1")
    @test_throws ArgumentError pyeval(Main, Main)
    @test_throws ArgumentError pyeval("1+1", "1+1")
    @test_throws ArgumentError pyexec(Main, "1+1")
    @test_throws ArgumentError pyexec(Main, Main)
    @test_throws ArgumentError pyexec("1+1", "1+1")
    # basic code execution
    m = Module(:test)
    g = pydict()
    @test pyeq(Bool, pyeval("1+1", m), 2)
    @test pyeq(Bool, pyeval("1+1", g), 2)
    @test pyeq(Bool, pyeval(pystr("1+1"), g), 2)
    @test pyexec("1+1", m) === nothing
    @test pyexec("1+1", g) === nothing
    @test pyexec(pystr("1+1"), g) === nothing
    # check the globals are what we think they are
    @test pyis(pyeval("globals()", g), g)
    mg = pyeval("globals()", m)
    @test pyisinstance(mg, pybuiltins.dict)
    # these automatically gain 1 item, __builtins__
    @test length(g) == 1
    @test length(mg) == 1
    @test pycontains(g, "__builtins__")
    @test pycontains(mg, "__builtins__")
    # code should fail when x does not exist
    @test_throws PyException pyeval("x+1", g)
    @test_throws PyException pyeval("x+1", g)
    # now set x and try again
    g["x"] = 1
    @test pyeq(Bool, pyeval("x+1", g), 2)
    # set x using pyexec this time
    pyexec("x=2", g)
    @test pyeq(Bool, g["x"], 2)
    @test pyeq(Bool, pyeval("x+1", g), 3)
    # now use locals
    # check empty locals have no effect
    l = pydict()
    @test pyeq(Bool, pyeval("x+1", g, l), 3)
    @test pyeq(Bool, pyeval("x+1", g, Dict()), 3)
    # now set x locally
    l["x"] = 3
    @test pyeq(Bool, pyeval("x+1", g, l), 4)
    @test pyeq(Bool, pyeval("x+1", g, Dict()), 3)
    @test pyeq(Bool, pyeval("x+1", g, Dict("x" => 0)), 1)
    @test pyeq(Bool, pyeval("x+1", g, (x = 1,)), 2)
    # check pyexec runs in local scope
    pyexec("x=4", g, l)
    @test pyeq(Bool, g["x"], 2)
    @test pyeq(Bool, l["x"], 4)
    # check global code runs in global scope
    pyexec("global y; y=x+1", g, l)
    @test pyeq(Bool, g["y"], 5)
    @test !pycontains(l, "y")
    # check pyeval converts types correctly
    @test pyeval(Int, "1+1", g) === 2
    @test pyeval(Nothing, "None", g) === nothing
    # @pyexec
    @test_throws PyException @pyexec(`raise ValueError`)
    @test @pyexec(`1 + 2`) === nothing
    @test @pyexec(`ans = 1 + 2` => (ans::Int,)) === (ans = 3,)
    @test @pyexec((x = 1, y = 2) => `ans = x + y` => (ans::Int,)) === (ans = 3,)
    # @pyeval
    @test_throws PyException @pyeval(`import sys`)  # not an expression
    @test_throws PyException @pyeval(`None + None`)
    @test @pyeval(`1 + 2` => Int) === 3
    @test @pyeval((x = 1, y = 2) => `x + y` => Int) === 3
end

@testitem "@pyconst" begin
    f() = @pyconst "hello"
    g() = @pyconst "hello"
    @test f() === f()
    @test f() === f()
    @test g() === g()
    @test g() !== f()
    @test f() isa Py
    @test pyeq(Bool, f(), "hello")
end

@testitem "Base.jl" begin
    @testset "broadcast" begin
        # Py always broadcasts as a scalar
        x = [1 2; 3 4] .+ Py(1)
        @test isequal(x, [Py(2) Py(3); Py(4) Py(5)])
        x = Py("foo") .* [1 2; 3 4]
        @test isequal(x, [Py("foo") Py("foofoo"); Py("foofoofoo") Py("foofoofoofoo")])
        # this previously treated the list as a shape (2,) object
        # but now tries to do `1 + [1, 2]` which properly fails
        @test_throws PyException [1 2; 3 4] .+ pylist([1, 2])
    end
    @testset "showable" begin
        @test showable(MIME("text/plain"), Py(nothing))
        @test showable(MIME("text/plain"), Py(12))
        # https://github.com/JuliaPy/PythonCall.jl/issues/522
        @test showable(MIME("text/plain"), PythonCall.pynew())
        @test !showable(MIME("text/html"), PythonCall.pynew())
    end
    @testset "show" begin
        @test sprint(show, MIME("text/plain"), Py(nothing)) == "Python: None"
        @test sprint(show, MIME("text/plain"), Py(12)) == "Python: 12"
        # https://github.com/JuliaPy/PythonCall.jl/issues/522
        @test sprint(show, MIME("text/plain"), PythonCall.pynew()) == "Python: NULL"
        # test compact printing
        @test sprint(show, MIME("text/plain"), Py(String('A':'Z')), context=(:compact=>true, :displaysize=>(50, 20))) == "Py: 'ABCDE ... WXYZ'"
        @test sprint(show, MIME("text/plain"), Py(String('A':'Z')), context=(:compact=>true, :limit=>false, :displaysize=>(50, 20))) == "Py: 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'"
        @test_throws MethodError sprint(show, MIME("text/html"), PythonCall.pynew())
    end
end

@testitem "pywith" begin
    @testset "no error" begin
        tdir = pyimport("tempfile").TemporaryDirectory()
        tname = pyconvert(String, tdir.name)
        @test isdir(tname)
        pywith(tdir) do name
            @test pyconvert(String, name) == tname
        end
        @test !isdir(tname)
    end
    @testset "error" begin
        tdir = pyimport("tempfile").TemporaryDirectory()
        tname = pyconvert(String, tdir.name)
        @test isdir(tname)
        @test_throws PyException pywith(name -> name.invalid_attr, tdir)
        @test !isdir(tname)
    end
end

@testitem "propertynames" begin
    @testset "basic" begin
        x = pyint(7)
        task = Threads.@spawn propertynames(x)
        properties = propertynames(x)
        @test :__init__ in properties
        prop_task = fetch(task)
        @test properties == prop_task
    end
    @testset "gil (#751)" begin
        o = pyint(751)
        t = Base.Threads.@spawn begin
            PythonCall.GIL.@lock begin
                propertynames(o)
            end
        end
        PythonCall.GIL.@unlock wait(t)
    end
end

@testitem "on_main_thread" begin
    refid = PythonCall.C.on_main_thread() do; Threads.threadid(); end
    tasks = [Threads.@spawn(PythonCall.C.on_main_thread() do; Threads.threadid(); end) for _ in 1:20]
    @test all(t -> fetch(t) == refid, tasks)
    @test_throws DivideError redirect_stderr(devnull) do
        PythonCall.C.on_main_thread() do
            throw(DivideError())
        end
    end
end

ispy(x::PyPandasDataFrame) = true
Py(x::PyPandasDataFrame) = x.py

pyconvert_rule_pandasdataframe(::Type{PyPandasDataFrame}, x::Py) =
    pyconvert_return(PyPandasDataFrame(x))

### Show

### Tables

Tables.istable(::Type{PyPandasDataFrame}) = true

Tables.columnaccess(::Type{PyPandasDataFrame}) = true

Tables.columns(df::PyPandasDataFrame) = _columns(df, df.columnnames, df.columntypes)

function _columns(df, columnnames, columntypes)
    # collect columns
    colnames = Symbol[]
    pycolumns = Py[]
    if df.indexname !== nothing
        push!(colnames, df.indexname)
        push!(pycolumns, df.py.index.values)
    end
    for pycolname in df.py.columns
        colname = columnnames(pycolname)::Symbol
        pycolumn = df.py[pycolname].values
        push!(colnames, colname)
        push!(pycolumns, pycolumn)
    end
    # ensure column names are unique by appending a _N suffix
    colnamecount = Dict{Symbol,Int}()
    for (i, colname) in pairs(colnames)
        n = get(colnamecount, colname, 0) + 1
        colnamecount[colname] = n
        if n > 1
            colnames[i] = Symbol(colname, :_, n)
        end
    end
    # convert columns to vectors
    columns = AbstractVector[]
    coltypes = Type[]
    for (colname, pycolumn) in zip(colnames, pycolumns)
        coltype = columntypes(colname)::Union{Nothing,Type}
        if coltype !== nothing
            column = pyconvert(AbstractVector{coltype}, pycolumn)
        else
            column = pyconvert(AbstractVector, pycolumn)
            if eltype(column) == Py
                column = pyconvert(AbstractVector{Any}, pycolumn)
            end
            if !isconcretetype(eltype(column))
                column = [(x === nothing) ? missing : x for x in column]
                if eltype(column) != Float64 && Float64 <: eltype(column)
                    column = [x === NaN ? missing : x for x in column]
                end
            end
        end
        push!(columns, column)
        push!(coltypes, eltype(column))
    end
    # output a table
    # TODO: realising columns to vectors could be done lazily with a different table type
    schema = Tables.Schema(colnames, coltypes)
    coldict = Tables.OrderedDict(k => v for (k, v) in zip(colnames, columns))
    table = Tables.DictColumnTable(schema, coldict)
    Tables.columns(table)
end

struct pyconvert_rule_numpysimplevalue{R,S} <: Function end

function (::pyconvert_rule_numpysimplevalue{R,SAFE})(::Type{T}, x::Py) where {R,SAFE,T}
    ans = C.PySimpleObject_GetValue(R, x)
    if SAFE
        pyconvert_return(convert(T, ans))
    else
        pyconvert_tryconvert(T, ans)
    end
end

function pyconvert_rule_datetime64(::Type{DateTime64}, x::Py)
    pyconvert_return(C.PySimpleObject_GetValue(DateTime64, x))
end

function pyconvert_rule_datetime64(::Type{T}, x::Py) where {T<:InlineDateTime64}
    pyconvert_tryconvert(T, C.PySimpleObject_GetValue(DateTime64, x))
end

function pyconvert_rule_datetime64(::Type{T}, x::Py) where {T<:NumpyDates.DatesInstant}
    d = C.PySimpleObject_GetValue(DateTime64, x)
    if isnan(d)
        pyconvert_unconverted()
    else
        pyconvert_tryconvert(T, d)
    end
end

function pyconvert_rule_datetime64(::Type{Missing}, x::Py)
    d = C.PySimpleObject_GetValue(DateTime64, x)
    if isnan(d)
        pyconvert_return(missing)
    else
        pyconvert_unconverted()
    end
end

function pyconvert_rule_datetime64(::Type{Nothing}, x::Py)
    d = C.PySimpleObject_GetValue(DateTime64, x)
    if isnan(d)
        pyconvert_return(nothing)
    else
        pyconvert_unconverted()
    end
end

function pyconvert_rule_timedelta64(::Type{TimeDelta64}, x::Py)
    pyconvert_return(C.PySimpleObject_GetValue(TimeDelta64, x))
end

function pyconvert_rule_timedelta64(::Type{T}, x::Py) where {T<:InlineTimeDelta64}
    pyconvert_tryconvert(T, C.PySimpleObject_GetValue(TimeDelta64, x))
end

function pyconvert_rule_timedelta64(::Type{T}, x::Py) where {T<:NumpyDates.DatesPeriod}
    d = C.PySimpleObject_GetValue(TimeDelta64, x)
    if isnan(d)
        pyconvert_unconverted()
    else
        pyconvert_tryconvert(T, d)
    end
end

function pyconvert_rule_timedelta64(::Type{Missing}, x::Py)
    d = C.PySimpleObject_GetValue(TimeDelta64, x)
    if isnan(d)
        pyconvert_return(missing)
    else
        pyconvert_unconverted()
    end
end

function pyconvert_rule_timedelta64(::Type{Nothing}, x::Py)
    d = C.PySimpleObject_GetValue(TimeDelta64, x)
    if isnan(d)
        pyconvert_return(missing)
    else
        pyconvert_unconverted()
    end
end

const NUMPY_SIMPLE_TYPES = [
    ("bool_", Bool),
    ("int8", Int8),
    ("int16", Int16),
    ("int32", Int32),
    ("int64", Int64),
    ("uint8", UInt8),
    ("uint16", UInt16),
    ("uint32", UInt32),
    ("uint64", UInt64),
    ("float16", Float16),
    ("float32", Float32),
    ("float64", Float64),
    ("complex32", ComplexF16),
    ("complex64", ComplexF32),
    ("complex128", ComplexF64),
]

function init_numpy()
    # simple numeric scalar types
    for (t, T) in NUMPY_SIMPLE_TYPES
        isbool = occursin("bool", t)
        isint = occursin("int", t) || isbool
        isuint = occursin("uint", t) || isbool
        isfloat = occursin("float", t)
        iscomplex = occursin("complex", t)
        isreal = isint || isfloat
        isnumber = isreal || iscomplex

        name = "numpy:$t"
        rule = pyconvert_rule_numpysimplevalue{T,false}()
        saferule = pyconvert_rule_numpysimplevalue{T,true}()

        pyconvert_add_rule(name, T, saferule, PYCONVERT_PRIORITY_ARRAY)
        isuint && pyconvert_add_rule(name, UInt, sizeof(T) ≤ sizeof(UInt) ? saferule : rule)
        isuint && pyconvert_add_rule(name, Int, sizeof(T) < sizeof(Int) ? saferule : rule)
        isint &&
            !isuint &&
            pyconvert_add_rule(name, Int, sizeof(T) ≤ sizeof(Int) ? saferule : rule)
        isint && pyconvert_add_rule(name, Integer, rule)
        isfloat && pyconvert_add_rule(name, Float64, saferule)
        isreal && pyconvert_add_rule(name, Real, rule)
        iscomplex && pyconvert_add_rule(name, ComplexF64, saferule)
        iscomplex && pyconvert_add_rule(name, Complex, rule)
        isnumber && pyconvert_add_rule(name, Number, rule)
    end

    # datetime64
    pyconvert_add_rule(
        "numpy:datetime64",
        DateTime64,
        pyconvert_rule_datetime64,
        PYCONVERT_PRIORITY_ARRAY,
    )
    pyconvert_add_rule("numpy:datetime64", InlineDateTime64, pyconvert_rule_datetime64)
    pyconvert_add_rule(
        "numpy:datetime64",
        NumpyDates.DatesInstant,
        pyconvert_rule_datetime64,
    )
    pyconvert_add_rule("numpy:datetime64", Missing, pyconvert_rule_datetime64)
    pyconvert_add_rule("numpy:datetime64", Nothing, pyconvert_rule_datetime64)

    # timedelta64
    pyconvert_add_rule(
        "numpy:timedelta64",
        TimeDelta64,
        pyconvert_rule_timedelta64,
        PYCONVERT_PRIORITY_ARRAY,
    )
    pyconvert_add_rule("numpy:timedelta64", InlineTimeDelta64, pyconvert_rule_timedelta64)
    pyconvert_add_rule(
        "numpy:timedelta64",
        NumpyDates.DatesPeriod,
        pyconvert_rule_timedelta64,
    )
    pyconvert_add_rule("numpy:timedelta64", Missing, pyconvert_rule_timedelta64)
    pyconvert_add_rule("numpy:timedelta64", Nothing, pyconvert_rule_timedelta64)
end

struct DictPairSet{K,V,T<:AbstractDict{K,V}} <: AbstractSet{Tuple{K,V}}
    dict::T
end
Base.length(x::DictPairSet) = length(x.dict)
Base.iterate(x::DictPairSet) =
    (r = iterate(x.dict); r === nothing ? nothing : (Tuple(r[1]), r[2]))
Base.iterate(x::DictPairSet, st) =
    (r = iterate(x.dict, st); r === nothing ? nothing : (Tuple(r[1]), r[2]))
Base.in(v::Pair, x::DictPairSet) = v in x.dict
Base.in(v::Tuple{Any,Any}, x::DictPairSet) = Pair(v[1], v[2]) in x.dict

pyjldict_iter(x::AbstractDict) = Py(Iterator(keys(x)))

pyjldict_contains(x::AbstractDict, k::Py) =
    Py(haskey(x, @pyconvert(keytype(x), k, return Py(false))))

pyjldict_clear(x::AbstractDict) = (empty!(x); Py(nothing))

pyjldict_getitem(x::AbstractDict, k::Py) = Py(x[pyconvert(keytype(x), k)])

pyjldict_setitem(x::AbstractDict, k::Py, v::Py) =
    (x[pyconvertarg(keytype(x), k, "key")] = pyconvertarg(valtype(x), v, "value");
    Py(nothing))

pyjldict_delitem(x::AbstractDict, k::Py) =
    (delete!(x, pyconvert(keytype(x), k)); Py(nothing))

function pyjldict_update(x::AbstractDict, items_::Py)
    for item_ in items_
        (k, v) = pyconvert(Tuple{keytype(x),valtype(x)}, item_)
        x[k] = v
    end
    Py(nothing)
end

const pyjldicttype = pynew()

function init_dict()
    jl = pyjuliacallmodule
    pybuiltins.exec(
        pybuiltins.compile(
            """
$("\n"^(@__LINE__()-1))
class DictValue(AnyValue):
    __slots__ = ()
    _jl_undefined_ = object()
    def __bool__(self):
        return bool(len(self))
    def __iter__(self):
        return self._jl_callmethod($(pyjl_methodnum(pyjldict_iter)))
    def __contains__(self, key):
        return self._jl_callmethod($(pyjl_methodnum(pyjldict_contains)), key)
    def __getitem__(self, key):
        if key in self:
            return self._jl_callmethod($(pyjl_methodnum(pyjldict_getitem)), key)
        else:
            raise KeyError(key)
    def __setitem__(self, key, value):
        return self._jl_callmethod($(pyjl_methodnum(pyjldict_setitem)), key, value)
    def __delitem__(self, key):
        if key in self:
            return self._jl_callmethod($(pyjl_methodnum(pyjldict_delitem)), key)
        else:
            raise KeyError(key)
    def keys(self):
        return self._jl_callmethod($(pyjl_methodnum(Py ∘ keys)))
    def values(self):
        return self._jl_callmethod($(pyjl_methodnum(Py ∘ values)))
    def items(self):
        return self._jl_callmethod($(pyjl_methodnum(Py ∘ DictPairSet)))
    def get(self, key, default=None):
        if key in self:
            return self[key]
        else:
            return default
    def setdefault(self, key, default=None):
        if key not in self:
            self[key] = default
        return self[key]
    def clear(self):
        return self._jl_callmethod($(pyjl_methodnum(pyjldict_clear)))
    def pop(self, key, default=_jl_undefined_):
        if key in self:
            ans = self[key]
            del self[key]
            return ans
        elif default is self._jl_undefined_:
            raise KeyError(key)
        else:
            return default
    def popitem(self):
        if len(self):
            return self._jl_callmethod($(pyjl_methodnum(Py ∘ pop!)))
        else:
            raise KeyError()
    def update(self, other=_jl_undefined_, **kwargs):
        if other is self._jl_undefined_:
            pass
        else:
            if hasattr(other, "keys"):
                items = ((k, other[k]) for k in other.keys())
            else:
                items = other
            self._jl_callmethod($(pyjl_methodnum(pyjldict_update)), items)
        if kwargs:
            self.update(kwargs)
    def copy(self):
        return self._jl_callmethod($(pyjl_methodnum(Py ∘ copy)))
import collections.abc
collections.abc.MutableMapping.register(DictValue)
del collections
""",
            @__FILE__(),
            "exec",
        ),
        jl.__dict__,
    )
    pycopy!(pyjldicttype, jl.DictValue)
end

pyjltype(::AbstractDict) = pyjldicttype

"""
    module PythonCall.JlWrap

Defines the Python object wrappers around Julia objects (`juliacall.AnyValue` etc).
"""
module JlWrap

using ..PythonCall
using ..Utils
using ..NumpyDates: NumpyDates
using ..C
using ..Core
using ..Convert
using ..GC: GC
using ..GIL

import ..PythonCall:
    pyfunc,
    pyclassmethod,
    pystaticmethod,
    pyproperty,
    pyjl,
    pyjltype,
    pyisjl,
    pyjlvalue,
    pyjlraw,
    pybinaryio,
    pytextio,
    PyObjectVector,
    PyObjectMatrix,
    PyObjectArray

using Base: @propagate_inbounds, allocatedinline

import ..Core: Py

include("C.jl")
include("base.jl")
include("raw.jl")
include("any.jl")
include("iter.jl")
include("type.jl")
include("module.jl")
include("io.jl")
include("number.jl")
include("objectarray.jl")
include("array.jl")
include("vector.jl")
include("dict.jl")
include("set.jl")
include("callback.jl")

function __init__()
    init_base()
    init_raw()
    init_any()
    init_iter()
    init_type()
    init_module()
    init_io()
    init_number()
    init_array()
    init_vector()
    init_dict()
    init_set()
    init_callback()
    # add packages to juliacall
    jl = pyjuliacallmodule
    jl.Core = Base.Core
    jl.Base = Base
    jl.Main = Main
    jl.PythonCall = PythonCall
end

end

struct UnsafePyObject
    ptr::C.PyPtr
end


ispy(::PyArray) = true
Py(x::PyArray) = x.py

for N in (missing, 1, 2)
    for M in (missing, true, false)
        for L in (missing, true, false)
            for R in (true, false)
                name = Symbol(
                    "Py",
                    M === missing ? "" : M ? "Mutable" : "Immutable",
                    L === missing ? "" : L ? "Linear" : "Cartesian",
                    R ? "Raw" : "",
                    N === missing ? "Array" : N == 1 ? "Vector" : "Matrix",
                )
                name == :PyArray && continue
                vars = Any[
                    :T,
                    N === missing ? :N : N,
                    M === missing ? :M : M,
                    L === missing ? :L : L,
                    R ? :T : :R,
                ]
                @eval const $name{$(unique([v for v in vars if v isa Symbol])...)} = PyArray{$(vars...)}
                @eval export $name
            end
        end
    end
end

(::Type{A})(
    x;
    array::Bool = true,
    buffer::Bool = true,
    copy::Bool = true,
) where {A<:PyArray} = @autopy x begin
    r = pyarray_make(A, x_, array = array, buffer = buffer, copy = copy)
    if pyconvert_isunconverted(r)
        error("cannot convert this Python '$(pytype(x_).__name__)' to a '$A'")
    else
        return pyconvert_result(r)::A
    end
end

pyconvert_rule_array_nocopy(::Type{A}, x::Py) where {A<:PyArray} =
    pyarray_make(A, x, copy = false)

function pyconvert_rule_array(::Type{A}, x::Py) where {A<:AbstractArray}
    r = pyarray_make(PyArray, x)
    if pyconvert_isunconverted(r)
        return pyconvert_unconverted()
    else
        return pyconvert_tryconvert(A, pyconvert_result(PyArray, r))
    end
end

abstract type PyArraySource end

function pyarray_make(
    ::Type{A},
    x::Py;
    array::Bool = true,
    buffer::Bool = true,
    copy::Bool = true,
) where {A<:PyArray}
    # TODO: try/catch is SLOW if an error is thrown, think about sending errors via return values instead
    A == Union{} && return pyconvert_unconverted()
    if array && (xa = pygetattr(x, "__array_struct__", PyNULL); !pyisnull(xa))
        try
            return pyarray_make(A, x, PyArraySource_ArrayStruct(x, xa))
        catch exc
            @debug "failed to make PyArray from __array_struct__" exc = exc
        end
    end
    if array && (xi = pygetattr(x, "__array_interface__", PyNULL); !pyisnull(xi))
        try
            return pyarray_make(A, x, PyArraySource_ArrayInterface(x, xi))
        catch exc
            @debug "failed to make PyArray from __array_interface__" exc = exc
        end
    end
    if buffer && C.PyObject_CheckBuffer(x)
        try
            return pyarray_make(A, x, PyArraySource_Buffer(x))
        catch exc
            @debug "failed to make PyArray from buffer" exc = exc
        end
    end
    if copy && array && pyhasattr(x, "__array__")
        y = x.__array__()
        if (ya = pygetattr(y, "__array_struct__", PyNULL); !pyisnull(ya))
            try
                return pyarray_make(A, y, PyArraySource_ArrayStruct(y, ya))
            catch exc
                @debug "failed to make PyArray from __array__().__array_interface__" exc =
                    exc
            end
        end
        if (yi = pygetattr(y, "__array_interface__", PyNULL); !pyisnull(yi))
            try
                return pyarray_make(A, y, PyArraySource_ArrayInterface(y, yi))
            catch exc
                @debug "failed to make PyArray from __array__().__array_interface__" exc =
                    exc
            end
        end
    end
    return pyconvert_unconverted()
end

function pyarray_make(
    ::Type{A},
    x::Py,
    info::PyArraySource,
    ::Type{PyArray{T0,N0,M0,L0,R0}} = Utils._type_lb(A),
    ::Type{PyArray{T1,N1,M1,L1,R1}} = Utils._type_ub(A),
) where {A<:PyArray,T0,N0,M0,L0,R0,T1,N1,M1,L1,R1}
    # R (buffer eltype)
    R′ = pyarray_get_R(info)::DataType
    if R0 == R1
        R = R1
        R == R′ || error("incorrect R, got $R, should be $R′")
        # elseif T0 == T1 && T1 in (Bool, Int8, Int16, Int32, Int64, Int128, UInt8, UInt16, UInt32, UInt64, UInt128, Float16, Float32, Float64, ComplexF16, ComplexF32, ComplexF64)
        #     R = T1
        #     R == R′ || error("incorrect R, got $R, should be $R′")
        #     R <: R1 || error("R out of bounds, got $R, should be <: $R1")
        #     R >: R0 || error("R out of bounds, got $R, should be >: $R0")
    else
        R = R′
    end
    # ptr
    ptr = pyarray_get_ptr(info, R)::Ptr{R}
    # T (eltype)
    if T0 == T1
        T = T1
        pyarray_check_T(T, R)
    else
        T = pyarray_get_T(R, T0, T1)::DataType
        T <: T1 || error("T out of bounds, got $T, should be <: $T1")
        T >: T0 || error("T out of bounds, got $T, should be >: $T0")
    end
    # N (ndims)
    N′ = pyarray_get_N(info)::Int
    if N0 == N1
        N = N1 isa Int ? N1 : Int(N1)
        N == N′ || error("incorrect N, got $N, should be $N′")
    else
        N = N′
    end
    # size
    size = pyarray_get_size(info, Val(N))::NTuple{N,Int}
    # strides
    strides = pyarray_get_strides(info, Val(N), R, size)::NTuple{N,Int}
    # M (mutable)
    # TODO: if M==false, we don't need to compute M′
    M′ = pyarray_get_M(info)::Bool
    if M0 == M1
        M = M1 isa Bool ? M1 : Bool(M1)
        M && !M′ && error("incorrect M, got $M, should be $M′")
    else
        M = M′
    end
    # L (linearly indexable)
    # TODO: if L==false, we don't need to compute L′
    L′ = N < 2 || strides == Utils.size_to_fstrides(strides[1], size)
    if L0 == L1
        L = L1 isa Bool ? L1 : Bool(L1)
        L && !L′ && error("incorrect L, got $L, should be $L′")
    else
        L = L′
    end
    # handle
    handle = pyarray_get_handle(info)
    # done
    arr = PyArray{T,N,M,L,R}(Val(:new), ptr, size, strides, x, handle)
    return pyconvert_return(arr)
end

# array interface

struct PyArraySource_ArrayInterface <: PyArraySource
    obj::Py
    dict::Py
    ptr::Ptr{Cvoid}
    readonly::Bool
    handle::Py
end
function PyArraySource_ArrayInterface(x::Py, d::Py = x.__array_interface__)
    # offset
    # TODO: how is the offset measured?
    offset = pyconvert(Int, @py d.get("offset", 0))
    offset == 0 || error("not supported: non-zero offset")
    # mask
    @py("mask" in d) && error("not supported: mask")
    # data
    data = @py d.get("data")
    if pyistuple(data)
        ptr = Ptr{Cvoid}(pyconvert(UInt, data[0]))
        readonly = pyconvert(Bool, data[1])
        pydel!(data)
        handle = Py((x, d))
    else
        memview = @py memoryview(data === None ? x : data)
        pydel!(data)
        buf = UnsafePtr(C.PyMemoryView_GET_BUFFER(memview))
        ptr = buf.buf[!]
        readonly = buf.readonly[] != 0
        handle = Py((x, memview))
    end
    PyArraySource_ArrayInterface(x, d, ptr, readonly, handle)
end

pyarray_typestrdescr_to_type(ts::String, descr::Py) = begin
    # byte swapped?
    bsc = ts[1]
    bs =
        bsc == '<' ? !Utils.islittleendian() :
        bsc == '>' ? Utils.islittleendian() :
        bsc == '|' ? false : error("endianness character not supported: $ts")
    bs && error("byte-swapping not supported: $ts")
    # element type
    etc = ts[2]
    if etc == 'b'
        sz = parse(Int, ts[3:end])
        sz == sizeof(Bool) && return Bool
        error("bool of this size not supported: $ts")
    elseif etc == 'i'
        sz = parse(Int, ts[3:end])
        sz == 1 && return Int8
        sz == 2 && return Int16
        sz == 4 && return Int32
        sz == 8 && return Int64
        sz == 16 && return Int128
        error("signed int of this size not supported: $ts")
    elseif etc == 'u'
        sz = parse(Int, ts[3:end])
        sz == 1 && return UInt8
        sz == 2 && return UInt16
        sz == 4 && return UInt32
        sz == 8 && return UInt64
        sz == 16 && return UInt128
        error("unsigned int of this size not supported: $ts")
    elseif etc == 'f'
        sz = parse(Int, ts[3:end])
        sz == 2 && return Float16
        sz == 4 && return Float32
        sz == 8 && return Float64
        error("float of this size not supported: $ts")
    elseif etc == 'c'
        sz = parse(Int, ts[3:end])
        sz == 4 && return Complex{Float16}
        sz == 8 && return Complex{Float32}
        sz == 16 && return Complex{Float64}
        error("complex of this size not supported: $ts")
    elseif etc == 'U'
        sz = parse(Int, ts[3:end])
        return Utils.StaticString{UInt32,sz}
    elseif etc == 'O'
        return UnsafePyObject
    elseif etc == 'V'
        pyisnull(descr) && error("not supported: void dtype with null descr")
        sz = parse(Int, ts[3:end])
        T = pyarray_descr_to_type(descr)
        sizeof(T) == sz ||
            error("size mismatch: itemsize=$sz but sizeof(descr)=$(sizeof(T))")
        return T
    elseif etc == 'M' || etc == 'm'
        m = match(r"^([0-9]+)(\[([0-9]+)?([a-zA-Z]+)\])?$", ts[3:end])
        m === nothing && error("could not parse type: $ts")
        sz = parse(Int, m[1])
        sz == sizeof(Int64) || error(
            "$(etc == 'M' ? "datetime" : "timedelta") of this size not supported: $sz",
        )
        s = m[3] === nothing ? 1 : parse(Int, m[3])
        us = m[4] === nothing ? "" : m[4]
        u =
            us == "" ? NumpyDates.UNBOUND_UNITS :
            us == "Y" ? NumpyDates.YEARS :
            us == "M" ? NumpyDates.MONTHS :
            us == "W" ? NumpyDates.WEEKS :
            us == "D" ? NumpyDates.DAYS :
            us == "h" ? NumpyDates.HOURS :
            us == "m" ? NumpyDates.MINUTES :
            us == "s" ? NumpyDates.SECONDS :
            us == "ms" ? NumpyDates.MILLISECONDS :
            us == "us" ? NumpyDates.MICROSECONDS :
            us == "ns" ? NumpyDates.NANOSECONDS :
            us == "ps" ? NumpyDates.PICOSECONDS :
            us == "fs" ? NumpyDates.FEMTOSECONDS :
            us == "as" ? NumpyDates.ATTOSECONDS :
            error("not supported: $(etc == 'M' ? "datetime" : "timedelta") unit: $us")
        if etc == 'M'
            return NumpyDates.InlineDateTime64{s == 1 ? u : (u, s)}
        else
            return NumpyDates.InlineTimeDelta64{s == 1 ? u : (u, s)}
        end
    else
        error("not supported: dtype of kind: $(repr(etc))")
    end
end

function pyarray_descr_to_type(descr::Py)
    fnames = Symbol[]
    foffsets = Int[]
    ftypes = DataType[]
    curoffset = 0
    for item in descr
        # get the name
        name = item[0]
        if pyistuple(name)
            name = name[0]
        end
        fname = Symbol(pyconvert(String, name))
        # get the shape
        if length(item) > 2
            shape = pyconvert(Vector{Int}, item[2])
        else
            shape = Int[]
        end
        # get the type
        descr2 = item[1]
        if pyisstr(descr2)
            typestr = pyconvert(String, descr2)
            # void entries are just padding to ignore
            if typestr[2] == 'V'
                curoffset += parse(Int, typestr[3:end]) * prod(shape)
                continue
            end
            ftype = pyarray_typestrdescr_to_type(typestr, PyNULL)
        else
            ftype = pyarray_descr_to_type(descr2)
        end
        # apply the shape
        for n in reverse(shape)
            ftype = NTuple{n,ftype}
        end
        # save the field
        push!(fnames, fname)
        push!(foffsets, curoffset)
        push!(ftypes, ftype)
        curoffset += sizeof(ftype)
    end
    # construct the tuple type and check its offsets and size
    # TODO: support non-aligned dtypes by packing them into a custom type and reinterpreting
    T = Tuple{ftypes...}
    for (i, o) in pairs(foffsets)
        fieldoffset(T, i) == o || error("not supported: dtype that is not aligned: $descr")
    end
    sizeof(T) == curoffset || error("not supported: dtype with end padding: $descr")
    # return the tuple type if the field names are f0, f1, ..., else return a named tuple
    if fnames == [Symbol(:f, i - 1) for i = 1:length(fnames)]
        return T
    else
        return NamedTuple{Tuple(fnames),T}
    end
end

function pyarray_get_R(src::PyArraySource_ArrayInterface)
    typestr = pyconvert(String, src.dict["typestr"])
    descr = @py @jl(src.dict).get("descr")
    R = pyarray_typestrdescr_to_type(typestr, descr)::DataType
    pydel!(descr)
    return R
end

pyarray_get_ptr(src::PyArraySource_ArrayInterface, ::Type{R}) where {R} = Ptr{R}(src.ptr)

pyarray_get_N(src::PyArraySource_ArrayInterface) = Int(@py jllen(@jl(src.dict)["shape"]))

pyarray_get_size(src::PyArraySource_ArrayInterface, ::Val{N}) where {N} =
    pyconvert(NTuple{N,Int}, src.dict["shape"])

function pyarray_get_strides(
    src::PyArraySource_ArrayInterface,
    ::Val{N},
    ::Type{R},
    size::NTuple{N,Int},
) where {R,N}
    @py strides = @jl(src.dict).get("strides")
    if pyisnone(strides)
        pydel!(strides)
        return Utils.size_to_cstrides(sizeof(R), size)
    else
        return pyconvert(NTuple{N,Int}, strides)
    end
end

pyarray_get_M(src::PyArraySource_ArrayInterface) = !src.readonly

pyarray_get_handle(src::PyArraySource_ArrayInterface) = src.handle

# array struct

struct PyArraySource_ArrayStruct <: PyArraySource
    obj::Py
    capsule::Py
    info::C.PyArrayInterface
end
function PyArraySource_ArrayStruct(x::Py, capsule::Py = x.__array_struct__)
    name = C.PyCapsule_GetName(capsule)
    ptr = C.PyCapsule_GetPointer(capsule, name)
    info = unsafe_load(Ptr{C.PyArrayInterface}(ptr))
    @assert info.two == 2
    return PyArraySource_ArrayStruct(x, capsule, info)
end

function pyarray_get_R(src::PyArraySource_ArrayStruct)
    swapped = !Utils.isflagset(src.info.flags, C.NPY_ARRAY_NOTSWAPPED)
    hasdescr = Utils.isflagset(src.info.flags, C.NPY_ARR_HAS_DESCR)
    swapped && error("byte-swapping not supported")
    kind = src.info.typekind
    size = src.info.itemsize
    if kind == 98  # b = bool
        if size == sizeof(Bool)
            return Bool
        else
            error("bool of this size not supported: $size")
        end
    elseif kind == 105  # i = int
        if size == 1
            return Int8
        elseif size == 2
            return Int16
        elseif size == 4
            return Int32
        elseif size == 8
            return Int64
        else
            error("int of this size not supported: $size")
        end
    elseif kind == 117  # u = uint
        if size == 1
            return UInt8
        elseif size == 2
            return UInt16
        elseif size == 4
            return UInt32
        elseif size == 8
            return UInt64
        else
            error("uint of this size not supported: $size")
        end
    elseif kind == 102  # f = float
        if size == 2
            return Float16
        elseif size == 4
            return Float32
        elseif size == 8
            return Float64
        else
            error("float of this size not supported: $size")
        end
    elseif kind == 99  # c = complex
        if size == 4
            return ComplexF16
        elseif size == 8
            return ComplexF32
        elseif size == 16
            return ComplexF64
        end
    elseif kind == 109  # m = timedelta
        error("timedelta not supported")
    elseif kind == 77  # M = datetime
        error("datetime not supported")
    elseif kind == 79  # O = object
        if size == sizeof(C.PyPtr)
            return UnsafePyObject
        else
            error("object pointer of this size not supported: $size")
        end
    elseif kind == 83  # S = byte string
        error("byte strings not supported")
    elseif kind == 85  # U = unicode string
        mod(size, 4) == 0 || error("unicode size must be a multiple of 4: $size")
        return Utils.StaticString{UInt32,div(size, 4)}
    elseif kind == 86  # V = void (should have descr)
        hasdescr || error("not supported: void dtype with no descr")
        descr = pynew(incref(src.info.descr))
        T = pyarray_descr_to_type(descr)
        sizeof(T) == size ||
            error("size mismatch: itemsize=$size but sizeof(descr)=$(sizeof(T))")
        return T
    else
        error("not supported: dtype of kind: $(Char(kind))")
    end
    @assert false
end

function pyarray_get_ptr(src::PyArraySource_ArrayStruct, ::Type{R}) where {R}
    return Ptr{R}(src.info.data)
end

function pyarray_get_N(src::PyArraySource_ArrayStruct)
    return Int(src.info.nd)
end

function pyarray_get_size(src::PyArraySource_ArrayStruct, ::Val{N}) where {N}
    ptr = src.info.shape
    return ntuple(i -> Int(unsafe_load(ptr, i)), Val(N))
end

function pyarray_get_strides(
    src::PyArraySource_ArrayStruct,
    ::Val{N},
    ::Type{R},
    size::NTuple{N,Int},
) where {N,R}
    ptr = src.info.strides
    return ntuple(i -> Int(unsafe_load(ptr, i)), Val(N))
end

function pyarray_get_M(src::PyArraySource_ArrayStruct)
    return Utils.isflagset(src.info.flags, C.NPY_ARRAY_WRITEABLE)
end

function pyarray_get_handle(src::PyArraySource_ArrayStruct)
    return src.capsule
end

# buffer protocol

struct PyArraySource_Buffer <: PyArraySource
    obj::Py
    memview::Py
    buf::C.UnsafePtr{C.Py_buffer}
end
function PyArraySource_Buffer(x::Py)
    memview = pybuiltins.memoryview(x)
    buf = C.UnsafePtr(C.PyMemoryView_GET_BUFFER(memview))
    buf.suboffsets[] == C_NULL ||
        error("PyArray does not support buffers with non-trivial suboffsets (PIL-style indirect layout)")
    PyArraySource_Buffer(x, memview, buf)
end

const PYARRAY_BUFFERFORMAT_TO_TYPE = let c = Utils.islittleendian() ? '<' : '>'
    Dict(
        "b" => Cchar,
        "B" => Cuchar,
        "h" => Cshort,
        "H" => Cushort,
        "i" => Cint,
        "I" => Cuint,
        "l" => Clong,
        "L" => Culong,
        "q" => Clonglong,
        "Q" => Culonglong,
        "e" => Float16,
        "f" => Cfloat,
        "d" => Cdouble,
        "$(c)b" => Cchar,
        "$(c)B" => Cuchar,
        "$(c)h" => Cshort,
        "$(c)H" => Cushort,
        "$(c)i" => Cint,
        "$(c)I" => Cuint,
        "$(c)l" => Clong,
        "$(c)L" => Culong,
        "$(c)q" => Clonglong,
        "$(c)Q" => Culonglong,
        "$(c)e" => Float16,
        "$(c)f" => Cfloat,
        "$(c)d" => Cdouble,
        "?" => Bool,
        "P" => Ptr{Cvoid},
        "O" => UnsafePyObject,
        "=e" => Float16,
        "=f" => Float32,
        "=d" => Float64,
    )
end

pyarray_bufferformat_to_type(fmt::String) = get(
    () -> error("not implemented: buffer format $(repr(fmt))"),
    PYARRAY_BUFFERFORMAT_TO_TYPE,
    fmt,
)

function pyarray_get_R(src::PyArraySource_Buffer)
    ptr = src.buf.format[]
    return ptr == C_NULL ? UInt8 : pyarray_bufferformat_to_type(String(ptr))
end

pyarray_get_ptr(src::PyArraySource_Buffer, ::Type{R}) where {R} = Ptr{R}(src.buf.buf[!])

pyarray_get_N(src::PyArraySource_Buffer) = Int(src.buf.ndim[])

function pyarray_get_size(src::PyArraySource_Buffer, ::Val{N}) where {N}
    size = src.buf.shape[]
    if size == C_NULL
        N == 0 ? () : N == 1 ? (Int(src.buf.len[]),) : @assert false
    else
        ntuple(i -> Int(size[i]), N)
    end
end

function pyarray_get_strides(
    src::PyArraySource_Buffer,
    ::Val{N},
    ::Type{R},
    size::NTuple{N,Int},
) where {N,R}
    strides = src.buf.strides[]
    if strides == C_NULL
        itemsize = src.buf.shape[] == C_NULL ? 1 : src.buf.itemsize[]
        Utils.size_to_cstrides(itemsize, size)
    else
        ntuple(i -> Int(strides[i]), N)
    end
end

pyarray_get_M(src::PyArraySource_Buffer) = src.buf.readonly[] == 0

pyarray_get_handle(src::PyArraySource_Buffer) = src.memview

# AbstractArray methods

Base.length(x::PyArray) = x.length

Base.size(x::PyArray) = x.size

Utils.ismutablearray(x::PyArray{T,N,M,L,R}) where {T,N,M,L,R} = M

Base.IndexStyle(::Type{PyArray{T,N,M,L,R}}) where {T,N,M,L,R} =
    L ? Base.IndexLinear() : Base.IndexCartesian()

Base.unsafe_convert(::Type{Ptr{T}}, x::PyArray{T,N,M,L,T}) where {T,N,M,L} = x.ptr

Base.elsize(::Type{PyArray{T,N,M,L,T}}) where {T,N,M,L} = sizeof(T)

Base.strides(x::PyArray{T,N,M,L,R}) where {T,N,M,L,R} =
    if all(mod.(x.strides, sizeof(R)) .== 0)
        div.(x.strides, sizeof(R))
    else
        error("strides are not a multiple of element size")
    end

function Base.showarg(io::IO, x::PyArray{T,N}, toplevel::Bool) where {T,N}
    toplevel || print(io, "::")
    print(io, "PyArray{")
    show(io, T)
    print(io, ", ", N, "}")
    return
end

@propagate_inbounds Base.getindex(x::PyArray{T,N}, i::Vararg{Int,N}) where {T,N} =
    pyarray_getindex(x, i...)
@propagate_inbounds Base.getindex(x::PyArray{T,N,M,true}, i::Int) where {T,N,M} =
    pyarray_getindex(x, i)
@propagate_inbounds Base.getindex(x::PyArray{T,1,M,true}, i::Int) where {T,M} =
    pyarray_getindex(x, i)

@propagate_inbounds function pyarray_getindex(x::PyArray, i...)
    @boundscheck checkbounds(x, i...)
    pyarray_load(eltype(x), x.ptr + pyarray_offset(x, i...))
end

@propagate_inbounds Base.setindex!(x::PyArray{T,N,true}, v, i::Vararg{Int,N}) where {T,N} =
    pyarray_setindex!(x, v, i...)
@propagate_inbounds Base.setindex!(x::PyArray{T,N,true,true}, v, i::Int) where {T,N} =
    pyarray_setindex!(x, v, i)
@propagate_inbounds Base.setindex!(x::PyArray{T,1,true,true}, v, i::Int) where {T} =
    pyarray_setindex!(x, v, i)

@propagate_inbounds function pyarray_setindex!(x::PyArray{T,N,true}, v, i...) where {T,N}
    @boundscheck checkbounds(x, i...)
    pyarray_store!(x.ptr + pyarray_offset(x, i...), convert(T, v))
    x
end

pyarray_offset(x::PyArray{T,N,M,true}, i::Int) where {T,N,M} =
    N == 0 ? 0 : (i - 1) * x.strides[1]
pyarray_offset(x::PyArray{T,1,M,true}, i::Int) where {T,M} = (i - 1) .* x.strides[1]
pyarray_offset(x::PyArray{T,N}, i::Vararg{Int,N}) where {T,N} = sum((i .- 1) .* x.strides)
pyarray_offset(x::PyArray{T,0}) where {T} = 0

function pyarray_load(::Type{T}, p::Ptr{R}) where {T,R}
    if R == T
        unsafe_load(p)
    elseif R == UnsafePyObject
        u = unsafe_load(p)
        o = u.ptr == C_NULL ? pynew(Py(nothing)) : pynew(incref(u.ptr))
        T == Py ? o : pyconvert(T, o)
    else
        convert(T, unsafe_load(p))
    end
end

function pyarray_store!(p::Ptr{R}, x::T) where {R,T}
    if R == T
        unsafe_store!(p, x)
    elseif R == UnsafePyObject
        @autopy x begin
            decref(unsafe_load(p).ptr)
            unsafe_store!(p, UnsafePyObject(getptr(incref(x_))))
        end
    else
        unsafe_store!(p, convert(R, x))
    end
end

function pyarray_get_T(::Type{R}, ::Type{T0}, ::Type{T1}) where {R,T0,T1}
    if R == UnsafePyObject
        if T0 <: Py <: T1
            Py
        else
            T1
        end
    elseif T0 <: R <: T1
        R
    else
        error("impossible")
    end
end

function pyarray_check_T(::Type{T}, ::Type{R}) where {T,R}
    if R == UnsafePyObject
        nothing
    elseif T == R
        nothing
    elseif T <: Number && R <: Number
        nothing
    elseif T <: AbstractString && R <: AbstractString
        nothing
    else
        error("invalid eltype T=$T for raw eltype R=$R")
    end
end

### Py
#
# We use pickle to serialise Python objects to bytes.

_pickle_module() = pyimport(Utils.getpref_pickle())

function serialize_py(s, x::Py)
    if pyisnull(x)
        serialize(s, nothing)
    else
        b = _pickle_module().dumps(x)
        serialize(s, pybytes_asvector(b))
    end
end

function deserialize_py(s)
    v = deserialize(s)
    if v === nothing
        pynew()
    else
        _pickle_module().loads(pybytes(v))
    end
end

function Serialization.serialize(s::AbstractSerializer, x::Py)
    Serialization.serialize_type(s, Py, false)
    serialize_py(s, x)
end

Serialization.deserialize(s::AbstractSerializer, ::Type{Py}) = deserialize_py(s)

### PyException
#
# Traceback objects are not serialisable, but Exception objects are (because pickle just
# ignores the __traceback__ attribute), so we serialise a PyException by just serialising
# its (normalised) `v` field, from which we can recover the type and traceback.
#
# This means the user can install something like "tblib" to enable pickling of tracebacks
# and for free this enables serializing PyException including the traceback.

function Serialization.serialize(s::AbstractSerializer, x::PyException)
    Serialization.serialize_type(s, PyException, false)
    serialize_py(s, x.v)
end

Serialization.deserialize(s::AbstractSerializer, ::Type{PyException}) =
    PyException(deserialize_py(s))

### PyArray
#
# This type holds a pointer and a handle (usually a python memoryview or capsule) which are
# not serializable by default, and even if they were would not be consistent after
# serializing each field independently. So we just serialize the wrapped Python object.

function Serialization.serialize(s::AbstractSerializer, x::PyArray)
    Serialization.serialize_type(s, typeof(x), false)
    serialize_py(s, x.py)
end

function Serialization.deserialize(s::AbstractSerializer, ::Type{T}) where {T<:PyArray}
    # TODO: set buffer and array args too?
    T(deserialize_py(s); copy = false)
end

"""
    python_executable_path()

Path to the Python interpreter, or `missing` if not known.
"""
python_executable_path() = CTX.exe_path

"""
    python_library_path()

Path to libpython, or `missing` if not known.
"""
python_library_path() = CTX.lib_path

"""
    python_library_handle()

Handle to the open libpython, or `C_NULL` if not known.
"""
python_library_handle() = CTX.lib_ptr

"""
    python_version()

The version of Python, or `missing` if not known.
"""
python_version() = CTX.version

using Dates

oldver = ARGS[1]
newver = ARGS[2]

function bump(file, oldpat, newpat)
    println("Bumping $file...")
    @assert oldpat != newpat
    oldtext = read(file, String)
    newtext = replace(oldtext, oldpat => newpat)
    @assert newtext != oldtext
    write(file, newtext)
end

function bumpver(file, pattern, oldver, newver)
    @assert oldver != newver
    oldpat = replace(pattern, "{}" => oldver)
    @assert oldpat != pattern
    newpat = replace(pattern, "{}" => newver)
    @assert newpat != pattern
    bump(file, oldver, newver)
end

bumpver("Project.toml", "version = \"{}\"\n", oldver, newver)
bumpver("pyproject.toml", "version = \"{}\"\n", oldver, newver)
bumpver("pysrc/juliacall/__init__.py", "__version__ = '{}'\n", oldver, newver)
bumpver("pysrc/juliacall/juliapkg.json", "\"version\": \"={}\"", oldver, newver)
bumpver("pysrc/juliacall/juliapkg-dev.json", "\"version\": \"={}\"", oldver, newver)
bumpver("src/API/API.jl", "VERSION = v\"{}\"", oldver, newver)
bumpver("src/Core/Core.jl", "VERSION = v\"{}\"", oldver, newver)
bump("CHANGELOG.md", "## Unreleased", "## $newver ($(today()))")

### object interface

"""
    pyis(x, y)

True if `x` and `y` are the same Python object. Equivalent to `x is y` in Python.
"""
pyis(x, y) = @autopy x y getptr(x_) == getptr(y_)

pyisnot(x, y) = !pyis(x, y)

"""
    pyrepr(x)

Equivalent to `repr(x)` in Python.
"""
pyrepr(x) = pynew(errcheck(@autopy x C.PyObject_Repr(x_)))
pyrepr(::Type{String}, x) = (s = pyrepr(x); ans = pystr_asstring(s); pydel!(s); ans)

"""
    pyascii(x)

Equivalent to `ascii(x)` in Python.
"""
pyascii(x) = pynew(errcheck(@autopy x C.PyObject_ASCII(x_)))
pyascii(::Type{String}, x) = (s = pyascii(x); ans = pystr_asstring(s); pydel!(s); ans)

"""
    pyhasattr(x, k)

Equivalent to `hasattr(x, k)` in Python.

Tests if `getattr(x, k)` raises an `AttributeError`.
"""
function pyhasattr(x, k)
    ptr = @autopy x k C.PyObject_GetAttr(x_, k_)
    if iserrset(ptr)
        if errmatches(pybuiltins.AttributeError)
            errclear()
            return false
        else
            pythrow()
        end
    else
        decref(ptr)
        return true
    end
end
# pyhasattr(x, k) = errcheck(@autopy x k C.PyObject_HasAttr(x_, k_)) == 1

"""
    pygetattr(x, k, [d])

Equivalent to `getattr(x, k)` or `x.k` in Python.

If `d` is specified, it is returned if the attribute does not exist.
"""
pygetattr(x, k) = pynew(errcheck(@autopy x k C.PyObject_GetAttr(x_, k_)))
function pygetattr(x, k, d)
    ptr = @autopy x k C.PyObject_GetAttr(x_, k_)
    if iserrset(ptr)
        if errmatches(pybuiltins.AttributeError)
            errclear()
            return d
        else
            pythrow()
        end
    else
        return pynew(ptr)
    end
end

"""
    pysetattr(x, k, v)

Equivalent to `setattr(x, k, v)` or `x.k = v` in Python.
"""
pysetattr(x, k, v) = (errcheck(@autopy x k v C.PyObject_SetAttr(x_, k_, v_)); nothing)

"""
    pydelattr(x, k)

Equivalent to `delattr(x, k)` or `del x.k` in Python.
"""
pydelattr(x, k) = (errcheck(@autopy x k C.PyObject_SetAttr(x_, k_, C.PyNULL)); nothing)

"""
    pyissubclass(s, t)

Test if `s` is a subclass of `t`. Equivalent to `issubclass(s, t)` in Python.
"""
pyissubclass(s, t) = errcheck(@autopy s t C.PyObject_IsSubclass(s_, t_)) == 1

"""
    pyisinstance(x, t)

Test if `x` is of type `t`. Equivalent to `isinstance(x, t)` in Python.
"""
pyisinstance(x, t) = errcheck(@autopy x t C.PyObject_IsInstance(x_, t_)) == 1

"""
    pyhash(x)

Equivalent to `hash(x)` in Python, converted to an `Integer`.
"""
pyhash(x) = errcheck(@autopy x C.PyObject_Hash(x_))

"""
    pytruth(x)

The truthyness of `x`. Equivalent to `bool(x)` in Python, converted to a `Bool`.
"""
pytruth(x) = errcheck(@autopy x C.PyObject_IsTrue(x_)) == 1

"""
    pynot(x)

The falsyness of `x`. Equivalent to `not x` in Python, converted to a `Bool`.
"""
pynot(x) = errcheck(@autopy x C.PyObject_Not(x_)) == 1

"""
    pylen(x)

The length of `x`. Equivalent to `len(x)` in Python, converted to an `Integer`.
"""
pylen(x) = errcheck(@autopy x C.PyObject_Length(x_))

"""
    pyhasitem(x, k)

Test if `pygetitem(x, k)` raises a `KeyError` or `AttributeError`.
"""
function pyhasitem(x, k)
    ptr = @autopy x k C.PyObject_GetItem(x_, k_)
    if iserrset(ptr)
        if errmatches(pybuiltins.KeyError) || errmatches(pybuiltins.IndexError)
            errclear()
            return false
        else
            pythrow()
        end
    else
        decref(ptr)
        return true
    end
end

"""
    pygetitem(x, k, [d])

Equivalent `x[k]` in Python.

If `d` is specified, it is returned if the item does not exist (i.e. if `x[k]` raises a
`KeyError` or `IndexError`).
"""
pygetitem(x, k) = pynew(errcheck(@autopy x k C.PyObject_GetItem(x_, k_)))
function pygetitem(x, k, d)
    ptr = @autopy x k C.PyObject_GetItem(x_, k_)
    if iserrset(ptr)
        if errmatches(pybuiltins.KeyError) || errmatches(pybuiltins.IndexError)
            errclear()
            return d
        else
            pythrow()
        end
    else
        return pynew(ptr)
    end
end

"""
    pysetitem(x, k, v)

Equivalent to `setitem(x, k, v)` or `x[k] = v` in Python.
"""
pysetitem(x, k, v) = (errcheck(@autopy x k v C.PyObject_SetItem(x_, k_, v_)); nothing)

"""
    pydelitem(x, k)

Equivalent to `delitem(x, k)` or `del x[k]` in Python.
"""
pydelitem(x, k) = (errcheck(@autopy x k C.PyObject_DelItem(x_, k_)); nothing)

"""
    pydir(x)

Equivalent to `dir(x)` in Python.
"""
pydir(x) = pynew(errcheck(@autopy x C.PyObject_Dir(x_)))

pycallargs(f) = pynew(errcheck(@autopy f C.PyObject_CallObject(f_, C.PyNULL)))
pycallargs(f, args) = pynew(errcheck(@autopy f args C.PyObject_CallObject(f_, args_)))
pycallargs(f, args, kwargs) =
    pynew(errcheck(@autopy f args kwargs C.PyObject_Call(f_, args_, kwargs_)))

"""
    pycall(f, args...; kwargs...)

Call the Python object `f` with the given arguments.
"""
pycall(f, args...; kwargs...) =
    if !isempty(kwargs)
        args_ = pytuple_fromiter(args)
        kwargs_ = pystrdict_fromiter(kwargs)
        ans = pycallargs(f, args_, kwargs_)
        pydel!(args_)
        pydel!(kwargs_)
        ans
    elseif !isempty(args)
        args_ = pytuple_fromiter(args)
        ans = pycallargs(f, args_)
        pydel!(args_)
        ans
    else
        pycallargs(f)
    end

"""
    pyeq(x, y)
    pyeq(Bool, x, y)

Equivalent to `x == y` in Python. The second form converts to `Bool`.
"""
pyeq(x, y) = pynew(errcheck(@autopy x y C.PyObject_RichCompare(x_, y_, C.Py_EQ)))

"""
    pyne(x, y)
    pyne(Bool, x, y)

Equivalent to `x != y` in Python. The second form converts to `Bool`.
"""
pyne(x, y) = pynew(errcheck(@autopy x y C.PyObject_RichCompare(x_, y_, C.Py_NE)))

"""
    pyle(x, y)
    pyle(Bool, x, y)

Equivalent to `x <= y` in Python. The second form converts to `Bool`.
"""
pyle(x, y) = pynew(errcheck(@autopy x y C.PyObject_RichCompare(x_, y_, C.Py_LE)))

"""
    pylt(x, y)
    pylt(Bool, x, y)

Equivalent to `x < y` in Python. The second form converts to `Bool`.
"""
pylt(x, y) = pynew(errcheck(@autopy x y C.PyObject_RichCompare(x_, y_, C.Py_LT)))

"""
    pyge(x, y)
    pyge(Bool, x, y)

Equivalent to `x >= y` in Python. The second form converts to `Bool`.
"""
pyge(x, y) = pynew(errcheck(@autopy x y C.PyObject_RichCompare(x_, y_, C.Py_GE)))

"""
    pygt(x, y)
    pygt(Bool, x, y)

Equivalent to `x > y` in Python. The second form converts to `Bool`.
"""
pygt(x, y) = pynew(errcheck(@autopy x y C.PyObject_RichCompare(x_, y_, C.Py_GT)))
pyeq(::Type{Bool}, x, y) =
    errcheck(@autopy x y C.PyObject_RichCompareBool(x_, y_, C.Py_EQ)) == 1
pyne(::Type{Bool}, x, y) =
    errcheck(@autopy x y C.PyObject_RichCompareBool(x_, y_, C.Py_NE)) == 1
pyle(::Type{Bool}, x, y) =
    errcheck(@autopy x y C.PyObject_RichCompareBool(x_, y_, C.Py_LE)) == 1
pylt(::Type{Bool}, x, y) =
    errcheck(@autopy x y C.PyObject_RichCompareBool(x_, y_, C.Py_LT)) == 1
pyge(::Type{Bool}, x, y) =
    errcheck(@autopy x y C.PyObject_RichCompareBool(x_, y_, C.Py_GE)) == 1
pygt(::Type{Bool}, x, y) =
    errcheck(@autopy x y C.PyObject_RichCompareBool(x_, y_, C.Py_GT)) == 1

"""
    pycontains(x, v)

Equivalent to `v in x` in Python.
"""
pycontains(x, v) = errcheck(@autopy x v C.PySequence_Contains(x_, v_)) == 1

"""
    pyin(v, x)

Equivalent to `v in x` in Python.
"""
pyin(v, x) = pycontains(x, v)

pynotin(v, x) = !pyin(v, x)

### number interface

# unary
"""
    pyneg(x)

Equivalent to `-x` in Python.
"""
pyneg(x) = pynew(errcheck(@autopy x C.PyNumber_Negative(x_)))
"""
    pypos(x)

Equivalent to `+x` in Python.
"""
pypos(x) = pynew(errcheck(@autopy x C.PyNumber_Positive(x_)))
"""
    pyabs(x)

Equivalent to `abs(x)` in Python.
"""
pyabs(x) = pynew(errcheck(@autopy x C.PyNumber_Absolute(x_)))
"""
    pyinv(x)

Equivalent to `~x` in Python.
"""
pyinv(x) = pynew(errcheck(@autopy x C.PyNumber_Invert(x_)))
"""
    pyindex(x)

Convert `x` losslessly to an `int`.
"""
pyindex(x) = pynew(errcheck(@autopy x C.PyNumber_Index(x_)))

# binary
"""
    pyadd(x, y)

Equivalent to `x + y` in Python.
"""
pyadd(x, y) = pynew(errcheck(@autopy x y C.PyNumber_Add(x_, y_)))
"""
    pysub(x, y)

Equivalent to `x - y` in Python.
"""
pysub(x, y) = pynew(errcheck(@autopy x y C.PyNumber_Subtract(x_, y_)))
"""
    pymul(x, y)

Equivalent to `x * y` in Python.
"""
pymul(x, y) = pynew(errcheck(@autopy x y C.PyNumber_Multiply(x_, y_)))
"""
    pymatmul(x, y)

Equivalent to `x @ y` in Python.
"""
pymatmul(x, y) = pynew(errcheck(@autopy x y C.PyNumber_MatrixMultiply(x_, y_)))
"""
    pyfloordiv(x, y)

Equivalent to `x // y` in Python.
"""
pyfloordiv(x, y) = pynew(errcheck(@autopy x y C.PyNumber_FloorDivide(x_, y_)))
"""
    pytruediv(x, y)

Equivalent to `x / y` in Python.
"""
pytruediv(x, y) = pynew(errcheck(@autopy x y C.PyNumber_TrueDivide(x_, y_)))
"""
    pymod(x, y)

Equivalent to `x % y` in Python.
"""
pymod(x, y) = pynew(errcheck(@autopy x y C.PyNumber_Remainder(x_, y_)))
"""
    pydivmod(x, y)

Equivalent to `divmod(x, y)` in Python.
"""
pydivmod(x, y) = pynew(errcheck(@autopy x y C.PyNumber_Divmod(x_, y_)))
"""
    pylshift(x, y)

Equivalent to `x << y` in Python.
"""
pylshift(x, y) = pynew(errcheck(@autopy x y C.PyNumber_Lshift(x_, y_)))
"""
    pyrshift(x, y)

Equivalent to `x >> y` in Python.
"""
pyrshift(x, y) = pynew(errcheck(@autopy x y C.PyNumber_Rshift(x_, y_)))
"""
    pyand(x, y)

Equivalent to `x & y` in Python.
"""
pyand(x, y) = pynew(errcheck(@autopy x y C.PyNumber_And(x_, y_)))
"""
    pyxor(x, y)

Equivalent to `x ^ y` in Python.
"""
pyxor(x, y) = pynew(errcheck(@autopy x y C.PyNumber_Xor(x_, y_)))
"""
    pyor(x, y)

Equivalent to `x | y` in Python.
"""
pyor(x, y) = pynew(errcheck(@autopy x y C.PyNumber_Or(x_, y_)))

# binary in-place
"""
    pyiadd(x, y)

In-place add. `x = pyiadd(x, y)` is equivalent to `x += y` in Python.
"""
pyiadd(x, y) = pynew(errcheck(@autopy x y C.PyNumber_InPlaceAdd(x_, y_)))
"""
    pyisub(x, y)

In-place subtract. `x = pyisub(x, y)` is equivalent to `x -= y` in Python.
"""
pyisub(x, y) = pynew(errcheck(@autopy x y C.PyNumber_InPlaceSubtract(x_, y_)))
"""
    pyimul(x, y)

In-place multiply. `x = pyimul(x, y)` is equivalent to `x *= y` in Python.
"""
pyimul(x, y) = pynew(errcheck(@autopy x y C.PyNumber_InPlaceMultiply(x_, y_)))
"""
    pyimatmul(x, y)

In-place matrix multiply. `x = pyimatmul(x, y)` is equivalent to `x @= y` in Python.
"""
pyimatmul(x, y) = pynew(errcheck(@autopy x y C.PyNumber_InPlaceMatrixMultiply(x_, y_)))
"""
    pyifloordiv(x, y)

In-place floor divide. `x = pyifloordiv(x, y)` is equivalent to `x //= y` in Python.
"""
pyifloordiv(x, y) = pynew(errcheck(@autopy x y C.PyNumber_InPlaceFloorDivide(x_, y_)))
"""
    pyitruediv(x, y)

In-place true division. `x = pyitruediv(x, y)` is equivalent to `x /= y` in Python.
"""
pyitruediv(x, y) = pynew(errcheck(@autopy x y C.PyNumber_InPlaceTrueDivide(x_, y_)))
"""
    pyimod(x, y)

In-place subtraction. `x = pyimod(x, y)` is equivalent to `x %= y` in Python.
"""
pyimod(x, y) = pynew(errcheck(@autopy x y C.PyNumber_InPlaceRemainder(x_, y_)))
"""
    pyilshift(x, y)

In-place left shift. `x = pyilshift(x, y)` is equivalent to `x <<= y` in Python.
"""
pyilshift(x, y) = pynew(errcheck(@autopy x y C.PyNumber_InPlaceLshift(x_, y_)))
"""
    pyirshift(x, y)

In-place right shift. `x = pyirshift(x, y)` is equivalent to `x >>= y` in Python.
"""
pyirshift(x, y) = pynew(errcheck(@autopy x y C.PyNumber_InPlaceRshift(x_, y_)))
"""
    pyiand(x, y)

In-place and. `x = pyiand(x, y)` is equivalent to `x &= y` in Python.
"""
pyiand(x, y) = pynew(errcheck(@autopy x y C.PyNumber_InPlaceAnd(x_, y_)))
"""
    pyixor(x, y)

In-place xor. `x = pyixor(x, y)` is equivalent to `x ^= y` in Python.
"""
pyixor(x, y) = pynew(errcheck(@autopy x y C.PyNumber_InPlaceXor(x_, y_)))
"""
    pyior(x, y)

In-place or. `x = pyior(x, y)` is equivalent to `x |= y` in Python.
"""
pyior(x, y) = pynew(errcheck(@autopy x y C.PyNumber_InPlaceOr(x_, y_)))

# power
"""
    pypow(x, y, z=None)

Equivalent to `x ** y` or `pow(x, y, z)` in Python.
"""
pypow(x, y, z = pybuiltins.None) =
    pynew(errcheck(@autopy x y z C.PyNumber_Power(x_, y_, z_)))
"""
    pyipow(x, y, z=None)

In-place power. `x = pyipow(x, y)` is equivalent to `x **= y` in Python.
"""
pyipow(x, y, z = pybuiltins.None) =
    pynew(errcheck(@autopy x y z C.PyNumber_InPlacePower(x_, y_, z_)))

### iter

"""
    pyiter(x)

Equivalent to `iter(x)` in Python.
"""
pyiter(x) = pynew(errcheck(@autopy x C.PyObject_GetIter(x_)))

"""
    pynext(x, [d])

Equivalent to `next(x, d)` in Python.

Returns the next item from the iterator `x`. If there are no more items, returns `d` if
given, else raises `StopIteration`.
"""
function pynext(x)
    ptr = errcheck_ambig(C.PyIter_Next(x))
    if ptr == C.PyNULL
        errset(pybuiltins.StopIteration)
        pythrow()
    else
        pynew(ptr)
    end
end

function pynext(x, d)
    ptr = errcheck_ambig(C.PyIter_Next(x))
    ptr == C.PyNULL ? d : pynew(ptr)
end

"""
    unsafe_pynext(x)

Return the next item in the iterator `x`. When there are no more items, return NULL.
"""
unsafe_pynext(x::Py) = Base.GC.@preserve x pynew(errcheck_ambig(C.PyIter_Next(x)))

### None

pyisnone(x) = pyis(x, pybuiltins.None)

### bool

"""
    pybool(x)

Convert `x` to a Python `bool`.
"""
pybool(x::Bool = false) = pynew(x ? pybuiltins.True : pybuiltins.False)
pybool(x::Number) = pybool(!iszero(x))
pybool(x) = pybuiltins.bool(x)

pyisTrue(x) = pyis(x, pybuiltins.True)
pyisFalse(x) = pyis(x, pybuiltins.False)
pyisbool(x) = pyisTrue(x) || pyisFalse(x)

function pybool_asbool(x)
    @autopy x if pyisTrue(x_)
        true
    elseif pyisFalse(x_)
        false
    else
        error("not a bool")
    end
end

### str

pystr_fromUTF8(x::Ptr, n::Integer) = pynew(errcheck(C.PyUnicode_DecodeUTF8(x, n, C_NULL)))
pystr_fromUTF8(x) = pystr_fromUTF8(pointer(x), sizeof(x))

"""
    pystr(x)

Convert `x` to a Python `str`.
"""
pystr(x) = pynew(errcheck(@autopy x C.PyObject_Str(x_)))
pystr(x::String) = pystr_fromUTF8(x)
pystr(x::SubString{String}) = pystr_fromUTF8(x)
pystr(x::Char) = pystr(string(x))
pystr(x::AbstractString) = pystr(convert(String, x)::String)
pystr(x::AbstractChar) = pystr(convert(Char, x)::Char)
pystr(::Type{String}, x) = (s = pystr(x); ans = pystr_asstring(s); pydel!(s); ans)

pystr_asUTF8bytes(x::Py) = pynew(errcheck(C.PyUnicode_AsUTF8String(x)))
pystr_asUTF8vector(x::Py) =
    (b = pystr_asUTF8bytes(x); ans = pybytes_asvector(b); pydel!(b); ans)
pystr_asstring(x::Py) =
    (b = pystr_asUTF8bytes(x); ans = pybytes_asUTF8string(b); pydel!(b); ans)

function pystr_intern!(x::Py)
    ptr = Ref(getptr(x))
    C.PyUnicode_InternInPlace(ptr)
    setptr!(x, ptr[])
end

pyisstr(x) = pytypecheckfast(x, C.Py_TPFLAGS_UNICODE_SUBCLASS)

### bytes

pybytes_fromdata(x::Ptr, n::Integer) = pynew(errcheck(C.PyBytes_FromStringAndSize(x, n)))
pybytes_fromdata(x) = pybytes_fromdata(pointer(x), sizeof(x))

"""
    pybytes(x)

Convert `x` to a Python `bytes`.
"""
pybytes(x) = pynew(errcheck(@autopy x C.PyObject_Bytes(x_)))
pybytes(x::Vector{UInt8}) = pybytes_fromdata(x)
pybytes(x::Base.CodeUnits{UInt8,String}) = pybytes_fromdata(x)
pybytes(x::Base.CodeUnits{UInt8,SubString{String}}) = pybytes_fromdata(x)
pybytes(::Type{T}, x) where {Vector{UInt8} <: T <: Vector} =
    (b = pybytes(x); ans = pybytes_asvector(b); pydel!(b); ans)
pybytes(::Type{T}, x) where {Base.CodeUnits{UInt8,String} <: T <: Base.CodeUnits} =
    (b = pybytes(x); ans = Base.CodeUnits(pybytes_asUTF8string(b)); pydel!(b); ans)

pyisbytes(x) = pytypecheckfast(x, C.Py_TPFLAGS_BYTES_SUBCLASS)

function pybytes_asdata(x::Py)
    ptr = Ref(Ptr{Cchar}(0))
    len = Ref(C.Py_ssize_t(0))
    errcheck(C.PyBytes_AsStringAndSize(x, ptr, len))
    ptr[], len[]
end

function pybytes_asvector(x::Py)
    ptr, len = pybytes_asdata(x)
    unsafe_wrap(Array, Ptr{UInt8}(ptr), len)
end

function pybytes_asUTF8string(x::Py)
    ptr, len = pybytes_asdata(x)
    unsafe_string(Ptr{UInt8}(ptr), len)
end

### int

pyint_fallback(
    x::Union{Int8,Int16,Int32,Int64,Int128,UInt8,UInt16,UInt32,UInt64,UInt128,BigInt},
) = pynew(errcheck(C.PyLong_FromString(string(x, base = 32), C_NULL, 32)))
pyint_fallback(x::Integer) = pyint_fallback(BigInt(x))

"""
    pyint(x=0)

Convert `x` to a Python `int`.
"""
function pyint(x::Integer = 0)
    y = mod(x, Clonglong)
    if x == y
        pynew(errcheck(C.PyLong_FromLongLong(y)))
    else
        pyint_fallback(x)
    end
end
function pyint(x::Unsigned)
    y = mod(x, Culonglong)
    if x == y
        pynew(errcheck(C.PyLong_FromUnsignedLongLong(y)))
    else
        pyint_fallback(x)
    end
end
pyint(x) = @autopy x pynew(errcheck(C.PyNumber_Long(x_)))

pyisint(x) = pytypecheckfast(x, C.Py_TPFLAGS_LONG_SUBCLASS)

### float

"""
    pyfloat(x=0.0)

Convert `x` to a Python `float`.
"""
pyfloat(x::Real = 0.0) = pynew(errcheck(C.PyFloat_FromDouble(x)))
pyfloat(x) = @autopy x pynew(errcheck(C.PyNumber_Float(x_)))

pyisfloat(x) = pytypecheck(x, pybuiltins.float)

pyfloat_asdouble(x) = errcheck_ambig(@autopy x C.PyFloat_AsDouble(x_))

### complex

"""
    pycomplex(x=0.0)
    pycomplex(re, im)

Convert `x` to a Python `complex`, or create one from given real and imaginary parts.
"""
pycomplex(x::Real = 0.0, y::Real = 0.0) = pynew(errcheck(C.PyComplex_FromDoubles(x, y)))
pycomplex(x::Complex) = pycomplex(real(x), imag(x))
pycomplex(x) = pybuiltins.complex(x)
pycomplex(x, y) = pybuiltins.complex(x, y)

pyiscomplex(x) = pytypecheck(x, pybuiltins.complex)

function pycomplex_ascomplex(x)
    c = @autopy x C.PyComplex_AsCComplex(x_)
    c.real == -1 && c.imag == 0 && errcheck()
    return Complex(c.real, c.imag)
end

### type

"""
    pytype(x)

The Python `type` of `x`.
"""
pytype(x) = pynew(errcheck(@autopy x C.PyObject_Type(x_)))

"""
    pytype(name, bases, dict)

Create a new type. Equivalent to `type(name, bases, dict)` in Python.

If `bases` is not a Python object, it is converted to one using `pytuple`.

The `dict` may either by a Python object or a Julia iterable. In the latter case, each item
may either be a `name => value` pair or a Python object with a `__name__` attribute.

In order to use a Julia `Function` as an instance method, it must be wrapped into a Python
function with [`pyfunc`](@ref PythonCall.pyfunc). Similarly, see also [`pyclassmethod`](@ref PythonCall.pyclassmethod),
[`pystaticmethod`](@ref PythonCall.pystaticmethod) or [`pyproperty`](@ref PythonCall.pyproperty). In all these cases, the arguments passed
to the function always have type `Py`. See the example below.

# Example

```julia
Foo = pytype("Foo", (), [
    "__module__" => "__main__",

    pyfunc(
        name = "__init__",
        doc = \"\"\"
        Specify x and y to store in the Foo.

        If omitted, y defaults to None.
        \"\"\",
        function (self, x, y = nothing)
            self.x = x
            self.y = y
            return
        end,
    ),

    pyfunc(
        name = "__repr__",
        self -> "Foo(\$(self.x), \$(self.y))",
    ),

    pyclassmethod(
        name = "frompair",
        doc = "Construct a Foo from a tuple of length two.",
        (cls, xy) -> cls(xy...),
    ),

    pystaticmethod(
        name = "hello",
        doc = "Prints a friendly greeting.",
        (name) -> println("Hello, \$name"),
    ),

    "xy" => pyproperty(
        doc = "A tuple of x and y.",
        get = (self) -> (self.x, self.y),
        set = function (self, xy)
            (x, y) = xy
            self.x = x
            self.y = y
            nothing
        end,
    ),
])
```
"""
function pytype(name, bases, dict)
    bases2 = ispy(bases) ? bases : pytuple(bases)
    dict2 =
        ispy(dict) ? dict :
        pydict(ispy(item) ? (pygetattr(item, "__name__") => item) : item for item in dict)
    pybuiltins.type(name, bases2, dict2)
end

pyistype(x) = pytypecheckfast(x, C.Py_TPFLAGS_TYPE_SUBCLASS)

pytypecheck(x, t) = (@autopy x t C.Py_TypeCheck(x_, t_)) == 1
pytypecheckfast(x, f) = (@autopy x C.Py_TypeCheckFast(x_, f)) == 1

### slice

"""
    pyslice([start], stop, [step])

Construct a Python `slice`. Unspecified arguments default to `None`.
"""
pyslice(x, y, z = pybuiltins.None) =
    pynew(errcheck(@autopy x y z C.PySlice_New(x_, y_, z_)))
pyslice(y) = pyslice(pybuiltins.None, y, pybuiltins.None)

pyisslice(x) = pytypecheck(x, pybuiltins.slice)

### range

"""
    pyrange([[start], [stop]], [step])

Construct a Python `range`. Unspecified arguments default to `None`.
"""
pyrange(x, y, z) = pybuiltins.range(x, y, z)
pyrange(x, y) = pybuiltins.range(x, y)
pyrange(y) = pybuiltins.range(y)

pyrange_fromrange(x::AbstractRange) = pyrange(first(x), last(x) + sign(step(x)), step(x))

pyisrange(x) = pytypecheck(x, pybuiltins.range)

### tuple

pynulltuple(len) = pynew(errcheck(C.PyTuple_New(len)))

function pytuple_setitem(xs::Py, i, x)
    errcheck(C.PyTuple_SetItem(xs, i, incref(Py(x))))
    return xs
end

function pytuple_getitem(xs::Py, i)
    Base.GC.@preserve xs pynew(incref(errcheck(C.PyTuple_GetItem(xs, i))))
end

function pytuple_fromiter(xs)
    sz = Base.IteratorSize(typeof(xs))
    if sz isa Base.HasLength || sz isa Base.HasShape
        # length known, e.g. Tuple, Pair, Vector
        ans = pynulltuple(length(xs))
        for (i, x) in enumerate(xs)
            pytuple_setitem(ans, i - 1, x)
        end
        return ans
    else
        # length unknown
        xs_ = pylist_fromiter(xs)
        ans = pylist_astuple(xs_)
        pydel!(xs_)
        return ans
    end
end

@generated function pytuple_fromiter(xs::Tuple)
    n = length(xs.parameters)
    code = []
    push!(code, :(ans = pynulltuple($n)))
    for i = 1:n
        push!(code, :(pytuple_setitem(ans, $(i - 1), xs[$i])))
    end
    push!(code, :(return ans))
    return Expr(:block, code...)
end

"""
    pytuple(x=())

Convert `x` to a Python `tuple`.

If `x` is a Python object, this is equivalent to `tuple(x)` in Python.
Otherwise `x` must be iterable.
"""
pytuple() = pynulltuple(0)
pytuple(x) = ispy(x) ? pybuiltins.tuple(x) : pytuple_fromiter(x)

pyistuple(x) = pytypecheckfast(x, C.Py_TPFLAGS_TUPLE_SUBCLASS)

### list

pynulllist(len) = pynew(errcheck(C.PyList_New(len)))

function pylist_setitem(xs::Py, i, x)
    errcheck(C.PyList_SetItem(xs, i, incref(Py(x))))
    return xs
end

pylist_append(xs::Py, x) = errcheck(@autopy x C.PyList_Append(xs, x_))

pylist_astuple(x) = pynew(errcheck(@autopy x C.PyList_AsTuple(x_)))

function pylist_fromiter(xs)
    sz = Base.IteratorSize(typeof(xs))
    if sz isa Base.HasLength || sz isa Base.HasShape
        # length known
        ans = pynulllist(length(xs))
        for (i, x) in enumerate(xs)
            pylist_setitem(ans, i - 1, x)
        end
        return ans
    else
        # length unknown
        ans = pynulllist(0)
        for x in xs
            pylist_append(ans, x)
        end
        return ans
    end
end

"""
    pylist(x=())

Convert `x` to a Python `list`.

If `x` is a Python object, this is equivalent to `list(x)` in Python.
Otherwise `x` must be iterable.
"""
pylist() = pynulllist(0)
pylist(x) = ispy(x) ? pybuiltins.list(x) : pylist_fromiter(x)

"""
    pycollist(x::AbstractArray)

Create a nested Python `list`-of-`list`s from the elements of `x`. For matrices, this is a list of columns.
"""
function pycollist(x::AbstractArray{T,N}) where {T,N}
    N == 0 && return pynew(Py(x[]))
    d = N
    ax = axes(x, d)
    ans = pynulllist(length(ax))
    for (i, j) in enumerate(ax)
        y = pycollist(selectdim(x, d, j))
        pylist_setitem(ans, i - 1, y)
        pydel!(y)
    end
    return ans
end

"""
    pyrowlist(x::AbstractArray)

Create a nested Python `list`-of-`list`s from the elements of `x`. For matrices, this is a list of rows.
"""
function pyrowlist(x::AbstractArray{T,N}) where {T,N}
    ndims(x) == 0 && return pynew(Py(x[]))
    d = 1
    ax = axes(x, d)
    ans = pynulllist(length(ax))
    for (i, j) in enumerate(ax)
        y = pyrowlist(selectdim(x, d, j))
        pylist_setitem(ans, i - 1, y)
        pydel!(y)
    end
    return ans
end

### set

pyset_add(set::Py, x) = (errcheck(@autopy x C.PySet_Add(set, x_)); set)

function pyset_update_fromiter(set::Py, xs)
    for x in xs
        pyset_add(set, x)
    end
    return set
end
pyset_fromiter(xs) = pyset_update_fromiter(pyset(), xs)
pyfrozenset_fromiter(xs) = pyset_update_fromiter(pyfrozenset(), xs)

"""
    pyset(x=())

Convert `x` to a Python `set`.

If `x` is a Python object, this is equivalent to `set(x)` in Python.
Otherwise `x` must be iterable.
"""
pyset() = pynew(errcheck(C.PySet_New(C.PyNULL)))
pyset(x) = ispy(x) ? pybuiltins.set(x) : pyset_fromiter(x)

"""
    pyfrozenset(x=())

Convert `x` to a Python `frozenset`.

If `x` is a Python object, this is equivalent to `frozenset(x)` in Python.
Otherwise `x` must be iterable.
"""
pyfrozenset() = pynew(errcheck(C.PyFrozenSet_New(C.PyNULL)))
pyfrozenset(x) = ispy(x) ? pybuiltins.frozenset(x) : pyfrozenset_fromiter(x)

### dict

pydict_setitem(x::Py, k, v) = errcheck(@autopy k v C.PyDict_SetItem(x, k_, v_))

function pydict_fromiter(kvs)
    ans = pydict()
    for (k, v) in kvs
        pydict_setitem(ans, k, v)
    end
    return ans
end

function pystrdict_fromiter(kvs)
    ans = pydict()
    for (k, v) in kvs
        pydict_setitem(ans, string(k), v)
    end
    return ans
end

"""
    pydict(x)
    pydict(; x...)
    pydict(x::Pair...)

Convert `x` to a Python `dict`. In the second form, the keys are strings.

If `x` is a Python object, this is equivalent to `dict(x)` in Python.
Otherwise `x` must iterate over key-value pairs.
"""
pydict(; kwargs...) =
    isempty(kwargs) ? pynew(errcheck(C.PyDict_New())) : pystrdict_fromiter(kwargs)
pydict(x) = ispy(x) ? pybuiltins.dict(x) : pydict_fromiter(x)
pydict(x::NamedTuple) = pydict(; x...)
pydict(pair::Pair, pairs::Pair...) = pydict((pair, pairs...))

### datetime

# We used to use 1/1/1 but pandas.Timestamp is a subclass of datetime and does not include
# this date, so we use 1970 instead.
const _base_datetime = DateTime(1970, 1, 1)
const _base_pydatetime = pynew()

function init_datetime()
    pycopy!(_base_pydatetime, pydatetimetype(1970, 1, 1))
end

pydate(year, month, day) = pydatetype(year, month, day)
pydate(x::Date) = pydate(year(x), month(x), day(x))

pytime(
    _hour = 0,
    _minute = 0,
    _second = 0,
    _microsecond = 0,
    _tzinfo = nothing;
    hour = _hour,
    minute = _minute,
    second = _second,
    microsecond = _microsecond,
    tzinfo = _tzinfo,
    fold = 0,
) = pytimetype(hour, minute, second, microsecond, tzinfo, fold = fold)
pytime(x::Time) =
    if iszero(nanosecond(x))
        pytime(hour(x), minute(x), second(x), millisecond(x) * 1000 + microsecond(x))
    else
        errset(
            pybuiltins.ValueError,
            "cannot create 'datetime.time' with less than microsecond resolution",
        )
        pythrow()
    end

pydatetime(
    year,
    month,
    day,
    _hour = 0,
    _minute = 0,
    _second = 0,
    _microsecond = 0,
    _tzinfo = nothing;
    hour = _hour,
    minute = _minute,
    second = _second,
    microsecond = _microsecond,
    tzinfo = _tzinfo,
    fold = 0,
) = pydatetimetype(year, month, day, hour, minute, second, microsecond, tzinfo, fold = fold)
function pydatetime(x::DateTime)
    # compute time since _base_datetime
    # this accounts for fold
    d = pytimedeltatype(milliseconds = (x - _base_datetime).value)
    ans = _base_pydatetime + d
    pydel!(d)
    return ans
end
pydatetime(x::Date) = pydatetime(year(x), month(x), day(x))

function pytime_isaware(x)
    tzinfo = pygetattr(x, "tzinfo")
    if pyisnone(tzinfo)
        pydel!(tzinfo)
        return false
    end
    utcoffset = tzinfo.utcoffset
    pydel!(tzinfo)
    o = utcoffset(nothing)
    pydel!(utcoffset)
    ans = !pyisnone(o)
    pydel!(o)
    return ans
end

function pydatetime_isaware(x)
    tzinfo = pygetattr(x, "tzinfo")
    if pyisnone(tzinfo)
        pydel!(tzinfo)
        return false
    end
    utcoffset = tzinfo.utcoffset
    pydel!(tzinfo)
    o = utcoffset(x)
    pydel!(utcoffset)
    ans = !pyisnone(o)
    pydel!(o)
    return ans
end

### fraction

pyfraction(x::Rational) = pyfraction(numerator(x), denominator(x))
pyfraction(x, y) = pyfractiontype(x, y)
pyfraction(x) = pyfractiontype(x)
pyfraction() = pyfractiontype()

### eval/exec

const MODULE_GLOBALS = Dict{Module,Py}()

function _pyeval_args(code, globals, locals)
    if code isa AbstractString
        code_ = code
    elseif ispy(code)
        code_ = code
    else
        throw(ArgumentError("code must be a string or Python code"))
    end
    if globals isa Module
        globals_ = get!(pydict, MODULE_GLOBALS, globals)
    elseif ispy(globals)
        globals_ = globals
    else
        throw(ArgumentError("globals must be a module or a Python dict"))
    end
    if locals === nothing
        locals_ = pynew(Py(globals_))
    elseif ispy(locals)
        locals_ = pynew(Py(locals))
    else
        locals_ = pydict(locals)
    end
    return (code_, globals_, locals_)
end

"""
    pyeval([T=Py], code, globals, locals=nothing)

Evaluate the given Python `code`, returning the result as a `T`.

If `globals` is a `Module`, then a persistent `dict` unique to that module is used.

By default the code runs in global scope (i.e. `locals===globals`). To use a temporary
local scope, set `locals` to `()`, or to a `NamedTuple` of variables to include in the
scope.

See also [`@pyeval`](@ref).

# Examples

The following computes `1.1+2.2` in the `Main` module as a `Float64`:
```
pyeval(Float64, "x+y", Main, (x=1.1, y=2.2))  # returns 3.3
```
"""
function pyeval(::Type{T}, code, globals, locals = nothing) where {T}
    code_, globals_, locals_ = _pyeval_args(code, globals, locals)
    ans = pybuiltins.eval(code_, globals_, locals_)
    pydel!(locals_)
    return pyconvert(T, ans)
end
pyeval(code, globals, locals = nothing) = pyeval(Py, code, globals, locals)

_pyexec_ans(::Type{Nothing}, globals, locals) = nothing
@generated function _pyexec_ans(
    ::Type{NamedTuple{names,types}},
    globals,
    locals,
) where {names,types}
    # TODO: use precomputed interned strings
    # TODO: try to load from globals too
    n = length(names)
    code = []
    vars = Symbol[]
    for i = 1:n
        v = Symbol(:ans, i)
        push!(vars, v)
        push!(
            code,
            :(
                $v = pyconvert(
                    $(types.parameters[i]),
                    pygetitem(locals, $(string(names[i]))),
                )
            ),
        )
    end
    push!(code, :(return $(NamedTuple{names,types})(($(vars...),))))
    return Expr(:block, code...)
end

"""
    pyexec([T=Nothing], code, globals, locals=nothing)

Execute the given Python `code`.

If `globals` is a `Module`, then a persistent `dict` unique to that module is used.

By default the code runs in global scope (i.e. `locals===globals`). To use a temporary
local scope, set `locals` to `()`, or to a `NamedTuple` of variables to include in the
scope.

If `T==Nothing` then returns `nothing`. Otherwise `T` must be a concrete `NamedTuple` type
and the corresponding items from `locals` are extracted and returned.

See also [`@pyexec`](@ref).

# Examples

The following computes `1.1+2.2` in the `Main` module as a `Float64`:
```
pyexec(@NamedTuple{ans::Float64}, "ans=x+y", Main, (x=1.1, y=2.2))  # returns (ans = 3.3,)
```

Marking variables as `global` saves them into the module scope, so that they are available
in subsequent invocations:
```
pyexec("global x; x=12", Main)
pyeval(Int, "x", Main)  # returns 12
```
"""
function pyexec(::Type{T}, code, globals, locals = nothing) where {T}
    code_, globals_, locals_ = _pyeval_args(code, globals, locals)
    pydel!(pybuiltins.exec(code_, globals_, locals_))
    ans = _pyexec_ans(T, globals_, locals_)
    pydel!(locals_)
    return ans
end
pyexec(code, globals, locals = nothing) = pyexec(Nothing, code, globals, locals)

function _pyeval_macro_code(arg)
    if arg isa String
        return arg
    elseif arg isa Expr && arg.head === :macrocall && arg.args[1] == :(`foo`).args[1]
        return arg.args[3]
    else
        return nothing
    end
end

function _pyeval_macro_args(arg, filename, mode)
    # separate out inputs => code => outputs (with only code being required)
    if @capture(arg, inputs_ => code_ => outputs_)
        code = _pyeval_macro_code(code)
        code === nothing && error("invalid code")
    elseif @capture(arg, lhs_ => rhs_)
        code = _pyeval_macro_code(lhs)
        if code === nothing
            code = _pyeval_macro_code(rhs)
            code === nothing && error("invalid code")
            inputs = lhs
            outputs = nothing
        else
            inputs = nothing
            outputs = rhs
        end
    else
        code = _pyeval_macro_code(arg)
        code === nothing && error("invalid code")
        inputs = outputs = nothing
    end
    # precompile the code
    codestr = code
    codeobj = pynew()
    codeready = Ref(false)
    code = quote
        if !$codeready[]
            $pycopy!($codeobj, $pybuiltins.compile($codestr, $filename, $mode))
            $codeready[] = true
        end
        $codeobj
    end
    # convert inputs to locals
    if inputs === nothing
        locals = ()
    else
        if inputs isa Expr && inputs.head === :tuple
            inputs = inputs.args
        else
            inputs = [inputs]
        end
        locals = []
        for input in inputs
            if @capture(input, var_Symbol)
                push!(locals, var => var)
            elseif @capture(input, var_Symbol = ex_)
                push!(locals, var => ex)
            else
                error("invalid input: $input")
            end
        end
        locals = :(($([:($var = $ex) for (var, ex) in locals]...),))
    end
    # done
    return locals, code, outputs
end

"""
    @pyeval [inputs =>] code [=> T]

Evaluate the given `code` in a new local scope and return the answer as a `T`.

The global scope is persistent and unique to the current module.

The `code` must be a literal string or command.

The `inputs` is a tuple of inputs of the form `v=expr` to be included in the local scope.
Only `v` is required, `expr` defaults to `v`.

# Examples

The following computes `1.1+2.2` and returns a `Float64`:
```
@pyeval (x=1.1, y=2.2) => `x+y` => Float64  # returns 3.3
```
"""
macro pyeval(arg)
    locals, code, outputs =
        _pyeval_macro_args(arg, "$(__source__.file):$(__source__.line)", "eval")
    if outputs === nothing
        outputs = Py
    end
    esc(:($pyeval($outputs, $code, $__module__, $locals)))
end

"""
    @pyexec [inputs =>] code [=> outputs]

Execute the given `code` in a new local scope.

The global scope is persistent and unique to the current module.

The `code` must be a literal string or command.

The `inputs` is a tuple of inputs of the form `v=expr` to be included in the local scope.
Only `v` is required, `expr` defaults to `v`.

The `outputs` is a tuple of outputs of the form `x::T=v`, meaning that `v` is extracted from
locals, converted to `T` and assigned to `x`. Only `x` is required: `T` defaults to `Py`
and `v` defaults to `x`.

# Examples

The following computes `1.1+2.2` and assigns its value to `ans` as a `Float64`:
```
@pyexec (x=1.1, y=2.2) => `ans=x+y` => ans::Float64  # returns 3.3
```

Marking variables as `global` saves them into the module scope, so that they are available
in subsequent invocations:
```
@pyexec `global x; x=12`
@pyeval `x` => Int  # returns 12
```
"""
macro pyexec(arg)
    locals, code, outputs =
        _pyeval_macro_args(arg, "$(__source__.file):$(__source__.line)", "exec")
    if outputs === nothing
        outputs = Nothing
        esc(:($pyexec(Nothing, $code, $__module__, $locals)))
    else
        if outputs isa Expr && outputs.head === :tuple
            oneoutput = false
            outputs = outputs.args
        else
            oneoutput = true
            outputs = [outputs]
        end
        pyvars = Symbol[]
        jlvars = Symbol[]
        types = []
        for output in outputs
            if @capture(output, lhs_ = rhs_)
                rhs isa Symbol || error("invalid output: $output")
                output = lhs
                pyvar = rhs
            else
                pyvar = missing
            end
            if @capture(output, lhs_::rhs_)
                outtype = rhs
                output = lhs
            else
                outtype = Py
            end
            output isa Symbol || error("invalid output: $output")
            if pyvar === missing
                pyvar = output
            end
            push!(pyvars, pyvar)
            push!(jlvars, output)
            push!(types, outtype)
        end
        outtype = :($NamedTuple{($(map(QuoteNode, pyvars)...),),Tuple{$(types...)}})
        ans = :($pyexec($outtype, $code, $__module__, $locals))
        if oneoutput
            ans = :($(jlvars[1]) = $ans[1])
        else
            if pyvars != jlvars
                outtype2 =
                    :($NamedTuple{($(map(QuoteNode, jlvars)...),),Tuple{$(types...)}})
                ans = :($outtype2($ans))
            end
            ans = :(($(jlvars...),) = $ans)
        end
        esc(ans)
    end
end

### with

"""
    pywith(f, o, d=nothing)

Equivalent to `with o as x: f(x)` in Python, where `x` is a `Py`.

On success, the value of `f(x)` is returned.

If an exception occurs but is suppressed then `d` is returned.
"""
function pywith(f, o, d = nothing)
    o = Py(o)
    t = pytype(o)
    exit = t.__exit__
    value = t.__enter__(o)
    exited = false
    try
        return f(value)
    catch exc
        if exc isa PyException
            exited = true
            if pytruth(exit(o, exc.t, exc.v, exc.b))
                return d
            end
        end
        rethrow()
    finally
        exited || exit(o, pybuiltins.None, pybuiltins.None, pybuiltins.None)
    end
end

### import

"""
    pyimport(m)
    pyimport(m => k)
    pyimport(m => (k1, k2, ...))
    pyimport(m1, m2, ...)

Import a module `m`, or an attribute `k`, or a tuple of attributes.

If several arguments are given, return the results of importing each one in a tuple.
"""
pyimport(m) = pynew(errcheck(@autopy m C.PyImport_Import(m_)))
pyimport((m, k)::Pair) = (m_ = pyimport(m); k_ = pygetattr(m_, k); pydel!(m_); k_)
pyimport((m, ks)::Pair{<:Any,<:Tuple}) =
    (m_ = pyimport(m); ks_ = map(k -> pygetattr(m_, k), ks); pydel!(m_); ks_)
pyimport(m1, m2, ms...) = map(pyimport, (m1, m2, ms...))

### builtins not covered elsewhere

"""
    pyprint(...)

Equivalent to `print(...)` in Python.
"""
pyprint(args...; kwargs...) = (pydel!(pybuiltins.print(args...; kwargs...)); nothing)

function _pyhelp(args...)
    pyisnone(pybuiltins.help) && error("Python help is not available")
    pydel!(pybuiltins.help(args...))
    nothing
end
"""
    pyhelp([x])

Equivalent to `help(x)` in Python.
"""
pyhelp() = _pyhelp()
pyhelp(x) = _pyhelp(x)

"""
    pyall(x)

Equivalent to `all(x)` in Python.
"""
function pyall(x)
    y = pybuiltins.all(x)
    z = pybool_asbool(y)
    pydel!(y)
    z
end

"""
    pyany(x)

Equivalent to `any(x)` in Python.
"""
function pyany(x)
    y = pybuiltins.any(x)
    z = pybool_asbool(y)
    pydel!(y)
    z
end

"""
    pycallable(x)

Equivalent to `callable(x)` in Python.
"""
function pycallable(x)
    y = pybuiltins.callable(x)
    z = pybool_asbool(y)
    pydel!(y)
    z
end

"""
    pycompile(...)

Equivalent to `compile(...)` in Python.
"""
pycompile(args...; kwargs...) = pybuiltins.compile(args...; kwargs...)

"""
    module PythonCall.Convert

Implements `pyconvert`.
"""
module Convert

using ..PythonCall
using ..Utils
using ..C
using ..Core
using ..NumpyDates

using Dates: Date, Time, DateTime, Second, Millisecond, Microsecond, Nanosecond

import ..PythonCall:
    @pyconvert,
    pyconvert_add_rule,
    pyconvert_return,
    pyconvert_unconverted,
    pyconvert,
    PyConvertPriority

export pyconvert_isunconverted,
    pyconvert_result,
    pyconvert_result,
    pyconvert_tryconvert,
    pyconvert_unconverted,
    pyconvertarg


include("pyconvert.jl")
include("rules.jl")
include("ctypes.jl")
include("numpy.jl")
include("pandas.jl")

function __init__()
    init_pyconvert()
    init_ctypes()
    init_numpy()
    init_pandas()
end

end

@testitem "bool → Bool" begin
    @test pyconvert(Bool, true) === true
    @test pyconvert(Bool, false) === false
    @test_throws Exception pyconvert(Bool, "hello")
end

@testitem "bool → Integer" begin
    @test pyconvert(Int, true) === 1
    @test pyconvert(Int, false) === 0
end

@testitem "bytes → Vector" begin
    x1 = pyconvert(Vector{UInt8}, pybytes(pylist([1, 2, 3])))
    @test x1 isa Vector{UInt8}
    @test x1 == [0x01, 0x02, 0x03]
    x2 = pyconvert(Base.CodeUnits, pybytes(pylist([102, 111, 111])))
    @test x2 isa Base.CodeUnits
    @test x2 == b"foo"
end

@testitem "complex → Complex" begin
    x1 = pyconvert(ComplexF32, pycomplex(1, 2))
    @test x1 === ComplexF32(1, 2)
    x2 = pyconvert(Complex, pycomplex(3, 4))
    @test x2 === ComplexF64(3, 4)
end

@testitem "float → Float" begin
    x1 = pyconvert(Float32, 12)
    @test x1 === Float32(12)
    x2 = pyconvert(Float64, 3.5)
    @test x2 === 3.5
end

@testitem "float → Nothing" begin
    @test_throws Exception pyconvert(Nothing, pyfloat(1.2))
    x1 = pyconvert(Nothing, pyfloat(NaN))
    @test x1 === nothing
end

@testitem "float → Missing" begin
    @test_throws Exception pyconvert(Missing, pyfloat(1.2))
    x1 = pyconvert(Missing, pyfloat(NaN))
    @test x1 === missing
end

@testitem "int → Integer" begin
    @test_throws Exception pyconvert(Int8, 300)
    @test_throws Exception pyconvert(UInt, -3)
    x1 = pyconvert(Int, 34)
    @test x1 === 34
    x2 = pyconvert(UInt8, 7)
    @test x2 === 0x07
    x3 = pyconvert(UInt32, typemax(UInt32))
    @test x3 === typemax(UInt32)
    x4 = pyconvert(Integer, big(3)^1000)
    @test x4 isa BigInt
    @test x4 == big(3)^1000
end

@testitem "None → Nothing" begin
    x1 = pyconvert(Nothing, pybuiltins.None)
    @test x1 === nothing
end

@testitem "None → Missing" begin
    x1 = pyconvert(Missing, pybuiltins.None)
    @test x1 === missing
end

@testitem "range → StepRange" begin
    x1 = pyconvert(StepRange, pyrange(10))
    @test x1 === (0:1:9)
    x2 = pyconvert(StepRange, pyrange(3, 9, 2))
    @test x2 === (3:2:7)
    x3 = pyconvert(StepRange, pyrange(20, 14, -1))
    @test x3 === (20:-1:15)
    x4 = pyconvert(StepRange, pyrange(30, -10, -3))
    @test x4 === (30:-3:-9)
end

@testitem "range → UnitRange" begin
    x1 = pyconvert(UnitRange, pyrange(10))
    @test x1 === (0:9)
    x2 = pyconvert(UnitRange, pyrange(3, 9, 1))
    @test x2 === (3:8)
end

@testitem "str → String" begin
    x1 = pyconvert(String, pystr("foo"))
    @test x1 === "foo"
    x2 = pyconvert(String, pystr("αβγℵ√"))
    @test x2 === "αβγℵ√"
end

@testitem "str → Symbol" begin
    x1 = pyconvert(Symbol, pystr("hello"))
    @test x1 === :hello
end

@testitem "str → Char" begin
    @test_throws Exception pyconvert(Char, pystr(""))
    @test_throws Exception pyconvert(Char, pystr("ab"))
    @test_throws Exception pyconvert(Char, pystr("abc"))
    x1 = pyconvert(Char, pystr("a"))
    @test x1 === 'a'
    x2 = pyconvert(Char, pystr("Ψ"))
    @test x2 === 'Ψ'
end

@testitem "iterable → Tuple" begin
    t1 = pyconvert(Tuple, (1, 2))
    @test t1 === (1, 2)
    t2 = pyconvert(Tuple{Vararg{Int}}, (3, 4, 5))
    @test t2 === (3, 4, 5)
    t3 = pyconvert(Tuple{Int,Int}, (6, 7))
    @test t3 === (6, 7)
    # generic case (>16 fields)
    t4 = pyconvert(Tuple{ntuple(i -> Int, 20)...,Vararg{Int}}, ntuple(i -> i, 30))
    @test t4 === ntuple(i -> i, 30)
end

@testitem "iterable → Vector" begin
    x1 = pyconvert(Vector, pylist([1, 2]))
    @test x1 isa Vector{Int}
    @test x1 == [1, 2]
    x2 = pyconvert(Vector, pylist([1, 2, nothing, 3]))
    @test x2 isa Vector{Union{Int,Nothing}}
    @test x2 == [1, 2, nothing, 3]
    x3 = pyconvert(Vector{Float64}, pylist([4, 5, 6]))
    @test x3 isa Vector{Float64}
    @test x3 == [4.0, 5.0, 6.0]
end

@testitem "iterable → Set" begin
    x1 = pyconvert(Set, pyset([1, 2]))
    @test x1 isa Set{Int}
    @test x1 == Set([1, 2])
    x2 = pyconvert(Set, pyset([1, 2, nothing, 3]))
    @test x2 isa Set{Union{Int,Nothing}}
    @test x2 == Set([1, 2, nothing, 3])
    x3 = pyconvert(Set{Float64}, pyset([4, 5, 6]))
    @test x3 isa Set{Float64}
    @test x3 == Set([4.0, 5.0, 6.0])
end

@testitem "iterable → Pair" begin
    @test_throws Exception pyconvert(Pair, ())
    @test_throws Exception pyconvert(Pair, (1,))
    @test_throws Exception pyconvert(Pair, (1, 2, 3))
    x1 = pyconvert(Pair, (2, 3))
    @test x1 === (2 => 3)
    x2 = pyconvert(Pair{String,Missing}, ("foo", nothing))
    @test x2 === ("foo" => missing)
end

@testitem "named tuple → NamedTuple" begin
    NT = pyimport("collections" => "namedtuple")
    t1 = pyconvert(NamedTuple, NT("NT", "x y")(1, 2))
    @test t1 === (x = 1, y = 2)
    @test_throws Exception pyconvert(NamedTuple, (2, 3))
    t2 = pyconvert(NamedTuple{(:x, :y)}, NT("NT", "x y")(3, 4))
    @test t2 === (x = 3, y = 4)
    @test_throws Exception pyconvert(NamedTuple{(:y, :x)}, NT("NT", "x y")(3, 4))
    t3 = pyconvert(NamedTuple{names,Tuple{Int,Int}} where {names}, NT("NT", "x y")(4, 5))
    @test t3 === (x = 4, y = 5)
    @test_throws Exception pyconvert(NamedTuple{names,Tuple{Int,Int}} where {names}, (5, 6))
    t4 = pyconvert(NamedTuple{(:x, :y),Tuple{Int,Int}}, NT("NT", "x y")(6, 7))
    @test t4 === (x = 6, y = 7)
end

@testitem "mapping → PyDict" begin
    x1 = pyconvert(PyDict, pydict([1 => 11, 2 => 22, 3 => 33]))
    @test x1 isa PyDict{Any,Any}
    @test isequal(x1, Dict([1 => 11, 2 => 22, 3 => 33]))
    x2 = pyconvert(PyDict{Int,Int}, pydict([1 => 11, 2 => 22, 3 => 33]))
    @test x2 isa PyDict{Int,Int}
    @test x2 == Dict(1 => 11, 2 => 22, 3 => 33)
end

@testitem "mapping → Dict" begin
    x1 = pyconvert(Dict, pydict(["a" => 1, "b" => 2]))
    @test x1 isa Dict{String,Int}
    @test x1 == Dict("a" => 1, "b" => 2)
    x2 = pyconvert(Dict{Char,Float32}, pydict(["c" => 3, "d" => 4]))
    @test x2 isa Dict{Char,Float32}
    @test x2 == Dict('c' => 3.0, 'd' => 4.0)
end

@testitem "sequence → PyList" begin
    x1 = pyconvert(PyList, pylist([1, 2, 3]))
    @test x1 isa PyList{Any}
    @test isequal(x1, [1, 2, 3])
    x2 = pyconvert(PyList{Int}, pylist([1, 2, 3]))
    @test x2 isa PyList{Int}
    @test x2 == [1, 2, 3]
end

@testitem "set → PySet" begin
    x1 = pyconvert(PySet, pyset([1, 2, 3]))
    @test x1 isa PySet{Any}
    @test isequal(x1, Set([1, 2, 3]))
    x2 = pyconvert(PySet{Int}, pyset([1, 2, 3]))
    @test x2 isa PySet{Int}
    @test x2 == Set([1, 2, 3])
end

@testitem "date → Date" begin
    using Dates
    x1 = pyconvert(Date, pydate(2001, 2, 3))
    @test x1 === Date(2001, 2, 3)
end

@testitem "time → Time" begin
    using Dates
    x1 = pyconvert(Time, pytime(12, 3, 4, 5))
    @test x1 === Time(12, 3, 4, 0, 5)
end

@testitem "datetime → DateTime" begin
    using Dates
    x1 = pyconvert(DateTime, pydatetime(2001, 2, 3, 4, 5, 6, 7000))
    @test x1 === DateTime(2001, 2, 3, 4, 5, 6, 7)
end

@testitem "timedelta → Nanosecond" begin
    using Dates
    td = pyimport("datetime").timedelta
    @testset for x in [
        -1_000_000_000,
        -1_000_000,
        -1_000,
        -1,
        0,
        1,
        1_000,
        1_000_000,
        1_000_000_000,
    ]
        y = pyconvert(Nanosecond, td(microseconds = x))
        @test y === Nanosecond(x * 1000)
    end
    @test_throws Exception pyconvert(Nanosecond, td(days = 200_000))
    @test_throws Exception pyconvert(Nanosecond, td(days = -200_000))
end

@testitem "timedelta → Microsecond" begin
    using Dates
    td = pyimport("datetime").timedelta
    @testset for x in [
        -1_000_000_000,
        -1_000_000,
        -1_000,
        -1,
        0,
        1,
        1_000,
        1_000_000,
        1_000_000_000,
    ]
        y = pyconvert(Microsecond, td(microseconds = x))
        @test y === Microsecond(x)
    end
    @test_throws Exception pyconvert(Microsecond, td(days = 200_000_000))
    @test_throws Exception pyconvert(Microsecond, td(days = -200_000_000))
end

@testitem "timedelta → Millisecond" begin
    using Dates
    td = pyimport("datetime").timedelta
    @testset for x in [
        -1_000_000_000,
        -1_000_000,
        -1_000,
        -1,
        0,
        1,
        1_000,
        1_000_000,
        1_000_000_000,
    ]
        y = pyconvert(Millisecond, td(microseconds = x * 1000))
        @test y === Millisecond(x)
    end
    @test_throws Exception pyconvert(Millisecond, td(microseconds = 1))
end

@testitem "timedelta → Second" begin
    using Dates
    td = pyimport("datetime").timedelta
    @testset for x in [
        -1_000_000_000,
        -1_000_000,
        -1_000,
        -1,
        0,
        1,
        1_000,
        1_000_000,
        1_000_000_000,
    ]
        y = pyconvert(Second, td(seconds = x))
        @test y === Second(x)
    end
    @test_throws Exception pyconvert(Second, td(microseconds = 1000))
end

@testitem "pandas.DataFrame → PyPandasDataFrame" setup=[Setup] begin
    if Setup.devdeps
        pd = pyimport("pandas")
        df = pd.DataFrame()
        df2 = pyconvert(PyPandasDataFrame, df)
        @test df2 isa PyPandasDataFrame
        @test pyis(df2, df)
        df3 = pyconvert(PyTable, df)
        @test df3 isa PyPandasDataFrame
        @test pyis(df3, df)
    end
end

@testitem "pyconvert_add_rule (#364)" begin
    id = string(rand(UInt128), base = 16)
    pyexec(
        """
 class Hello_364_$id:
     pass
 """,
        @__MODULE__
    )
    x = pyeval("Hello_364_$id()", @__MODULE__)
    @test pyconvert(Any, x) === x # This test has a side effect of influencing the rules cache
    t = pytype(x)
    PythonCall.pyconvert_add_rule(
        "$(t.__module__):$(t.__qualname__)",
        String,
        (_, _) -> "Hello!!",
    )
    @test pyconvert(String, x) == "Hello!!"
    @test pyconvert(Any, x) == "Hello!!" # Broken before PR #365
end

const CAPI_FUNC_SIGS = Dict{Symbol,Pair{Tuple,Type}}(
    # INITIALIZE
    :Py_Initialize => () => Cvoid,
    :Py_InitializeEx => (Cint,) => Cvoid,
    :Py_FinalizeEx => () => Cint,
    :Py_AtExit => (Ptr{Cvoid},) => Cint,
    :Py_IsInitialized => () => Cint,
    :Py_SetPythonHome => (Ptr{Cwchar_t},) => Cvoid,
    :Py_SetProgramName => (Ptr{Cwchar_t},) => Cvoid,
    :Py_GetVersion => () => Ptr{Cchar},
    # REFCOUNT
    :Py_IncRef => (PyPtr,) => Cvoid,
    :Py_DecRef => (PyPtr,) => Cvoid,
    # EVAL
    :PyEval_EvalCode => (PyPtr, PyPtr, PyPtr) => PyPtr,
    :Py_CompileString => (Ptr{Cchar}, Ptr{Cchar}, Cint) => PyPtr,
    :PyEval_GetBuiltins => () => PyPtr,
    :PyRun_InteractiveOne => (Ptr{Cvoid}, Ptr{Cchar}) => Cint,
    # GIL & THREADS
    :PyEval_SaveThread => () => Ptr{Cvoid},
    :PyEval_RestoreThread => (Ptr{Cvoid},) => Cvoid,
    :PyGILState_Ensure => () => PyGILState_STATE,
    :PyGILState_Release => (PyGILState_STATE,) => Cvoid,
    :PyGILState_GetThisThreadState => () => Ptr{Cvoid},
    :PyGILState_Check => () => Cint,
    # IMPORT
    :PyImport_ImportModule => (Ptr{Cchar},) => PyPtr,
    :PyImport_Import => (PyPtr,) => PyPtr,
    :PyImport_ImportModuleLevelObject => (PyPtr, PyPtr, PyPtr, PyPtr, Cint) => PyPtr,
    :PyImport_GetModuleDict => () => PyPtr, # borrowed
    # MODULE
    :PyModule_GetDict => (PyPtr,) => PyPtr, # borrowed
    # ERRORS
    :PyErr_Print => () => Cvoid,
    :PyErr_Occurred => () => PyPtr, # borrowed
    :PyErr_ExceptionMatches => (PyPtr,) => Cint,
    :PyErr_GivenExceptionMatches => (PyPtr, PyPtr) => Cint,
    :PyErr_Clear => () => Cvoid,
    :PyErr_SetNone => (PyPtr,) => Cvoid,
    :PyErr_SetString => (PyPtr, Ptr{Cchar}) => Cvoid,
    :PyErr_SetObject => (PyPtr, PyPtr) => Cvoid,
    :PyErr_Fetch => (Ptr{PyPtr}, Ptr{PyPtr}, Ptr{PyPtr}) => Cvoid,
    :PyErr_NormalizeException => (Ptr{PyPtr}, Ptr{PyPtr}, Ptr{PyPtr}) => Cvoid,
    :PyErr_Restore => (PyPtr, PyPtr, PyPtr) => Cvoid, # steals
    # OBJECT
    :_PyObject_New => (PyPtr,) => PyPtr,
    :PyObject_ClearWeakRefs => (PyPtr,) => Cvoid,
    :PyObject_HasAttrString => (PyPtr, Ptr{Cchar}) => Cint,
    :PyObject_HasAttr => (PyPtr, PyPtr) => Cint,
    :PyObject_GetAttrString => (PyPtr, Ptr{Cchar}) => PyPtr,
    :PyObject_GetAttr => (PyPtr, PyPtr) => PyPtr,
    :PyObject_GenericGetAttr => (PyPtr, PyPtr) => PyPtr,
    :PyObject_SetAttrString => (PyPtr, Ptr{Cchar}, PyPtr) => Cint,
    :PyObject_SetAttr => (PyPtr, PyPtr, PyPtr) => Cint,
    :PyObject_GenericSetAttr => (PyPtr, PyPtr, PyPtr) => PyPtr,
    :PyObject_RichCompare => (PyPtr, PyPtr, Cint) => PyPtr,
    :PyObject_RichCompareBool => (PyPtr, PyPtr, Cint) => Cint,
    :PyObject_Repr => (PyPtr,) => PyPtr,
    :PyObject_ASCII => (PyPtr,) => PyPtr,
    :PyObject_Str => (PyPtr,) => PyPtr,
    :PyObject_Bytes => (PyPtr,) => PyPtr,
    :PyObject_IsSubclass => (PyPtr, PyPtr) => Cint,
    :PyObject_IsInstance => (PyPtr, PyPtr) => Cint,
    :PyObject_Hash => (PyPtr,) => Py_hash_t,
    :PyObject_IsTrue => (PyPtr,) => Cint,
    :PyObject_Not => (PyPtr,) => Cint,
    :PyObject_Length => (PyPtr,) => Py_ssize_t,
    :PyObject_GetItem => (PyPtr, PyPtr) => PyPtr,
    :PyObject_SetItem => (PyPtr, PyPtr, PyPtr) => Cint,
    :PyObject_DelItem => (PyPtr, PyPtr) => Cint,
    :PyObject_Dir => (PyPtr,) => PyPtr,
    :PyObject_GetIter => (PyPtr,) => PyPtr,
    :PyObject_Call => (PyPtr, PyPtr, PyPtr) => PyPtr,
    :PyObject_CallObject => (PyPtr, PyPtr) => PyPtr,
    # TYPE
    :PyType_IsSubtype => (PyPtr, PyPtr) => Cint,
    :PyType_Ready => (PyPtr,) => Cint,
    :PyType_GenericNew => (PyPtr, PyPtr, PyPtr) => PyPtr,
    :PyType_FromSpec => (Ptr{Cvoid},) => PyPtr,
    :PyType_GetFlags => (PyPtr,) => Culong,
    :PyType_GetSlot => (PyPtr, Cint) => Ptr{Cvoid},
    # MAPPING
    :PyMapping_HasKeyString => (PyPtr, Ptr{Cchar}) => Cint,
    :PyMapping_SetItemString => (PyPtr, Ptr{Cchar}, PyPtr) => Cint,
    :PyMapping_GetItemString => (PyPtr, Ptr{Cchar}) => PyPtr,
    # SEQUENCE
    :PySequence_Length => (PyPtr,) => Py_ssize_t,
    :PySequence_GetItem => (PyPtr, Py_ssize_t) => PyPtr,
    :PySequence_SetItem => (PyPtr, Py_ssize_t, PyPtr) => Cint,
    :PySequence_Contains => (PyPtr, PyPtr) => Cint,
    # NUMBER
    :PyNumber_Add => (PyPtr, PyPtr) => PyPtr,
    :PyNumber_Subtract => (PyPtr, PyPtr) => PyPtr,
    :PyNumber_Multiply => (PyPtr, PyPtr) => PyPtr,
    :PyNumber_MatrixMultiply => (PyPtr, PyPtr) => PyPtr,
    :PyNumber_FloorDivide => (PyPtr, PyPtr) => PyPtr,
    :PyNumber_TrueDivide => (PyPtr, PyPtr) => PyPtr,
    :PyNumber_Remainder => (PyPtr, PyPtr) => PyPtr,
    :PyNumber_Divmod => (PyPtr, PyPtr) => PyPtr,
    :PyNumber_Power => (PyPtr, PyPtr, PyPtr) => PyPtr,
    :PyNumber_Negative => (PyPtr,) => PyPtr,
    :PyNumber_Positive => (PyPtr,) => PyPtr,
    :PyNumber_Absolute => (PyPtr,) => PyPtr,
    :PyNumber_Invert => (PyPtr,) => PyPtr,
    :PyNumber_Lshift => (PyPtr, PyPtr) => PyPtr,
    :PyNumber_Rshift => (PyPtr, PyPtr) => PyPtr,
    :PyNumber_And => (PyPtr, PyPtr) => PyPtr,
    :PyNumber_Xor => (PyPtr, PyPtr) => PyPtr,
    :PyNumber_Or => (PyPtr, PyPtr) => PyPtr,
    :PyNumber_InPlaceAdd => (PyPtr, PyPtr) => PyPtr,
    :PyNumber_InPlaceSubtract => (PyPtr, PyPtr) => PyPtr,
    :PyNumber_InPlaceMultiply => (PyPtr, PyPtr) => PyPtr,
    :PyNumber_InPlaceMatrixMultiply => (PyPtr, PyPtr) => PyPtr,
    :PyNumber_InPlaceFloorDivide => (PyPtr, PyPtr) => PyPtr,
    :PyNumber_InPlaceTrueDivide => (PyPtr, PyPtr) => PyPtr,
    :PyNumber_InPlaceRemainder => (PyPtr, PyPtr) => PyPtr,
    :PyNumber_InPlacePower => (PyPtr, PyPtr, PyPtr) => PyPtr,
    :PyNumber_InPlaceLshift => (PyPtr, PyPtr) => PyPtr,
    :PyNumber_InPlaceRshift => (PyPtr, PyPtr) => PyPtr,
    :PyNumber_InPlaceAnd => (PyPtr, PyPtr) => PyPtr,
    :PyNumber_InPlaceXor => (PyPtr, PyPtr) => PyPtr,
    :PyNumber_InPlaceOr => (PyPtr, PyPtr) => PyPtr,
    :PyNumber_Long => (PyPtr,) => PyPtr,
    :PyNumber_Float => (PyPtr,) => PyPtr,
    :PyNumber_Index => (PyPtr,) => PyPtr,
    # ITERATION
    :PyIter_Next => (PyPtr,) => PyPtr,
    # INT
    :PyLong_FromLongLong => (Clonglong,) => PyPtr,
    :PyLong_FromUnsignedLongLong => (Culonglong,) => PyPtr,
    :PyLong_FromString => (Ptr{Cchar}, Ptr{Ptr{Cchar}}, Cint) => PyPtr,
    :PyLong_AsLongLong => (PyPtr,) => Clonglong,
    :PyLong_AsUnsignedLongLong => (PyPtr,) => Culonglong,
    # FLOAT
    :PyFloat_FromDouble => (Cdouble,) => PyPtr,
    :PyFloat_AsDouble => (PyPtr,) => Cdouble,
    # COMPLEX
    :PyComplex_FromDoubles => (Cdouble, Cdouble) => PyPtr,
    :PyComplex_RealAsDouble => (PyPtr,) => Cdouble,
    :PyComplex_ImagAsDouble => (PyPtr,) => Cdouble,
    :PyComplex_AsCComplex => (PyPtr,) => Py_complex,
    # STR
    :PyUnicode_DecodeUTF8 => (Ptr{Cchar}, Py_ssize_t, Ptr{Cchar}) => PyPtr,
    :PyUnicode_AsUTF8String => (PyPtr,) => PyPtr,
    :PyUnicode_InternInPlace => (Ptr{PyPtr},) => Cvoid,
    # BYTES
    :PyBytes_FromStringAndSize => (Ptr{Cchar}, Py_ssize_t) => PyPtr,
    :PyBytes_AsStringAndSize => (PyPtr, Ptr{Ptr{Cchar}}, Ptr{Py_ssize_t}) => Cint,
    # TUPLE
    :PyTuple_New => (Py_ssize_t,) => PyPtr,
    :PyTuple_Size => (PyPtr,) => Py_ssize_t,
    :PyTuple_GetItem => (PyPtr, Py_ssize_t) => PyPtr, # borrowed
    :PyTuple_SetItem => (PyPtr, Py_ssize_t, PyPtr) => Cint, # steals
    # LIST
    :PyList_New => (Py_ssize_t,) => PyPtr,
    :PyList_Append => (PyPtr, PyPtr) => Cint,
    :PyList_AsTuple => (PyPtr,) => PyPtr,
    :PyList_SetItem => (PyPtr, Py_ssize_t, PyPtr) => Cint, # steals
    # DICT
    :PyDict_New => () => PyPtr,
    :PyDict_GetItem => (PyPtr, PyPtr) => PyPtr, # borrowed
    :PyDict_GetItemString => (PyPtr, Ptr{Cchar}) => PyPtr, # borrowed
    :PyDict_SetItem => (PyPtr, PyPtr, PyPtr) => Cint,
    :PyDict_SetItemString => (PyPtr, Ptr{Cchar}, PyPtr) => Cint,
    :PyDict_DelItemString => (PyPtr, Ptr{Cchar}) => Cint,
    # SET
    :PySet_New => (PyPtr,) => PyPtr,
    :PyFrozenSet_New => (PyPtr,) => PyPtr,
    :PySet_Add => (PyPtr, PyPtr) => Cint,
    # SLICE
    :PySlice_New => (PyPtr, PyPtr, PyPtr) => PyPtr,
    # METHOD
    :PyInstanceMethod_New => (PyPtr,) => PyPtr,
    # CAPSULE
    :PyCapsule_New => (Ptr{Cvoid}, Ptr{Cchar}, Ptr{Cvoid}) => PyPtr,
    :PyCapsule_GetName => (PyPtr,) => Ptr{Cchar},
    :PyCapsule_SetName => (PyPtr, Ptr{Cchar}) => Cint,
    :PyCapsule_GetPointer => (PyPtr, Ptr{Cchar}) => Ptr{Cvoid},
    :PyCapsule_SetDestructor => (PyPtr, Ptr{Cvoid}) => Cint,
)

const CAPI_EXCEPTIONS = Set([
    :PyExc_BaseException,
    :PyExc_Exception,
    :PyExc_StopIteration,
    :PyExc_GeneratorExit,
    :PyExc_ArithmeticError,
    :PyExc_LookupError,
    :PyExc_AssertionError,
    :PyExc_AttributeError,
    :PyExc_BufferError,
    :PyExc_EOFError,
    :PyExc_FloatingPointError,
    :PyExc_OSError,
    :PyExc_ImportError,
    :PyExc_IndexError,
    :PyExc_KeyError,
    :PyExc_KeyboardInterrupt,
    :PyExc_MemoryError,
    :PyExc_NameError,
    :PyExc_OverflowError,
    :PyExc_RuntimeError,
    :PyExc_RecursionError,
    :PyExc_NotImplementedError,
    :PyExc_SyntaxError,
    :PyExc_IndentationError,
    :PyExc_TabError,
    :PyExc_ReferenceError,
    :PyExc_SystemError,
    :PyExc_SystemExit,
    :PyExc_TypeError,
    :PyExc_UnboundLocalError,
    :PyExc_UnicodeError,
    :PyExc_UnicodeEncodeError,
    :PyExc_UnicodeDecodeError,
    :PyExc_UnicodeTranslateError,
    :PyExc_ValueError,
    :PyExc_ZeroDivisionError,
    :PyExc_BlockingIOError,
    :PyExc_BrokenPipeError,
    :PyExc_ChildProcessError,
    :PyExc_ConnectionError,
    :PyExc_ConnectionAbortedError,
    :PyExc_ConnectionRefusedError,
    :PyExc_FileExistsError,
    :PyExc_FileNotFoundError,
    :PyExc_InterruptedError,
    :PyExc_IsADirectoryError,
    :PyExc_NotADirectoryError,
    :PyExc_PermissionError,
    :PyExc_ProcessLookupError,
    :PyExc_TimeoutError,
    :PyExc_EnvironmentError,
    :PyExc_IOError,
    # :PyExc_WindowsError, # only on Windows
    :PyExc_Warning,
    :PyExc_UserWarning,
    :PyExc_DeprecationWarning,
    :PyExc_PendingDeprecationWarning,
    :PyExc_SyntaxWarning,
    :PyExc_RuntimeWarning,
    :PyExc_FutureWarning,
    :PyExc_ImportWarning,
    :PyExc_UnicodeWarning,
    :PyExc_BytesWarning,
    :PyExc_ResourceWarning,
])

const CAPI_FUNCS = Set(keys(CAPI_FUNC_SIGS))

const CAPI_OBJECTS = Set([
    # TYPES
    :PyBool_Type,
    :PyBytes_Type,
    :PyComplex_Type,
    :PyDict_Type,
    :PyFloat_Type,
    :PyLong_Type,
    :PyList_Type,
    :PyBaseObject_Type,
    :PySet_Type,
    :PyFrozenSet_Type,
    :PySlice_Type,
    :PyUnicode_Type,
    :PyTuple_Type,
    :PyType_Type,
    :PyCapsule_Type,
    # OTHERS
    :_Py_TrueStruct,
    :_Py_FalseStruct,
    :_Py_NotImplementedStruct,
    :_Py_NoneStruct,
    :_Py_EllipsisObject,
])

@eval @kwdef mutable struct CAPIPointers
    $([:($name::Ptr{Cvoid} = C_NULL) for name in CAPI_FUNCS]...)
    $([:($name::PyPtr = C_NULL) for name in CAPI_EXCEPTIONS]...)
    $([:($name::PyPtr = C_NULL) for name in CAPI_OBJECTS]...)
    PyOS_InputHookPtr::Ptr{Ptr{Cvoid}} = C_NULL
end

const POINTERS = CAPIPointers()

@eval init_pointers(p::CAPIPointers = POINTERS, lib::Ptr = CTX.lib_ptr) = begin
    $([
        :(p.$name = dlsym(lib, $(QuoteNode(name))))
        for name in CAPI_FUNCS
    ]...)
    $(
        [
            :(p.$name =
                    Base.unsafe_load(Ptr{PyPtr}(dlsym(lib, $(QuoteNode(name)))::Ptr))) for name in CAPI_EXCEPTIONS
        ]...
    )
    $([:(p.$name = dlsym(lib, $(QuoteNode(name)))) for name in CAPI_OBJECTS]...)
    p.PyOS_InputHookPtr = dlsym(CTX.lib_ptr, :PyOS_InputHook)
end

for (name, (argtypes, rettype)) in CAPI_FUNC_SIGS
    args = [Symbol("x", i) for (i, _) in enumerate(argtypes)]
    @eval $name($(args...)) = ccall(POINTERS.$name, $rettype, ($(argtypes...),), $(args...))
end

PySet(x = pyset()) = PySet{Py}(x)

ispy(::PySet) = true
Py(x::PySet) = x.py

function pyconvert_rule_set(
    ::Type{T},
    x::Py,
    ::Type{T1} = Utils._type_ub(T),
) where {T<:PySet,T1}
    pyconvert_return(T1(x))
end

Base.length(x::PySet) = Int(pylen(x))

Base.isempty(x::PySet) = length(x) == 0

function Base.iterate(x::PySet{T}, it::Py = pyiter(x)) where {T}
    y = unsafe_pynext(it)
    if pyisnull(y)
        pydel!(it)
        return nothing
    else
        return (pyconvert(T, y), it)
    end
end

function Base.in(v, x::PySet{T}) where {T}
    if v isa T
        return pycontains(x, v)
    else
        r = pyconvert_tryconvert(T, v)
        if pyconvert_isunconverted(r)
            return false
        else
            return pycontains(x, pyconvert_result(T, r))
        end
    end
end

function Base.push!(x::PySet{T}, v) where {T}
    pydel!(@py x.add(@jl(convert(T, v))))
    return x
end

function Base.delete!(x::PySet{T}, v) where {T}
    if v isa T
        pydel!(@py x.discard(v))
    else
        r = pyconvert_tryconvert(T, v)
        if !pyconvert_isunconverted(r)
            pydel!(@py x.discard(@jl pyconvert_result(T, r)))
        end
    end
    return x
end

Base.@propagate_inbounds function Base.pop!(x::PySet{T}) where {T}
    @boundscheck (isempty(x) && throw(ArgumentError("set must be non-empty")))
    return pyconvert(T, @py x.pop())
end

function Base.pop!(x::PySet, v)
    if v in x
        delete!(x, v)
        return v
    else
        throw(KeyError(v))
    end
end

function Base.pop!(x::PySet, v, d)
    if v in x
        delete!(x, v)
        return v
    else
        return d
    end
end

function Base.empty!(x::PySet)
    pydel!(@py x.clear())
    return x
end

function Base.copy(x::PySet{T}) where {T}
    return PySet{T}(@py x.copy())
end

const pyjlarraytype = pynew()

function pyjl_getaxisindex(x::AbstractUnitRange{<:Integer}, k::Py)
    if pyisslice(k)
        a = @pyconvert Union{Int,Nothing} k.start begin
            errset(pybuiltins.TypeError, "slice components must be integers")
            pythrow()
        end
        b = @pyconvert Union{Int,Nothing} k.step begin
            errset(pybuiltins.TypeError, "slice components must be integers")
            pythrow()
        end
        c = @pyconvert Union{Int,Nothing} k.stop begin
            errset(pybuiltins.TypeError, "slice components must be integers")
            pythrow()
        end
        # step defaults to 1
        b′ = b === nothing ? 1 : b
        if a === nothing && c === nothing
            # when neither is specified, start and stop default to the full range,
            # which is reversed when the step is negative
            if b′ > 0
                a′ = Int(first(x))
                c′ = Int(last(x))
            elseif b′ < 0
                a′ = Int(last(x))
                c′ = Int(first(x))
            else
                errset(pybuiltins.ValueError, "step must be non-zero")
                pythrow()
            end
        else
            # start defaults
            a′ = Int(a === nothing ? first(x) : a < 0 ? (last(x) + a + 1) : (first(x) + a))
            c′ = Int(
                c === nothing ? last(x) :
                c < 0 ? (last(x) + 1 + c - sign(b′)) : (first(x) + c - sign(b′)),
            )
        end
        r = StepRange{Int,Int}(a′, b′, c′)
        if checkbounds(Bool, x, r)
            return r
        else
            errset(pybuiltins.IndexError, "array index out of bounds")
            pythrow()
        end
    else
        j = @pyconvert Int k begin
            errset(
                pybuiltins.TypeError,
                "index must be slice or integer, got '$(pytype(k).__name__)'",
            )
            pythrow()
        end
        r = Int(j < 0 ? (last(x) + j + 1) : (first(x) + j))
        if checkbounds(Bool, x, r)
            return r
        else
            errset(pybuiltins.IndexError, "array index out of bounds")
            pythrow()
        end
    end
end

function pyjl_getarrayindices(x::AbstractArray{T,N}, ks::Py) where {T,N}
    if pyistuple(ks)
        if pylen(ks) == N
            return ntuple(N) do i
                k = pytuple_getitem(ks, i - 1)
                ans = pyjl_getaxisindex(axes(x, i), k)
                pydel!(k)
                return ans
            end
        else
            errset(pybuiltins.TypeError, "expecting $N indices, got $(pylen(ks))")
            pythrow()
        end
    elseif N == 1
        return (pyjl_getaxisindex(axes(x, 1), ks),)
    else
        errset(pybuiltins.TypeError, "expecting $N indices, got 1")
    end
end

function pyjlarray_getitem(x::AbstractArray{T,N}, k_::Py) where {T,N}
    k = pyjl_getarrayindices(x, k_)
    pydel!(k_)
    if k isa NTuple{N,Int}
        return Py(x[k...])
    else
        return Py(view(x, k...))
    end
end

function pyjlarray_setitem(x::AbstractArray{T,N}, k_::Py, v_::Py) where {T,N}
    k = pyjl_getarrayindices(x, k_)
    pydel!(k_)
    if k isa NTuple{N,Int}
        v = pyconvertarg(T, v_, "value")
        x[k...] = v
    else
        v = pyconvertarg(Any, v_, "value")
        x[k...] .= v
    end
    return Py(nothing)
end

function pyjlarray_delitem(x::AbstractArray{T,N}, k_::Py) where {T,N}
    if N == 1
        k = pyjl_getarrayindices(x, k_)
        pydel!(k_)
        deleteat!(x, k...)
    else
        errset(pybuiltins.TypeError, "can only delete from 1D arrays")
        pythrow()
    end
    return Py(nothing)
end
pyjl_handle_error_type(::typeof(pyjlarray_delitem), x, exc::MethodError) =
    exc.f === deleteat! ? pybuiltins.TypeError : PyNULL

function pyjlarray_reshape(x::AbstractArray, shape_::Py)
    shape = pyconvertarg(Union{Int,Vector{Int}}, shape_, "shape")
    pydel!(shape_)
    return Py(reshape(x, shape...))
end

pyjlarray_isbufferabletype(::Type{T}) where {T} = T in (
    Int8,
    Int16,
    Int32,
    Int64,
    UInt8,
    UInt16,
    UInt32,
    UInt64,
    Float16,
    Float32,
    Float64,
    Complex{Float16},
    Complex{Float32},
    Complex{Float64},
    Bool,
    Ptr{Cvoid},
)
pyjlarray_isbufferabletype(::Type{T}) where {T<:Tuple} =
    isconcretetype(T) &&
    allocatedinline(T) &&
    all(pyjlarray_isbufferabletype, fieldtypes(T))
pyjlarray_isbufferabletype(::Type{NamedTuple{names,T}}) where {names,T} =
    pyjlarray_isbufferabletype(T)

function pyjlarray_buffer_info(x::AbstractArray{T,N}) where {T,N}
    if pyjlarray_isbufferabletype(T)
        Cjl.PyBufferInfo{N}(
            ptr = Base.unsafe_convert(Ptr{T}, x),
            readonly = !Utils.ismutablearray(x),
            itemsize = sizeof(T),
            format = pybufferformat(T),
            shape = size(x),
            strides = strides(x) .* Base.aligned_sizeof(T),
        )
    else
        error("element type is not bufferable")
    end
end

const PYBUFFERFORMAT = IdDict{Type,String}()

pybufferformat(::Type{T}) where {T} =
    get!(PYBUFFERFORMAT, T) do
        T == Cchar ? "b" :
        T == Cuchar ? "B" :
        T == Cshort ? "h" :
        T == Cushort ? "H" :
        T == Cint ? "i" :
        T == Cuint ? "I" :
        T == Clong ? "l" :
        T == Culong ? "L" :
        T == Clonglong ? "q" :
        T == Culonglong ? "Q" :
        T == Float16 ? "e" :
        T == Cfloat ? "f" :
        T == Cdouble ? "d" :
        T == Complex{Float16} ? "Ze" :
        T == Complex{Cfloat} ? "Zf" :
        T == Complex{Cdouble} ? "Zd" :
        T == Bool ? "?" :
        T == Ptr{Cvoid} ? "P" :
        if (T <: Union{Tuple,NamedTuple}) && isstructtype(T) && isconcretetype(T) && allocatedinline(T)
            n = fieldcount(T)
            flds = []
            for i = 1:n
                nm = fieldname(T, i)
                tp = fieldtype(T, i)
                push!(flds, string(pybufferformat(tp), nm isa Symbol ? ":$nm:" : ""))
                d =
                    (i == n ? sizeof(T) : fieldoffset(T, i + 1)) -
                    (fieldoffset(T, i) + sizeof(tp))
                @assert d ≥ 0
                d > 0 && push!(flds, "$(d)x")
            end
            string("T{", join(flds, " "), "}")
        else
            "$(sizeof(T))x"
        end
    end

pyjlarray_isarrayabletype(::Type{T}) where {T} = T in (
    UInt8,
    Int8,
    UInt16,
    Int16,
    UInt32,
    Int32,
    UInt64,
    Int64,
    Bool,
    Float16,
    Float32,
    Float64,
    Complex{Float16},
    Complex{Float32},
    Complex{Float64},
)
pyjlarray_isarrayabletype(::Type{NumpyDates.InlineDateTime64{U}}) where {U} = true
pyjlarray_isarrayabletype(::Type{NumpyDates.InlineTimeDelta64{U}}) where {U} = true
pyjlarray_isarrayabletype(::Type{T}) where {T<:Tuple} =
    isconcretetype(T) &&
    Base.allocatedinline(T) &&
    all(pyjlarray_isarrayabletype, T.parameters)
pyjlarray_isarrayabletype(::Type{NamedTuple{names,types}}) where {names,types} =
    pyjlarray_isarrayabletype(types)

const PYTYPESTRDESCR = IdDict{Type,Tuple{String,Py}}()

function pytypestrdescr(::Type{T}) where {T}
    get!(PYTYPESTRDESCR, T) do
        c = Utils.islittleendian() ? '<' : '>'
        if T == Bool
            ("$(c)b$(sizeof(Bool))", PyNULL)
        elseif T == Int8
            ("$(c)i1", PyNULL)
        elseif T == UInt8
            ("$(c)u1", PyNULL)
        elseif T == Int16
            ("$(c)i2", PyNULL)
        elseif T == UInt16
            ("$(c)u2", PyNULL)
        elseif T == Int32
            ("$(c)i4", PyNULL)
        elseif T == UInt32
            ("$(c)u4", PyNULL)
        elseif T == Int64
            ("$(c)i8", PyNULL)
        elseif T == UInt64
            ("$(c)u8", PyNULL)
        elseif T == Float16
            ("$(c)f2", PyNULL)
        elseif T == Float32
            ("$(c)f4", PyNULL)
        elseif T == Float64
            ("$(c)f8", PyNULL)
        elseif T == Complex{Float16}
            ("$(c)c4", PyNULL)
        elseif T == Complex{Float32}
            ("$(c)c8", PyNULL)
        elseif T == Complex{Float64}
            ("$(c)c16", PyNULL)
        elseif isconcretetype(T) &&
               T <: Union{NumpyDates.InlineDateTime64,NumpyDates.InlineTimeDelta64}
            u, m = NumpyDates.unitpair(T)
            tc = T <: NumpyDates.InlineDateTime64 ? 'M' : 'm'
            us =
                u == NumpyDates.UNBOUND_UNITS ? "" :
                m == 1 ? "[$(Symbol(u))]" : "[$(m)$(Symbol(u))]"
            ("$(c)$(tc)8$(us)", PyNULL)
        elseif (T <: Union{Tuple,NamedTuple}) && isstructtype(T) && isconcretetype(T) && Base.allocatedinline(T)
            n = fieldcount(T)
            flds = []
            for i = 1:n
                nm = fieldname(T, i)
                tp = fieldtype(T, i)
                ts, ds = pytypestrdescr(tp)
                isempty(ts) && return ("", PyNULL)
                push!(
                    flds,
                    (nm isa Integer ? "f$(nm-1)" : string(nm), pyisnull(ds) ? ts : ds),
                )
                d =
                    (i == n ? sizeof(T) : fieldoffset(T, i + 1)) -
                    (fieldoffset(T, i) + sizeof(tp))
                @assert d ≥ 0
                d > 0 && push!(flds, ("", "|V$(d)"))
            end
            ("|$(sizeof(T))V", pylist(flds))
        else
            ("", PyNULL)
        end
    end
end

pyjlarray_array__array(x::AbstractArray) = x isa Array ? Py(nothing) : pyjl(Array(x))
pyjlarray_array__pyobjectarray(x::AbstractArray) = pyjl(PyObjectArray(x))

function pyjlarray_array_interface(x::AbstractArray{T,N}) where {T,N}
    if pyjlarray_isarrayabletype(eltype(x))
        data = (UInt(Base.unsafe_convert(Ptr{T}, x)), !Utils.ismutablearray(x))
        typestr, descr = pytypestrdescr(T)
        if !isempty(typestr)
            d = pydict()
            d["shape"] = size(x)
            d["typestr"] = typestr
            d["data"] = data
            d["strides"] = strides(x) .* Base.aligned_sizeof(T)
            d["version"] = 3
            if !pyisnull(descr)
                d["descr"] = descr
            end
            return d
        end
    end
    errset(pybuiltins.AttributeError, "__array_interface__")
    return PyNULL
end
pyjl_handle_error_type(::typeof(pyjlarray_array_interface), x, exc) =
    pybuiltins.AttributeError

function init_array()
    jl = pyjuliacallmodule
    pybuiltins.exec(
        pybuiltins.compile(
            """
$("\n"^(@__LINE__()-1))
class ArrayValue(AnyValue):
    __slots__ = ()
    _jl_buffer_info = $(pyjl_methodnum(pyjlarray_buffer_info))
    @property
    def ndim(self):
        return self._jl_callmethod($(pyjl_methodnum(Py ∘ ndims)))
    @property
    def shape(self):
        return self._jl_callmethod($(pyjl_methodnum(Py ∘ size)))
    def copy(self):
        return self._jl_callmethod($(pyjl_methodnum(Py ∘ copy)))
    def reshape(self, shape):
        return self._jl_callmethod($(pyjl_methodnum(pyjlarray_reshape)), shape)
    def __bool__(self):
        return bool(len(self))
    def __getitem__(self, k):
        return self._jl_callmethod($(pyjl_methodnum(pyjlarray_getitem)), k)
    def __setitem__(self, k, v):
        self._jl_callmethod($(pyjl_methodnum(pyjlarray_setitem)), k, v)
    def __delitem__(self, k):
        self._jl_callmethod($(pyjl_methodnum(pyjlarray_delitem)), k)
    @property
    def __array_interface__(self):
        return self._jl_callmethod($(pyjl_methodnum(pyjlarray_array_interface)))
    def __array__(self, dtype=None, copy=None):
        import numpy
        # convert to an array-like object
        arr = self
        if not (hasattr(arr, "__array_interface__") or hasattr(arr, "__array_struct__")):
            if copy is False:
                raise ValueError("copy=False is not supported when collecting ArrayValue data")
            # the first attempt collects into an Array
            arr = self._jl_callmethod($(pyjl_methodnum(pyjlarray_array__array)))
            if not (hasattr(arr, "__array_interface__") or hasattr(arr, "__array_struct__")):
                # the second attempt collects into a PyObjectArray
                arr = self._jl_callmethod($(pyjl_methodnum(pyjlarray_array__pyobjectarray)))
        # convert to a numpy array if numpy is available
        return numpy.array(arr, dtype=dtype, copy=copy)
    def to_numpy(self, dtype=None, copy=True, order="K"):
        import numpy
        return numpy.array(self, dtype=dtype, copy=copy, order=order)
""",
            @__FILE__(),
            "exec",
        ),
        jl.__dict__,
    )
    pycopy!(pyjlarraytype, jl.ArrayValue)
end

pyjltype(::AbstractArray) = pyjlarraytype

PyTable(x) = pyconvert(PyTable, x)

# Tables.istable(x::Py) = Tables.istable(@pyconvert(PyTable, x, return false))
# Tables.rowaccess(x::Py) = Tables.rowaccess(@pyconvert(PyTable, x, return false))
# Tables.rows(x::Py) = Tables.rows(pyconvert(PyTable, x))
# Tables.columnaccess(x::Py) = Tables.columnaccess(@pyconvert(PyTable, x, return false))
# Tables.columns(x::Py) = Tables.columns(pyconvert(PyTable, x))
# Tables.materializer(x::Py) = Tables.materializer(pyconvert(PyTable, x))

const pyjliobasetype = pynew()
const pyjlbinaryiotype = pynew()
const pyjltextiotype = pynew()

pyjlio_close(io::IO) = (close(io); Py(nothing))
pyjl_handle_error_type(::typeof(pyjlio_close), io, exc) =
    exc isa MethodError && exc.f === close ? pybuiltins.ValueError : PyNULL

pyjlio_closed(io::IO) = Py(!isopen(io))
pyjl_handle_error_type(::typeof(pyjlio_closed), io, exc) =
    exc isa MethodError && exc.f === isopen ? pybuiltins.ValueError : PyNULL

pyjlio_fileno(io::IO) = Py(fd(io))
pyjl_handle_error_type(::typeof(pyjlio_fileno), io, exc) =
    exc isa MethodError && exc.f === fd ? pybuiltins.ValueError : PyNULL

pyjlio_flush(io::IO) = (flush(io); Py(nothing))
pyjl_handle_error_type(::typeof(pyjlio_flush), io, exc) =
    exc isa MethodError && exc.f === flush ? pybuiltins.ValueError : PyNULL

pyjlio_isatty(io::IO) = Py(io isa Base.TTY)

pyjlio_readable(io::IO) = Py(isreadable(io))
pyjl_handle_error_type(::typeof(pyjlio_readable), io, exc) =
    exc isa MethodError && exc.f === isreadable ? pybuiltins.ValueError : PyNULL

function pyjlio_seek(io::IO, offset_::Py, whence_::Py)
    offset = pyconvertarg(Int, offset_, "offset")
    whence = pyconvertarg(Int, whence_, "whence")
    if whence == 0
        pos = offset
    elseif whence == 1
        pos = position(io) + offset
    elseif whence == 2
        seekend(io)
        pos = position(io) + offset
    else
        errset(pybuiltins.ValueError, "Argument 'whence' must be 0, 1 or 2")
        return PyNULL
    end
    seek(io, pos)
    Py(position(io))
end
pyjl_handle_error_type(::typeof(pyjlio_seek), io, exc) =
    exc isa MethodError && (exc.f === position || exc.f === seek || exc.f === seekend) ?
    pybuiltins.ValueError : PyNULL

pyjlio_tell(io::IO) = Py(position(io))
pyjl_handle_error_type(::typeof(pyjlio_tell), io, exc) =
    exc isa MethodError && exc.f === position ? pybuiltins.ValueError : PyNULL

function pyjlio_truncate(io::IO, size_::Py)
    size = pyconvertarg(Union{Int,Nothing}, size_, "size")
    if size === nothing
        size = position(io)
    end
    truncate(io, size)
    Py(size)
end
pyjl_handle_error_type(::typeof(pyjlio_truncate), io, exc) =
    exc isa MethodError && (exc.f === position || exc.f === truncate) ?
    pybuiltins.ValueError : PyNULL

pyjlio_writable(io::IO) = Py(iswritable(io))
pyjl_handle_error_type(::typeof(pyjlio_writable), io, exc) =
    exc isa MethodError && exc.f === iswritable ? pybuiltins.ValueError : PyNULL

function pyjlbinaryio_read(io::IO, size_::Py)
    size = pyconvertarg(Union{Int,Nothing}, size_, "size")
    if size === nothing || size < 0
        buf = read(io)
    else
        buf = read(io, size)
    end
    pybytes(buf)
end
pyjl_handle_error_type(::typeof(pyjlbinaryio_read), io, exc) =
    exc isa MethodError && exc.f === read ? pybuiltins.ValueError : PyNULL

function pyjlbinaryio_readline(io::IO, size_::Py)
    size = pyconvertarg(Union{Int,Nothing}, size_, "size")
    if size === nothing
        size = -1
    end
    buf = UInt8[]
    while !eof(io) && (size < 0 || length(buf) < size)
        c = read(io, UInt8)
        push!(buf, c)
        c == 0x0A && break
    end
    pybytes(buf)
end
pyjl_handle_error_type(::typeof(pyjlbinaryio_readline), io, exc) =
    exc isa MethodError && exc.f === read ? pybuiltins.ValueError : PyNULL

function pyjlbinaryio_readinto(io::IO, b::Py)
    m = pybuiltins.memoryview(b)
    c = m.c_contiguous
    if !pytruth(c)
        pydel!(c)
        errset(pybuiltins.ValueError, "input buffer is not contiguous")
        return PyNULL
    end
    pydel!(c)
    buf = unsafe_load(C.PyMemoryView_GET_BUFFER(m))
    if buf.readonly != 0
        pydel!(m)
        errset(pybuiltins.ValueError, "output buffer is read-only")
        return PyNULL
    end
    data = unsafe_wrap(Array, Ptr{UInt8}(buf.buf), buf.len)
    nb = readbytes!(io, data)
    pydel!(m)
    return Py(nb)
end
pyjl_handle_error_type(::typeof(pyjlbinaryio_readinto), io, exc) =
    exc isa MethodError && exc.f === readbytes! ? pybuiltins.ValueError : PyNULL

function pyjlbinaryio_write(io::IO, b::Py)
    m = pybuiltins.memoryview(b)
    c = m.c_contiguous
    if !pytruth(c)
        pydel!(c)
        errset(pybuiltins.ValueError, "input buffer is not contiguous")
        return PyNULL
    end
    pydel!(c)
    buf = unsafe_load(C.PyMemoryView_GET_BUFFER(m))
    data = unsafe_wrap(Array, Ptr{UInt8}(buf.buf), buf.len)
    write(io, data)
    pydel!(m)
    return Py(buf.len)
end
pyjl_handle_error_type(::typeof(pyjlbinaryio_write), io, exc) =
    exc isa MethodError && exc.f === write ? pybuiltins.ValueError : PyNULL

function pyjltextio_read(io::IO, size_::Py)
    size = pyconvertarg(Union{Int,Nothing}, size_, "size")
    if size === nothing
        size = -1
    end
    buf = IOBuffer()
    total = 0
    while !eof(io) && (size < 0 || total < size)
        c = read(io, Char)
        # translate "\n", "\r" and "\r\n" to "\n"
        if c == '\r'
            !eof(io) && peek(io) == 0x0A && read(io, UInt8)
            write(buf, '\n')
        else
            write(buf, c)
        end
        total += 1
    end
    Py(String(take!(buf)))
end
pyjl_handle_error_type(::typeof(pyjltextio_read), io, exc) =
    exc isa MethodError && exc.f === read ? pybuiltins.ValueError : PyNULL

function pyjltextio_readline(io::IO, size_::Py)
    size = pyconvertarg(Union{Int,Nothing}, size_, "size")
    if size === nothing
        size = -1
    end
    buf = IOBuffer()
    total = 0
    while !eof(io) && (size < 0 || total < size)
        c = read(io, Char)
        # translate "\n", "\r" and "\r\n" to "\n"
        if c == '\n'
            write(buf, c)
            total += 1
            break
        elseif c == '\r'
            !eof(io) && peek(io) == 0x0A && read(io, UInt8)
            write(buf, '\n')
            total += 1
            break
        else
            write(buf, c)
            total += 1
        end
    end
    Py(String(take!(buf)))
end
pyjl_handle_error_type(::typeof(pyjltextio_readline), io, exc) =
    exc isa MethodError && exc.f === read ? pybuiltins.ValueError : PyNULL

function pyjltextio_write(io::IO, s_::Py)
    if pyisstr(s_)
        s = pystr_asstring(s_)
        # get the line separator
        linesep_ = pyosmodule.linesep
        linesep = pystr_asstring(linesep_)
        pydel!(linesep_)
        # write the string
        # translating '\n' to os.linesep
        i = firstindex(s)
        iend = lastindex(s)
        while i ≤ iend
            j = findnext('\n', s, i)
            if j === nothing
                write(io, SubString(s, i))
                break
            else
                write(io, SubString(s, i, prevind(s, j)))
                write(io, linesep)
                i = nextind(s, j)
            end
        end
        # return number of characters written (not number of bytes)
        # TODO: is this the number of source characters, or the number of output characters?
        Py(length(s))
    else
        errset(
            pybuiltins.TypeError,
            "Argument 's' must be a 'str', got a '$(pytype(s_).__name__)'",
        )
        PyNULL
    end
end
pyjl_handle_error_type(::typeof(pyjltextio_write), io, exc) =
    exc isa MethodError && exc.f === write ? pybuiltins.ValueError : PyNULL

function init_io()
    jl = pyjuliacallmodule
    pybuiltins.exec(
        pybuiltins.compile(
            """
$("\n"^(@__LINE__()-1))
class IOValueBase(AnyValue):
    __slots__ = ()
    def close(self):
        return self._jl_callmethod($(pyjl_methodnum(pyjlio_close)))
    @property
    def closed(self):
        return self._jl_callmethod($(pyjl_methodnum(pyjlio_closed)))
    def fileno(self):
        return self._jl_callmethod($(pyjl_methodnum(pyjlio_fileno)))
    def flush(self):
        return self._jl_callmethod($(pyjl_methodnum(pyjlio_flush)))
    def isatty(self):
        return self._jl_callmethod($(pyjl_methodnum(pyjlio_isatty)))
    def readable(self):
        return self._jl_callmethod($(pyjl_methodnum(pyjlio_readable)))
    def readlines(self, hint=-1):
        lines = []
        total = 0
        while hint < 0 or total < hint:
            line = self.readline()
            if line:
                lines.append(line)
                total += len(line)
            else:
                break
        return lines
    def seek(self, offset, whence=0):
        return self._jl_callmethod($(pyjl_methodnum(pyjlio_seek)), offset, whence)
    def seekable(self):
        return True
    def tell(self):
        return self._jl_callmethod($(pyjl_methodnum(pyjlio_tell)))
    def truncate(self, size=None):
        return self._jl_callmethod($(pyjl_methodnum(pyjlio_truncate)), size)
    def writable(self):
        return self._jl_callmethod($(pyjl_methodnum(pyjlio_writable)))
    def writelines(self, lines):
        for line in lines:
            self.write(line)
    def __enter__(self):
        return self
    def __exit__(self, t, v, b):
        self.close()
    def __iter__(self):
        return self
    def __next__(self):
        line = self.readline()
        if line:
            return line
        else:
            raise StopIteration
class BinaryIOValue(IOValueBase):
    __slots__ = ()
    def detach(self):
        raise ValueError("Cannot detach '{}'.".format(type(self)))
    def read(self, size=-1):
        return self._jl_callmethod($(pyjl_methodnum(pyjlbinaryio_read)), size)
    def read1(self, size=-1):
        return self.read(size)
    def readline(self, size=-1):
        return self._jl_callmethod($(pyjl_methodnum(pyjlbinaryio_readline)), size)
    def readinto(self, b):
        return self._jl_callmethod($(pyjl_methodnum(pyjlbinaryio_readinto)), b)
    def readinto1(self, b):
        return self.readinto(b)
    def write(self, b):
        return self._jl_callmethod($(pyjl_methodnum(pyjlbinaryio_write)), b)
class TextIOValue(IOValueBase):
    __slots__ = ()
    @property
    def encoding(self):
        return "UTF-8"
    @property
    def errors(self):
        return "strict"
    def detach(self):
        raise ValueError("Cannot detach '{}'.".format(type(self)))
    def read(self, size=-1):
        return self._jl_callmethod($(pyjl_methodnum(pyjltextio_read)), size)
    def readline(self, size=-1):
        return self._jl_callmethod($(pyjl_methodnum(pyjltextio_readline)), size)
    def write(self, s):
        return self._jl_callmethod($(pyjl_methodnum(pyjltextio_write)), s)
import io
io.IOBase.register(IOValueBase)
io.BufferedIOBase.register(BinaryIOValue)
io.TextIOBase.register(TextIOValue)
del io
""",
            @__FILE__(),
            "exec",
        ),
        jl.__dict__,
    )
    pycopy!(pyjliobasetype, jl.IOValueBase)
    pycopy!(pyjlbinaryiotype, jl.BinaryIOValue)
    pycopy!(pyjltextiotype, jl.TextIOValue)
end

pyiobase(v::IO) = pyjl(pyjliobasetype, v)

"""
    pybinaryio(io::IO)

Wrap `io` as a Python binary IO object.

This is the default behaviour of `Py(io)`.
"""
pybinaryio(v::IO) = pyjl(pyjlbinaryiotype, v)

"""
    pytextio(io::IO)

Wrap `io` as a Python text IO object.
"""
pytextio(v::IO) = pyjl(pyjltextiotype, v)

pyjltype(::IO) = pyjlbinaryiotype

const pyjlmoduletype = pynew()

function pyjlmodule_dir(self::Module)
    ks = Symbol[]
    append!(ks, names(self, all = true, imported = true))
    for m in ccall(:jl_module_usings, Any, (Any,), self)::Vector
        append!(ks, names(m))
    end
    pylist(pyjl_attr_jl2py(string(k)) for k in ks)
end

function pyjlmodule_seval(self::Module, expr::Py)
    Py(Base.eval(self, Meta.parseall(strip(pyconvert(String, expr)))))
end

function init_module()
    jl = pyjuliacallmodule
    pybuiltins.exec(
        pybuiltins.compile(
            """
$("\n"^(@__LINE__()-1))
class ModuleValue(AnyValue):
    __slots__ = ()
    def __dir__(self):
        return ValueBase.__dir__(self) + self._jl_callmethod($(pyjl_methodnum(pyjlmodule_dir)))
    def seval(self, expr):
        return self._jl_callmethod($(pyjl_methodnum(pyjlmodule_seval)), expr)
""",
            @__FILE__(),
            "exec",
        ),
        jl.__dict__,
    )
    pycopy!(pyjlmoduletype, jl.ModuleValue)
end

pyjltype(::Module) = pyjlmoduletype

pyconvert_rule_pandas_na(::Type{Nothing}, x::Py) = pyconvert_return(nothing)
pyconvert_rule_pandas_na(::Type{Missing}, x::Py) = pyconvert_return(missing)

function init_pandas()
    pyconvert_add_rule(
        "pandas._libs.missing:NAType",
        Missing,
        pyconvert_rule_pandas_na,
        PYCONVERT_PRIORITY_CANONICAL,
    )
    pyconvert_add_rule("pandas._libs.missing:NAType", Nothing, pyconvert_rule_pandas_na)
end

### Extensible system for multimedia display of Python objects

const PYSHOW_RULES = Function[]

function pyshow_add_rule(rule::Function)
    push!(PYSHOW_RULES, rule)
    return
end

function pyshow(io::IO, mime::MIME, x)
    x_ = Py(x)
    if !pyisnull(x_)
        for rule in PYSHOW_RULES
            rule(io, string(mime), x_) && return
        end
    end
    throw(MethodError(show, (io, mime, x_)))
end

function pyshowable(mime::MIME, x)
    x_ = Py(x)
    if !pyisnull(x_)
        for rule in PYSHOW_RULES
            rule(devnull, string(mime), x_) && return true
        end
    end
    return false
end

### Particular rules

# x._repr_mimebundle_()
function pyshow_rule_mimebundle(io::IO, mime::String, x::Py)
    pyhasattr(x, "_repr_mimebundle_") || return false
    try
        ans = pytype(x)._repr_mimebundle_(x, include = pylist([mime]))
        if pyisinstance(ans, pybuiltins.tuple)
            data = ans[0][mime]
        else
            data = ans[mime]
        end
        data = @pyconvert(Union{String,Vector{UInt8}}, data, return false)
        write(io, data)
        return true
    catch exc
        if exc isa PyException
            return false
        else
            rethrow()
        end
    end
end

const MIME_TO_REPR_METHOD = Dict(
    "text/plain" => "__repr__",
    "text/html" => "_repr_html_",
    "text/markdown" => "_repr_markdown_",
    "text/json" => "_repr_json_",
    "text/latex" => "_repr_latex_",
    "application/javascript" => "_repr_javascript_",
    "application/pdf" => "_repr_pdf_",
    "image/jpeg" => "_repr_jpeg_",
    "image/png" => "_repr_png_",
    "image/svg+xml" => "_repr_svg_",
)

# x._repr_FORMAT_()
function pyshow_rule_repr(io::IO, mime::String, x::Py)
    method = get(MIME_TO_REPR_METHOD, mime, "")
    isempty(method) && return false
    pyhasattr(x, method) || return false
    try
        ans = pygetattr(pytype(x), method)(x)
        if pyisinstance(ans, pybuiltins.tuple)
            data = ans[0]
        else
            data = ans
        end
        write(io, @pyconvert(Union{String,Vector{UInt8}}, data, return false))
        return true
    catch exc
        if exc isa PyException
            return false
        else
            rethrow()
        end
    end
end

const MIME_TO_MATPLOTLIB_FORMAT = Dict(
    "image/png" => "png",
    "image/jpeg" => "jpeg",
    "image/tiff" => "tiff",
    "image/svg+xml" => "svg",
    "application/pdf" => "pdf",
)

# x.savefig()
# Requires x to be a matplotlib.pyplot.Figure, or x.figure to be one.
# Closes the underlying figure.
function pyshow_rule_savefig(io::IO, mime::String, x::Py)
    format = get(MIME_TO_MATPLOTLIB_FORMAT, mime, "")
    isempty(format) && return false
    pyhasattr(x, "savefig") || pyhasattr(x, "figure") || return false
    try
        plt = pysysmodule.modules["matplotlib.pyplot"]
        Figure = plt.Figure
        fig = x
        while !pyisinstance(fig, Figure)
            fig = fig.figure
        end
        buf = pyimport("io").BytesIO()
        x.savefig(buf, format = format, bbox_inches = "tight")
        data = @pyconvert(Vector{UInt8}, buf.getvalue(), return false)
        write(io, data)
        plt.close(fig)
        return true
    catch exc
        if exc isa PyException
            return false
        else
            rethrow()
        end
    end
end

function init_pyshow()
    pyshow_add_rule(pyshow_rule_mimebundle)
    pyshow_add_rule(pyshow_rule_repr)
    pyshow_add_rule(pyshow_rule_savefig)
end

### Py

Base.show(io::IO, mime::MIME, o::Py) = pyshow(io, mime, o)
Base.show(io::IO, mime::MIME"text/csv", o::Py) = pyshow(io, mime, o)
Base.show(io::IO, mime::MIME"text/tab-separated-values", o::Py) = pyshow(io, mime, o)
Base.showable(mime::MIME, o::Py) = pyshowable(mime, o)

### PyPandasDataFrame

function Base.show(io::IO, mime::MIME"text/plain", df::PyPandasDataFrame)
    nrows = pyconvert(Int, Py(df).shape[0])
    ncols = pyconvert(Int, Py(df).shape[1])
    printstyled(io, nrows, '×', ncols, ' ', typeof(df), '\n', bold = true)
    pyshow(io, mime, df)
end
Base.show(io::IO, mime::MIME, df::PyPandasDataFrame) = pyshow(io, mime, df)
Base.show(io::IO, mime::MIME"text/csv", df::PyPandasDataFrame) = pyshow(io, mime, df)
Base.show(io::IO, mime::MIME"text/tab-separated-values", df::PyPandasDataFrame) =
    pyshow(io, mime, df)
Base.showable(mime::MIME, df::PyPandasDataFrame) = pyshowable(mime, df)

module PyCallExt

# While this extension is precompilable, it can only be used without crashing if PyCall is
# using the same Python interpreter. However Julia precompiles all available extensions
# eagerly, which therefore crashes if PyCall is using a different interpreter. So for now
# we disable precompilation of this extension entirely.
__precompile__(false)

using PythonCall
using PythonCall.Core
using PythonCall.C

using PyCall: PyCall

import PythonCall: Py

# true if PyCall and PythonCall are using the same interpreter
const SAME = Ref{Bool}(false)

function __init__()
    # see if PyCall and PythonCall are using the same interpreter by checking if a couple of memory addresses are the same
    ptr1 = C.Py_GetVersion()
    ptr2 = ccall(PyCall.@pysym(:Py_GetVersion), Ptr{Cchar}, ())
    SAME[] = ptr1 == ptr2
    if PythonCall.C.CTX.which == :PyCall
        @assert SAME[]
    end
end

# allow explicit conversion between PythonCall.Py and PyCall.PyObject
# provided they are using the same interpretr
const ERRMSG = """
Conversion between `PyCall.PyObject` and `PythonCall.Py` is only possible when using the same Python interpreter.

There are two ways to achieve this:
- Set the environment variable `JULIA_PYTHONCALL_EXE` to `"@PyCall"`. This forces PythonCall to use the same
  interpreter as PyCall, but PythonCall loses the ability to manage its own dependencies.
- Set the environment variable `PYTHON` to `PythonCall.python_executable_path()` and rebuild PyCall. This forces
  PyCall to use the same interpreter as PythonCall, but needs to be repeated whenever you switch Julia environment.
"""

function Py(x::PyCall.PyObject)
    SAME[] || error(ERRMSG)
    return pynew(C.PyPtr(PyCall.pyreturn(x)))
end

function PyCall.PyObject(x::Py)
    SAME[] || error(ERRMSG)
    return PyCall.PyObject(PyCall.PyPtr(getptr(incref(x))))
end

end

"""
    module PythonCall.GC

Garbage collection of Python objects.

See [`gc`](@ref).
"""
module GC

using ..C: C

if Base.VERSION ≥ v"1.11"
    eval(
        Expr(
            :public,
            :disable,
            :enable,
            :gc,
        ),
    )
end

const QUEUE = (; items = C.PyPtr[], lock = Threads.SpinLock())
const HOOK = Ref{WeakRef}()

"""
    PythonCall.GC.disable()

Do nothing.

!!! note

    Historically this would disable the PythonCall garbage collector. This was required
    for safety in multi-threaded code but is no longer needed, so this is now a no-op.
"""
function disable()
    Base.depwarn(
        "disabling the PythonCall GC is no longer needed for thread-safety",
        :disable,
    )
    nothing
end

"""
    PythonCall.GC.enable()

Do nothing.

!!! note

    Historically this would enable the PythonCall garbage collector. This was required
    for safety in multi-threaded code but is no longer needed, so this is now a no-op.
"""
function enable()
    Base.depwarn(
        "disabling the PythonCall GC is no longer needed for thread-safety",
        :enable,
    )
    nothing
end

"""
    PythonCall.GC.gc()

Free any Python objects waiting to be freed.

These are objects that were finalized from a thread that was not holding the Python
GIL at the time.

Like most PythonCall functions, this must only be called from the main thread (i.e. the
thread currently holding the Python GIL.)
"""
function gc()
    if C.CTX.is_initialized
        unsafe_free_queue()
    end
    nothing
end

function unsafe_free_queue()
    Base.@lock QUEUE.lock begin
        for ptr in QUEUE.items
            if ptr != C.PyNULL
                C.Py_DecRef(ptr)
            end
        end
        empty!(QUEUE.items)
    end
    nothing
end

function enqueue(ptr::C.PyPtr)
    # If the ptr is NULL there is nothing to free.
    # If C.CTX.is_initialized is false then the Python interpreter hasn't started yet
    # or has been finalized; either way attempting to free will cause an error.
    if ptr != C.PyNULL && C.CTX.is_initialized
        if C.PyGILState_Check() == 1
            # If the current thread holds the GIL, then we can immediately free.
            C.Py_DecRef(ptr)
            # We may as well also free any other enqueued objects.
            if !isempty(QUEUE.items)
                unsafe_free_queue()
            end
        else
            # Otherwise we push the pointer onto the queue to be freed later, either:
            # (a) If a future Python object is finalized on the thread holding the GIL
            #     in the branch above.
            # (b) If the GCHook() object below is finalized in an ordinary GC.
            # (c) If the user calls PythonCall.GC.gc().
            Base.@lock QUEUE.lock push!(QUEUE.items, ptr)
        end
    end
    nothing
end

function enqueue_all(ptrs)
    if any(!=(C.PyNULL), ptrs) && C.CTX.is_initialized
        if C.PyGILState_Check() == 1
            for ptr in ptrs
                if ptr != C.PyNULL
                    C.Py_DecRef(ptr)
                end
            end
            if !isempty(QUEUE.items)
                unsafe_free_queue()
            end
        else
            Base.@lock QUEUE.lock append!(QUEUE.items, ptrs)
        end
    end
    nothing
end

"""
    GCHook()

An immortal object which frees any pending Python objects when Julia's GC runs.

This works by creating it but not holding any strong reference to it, so it is eligible
to be finalized by Julia's GC. The finalizer empties the PythonCall GC queue if
possible. The finalizer also re-attaches itself, so the object does not actually get
collected and so the finalizer will run again at next GC.
"""
mutable struct GCHook
    function GCHook()
        finalizer(_gchook_finalizer, new())
    end
end

function _gchook_finalizer(x)
    if C.CTX.is_initialized
        finalizer(_gchook_finalizer, x)
        if !isempty(QUEUE.items) && C.PyGILState_Check() == 1
            unsafe_free_queue()
        end
    end
    nothing
end

function __init__()
    HOOK[] = WeakRef(GCHook())
    nothing
end

end # module GC

asvector(x::AbstractVector) = x
asvector(x) = collect(x)

"""
    pytable(src, format=:pandas; ...)

Construct a Python table from the Tables.jl-compatible table `src`.

The `format` controls the type of the resulting table, and is one of:
- `:pandas`: A `pandas.DataFrame`. Keyword arguments are passed to the `DataFrame` constructor.
- `:columns`: A `dict` mapping column names to columns.
- `:rows`: A `list` of rows, which are `namedtuple`s.
- `:rowdicts`: A `list` of rows, which are `dict`s.
"""
function pytable(src, format = :pandas; opts...)
    format = Symbol(format)
    if format == :pandas
        _pytable_pandas(src; opts...)
    elseif format == :columns
        _pytable_columns(src)
    elseif format == :rows
        _pytable_rows(src)
    elseif format == :rowdicts
        _pytable_rowdicts(src)
    else
        error("invalid format")
    end
end

function _pytable_columns(src, cols = Tables.columns(src))
    pydict(
        pystr(String(n)) => asvector(Tables.getcolumn(cols, n)) for
        n in Tables.columnnames(cols)
    )
end

function _pytable_rows(src, rows = Tables.rows(src))
    names = Tables.columnnames(rows)
    t = pyimport("collections" => "namedtuple")(
        "Row",
        pylist(pystr(string(n)) for n in names),
    )
    pylist(t(map(n -> Tables.getcolumn(row, n), names)...) for row in rows)
end

function _pytable_rowdicts(src, rows = Tables.rows(src))
    names = Tables.columnnames(rows)
    pynames = [pystr(string(n)) for n in names]
    pylist(
        pydict(p => Tables.getcolumn(row, n) for (n, p) in zip(names, pynames)) for
        row in rows
    )
end

aspandasvector(x) = asvector(x)

function _pytable_pandas(src, cols = Tables.columns(src); opts...)
    pyimport("pandas").DataFrame(
        pydict(
            pystr(string(n)) => aspandasvector(Tables.getcolumn(cols, n)) for
            n in Tables.columnnames(cols)
        );
        opts...,
    )
end

@testitem "GC.gc()" begin
    let
        pyobjs = map(pylist, 1:100)
        PythonCall.GIL.@unlock Threads.@threads for obj in pyobjs
            finalize(obj)
        end
    end
    Threads.nthreads() > 1 &&
        VERSION >= v"1.10.0-" &&
        @test !isempty(PythonCall.GC.QUEUE.items)
    PythonCall.GC.gc()
    @test isempty(PythonCall.GC.QUEUE.items)
end

@testitem "GC.GCHook" begin
    let
        pyobjs = map(pylist, 1:100)
        PythonCall.GIL.@unlock Threads.@threads for obj in pyobjs
            finalize(obj)
        end
    end
    Threads.nthreads() > 1 &&
        VERSION >= v"1.10.0-" &&
        @test !isempty(PythonCall.GC.QUEUE.items)
    GC.gc()
    @test isempty(PythonCall.GC.QUEUE.items)
end

const pyjlnumbertype = pynew()
const pyjlcomplextype = pynew()
const pyjlrealtype = pynew()
const pyjlrationaltype = pynew()
const pyjlintegertype = pynew()

struct pyjlnumber_op{OP}
    op::OP
end
(op::pyjlnumber_op)(self) = Py(op.op(self))
function (op::pyjlnumber_op)(self, other_::Py)
    if pyisjl(other_)
        other = pyjlvalue(other_)
        pydel!(other_)
    else
        other = @pyconvert(Number, other_, return pybuiltins.NotImplemented)
    end
    Py(op.op(self, other))
end
function (op::pyjlnumber_op)(self, other_::Py, other2_::Py)
    if pyisjl(other_)
        other = pyjlvalue(other_)
        pydel!(other_)
    else
        other = @pyconvert(Number, other_, return pybuiltins.NotImplemented)
    end
    if pyisjl(other2_)
        other2 = pyjlvalue(other2_)
        pydel!(other2_)
    else
        other2 = @pyconvert(Number, other2_, return pybuiltins.NotImplemented)
    end
    Py(op.op(self, other, other2))
end
pyjl_handle_error_type(op::pyjlnumber_op, self, exc) =
    exc isa MethodError && exc.f === op.op ? pybuiltins.TypeError : PyNULL

struct pyjlnumber_rev_op{OP}
    op::OP
end
function (op::pyjlnumber_rev_op)(self, other_::Py)
    if pyisjl(other_)
        other = pyjlvalue(other_)
        pydel!(other_)
    else
        other = @pyconvert(Number, other_, return pybuiltins.NotImplemented)
    end
    Py(op.op(other, self))
end
function (op::pyjlnumber_rev_op)(self, other_::Py, other2_::Py)
    if pyisjl(other_)
        other = pyjlvalue(other_)
        pydel!(other_)
    else
        other = @pyconvert(Number, other_, return pybuiltins.NotImplemented)
    end
    if pyisjl(other2_)
        other2 = pyjlvalue(other2_)
        pydel!(other2_)
    else
        other2 = @pyconvert(Number, other2_, return pybuiltins.NotImplemented)
    end
    Py(op.op(other, self, other2))
end
pyjl_handle_error_type(op::pyjlnumber_rev_op, self, exc) =
    exc isa MethodError && exc.f === op.op ? pybuiltins.TypeError : PyNULL

pyjlreal_trunc(self::Real) = Py(trunc(Integer, self))
pyjl_handle_error_type(::typeof(pyjlreal_trunc), self, exc::MethodError) =
    exc.f === trunc ? pybuiltins.TypeError : PyNULL

pyjlreal_floor(self::Real) = Py(floor(Integer, self))
pyjl_handle_error_type(::typeof(pyjlreal_floor), self, exc::MethodError) =
    exc.f === floor ? pybuiltins.TypeError : PyNULL

pyjlreal_ceil(self::Real) = Py(ceil(Integer, self))
pyjl_handle_error_type(::typeof(pyjlreal_ceil), self, exc::MethodError) =
    exc.f === ceil ? pybuiltins.TypeError : PyNULL

function pyjlreal_round(self::Real, ndigits_::Py)
    ndigits = pyconvertarg(Union{Int,Nothing}, ndigits_, "ndigits")
    pydel!(ndigits_)
    if ndigits === nothing
        Py(round(Integer, self))
    else
        Py(round(self; digits = ndigits))
    end
end
pyjl_handle_error_type(::typeof(pyjlreal_round), self, exc::MethodError) =
    exc.f === round ? pybuiltins.TypeError : PyNULL

function init_number()
    jl = pyjuliacallmodule
    pybuiltins.exec(
        pybuiltins.compile(
            """
$("\n"^(@__LINE__()-1))
class NumberValue(AnyValue):
    __slots__ = ()
    def __bool__(self):
        return not self._jl_callmethod($(pyjl_methodnum(pyjlnumber_op(iszero))))
    def __add__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlnumber_op(+))), other)
    def __sub__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlnumber_op(-))), other)
    def __mul__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlnumber_op(*))), other)
    def __truediv__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlnumber_op(/))), other)
    def __floordiv__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlnumber_op(÷))), other)
    def __mod__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlnumber_op(%))), other)
    def __pow__(self, other, modulo=None):
        if modulo is None:
            return self._jl_callmethod($(pyjl_methodnum(pyjlnumber_op(^))), other)
        else:
            return self._jl_callmethod($(pyjl_methodnum(pyjlnumber_op(powermod))), other, modulo)
    def __lshift__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlnumber_op(<<))), other)
    def __rshift__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlnumber_op(>>))), other)
    def __and__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlnumber_op(&))), other)
    def __xor__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlnumber_op(⊻))), other)
    def __or__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlnumber_op(|))), other)
    def __radd__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlnumber_rev_op(+))), other)
    def __rsub__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlnumber_rev_op(-))), other)
    def __rmul__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlnumber_rev_op(*))), other)
    def __rtruediv__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlnumber_rev_op(/))), other)
    def __rfloordiv__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlnumber_rev_op(÷))), other)
    def __rmod__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlnumber_rev_op(%))), other)
    def __rpow__(self, other, modulo=None):
        if modulo is None:
            return self._jl_callmethod($(pyjl_methodnum(pyjlnumber_rev_op(^))), other)
        else:
            return self._jl_callmethod($(pyjl_methodnum(pyjlnumber_rev_op(powermod))), other, modulo)
    def __rlshift__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlnumber_rev_op(<<))), other)
    def __rrshift__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlnumber_rev_op(>>))), other)
    def __rand__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlnumber_rev_op(&))), other)
    def __rxor__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlnumber_rev_op(⊻))), other)
    def __ror__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlnumber_rev_op(|))), other)
    def __eq__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlnumber_op(==))), other)
    def __ne__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlnumber_op(!=))), other)
    def __le__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlnumber_op(≤))), other)
    def __lt__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlnumber_op(<))), other)
    def __ge__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlnumber_op(≥))), other)
    def __gt__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlnumber_op(>))), other)
class ComplexValue(NumberValue):
    __slots__ = ()
    def __complex__(self):
        return self._jl_callmethod($(pyjl_methodnum(pycomplex)))
    @property
    def real(self):
        return self._jl_callmethod($(pyjl_methodnum(pyjlnumber_op(real))))
    @property
    def imag(self):
        return self._jl_callmethod($(pyjl_methodnum(pyjlnumber_op(imag))))
    def conjugate(self):
        return self._jl_callmethod($(pyjl_methodnum(pyjlnumber_op(conj))))
class RealValue(ComplexValue):
    __slots__ = ()
    def __float__(self):
        return self._jl_callmethod($(pyjl_methodnum(pyfloat)))
    @property
    def real(self):
        return self
    @property
    def imag(self):
        return 0
    def conjugate(self):
        return self
    def __complex__(self):
        return complex(float(self))
    def __trunc__(self):
        return self._jl_callmethod($(pyjl_methodnum(pyjlreal_trunc)))
    def __floor__(self):
        return self._jl_callmethod($(pyjl_methodnum(pyjlreal_floor)))
    def __ceil__(self):
        return self._jl_callmethod($(pyjl_methodnum(pyjlreal_ceil)))
    def __round__(self, ndigits=None):
        return self._jl_callmethod($(pyjl_methodnum(pyjlreal_round)), ndigits)
class RationalValue(RealValue):
    __slots__ = ()
    @property
    def numerator(self):
        return self._jl_callmethod($(pyjl_methodnum(pyjlnumber_op(numerator))))
    @property
    def denominator(self):
        return self._jl_callmethod($(pyjl_methodnum(pyjlnumber_op(denominator))))
class IntegerValue(RationalValue):
    __slots__ = ()
    def __int__(self):
        return self._jl_callmethod($(pyjl_methodnum(pyint)))
    def __index__(self):
        return self.__int__()
    @property
    def numerator(self):
        return self
    @property
    def denominator(self):
        return 1
import numbers
numbers.Number.register(NumberValue)
numbers.Complex.register(ComplexValue)
numbers.Real.register(RealValue)
numbers.Rational.register(RationalValue)
numbers.Integral.register(IntegerValue)
del numbers
""",
            @__FILE__(),
            "exec",
        ),
        jl.__dict__,
    )
    pycopy!(pyjlnumbertype, jl.NumberValue)
    pycopy!(pyjlcomplextype, jl.ComplexValue)
    pycopy!(pyjlrealtype, jl.RealValue)
    pycopy!(pyjlrationaltype, jl.RationalValue)
    pycopy!(pyjlintegertype, jl.IntegerValue)
end

pyjltype(::Number) = pyjlnumbertype
pyjltype(::Complex) = pyjlcomplextype
pyjltype(::Real) = pyjlrealtype
pyjltype(::Rational) = pyjlrationaltype
pyjltype(::Integer) = pyjlintegertype

"""
    @enum Unit

The possible time units for datetimes and timedeltas in this module.

Values are: `YEARS`, `MONTHS`, `WEEKS`, `DAYS`, `HOURS`, `MINUTES`, `SECONDS`,
`MILLISECONDS`, `MICROSECONDS`, `NANOSECONDS`, `PICOSECONDS`, `FEMTOSECONDS`,
`ATTOSECONDS`.

For compatibility with numpy, the types in this module also accept scaled units as a
`Tuple{Unit,Int}`. For example `(MINUTES, 15)` for units of 15 minutes. This feature is
rarely used.
"""
@enum Unit::Cint begin
    YEARS = 0
    MONTHS = 1
    WEEKS = 2
    DAYS = 4
    HOURS = 5
    MINUTES = 6
    SECONDS = 7
    MILLISECONDS = 8
    MICROSECONDS = 9
    NANOSECONDS = 10
    PICOSECONDS = 11
    FEMTOSECONDS = 12
    ATTOSECONDS = 13
    UNBOUND_UNITS = 14
end

function Unit(u::Unit)
    u
end

function Unit(u::Symbol)
    u == :Y ? YEARS :
    u == :M ? MONTHS :
    u == :W ? WEEKS :
    u == :D ? DAYS :
    u == :h ? HOURS :
    u == :m ? MINUTES :
    u == :s ? SECONDS :
    u == :ms ? MILLISECONDS :
    u == :us ? MICROSECONDS :
    u == :ns ? NANOSECONDS :
    u == :ps ? PICOSECONDS :
    u == :fs ? FEMTOSECONDS : u == :as ? ATTOSECONDS : error("invalid unit: $u")
end

Unit(::Type{Dates.Date}) = DAYS
Unit(::Type{Dates.DateTime}) = MILLISECONDS
Unit(::Type{Dates.Year}) = YEARS
Unit(::Type{Dates.Month}) = MONTHS
Unit(::Type{Dates.Week}) = WEEKS
Unit(::Type{Dates.Day}) = DAYS
Unit(::Type{Dates.Hour}) = HOURS
Unit(::Type{Dates.Minute}) = MINUTES
Unit(::Type{Dates.Second}) = SECONDS
Unit(::Type{Dates.Millisecond}) = MILLISECONDS
Unit(::Type{Dates.Microsecond}) = MICROSECONDS
Unit(::Type{Dates.Nanosecond}) = NANOSECONDS

Unit(d::DatesInstant) = Unit(typeof(d))
Unit(p::DatesPeriod) = Unit(typeof(p))

function Base.Symbol(u::Unit)
    u == NumpyDates.YEARS ? :Y :
    u == NumpyDates.MONTHS ? :M :
    u == NumpyDates.WEEKS ? :W :
    u == NumpyDates.DAYS ? :D :
    u == NumpyDates.HOURS ? :h :
    u == NumpyDates.MINUTES ? :m :
    u == NumpyDates.SECONDS ? :s :
    u == NumpyDates.MILLISECONDS ? :ms :
    u == NumpyDates.MICROSECONDS ? :us :
    u == NumpyDates.NANOSECONDS ? :ns :
    u == NumpyDates.PICOSECONDS ? :ps :
    u == NumpyDates.FEMTOSECONDS ? :fs :
    u == NumpyDates.ATTOSECONDS ? :as : error("invalid unit: $u")
end

const UnitArg = Union{Unit,Symbol,Tuple{Unit,Integer},Tuple{Symbol,Integer}}

const UnitPair = Tuple{Unit,Integer}

function unitpair(u::UnitArg)
    u, m = u isa Tuple ? u : (u, 1)
    (Unit(u), m)
end

function unitparam(u::UnitArg)
    u, m = unitpair(u)
    m == 1 ? u : (u, Int(m))
end

defaultunit(::Any) = NANOSECONDS
defaultunit(d::DatesInstant) = Unit(d)
defaultunit(p::DatesPeriod) = Unit(p)

"""
    unitscale(u0::Unit, u1::Unit)

Returns `(multiplier, divisor)` to go from a value in units `u0` to units `u1`.

For example `unitscale(YEARS, MONTHS)` returns `(12, 1)` because 1 year is 12 months.
"""
function unitscale(u0::Unit, u1::Unit)
    m::Int64 = 1
    d::Int64 = 1
    c(n) = n isa Int128 ? Int64(0) : Int64(n)
    if u0 == u1
        # ok
    elseif u0 == YEARS
        if u1 == YEARS
            # ok
        elseif u1 == MONTHS
            m = c(12)
        else
            m = 0
        end
    elseif u0 == MONTHS
        if u1 == YEARS
            d = c(12)
        elseif u1 == MONTHS
            # ok
        else
            m = 0
        end
    elseif u0 == WEEKS
        if u1 == WEEKS
            # ok
        elseif u1 == DAYS
            m = c(7)
        elseif u1 == HOURS
            m = c(168)
        elseif u1 == MINUTES
            m = c(10_080)
        elseif u1 == SECONDS
            m = c(604_800)
        elseif u1 == MILLISECONDS
            m = c(604_800_000)
        elseif u1 == MICROSECONDS
            m = c(604_800_000_000)
        elseif u1 == NANOSECONDS
            m = c(604_800_000_000_000)
        elseif u1 == PICOSECONDS
            m = c(604_800_000_000_000_000)
        elseif u1 == FEMTOSECONDS
            m = c(604_800_000_000_000_000_000)
        elseif u1 == ATTOSECONDS
            m = c(604_800_000_000_000_000_000_000)
        else
            m = 0
        end
    elseif u0 == DAYS
        if u1 == WEEKS
            d = c(7)
        elseif u1 == DAYS
            # ok
        elseif u1 == HOURS
            m = c(24)
        elseif u1 == MINUTES
            m = c(1_440)
        elseif u1 == SECONDS
            m = c(86_400)
        elseif u1 == MILLISECONDS
            m = c(86_400_000)
        elseif u1 == MICROSECONDS
            m = c(86_400_000_000)
        elseif u1 == NANOSECONDS
            m = c(86_400_000_000_000)
        elseif u1 == PICOSECONDS
            m = c(86_400_000_000_000_000)
        elseif u1 == FEMTOSECONDS
            m = c(86_400_000_000_000_000_000)
        elseif u1 == ATTOSECONDS
            m = c(86_400_000_000_000_000_000_000)
        else
            m = 0
        end
    elseif u0 == HOURS
        if u1 == WEEKS
            d = c(168)
        elseif u1 == DAYS
            d = c(24)
        elseif u1 == HOURS
            # ok
        elseif u1 == MINUTES
            m = c(60)
        elseif u1 == SECONDS
            m = c(3_600)
        elseif u1 == MILLISECONDS
            m = c(3_600_000)
        elseif u1 == MICROSECONDS
            m = c(3_600_000_000)
        elseif u1 == NANOSECONDS
            m = c(3_600_000_000_000)
        elseif u1 == PICOSECONDS
            m = c(3_600_000_000_000_000)
        elseif u1 == FEMTOSECONDS
            m = c(3_600_000_000_000_000_000)
        elseif u1 == ATTOSECONDS
            m = c(3_600_000_000_000_000_000_000)
        else
            m = 0
        end
    elseif u0 == MINUTES
        if u1 == WEEKS
            d = c(10_080)
        elseif u1 == DAYS
            d = c(1_440)
        elseif u1 == HOURS
            d = c(60)
        elseif u1 == MINUTES
            # ok
        elseif u1 == SECONDS
            m = c(60)
        elseif u1 == MILLISECONDS
            m = c(60_000)
        elseif u1 == MICROSECONDS
            m = c(60_000_000)
        elseif u1 == NANOSECONDS
            m = c(60_000_000_000)
        elseif u1 == PICOSECONDS
            m = c(60_000_000_000_000)
        elseif u1 == FEMTOSECONDS
            m = c(60_000_000_000_000_000)
        elseif u1 == ATTOSECONDS
            m = c(60_000_000_000_000_000_000)
        else
            m = 0
        end
    elseif u0 == SECONDS
        if u1 == WEEKS
            d = c(604_800)
        elseif u1 == DAYS
            d = c(86_400)
        elseif u1 == HOURS
            d = c(3_600)
        elseif u1 == MINUTES
            d = c(60)
        elseif u1 == SECONDS
            # ok
        elseif u1 == MILLISECONDS
            m = c(1_000)
        elseif u1 == MICROSECONDS
            m = c(1_000_000)
        elseif u1 == NANOSECONDS
            m = c(1_000_000_000)
        elseif u1 == PICOSECONDS
            m = c(1_000_000_000_000)
        elseif u1 == FEMTOSECONDS
            m = c(1_000_000_000_000_000)
        elseif u1 == ATTOSECONDS
            m = c(1_000_000_000_000_000_000)
        else
            m = 0
        end
    elseif u0 == MILLISECONDS
        if u1 == WEEKS
            d = c(604_800_000)
        elseif u1 == DAYS
            d = c(86_400_000)
        elseif u1 == HOURS
            d = c(3_600_000)
        elseif u1 == MINUTES
            d = c(60_000)
        elseif u1 == SECONDS
            d = c(1_000)
        elseif u1 == MILLISECONDS
            # ok
        elseif u1 == MICROSECONDS
            m = c(1_000)
        elseif u1 == NANOSECONDS
            m = c(1_000_000)
        elseif u1 == PICOSECONDS
            m = c(1_000_000_000)
        elseif u1 == FEMTOSECONDS
            m = c(1_000_000_000_000)
        elseif u1 == ATTOSECONDS
            m = c(1_000_000_000_000_000)
        else
            m = 0
        end
    elseif u0 == MICROSECONDS
        if u1 == WEEKS
            d = c(604_800_000_000)
        elseif u1 == DAYS
            d = c(86_400_000_000)
        elseif u1 == HOURS
            d = c(3_600_000_000)
        elseif u1 == MINUTES
            d = c(60_000_000)
        elseif u1 == SECONDS
            d = c(1_000_000)
        elseif u1 == MILLISECONDS
            d = c(1_000)
        elseif u1 == MICROSECONDS
            # ok
        elseif u1 == NANOSECONDS
            m = c(1_000)
        elseif u1 == PICOSECONDS
            m = c(1_000_000)
        elseif u1 == FEMTOSECONDS
            m = c(1_000_000_000)
        elseif u1 == ATTOSECONDS
            m = c(1_000_000_000_000)
        else
            m = 0
        end
    elseif u0 == NANOSECONDS
        if u1 == WEEKS
            d = c(604_800_000_000_000)
        elseif u1 == DAYS
            d = c(86_400_000_000_000)
        elseif u1 == HOURS
            d = c(3_600_000_000_000)
        elseif u1 == MINUTES
            d = c(60_000_000_000)
        elseif u1 == SECONDS
            d = c(1_000_000_000)
        elseif u1 == MILLISECONDS
            d = c(1_000_000)
        elseif u1 == MICROSECONDS
            d = c(1_000)
        elseif u1 == NANOSECONDS
            # ok
        elseif u1 == PICOSECONDS
            m = c(1_000)
        elseif u1 == FEMTOSECONDS
            m = c(1_000_000)
        elseif u1 == ATTOSECONDS
            m = c(1_000_000_000)
        else
            m = 0
        end
    elseif u0 == PICOSECONDS
        if u1 == WEEKS
            d = c(604_800_000_000_000_000)
        elseif u1 == DAYS
            d = c(86_400_000_000_000_000)
        elseif u1 == HOURS
            d = c(3_600_000_000_000_000)
        elseif u1 == MINUTES
            d = c(60_000_000_000_000)
        elseif u1 == SECONDS
            d = c(1_000_000_000_000)
        elseif u1 == MILLISECONDS
            d = c(1_000_000_000)
        elseif u1 == MICROSECONDS
            d = c(1_000_000)
        elseif u1 == NANOSECONDS
            d = c(1_000)
        elseif u1 == PICOSECONDS
            # ok
        elseif u1 == FEMTOSECONDS
            m = c(1_000)
        elseif u1 == ATTOSECONDS
            m = c(1_000_000)
        else
            m = 0
        end
    elseif u0 == FEMTOSECONDS
        if u1 == WEEKS
            d = c(604_800_000_000_000_000_000)
        elseif u1 == DAYS
            d = c(86_400_000_000_000_000_000)
        elseif u1 == HOURS
            d = c(3_600_000_000_000_000_000)
        elseif u1 == MINUTES
            d = c(60_000_000_000_000_000)
        elseif u1 == SECONDS
            d = c(1_000_000_000_000_000)
        elseif u1 == MILLISECONDS
            d = c(1_000_000_000_000)
        elseif u1 == MICROSECONDS
            d = c(1_000_000_000)
        elseif u1 == NANOSECONDS
            d = c(1_000_000)
        elseif u1 == PICOSECONDS
            d = c(1_000)
        elseif u1 == FEMTOSECONDS
            # ok
        elseif u1 == ATTOSECONDS
            m = c(1_000)
        else
            m = 0
        end
    elseif u0 == ATTOSECONDS
        if u1 == WEEKS
            d = c(604_800_000_000_000_000_000_000)
        elseif u1 == DAYS
            d = c(86_400_000_000_000_000_000_000)
        elseif u1 == HOURS
            d = c(3_600_000_000_000_000_000_000)
        elseif u1 == MINUTES
            d = c(60_000_000_000_000_000_000)
        elseif u1 == SECONDS
            d = c(1_000_000_000_000_000_000)
        elseif u1 == MILLISECONDS
            d = c(1_000_000_000_000_000)
        elseif u1 == MICROSECONDS
            d = c(1_000_000_000_000)
        elseif u1 == NANOSECONDS
            d = c(1_000_000_000)
        elseif u1 == PICOSECONDS
            d = c(1_000_000)
        elseif u1 == FEMTOSECONDS
            d = c(1_000)
        elseif u1 == ATTOSECONDS
            # ok
        else
            m = 0
        end
    else
        m = 0
    end
    (m == 0 || d == 0) && error("cannot convert from $u0 to $u1")
    (m, d)
end

"""
    rescale(value::Int64, from_unit, to_unit)

Given a `value` in a given `from_unit`, rescale it to be in the `to_unit`.

Returns `(to_value, remainder)` where `remainder`

For example `rescale(2, YEARS, MONTHS) == (24, 0)` because 2 years is exactly 24 months.

And `rescale(2001, MILLISECONDS, SECONDS) == (2, 1)` because 2001 milliseconds is 2
seconds and 1 millisecond.
"""
function rescale(v::Int64, from_unit, to_unit)
    iszero(v) && return (v, zero(Int64))
    u0::Unit, m0::Int64 = unitpair(from_unit)
    u1::Unit, m1::Int64 = unitpair(to_unit)
    (multiplier, divisor) = unitscale(u0, u1)
    multiplier = mul(multiplier, m0)
    divisor = mul(divisor, m1)
    fldmod(mul(v, multiplier), divisor)
end

# type

"""
    TimeDelta64(value, [unit])

Construct a `TimeDelta64` with the given `value` and [`unit`](@ref Unit).

The unit is stored as a run-time value. If the units in your code are known, using
[`InlineTimeDelta64{unit}`](@ref InlineTimeDelta64) may be preferable. The memory layout
is the same as for a `numpy.timedelta64`.

The value can be:
- An `Integer`, in which case the `unit` is required.
- `"NaT"` or `"NaN"` to make a not-a-time value.
"""
struct TimeDelta64 <: AbstractTimeDelta64
    value::Int64
    unit::Tuple{Unit,Cint}
    function TimeDelta64(value::Integer, unit::UnitArg)
        new(Int(value), unitpair(unit))
    end
end

# accessors

unitpair(d::TimeDelta64) = d.unit

# constructors

# (outer value/unit constructor is unnecessary; inner constructor handles UnitArg)

function TimeDelta64(d::AbstractTimeDelta64, unit::UnitArg = defaultunit(d))
    unit = unitpair(unit)
    if unit == unitpair(d)
        TimeDelta64(value(d), unit)
    elseif isnan(d)
        TimeDelta64(NAT, unit)
    else
        v, r = rescale(value(d), unitpair(d), unit)
        iszero(r) || throw(InexactError(:convert, TimeDelta64, d))
        TimeDelta64(v, unit)
    end
end

function TimeDelta64(s::AbstractString, unit::UnitArg = defaultunit(s))
    unit = unitpair(unit)
    if s in NAT_STRINGS
        TimeDelta64(NAT, unit)
    else
        error(
            "Cannot construct TimeDelta64 from string '$s'. Only NaT variants are supported.",
        )
    end
end

function TimeDelta64(p::DatesPeriod, unit::UnitArg = defaultunit(p))
    v, r = rescale(value(p), Unit(p), unit)
    iszero(r) || throw(InexactError(:convert, TimeDelta64, p))
    TimeDelta64(v, unit)
end

# convert

Base.convert(::Type{TimeDelta64}, p::TimeDelta64) = p
Base.convert(::Type{TimeDelta64}, p::Union{AbstractTimeDelta64,DatesPeriod}) =
    TimeDelta64(p)

# show

function Base.show(io::IO, d::TimeDelta64)
    if get(io, :typeinfo, Any) == typeof(d)
        showvalue(io, d)
    else
        show(io, typeof(d))
        print(io, "(")
        showvalue(io, d)
        print(io, ", ")
        show(io, unitparam(unitpair(d)))
        print(io, ")")
    end
    nothing
end

Base.show(io::IO, ::MIME"text/plain", d::TimeDelta64) = show(io, d)

# type

"""
    InlineDateTime64{unit}(value)
    InlineDateTime64{unit}(value, format)
    InlineDateTime64(value, [unit])
    InlineDateTime64(value, format, [unit])

Construct an `InlineDateTime64` with the given `value` and [`unit`](@ref Unit).

The unit is part of the type, so an instance just consists of one `Int64` for the value.

The `value` can be:
- An `Integer`, in which case the `unit` is required.
- A `Dates.Date` or `Dates.DateTime`.
- `"NaT"` or `"NaN"` to make a not-a-time value.
- An `AbstractString`, which is parsed the same as `Dates.DateTime`, with an optional
  `format` string.
"""
struct InlineDateTime64{U} <: AbstractDateTime64
    value::Int64
    function InlineDateTime64{U}(value::Int64) where {U}
        U isa Unit ||
            U isa Tuple{Unit,Int} ||
            error("U must be a Unit or a Tuple{Unit,Int}")
        new{U}(value)
    end
end

# accessors

Dates.value(d::InlineDateTime64) = d.value

unitpair(::InlineDateTime64{U}) where {U} = unitpair(U)
unitpair(::Type{InlineDateTime64{U}}) where {U} = unitpair(U)

# constructors

function InlineDateTime64{U}(v::AbstractDateTime64) where {U}
    InlineDateTime64{U}(value(DateTime64(v, U)))
end

function InlineDateTime64{U}(v::AbstractString) where {U}
    InlineDateTime64{U}(value(DateTime64(v, U)))
end

function InlineDateTime64{U}(v::Dates.DateTime) where {U}
    InlineDateTime64{U}(value(DateTime64(v, U)))
end

function InlineDateTime64{U}(v::Dates.Date) where {U}
    InlineDateTime64{U}(value(DateTime64(v, U)))
end

function InlineDateTime64{U}(v::Integer) where {U}
    InlineDateTime64{U}(convert(Int, v))
end

function InlineDateTime64{U}(
    v::AbstractString,
    f::Union{AbstractString,Dates.DateFormat},
) where {U}
    InlineDateTime64{U}(value(DateTime64(v, f, U)))
end

function InlineDateTime64(v::AbstractDateTime64, u::UnitArg = defaultunit(v))
    InlineDateTime64{unitparam(u)}(v)
end

function InlineDateTime64(v::AbstractString, u::UnitArg = defaultunit(v))
    InlineDateTime64{unitparam(u)}(v)
end

function InlineDateTime64(v::Dates.DateTime, u::UnitArg = defaultunit(v))
    InlineDateTime64{unitparam(u)}(v)
end

function InlineDateTime64(v::Dates.Date, u::UnitArg = defaultunit(v))
    InlineDateTime64{unitparam(u)}(v)
end

function InlineDateTime64(v::Integer, u::UnitArg)
    InlineDateTime64{unitparam(u)}(v)
end

function InlineDateTime64(
    v::AbstractString,
    f::Union{AbstractString,Dates.DateFormat},
    u::UnitArg = defaultunit(v),
)
    InlineTimeDelta64{unitparam(u)}(v, f)
end

# convert

Base.convert(::Type{InlineDateTime64}, x::InlineDateTime64) = x
Base.convert(::Type{InlineDateTime64}, x::Union{AbstractDateTime64,DatesInstant}) =
    InlineDateTime64(x)
Base.convert(::Type{InlineDateTime64{U}}, x::InlineDateTime64{U}) where {U} = x
Base.convert(
    ::Type{InlineDateTime64{U}},
    x::Union{AbstractDateTime64,DatesInstant},
) where {U} = InlineDateTime64{U}(x)

# show

function Base.show(io::IO, d::InlineDateTime64)
    if get(io, :typeinfo, Any) == typeof(d)
        showvalue(io, d)
    else
        show(io, typeof(d))
        print(io, "(")
        showvalue(io, d)
        print(io, ")")
    end
    nothing
end

PyIterable(x) = PyIterable{Py}(x)

ispy(x::PyIterable) = true
Py(x::PyIterable) = x.py

Base.IteratorSize(::Type{PyIterable{T}}) where {T} = Base.SizeUnknown()
Base.eltype(::Type{PyIterable{T}}) where {T} = T

function Base.iterate(x::PyIterable{T}, it::Py = pyiter(x)) where {T}
    y = unsafe_pynext(it)
    if pyisnull(y)
        pydel!(it)
        return nothing
    else
        return (pyconvert(T, y), it)
    end
end

function pyconvert_rule_iterable(
    ::Type{T},
    x::Py,
    ::Type{T1} = Utils._type_ub(T),
) where {T<:PyIterable,T1}
    pyconvert_return(T1(x))
end

const pywrapcallback = pynew()
const pyjlcallbacktype = pynew()

pyjlcallback_repr(self) = Py("<jl $(repr(self))>")

pyjlcallback_str(self) = Py(sprint(print, self))

function pyjlcallback_call(self, args_::Py, kwargs_::Py)
    if pylen(kwargs_) > 0
        args = pyconvert(Vector{Py}, args_)
        kwargs = pyconvert(Dict{Symbol,Py}, kwargs_)
        ans = Py(self(args...; kwargs...))
    elseif (nargs = pylen(args_)) > 0
        args = pyconvert(Vector{Py}, args_)
        @assert length(args) == nargs
        if nargs == 1
            ans = Py(self(args[1]))
        elseif nargs == 2
            ans = Py(self(args[1], args[2]))
        elseif nargs == 3
            ans = Py(self(args[1], args[2], args[3]))
        elseif nargs == 4
            ans = Py(self(args[1], args[2], args[3], args[4]))
        elseif nargs == 5
            ans = Py(self(args[1], args[2], args[3], args[4], args[5]))
        else
            ans = Py(self(args...))
        end
    else
        ans = Py(self())
    end
    pydel!(args_)
    pydel!(kwargs_)
    ans
end
pyjl_handle_error_type(::typeof(pyjlcallback_call), self, exc::MethodError) =
    exc.f === self ? pybuiltins.TypeError : PyNULL

function init_callback()
    jl = pyjuliacallmodule
    pybuiltins.exec(
        pybuiltins.compile(
            """
$("\n"^(@__LINE__()-1))
class CallbackValue(ValueBase):
    __slots__ = ()
    def __repr__(self):
        if self._jl_isnull():
            return "<jl NULL>"
        else:
            return self._jl_callmethod($(pyjl_methodnum(pyjlcallback_repr)))
    def __str__(self):
        if self._jl_isnull():
            return "NULL"
        else:
            return self._jl_callmethod($(pyjl_methodnum(pyjlcallback_str)))
    def __call__(self, *args, **kwargs):
        return self._jl_callmethod($(pyjl_methodnum(pyjlcallback_call)), args, kwargs)
""",
            @__FILE__(),
            "exec",
        ),
        jl.__dict__,
    )
    pycopy!(pyjlcallbacktype, jl.CallbackValue)
    pycopy!(
        pywrapcallback,
        pybuiltins.eval("lambda f: lambda *args, **kwargs: f(*args, **kwargs)", pydict()),
    )
end

pyjlcallback(f) = pyjl(pyjlcallbacktype, f)

"""
    pyfunc(f; [name], [qualname], [doc], [signature])

Wrap the callable `f` as an ordinary Python function.

The name, qualname, docstring or signature can optionally be set with `name`, `qualname`,
`doc` or `signature`.

Unlike `Py(f)` (or `pyjl(f)`), the arguments passed to `f` are always of type `Py`, i.e.
they are never converted.
"""
function pyfunc(
    f;
    name = nothing,
    qualname = name,
    doc = nothing,
    signature = nothing,
    wrap = pywrapcallback,
)
    f2 = ispy(f) ? f : pyjlcallback(f)
    if wrap isa Pair
        wrapargs, wrapfunc = wrap
    else
        wrapargs, wrapfunc = (), wrap
    end
    if wrapfunc isa AbstractString
        f3 = pybuiltins.eval(wrapfunc, pydict())(f2, wrapargs...)
    else
        f3 = wrapfunc(f2, wrapargs...)
    end
    f3.__name__ = name === nothing ? "<lambda>" : name
    f3.__qualname__ = name === nothing ? "<lambda>" : qualname
    if doc !== nothing
        f3.__doc__ = doc
    end
    if signature !== nothing
        f3.__signature__ = signature
    end
    return f3
end

"""
    pyclassmethod(f; ...)

Convert callable `f` to a Python class method.

If `f` is not a Python object (e.g. if `f` is a `Function`) then it is converted to one with
[`pyfunc`](@ref PythonCall.pyfunc). In particular this means the arguments passed to `f` are always of type
`Py`. Keyword arguments are passed to `pyfunc`.
"""
pyclassmethod(f; kw...) = pybuiltins.classmethod(ispy(f) ? f : pyfunc(f; kw...))

"""
    pystaticmethod(f; ...)

Convert callable `f` to a Python static method.

If `f` is not a Python object (e.g. if `f` is a `Function`) then it is converted to one with
[`pyfunc`](@ref PythonCall.pyfunc). In particular this means the arguments passed to `f` are always of type
`Py`. Any keyword arguments are passed to `pyfunc`.
"""
pystaticmethod(f; kw...) = pybuiltins.staticmethod(ispy(f) ? f : pyfunc(f; kw...))

"""
    pyproperty(; get=nothing, set=nothing, del=nothing, doc=nothing)
    pyproperty(get)

Create a Python `property` with the given getter, setter and deleter.

If `get`, `set` or `del` is not a Python object (e.g. if it is a `Function`) then it is
converted to one with [`pyfunc`](@ref PythonCall.pyfunc). In particular this means the arguments passed to it
are always of type `Py`.
"""
pyproperty(; get = nothing, set = nothing, del = nothing, doc = nothing) =
    pybuiltins.property(
        fget = ispy(get) || get === nothing ? get : pyfunc(get),
        fset = ispy(set) || set === nothing ? set : pyfunc(set),
        fdel = ispy(del) || del === nothing ? del : pyfunc(del),
        doc = doc,
    )
pyproperty(get) = pyproperty(get = get)

@testitem "PyArray" begin
    x = pyimport("array").array("i", pylist([1, 2, 3]))
    y = PyArray(x)
    z = PyArray{Cint,1,false,false,Cint}(x)
    @testset "construct" begin
        @test y isa PyArray{Cint,1,true,true,Cint}
        @test z isa PyArray{Cint,1,false,false,Cint}
        @test PythonCall.ispy(y)
        @test PythonCall.ispy(z)
        @test Py(y) === x
        @test Py(z) === x
    end
    @testset "length" begin
        @test length(y) === 3
        @test length(z) === 3
    end
    @testset "size" begin
        @test size(y) === (3,)
        @test size(z) === (3,)
    end
    @testset "IndexStyle" begin
        @test Base.IndexStyle(y) === Base.IndexLinear()
        @test Base.IndexStyle(z) === Base.IndexCartesian()
    end
    @testset "strides" begin
        @test strides(y) === (1,)
        @test strides(z) === (1,)
    end
    @testset "elsize" begin
        @test Base.elsize(y) === sizeof(Cint)
        @test Base.elsize(z) === sizeof(Cint)
        @test Base.elsize(PyArray{Cint,1,true,true,Cint}) === sizeof(Cint)
        @test Base.elsize(PyArray{Cint,1,false,false,Cint}) === sizeof(Cint)
        @test_throws Exception elsize(PyArray{Cint,1,true,false,Cchar})
    end
    @testset "getindex" begin
        @test_throws BoundsError y[0]
        @test y[1] == 1
        @test y[2] == 2
        @test y[3] == 3
        @test_throws BoundsError y[4]
        @test_throws BoundsError z[0]
        @test z[1] == 1
        @test z[2] == 2
        @test z[3] == 3
        @test_throws BoundsError z[4]
    end
    @testset "copy" begin
        @test copy(y) == [1, 2, 3]
        @test copy(z) == [1, 2, 3]
    end
    @testset "setindex!" begin
        @test_throws BoundsError y[0] = 0
        y[2] = 22
        @test y[2] == 22
        y[2] = 2
        @test y[2] == 2
        @test_throws BoundsError y[4] = 0
        @test_throws Exception z[0] = 0
        @test_throws Exception z[1] = 0
        @test_throws Exception z[2] = 0
        @test_throws Exception z[3] = 0
        @test_throws Exception z[4] = 0
    end
    @testset "mutate" begin
        y[2] = 22
        @test pyconvert(Int, x[1]) == 22
        @test y[2] == 22
        @test z[2] == 22
        y[2] = 2
        x[2] = 33
        @test pyconvert(Int, x[2]) == 33
        @test y[3] == 33
        @test z[3] == 33
        x[2] = 3
        @test y == [1, 2, 3]
        @test z == [1, 2, 3]
    end
    @testset "serialize" begin
        using Serialization: serialize, deserialize
        io = IOBuffer()
        serialize(io, y)
        seekstart(io)
        y2 = deserialize(io)
        @test typeof(y) == typeof(y2)
        @test eltype(y) == eltype(y2)
        @test ndims(y) == ndims(y2)
        @test size(y) == size(y2)
        @test strides(y) == strides(y2)
        @test y == y2
    end
    @testset "reject suboffsets (#775)" begin
        tb = pyimport("_testbuffer")
        nd = tb.ndarray(
            pylist([1, 2, 3, 4, 5, 6]),
            shape = pylist([2, 3]),
            format = "i",
            flags = tb.ND_PIL | tb.ND_WRITABLE,
        )
        @test_throws Exception PyArray(nd; array = false, buffer = true)
    end
end

@testitem "PyDict" begin
    x = pydict(["foo" => 12])
    y = PyDict(x)
    z = PyDict{String,Int}(x)
    @testset "construct" begin
        @test y isa PyDict{Py,Py}
        @test PyDict{String}(x) isa PyDict{String,Py}
        @test z isa PyDict{String,Int}
        @test PythonCall.ispy(y)
        @test PythonCall.ispy(z)
        @test Py(y) === x
        @test Py(z) === x
    end
    @testset "length" begin
        @test length(y) == 1
        @test length(z) == 1
    end
    @testset "copy" begin
        t = copy(z)
        @test t isa PyDict{String,Int}
        @test !pyis(t, z)
        t["bar"] = 34
        @test z == Dict("foo" => 12)
        @test t == Dict("foo" => 12, "bar" => 34)
    end
    @testset "iterate" begin
        @test collect(z) == ["foo" => 12]
    end
    @testset "iterate keys" begin
        @test collect(keys(z)) == ["foo"]
    end
    @testset "getindex" begin
        @test z["foo"] === 12
        @test_throws KeyError z["bar"]
    end
    @testset "setindex!" begin
        t = copy(z)
        @test setindex!(t, 34, "bar") === t
        @test t == Dict("foo" => 12, "bar" => 34)
        @test setindex!(t, 56, "foo") === t
        @test t == Dict("foo" => 56, "bar" => 34)
        @test_throws Exception setindex!(t, 0, nothing)
        @test_throws Exception setindex!(t, nothing, "foo")
        @test t == Dict("foo" => 56, "bar" => 34)
    end
    @testset "delete!" begin
        t = copy(z)
        @test delete!(t, "bar") === t
        @test t == Dict("foo" => 12)
        @test delete!(t, 0) === t
        @test t == Dict("foo" => 12)
        @test delete!(t, "foo") === t
        @test isempty(t)
        @test delete!(t, "foo") === t
        @test isempty(t)
    end
    @testset "empty!" begin
        t = copy(z)
        @test !isempty(t)
        @test empty!(t) === t
        @test isempty(t)
    end
    @testset "haskey" begin
        @test haskey(z, "foo")
        @test !haskey(z, "bar")
        @test !haskey(z, nothing)
        @test !haskey(z, 99)
    end
    @testset "get" begin
        t = copy(z)
        @test get(t, "foo", nothing) === 12
        @test get(t, "bar", nothing) === nothing
        @test get(t, nothing, missing) === missing
        @test get(t, 0, 1) === 1
        @test get(Vector, t, "foo") === 12
        @test get(Vector, t, "bar") == []
        @test t == Dict("foo" => 12)
    end
    @testset "get!" begin
        t = copy(z)
        @test get!(t, "foo", 0) === 12
        @test t == Dict("foo" => 12)
        @test get!(t, "bar", 0) === 0
        @test t == Dict("foo" => 12, "bar" => 0)
        @test get!(() -> 99, t, "foo") === 12
        @test t == Dict("foo" => 12, "bar" => 0)
        @test get!(() -> 99, t, "baz") === 99
        @test t == Dict("foo" => 12, "bar" => 0, "baz" => 99)
        @test_throws Exception get!(t, 0, 0)
        @test_throws Exception get!(t, "", "")
        @test_throws Exception get!(() -> 99, t, 0)
        @test_throws Exception get!(Vector, t, "")
        @test t == Dict("foo" => 12, "bar" => 0, "baz" => 99)
    end
    @testset "construct empty" begin
        @test PyDict() isa PyDict{Py,Py}
        @test PyDict{String}() isa PyDict{String,Py}
        @test PyDict{String,Int}() isa PyDict{String,Int}
        @test isempty(PyDict{String,Int}())
    end
end

@testitem "PyIO" begin
    b0 = pyimport("io").BytesIO()
    s0 = pyimport("io").StringIO()
    b = PyIO(b0)
    s = PyIO(s0)
    @testset "ispy" begin
        @test ispy(b)
        @test ispy(s)
    end
    @testset "Py" begin
        @test Py(b) === b0
        @test Py(s) === s0
    end
    @testset "test" begin
        @test !b.text
        @test s.text
    end
    @testset "convert" begin
        ss = pyconvert(PyIO, s)
        bb = pyconvert(PyIO, b)
        @test ss isa PyIO
        @test bb isa PyIO
        @test Py(ss) === s0
        @test Py(bb) === b0
    end
    @testset "io" for io in [b, s]
        @test eof(io)
        @test position(io) == 0
        @test write(io, "hello") == 5
        @test position(io) == 5
        @test eof(io)
        seekstart(io)
        flush(io)
        @test position(io) == 0
        @test !eof(io)
        flush(io)
        @test read(io, String) == "hello"
        @test eof(io)
        seekstart(io)
        @test position(io) == 0
        seekend(io)
        @test position(io) == 5
        @test eof(io)
        seek(io, 0)
        @test position(io) == 0
        @test !eof(io)
        seek(io, 3)
        @test position(io) == 3
        @test !eof(io)
        seek(io, 5)
        @test position(io) == 5
        @test eof(io)
        seekstart(io)
        truncate(io, 3)
        @test position(io) == 0
        @test read(io, String) == "hel"
        @test position(io) == 3
        @test eof(io)
    end
    @testset "isreadable" begin
        @test isreadable(b)
        @test isreadable(s)
    end
    @testset "iswritable" begin
        @test iswritable(b)
        @test iswritable(s)
    end
    @testset "isopen" begin
        @test isopen(b)
        @test isopen(s)
    end
    @testset "close" begin
        close(b)
        close(s)
        @test !isopen(b)
        @test !isopen(s)
    end
    @testset "flush partial characters (issue 679)" begin
        # In this example, "touché!" takes up 8 bytes, with 'é' taking 2. So when we
        # make a PyIO with buflen=6, it tries to flush after 6 bytes. Previously this
        # would try to create a string from those 6 bytes and fail with a
        # UnicodeDecodeError because the final character is incomplete. This is now
        # fixed by deferring printing of incomplete characters.
        s0 = pyimport("io").StringIO()
        s = PyIO(s0, buflen=6)
        @test s.text
        @test write(s, "touché!") == 8
        flush(s)
        s0.seek(0)
        @test pyeq(Bool, s0.read(), "touché!")
    end
end

@testitem "PyIterable" begin
    x = pylist([1, 2, 3])
    y = PyIterable(x)
    z = PyIterable{Int}(x)
    @testset "construct" begin
        @test y isa PyIterable{Py}
        @test z isa PyIterable{Int}
        @test PythonCall.ispy(y)
        @test PythonCall.ispy(z)
        @test Py(y) === x
        @test Py(z) === x
    end
    @testset "iterate" begin
        @test Base.IteratorSize(typeof(y)) === Base.SizeUnknown()
        @test Base.IteratorSize(typeof(z)) === Base.SizeUnknown()
        @test eltype(y) == Py
        @test eltype(z) == Int
        @test collect(z) == [1, 2, 3]
    end
end

@testitem "PyList" begin
    x = pylist([1, 2, 3])
    y = PyList(x)
    z = PyList{Int}(x)
    @testset "construct" begin
        @test y isa PyList{Py}
        @test z isa PyList{Int}
        @test PythonCall.ispy(y)
        @test PythonCall.ispy(z)
        @test Py(y) === x
        @test Py(z) === x
    end
    @testset "length" begin
        @test length(y) == 3
        @test length(z) == 3
    end
    @testset "size" begin
        @test size(y) == (3,)
        @test size(z) == (3,)
    end
    @testset "getindex" begin
        @test y[1] isa Py
        @test pyeq(Bool, y[1], 1)
        @test pyeq(Bool, y[2], 2)
        @test pyeq(Bool, y[3], 3)
        @test_throws BoundsError y[-1]
        @test_throws BoundsError y[0]
        @test_throws BoundsError y[4]
        @test z[1] === 1
        @test z[2] === 2
        @test z[3] === 3
        @test_throws BoundsError z[-1]
        @test_throws BoundsError z[0]
        @test_throws BoundsError z[4]
    end
    @testset "copy" begin
        t = copy(z)
        @test t isa PyList{Int}
        push!(t, 99)
        @test z == [1, 2, 3]
        @test t == [1, 2, 3, 99]
    end
    @testset "setindex!" begin
        t = copy(z)
        @test setindex!(t, 11, 1) === t
        @test setindex!(t, 22.0, 2) === t
        @test setindex!(t, 66 // 2, 3) == t
        @test t == [11, 22, 33]
        @test_throws BoundsError t[-1] = 0
        @test_throws BoundsError t[0] = 0
        @test_throws BoundsError t[4] = 0
        @test t == [11, 22, 33]
        @test_throws Exception t[1] = nothing
        @test_throws Exception t[2] = missing
        @test_throws Exception t[3] = 4.5
        @test t == [11, 22, 33]
    end
    @testset "insert!" begin
        t = copy(z)
        @test insert!(t, 2, 11) === t
        @test t == [1, 11, 2, 3]
        @test insert!(t, 5, 33) === t
        @test t == [1, 11, 2, 3, 33]
        @test_throws BoundsError insert!(t, -1, 0)
        @test_throws BoundsError insert!(t, 0, 0)
        @test_throws BoundsError insert!(t, 7, 0)
        @test t == [1, 11, 2, 3, 33]
        @test_throws Exception insert!(t, nothing, 2)
        @test t == [1, 11, 2, 3, 33]
    end
    @testset "push!" begin
        t = copy(z)
        @test push!(t, 4) === t
        @test t == [1, 2, 3, 4]
        @test push!(t, 5, 6) === t
        @test t == [1, 2, 3, 4, 5, 6]
        @test_throws Exception push!(t, missing)
        @test t == [1, 2, 3, 4, 5, 6]
    end
    @testset "pushfirst!" begin
        t = copy(z)
        @test pushfirst!(t, -1) === t
        @test t == [-1, 1, 2, 3]
        @test pushfirst!(t, -3, -2) === t
        @test t == [-3, -2, -1, 1, 2, 3]
        @test_throws Exception pushfirst!(t, 4.5)
        @test t == [-3, -2, -1, 1, 2, 3]
    end
    @testset "append!" begin
        t = copy(z)
        @test append!(t, [4, 5, 6]) === t
        @test t == [1, 2, 3, 4, 5, 6]
        @test_throws Exception append!(t, [nothing, missing])
        @test t == [1, 2, 3, 4, 5, 6]
    end
    @testset "prepend!" begin
        t = copy(z)
        @test prepend!(t, [-3, -2, -1]) === t
        @test t == [-3, -2, -1, 1, 2, 3]
        @test_throws Exception append!(t, [nothing, missing])
        @test t == [-3, -2, -1, 1, 2, 3]
    end
    @testset "pop!" begin
        t = copy(z)
        @test pop!(t) == 3
        @test pop!(t) == 2
        @test pop!(t) == 1
        @test isempty(t)
        @test_throws BoundsError pop!(t)
    end
    @testset "popfirst!" begin
        t = copy(z)
        @test popfirst!(t) == 1
        @test popfirst!(t) == 2
        @test popfirst!(t) == 3
        @test isempty(t)
        @test_throws BoundsError popfirst!(t)
    end
    @testset "popat!" begin
        t = copy(z)
        @test_throws BoundsError popat!(t, 0)
        @test_throws BoundsError popat!(t, 4)
        @test t == [1, 2, 3]
        @test popat!(t, 2) == 2
        @test popat!(t, 2) == 3
        @test popat!(t, 1) == 1
        @test isempty(t)
        @test_throws BoundsError popat!(t, 1)
        @test_throws BoundsError popat!(t, 0)
        @test_throws BoundsError popat!(t, 1)
        @test_throws BoundsError popat!(t, 5)
    end
    @testset "reverse!" begin
        t = copy(z)
        @test reverse!(t) === t
        @test t == [3, 2, 1]
    end
    @testset "empty!" begin
        t = copy(z)
        @test !isempty(t)
        @test empty!(t) === t
        @test isempty(t)
    end
    @testset "construct empty" begin
        t = PyList{Int}()
        @test t isa PyList{Int}
        @test isempty(t)
        @test pyisinstance(t, pybuiltins.list)
    end
end

@testitem "PyPandasDataFrame" setup=[Setup] begin
    using Tables
    @test PyPandasDataFrame isa Type
    if Setup.devdeps
        pd = pyimport("pandas")
        df = pd.DataFrame(pydict(foo=pylist([1,2,3,4]), bar=pylist([2,3,4,5]), baz=pylist([3,4,5,6])))
        x = PyPandasDataFrame(df)
        @test ispy(x)
        @test Py(x) === df
        @test Tables.istable(x)
        @test Tables.columnaccess(x)
        # TODO: test the tables interface more fully
        Tables.columns(x)
        @test_throws Exception pyconvert(PyPandasDataFrame, 1)
        str = sprint(show, MIME("text/plain"), x)
        @test occursin(r"4×3 .*PyPandasDataFrame", str)
    end
end

@testitem "PySet" begin
    x = pyset([1, 2, 3])
    y = PySet(x)
    z = PySet{Int}(x)
    e = PySet{String}()
    @testset "construct" begin
        @test y isa PySet{Py}
        @test z isa PySet{Int}
        @test e isa PySet{String}
        @test PythonCall.ispy(y)
        @test PythonCall.ispy(z)
        @test PythonCall.ispy(e)
        @test Py(y) === x
        @test Py(z) === x
        @test Py(e) !== x
    end
    @testset "length" begin
        @test length(y) == 3
        @test length(z) == 3
        @test length(e) == 0
    end
    @testset "isempty" begin
        @test !isempty(y)
        @test !isempty(z)
        @test isempty(e)
    end
    @testset "in" begin
        @test 1 in z
        @test 3 in z
        @test !(4 in z)
        @test !(1 in e)
        @test 2.0 in z
        @test !(2.1 in z)
    end
    @testset "push!" begin
        a = PySet{String}(["a"])
        @test a == Set(["a"])
        push!(a, "b")
        @test a == Set(["a", "b"])
        push!(a, "a")
        @test a == Set(["a", "b"])
    end
    @testset "delete!" begin
        a = PySet{Int}()
        @test a == Set()
        delete!(a, 0)
        @test a == Set()
        delete!(a, nothing)
        @test a == Set()
        push!(a, 1, 2, 3)
        @test a == Set([1, 2, 3])
        delete!(a, 2)
        @test a == Set([1, 3])
        delete!(a, 1.2)
        @test a == Set([1, 3])
        delete!(a, 3.0)
        @test a == Set([1])
        delete!(a, nothing)
        @test a == Set([1])
    end
    @testset "pop!" begin
        a = PySet{Int}()
        @test_throws Exception pop!(a)
        push!(a, 1, -1)
        x = pop!(a)
        @test x in [1, -1]
        @test a == Set([-x])
        y = pop!(a)
        @test x == -y
        @test a == Set()
        @test_throws Exception pop!(a)
        push!(a, 1, 2, 3)
        @test pop!(a, 1) == 1
        @test a == Set([2, 3])
        @test pop!(a, 2.0) == 2
        @test a == Set([3])
        @test_throws Exception pop!(a, 1)
        @test_throws Exception pop!(a, 1.0)
        @test_throws Exception pop!(a, nothing)
        @test a == Set([3])
        @test pop!(a, 1, 99) === 99
        @test pop!(a, 1.0, 99) === 99
        @test pop!(a, nothing, 99) === 99
    end
    @testset "empty!" begin
        a = PySet{Int}([1, 2, 3])
        @test a == Set([1, 2, 3])
        @test empty!(a) === a
        @test a == Set()
    end
    @testset "copy" begin
        z2 = copy(z)
        @test z2 isa PySet{Int}
        push!(z2, 99)
        @test z == Set([1, 2, 3])
        @test z2 == Set([1, 2, 3, 99])
    end
end

@testitem "PyTable" begin
    # TODO: figure out how to get pandas into the test environment
    @test PyTable isa Type
    @test_throws Exception PyTable(0)
end

PyList(x = pylist()) = PyList{Py}(x)

ispy(::PyList) = true
Py(x::PyList) = x.py

function pyconvert_rule_sequence(
    ::Type{T},
    x::Py,
    ::Type{T1} = Utils._type_ub(T),
) where {T<:PyList,T1}
    pyconvert_return(T1(x))
end

Base.length(x::PyList) = Int(pylen(x))

Base.size(x::PyList) = (length(x),)

Base.@propagate_inbounds function Base.getindex(x::PyList{T}, i::Int) where {T}
    @boundscheck checkbounds(x, i)
    return pyconvert(T, @py x[@jl(i - 1)])
end

Base.@propagate_inbounds function Base.setindex!(x::PyList{T}, v, i::Int) where {T}
    @boundscheck checkbounds(x, i)
    pysetitem(x, i - 1, convert(T, v))
    return x
end

Base.@propagate_inbounds function Base.insert!(x::PyList{T}, i::Integer, v) where {T}
    @boundscheck (i == length(x) + 1 || checkbounds(x, i))
    pydel!(@py x.insert(@jl(i - 1), @jl(convert(T, v))))
    return x
end

function Base.push!(x::PyList{T}, v) where {T}
    pydel!(@py x.append(@jl(convert(T, v))))
    return x
end

function Base.pushfirst!(x::PyList, v)
    return @inbounds Base.insert!(x, 1, v)
end

function Base.append!(x::PyList, vs)
    for v in vs
        push!(x, v)
    end
    return x
end

function Base.prepend!(x::PyList, vs)
    for v in reverse(vs)
        pushfirst!(x, v)
    end
    return x
end

function Base.push!(x::PyList, v1, v2, vs...)
    push!(x, v1)
    push!(x, v2, vs...)
end

Base.@propagate_inbounds function Base.pop!(x::PyList{T}) where {T}
    @boundscheck (isempty(x) && throw(BoundsError(x)))
    return pyconvert(T, @py x.pop())
end

Base.@propagate_inbounds function Base.popat!(x::PyList{T}, i::Integer) where {T}
    @boundscheck checkbounds(x, i)
    return pyconvert(T, @py x.pop(@jl(i - 1)))
end

Base.@propagate_inbounds function Base.popfirst!(x::PyList{T}) where {T}
    @boundscheck checkbounds(x, 1)
    return pyconvert(T, @py x.pop(0))
end

function Base.reverse!(x::PyList)
    pydel!(@py x.reverse())
    return x
end

function Base.empty!(x::PyList)
    pydel!(@py x.clear())
    return x
end

function Base.copy(x::PyList{T}) where {T}
    return PyList{T}(@py x.copy())
end

using BenchmarkTools
using PythonCall
using PythonCall: pydel!, pyimport, pydict, pystr, pyrange

const SUITE = BenchmarkGroup()

function test_pydict_init()
    random = pyimport("random").random
    x = pydict()
    for i in pyrange(1000)
        x[pystr(i)] = i + random()
    end
    return x
end

SUITE["basic"]["julia"]["pydict"]["init"] = @benchmarkable test_pydict_init()

function test_pydict_pydel()
    random = pyimport("random").random
    x = pydict()
    for i in pyrange(1000)
        k = pystr(i)
        r = random()
        v = i + r
        x[k] = v
        pydel!(k)
        pydel!(r)
        pydel!(v)
        pydel!(i)
    end
    return x
end

SUITE["basic"]["julia"]["pydict"]["pydel"] = @benchmarkable test_pydict_pydel()

@generated function test_atpy(::Val{use_pydel}) where {use_pydel}
    quote
        @py begin
            import random: random
            x = {}
            for i in range(1000)
                x[str(i)] = i + random()
                $(use_pydel ? :(@jl PythonCall.pydel!(i)) : :(nothing))
            end
            x
        end
    end
end

SUITE["basic"]["@py"]["pydict"]["init"] = @benchmarkable test_atpy(Val(false))
SUITE["basic"]["@py"]["pydict"]["pydel"] = @benchmarkable test_atpy(Val(true))


include("gcbench.jl")
using .GCBench: append_lots

SUITE["gc"]["full"] = @benchmarkable(
    GC.gc(true),
    setup=(GC.gc(true); append_lots(size=159)),
    seconds=30,
    evals=1,
)

"""
    abstract type AbstractTimeDelta64 <: Dates.Period

Supertype for [`TimeDelta64`](@ref) and [`InlineTimeDelta64`](@ref).
"""
abstract type AbstractTimeDelta64 <: Dates.Period end

function construct(::Type{T}, d::AbstractTimeDelta64) where {T<:DatesPeriod}
    v, r = rescale(value(d), unitpair(d), Unit(T))
    iszero(r) || throw(InexactError(:convert, T, d))
    T(v)
end

Dates.Year(d::AbstractTimeDelta64) = construct(Dates.Year, d)
Dates.Month(d::AbstractTimeDelta64) = construct(Dates.Month, d)
Dates.Day(d::AbstractTimeDelta64) = construct(Dates.Day, d)
Dates.Hour(d::AbstractTimeDelta64) = construct(Dates.Hour, d)
Dates.Minute(d::AbstractTimeDelta64) = construct(Dates.Minute, d)
Dates.Second(d::AbstractTimeDelta64) = construct(Dates.Second, d)
Dates.Millisecond(d::AbstractTimeDelta64) = construct(Dates.Millisecond, d)
Dates.Microsecond(d::AbstractTimeDelta64) = construct(Dates.Microsecond, d)
Dates.Nanosecond(d::AbstractTimeDelta64) = construct(Dates.Nanosecond, d)

Base.convert(::Type{Dates.Year}, d::AbstractTimeDelta64) = Dates.Year(d)
Base.convert(::Type{Dates.Month}, d::AbstractTimeDelta64) = Dates.Month(d)
Base.convert(::Type{Dates.Day}, d::AbstractTimeDelta64) = Dates.Day(d)
Base.convert(::Type{Dates.Hour}, d::AbstractTimeDelta64) = Dates.Hour(d)
Base.convert(::Type{Dates.Minute}, d::AbstractTimeDelta64) = Dates.Minute(d)
Base.convert(::Type{Dates.Second}, d::AbstractTimeDelta64) = Dates.Second(d)
Base.convert(::Type{Dates.Millisecond}, d::AbstractTimeDelta64) = Dates.Millisecond(d)
Base.convert(::Type{Dates.Microsecond}, d::AbstractTimeDelta64) = Dates.Microsecond(d)
Base.convert(::Type{Dates.Nanosecond}, d::AbstractTimeDelta64) = Dates.Nanosecond(d)

function Base.isnan(d::AbstractTimeDelta64)
    value(d) == NAT
end

function showvalue(io::IO, d::AbstractTimeDelta64)
    u, m = unitpair(d)
    if isnan(d)
        show(io, "NaT")
    else
        show(io, value(d))
    end
    nothing
end

function defaultunit(d::AbstractTimeDelta64)
    unitpair(d)
end

PyObjectArray{N}(undef::UndefInitializer, dims::Vararg{Integer,N}) where {N} =
    PyObjectArray(undef, dims)
PyObjectArray(undef::UndefInitializer, dims::NTuple{N,Integer}) where {N} =
    PyObjectArray{N}(undef, dims)
PyObjectArray(undef::UndefInitializer, dims::Vararg{Integer,N}) where {N} =
    PyObjectArray{N}(undef, dims)
PyObjectArray{N}(x::AbstractArray{T,N}) where {T,N} =
    copyto!(PyObjectArray{N}(undef, size(x)), x)
PyObjectArray(x::AbstractArray{T,N}) where {T,N} = PyObjectArray{N}(x)

pyobjectarray_finalizer(x::PyObjectArray) = GC.enqueue_all(x.ptrs)

Base.IndexStyle(T::Type{<: PyObjectArray}) = Base.IndexStyle(fieldtype(T, :ptrs))

Base.length(x::PyObjectArray) = length(x.ptrs)

Base.size(x::PyObjectArray) = size(x.ptrs)

@propagate_inbounds function Base.isassigned(x::PyObjectArray, i::Vararg{Integer})
    @boundscheck checkbounds(Bool, x, i...) || return false
    return @inbounds x.ptrs[i...] != C_NULL
end

@propagate_inbounds function Base.getindex(x::PyObjectArray, i::Integer...)
    @boundscheck checkbounds(x, i...)
    Base.GC.@preserve x begin
        @inbounds ptr = x.ptrs[i...]
        ptr == C_NULL && throw(UndefRefError())
        return pynew(incref(C.PyPtr(ptr)))
    end
end

@propagate_inbounds function Base.setindex!(x::PyObjectArray, v, i::Integer...)
    @boundscheck checkbounds(x, i...)
    v_ = Py(v)
    @inbounds decref(C.PyPtr(x.ptrs[i...]))
    @inbounds x.ptrs[i...] = getptr(incref(v_))
    return x
end

@propagate_inbounds function Base.deleteat!(x::PyObjectVector, i::Integer)
    @boundscheck checkbounds(x, i)
    @inbounds decref(C.PyPtr(x.ptrs[i]))
    deleteat!(x.ptrs, i)
    return x
end

function pyjlarray_array_interface(x::PyObjectArray)
    return pydict(
        shape = size(x),
        typestr = "|O",
        data = (UInt(pointer(x.ptrs)), false),
        strides = strides(x.ptrs) .* sizeof(C.PyPtr),
        version = 3,
    )
end

# C._pyjlarray_get_buffer(o, buf, flags, x::PyObjectArray) = C.pyjl_get_buffer_impl(
#     o,
#     buf,
#     flags,
#     pointer(x.ptrs),
#     sizeof(CPyPtr),
#     length(x),
#     ndims(x),
#     "O",
#     size(x),
#     strides(x.ptrs) .* sizeof(CPyPtr),
#     true,
# )

### A Pluto.jl notebook ###
# v0.19.8

using Markdown
using InteractiveUtils

# ╔═╡ e9dcc3e9-7c0f-40aa-b633-1242aacca66c
using CondaPkg; CondaPkg.add("seaborn");

# ╔═╡ 545b2750-1bc5-11ec-1d6a-275133eec22d
using PythonCall, RDatasets;

# ╔═╡ dbf0b8fc-d9d1-492a-892e-79f1ea86c345
iris = dataset("datasets", "iris");

# ╔═╡ 41f6b405-3436-4058-979e-bcf7be661e9a
sns = pyimport("seaborn"); sns.set_theme();

# ╔═╡ 9f8ddcfe-778e-4e33-9308-c4acb409770f
sns.pairplot(pytable(iris), hue="Species")

# ╔═╡ 00000000-0000-0000-0000-000000000001
PLUTO_PROJECT_TOML_CONTENTS = """
[deps]
CondaPkg = "992eb4ea-22a4-4c89-a5bb-47a3300528ab"
PythonCall = "6099a3de-0909-46bc-b1f4-468b9a2dfc0d"
RDatasets = "ce6b1742-4840-55fa-b093-852dadbb1d8b"

[compat]
CondaPkg = "~0.2.10"
PythonCall = "~0.9.0"
RDatasets = "~0.7.7"
"""

# ╔═╡ 00000000-0000-0000-0000-000000000002
PLUTO_MANIFEST_TOML_CONTENTS = """
# This file is machine-generated - editing it directly is not advised

julia_version = "1.7.3"
manifest_format = "2.0"

[[deps.ArgTools]]
uuid = "0dad84c5-d112-42e6-8d28-ef12dabb789f"

[[deps.Artifacts]]
uuid = "56f22d72-fd6d-98f1-02f0-08ddc0907c33"

[[deps.Base64]]
uuid = "2a0f44e3-6c83-55bd-87e4-b1978d98bd5f"

[[deps.CSV]]
deps = ["CodecZlib", "Dates", "FilePathsBase", "InlineStrings", "Mmap", "Parsers", "PooledArrays", "SentinelArrays", "Tables", "Unicode", "WeakRefStrings"]
git-tree-sha1 = "873fb188a4b9d76549b81465b1f75c82aaf59238"
uuid = "336ed68f-0bac-5ca0-87d4-7b16caf5d00b"
version = "0.10.4"

[[deps.CategoricalArrays]]
deps = ["DataAPI", "Future", "Missings", "Printf", "Requires", "Statistics", "Unicode"]
git-tree-sha1 = "5f5a975d996026a8dd877c35fe26a7b8179c02ba"
uuid = "324d7699-5711-5eae-9e2f-1d82baa6b597"
version = "0.10.6"

[[deps.CodecZlib]]
deps = ["TranscodingStreams", "Zlib_jll"]
git-tree-sha1 = "ded953804d019afa9a3f98981d99b33e3db7b6da"
uuid = "944b1d66-785c-5afd-91f1-9de20f533193"
version = "0.7.0"

[[deps.Compat]]
deps = ["Base64", "Dates", "DelimitedFiles", "Distributed", "InteractiveUtils", "LibGit2", "Libdl", "LinearAlgebra", "Markdown", "Mmap", "Pkg", "Printf", "REPL", "Random", "SHA", "Serialization", "SharedArrays", "Sockets", "SparseArrays", "Statistics", "Test", "UUIDs", "Unicode"]
git-tree-sha1 = "9be8be1d8a6f44b96482c8af52238ea7987da3e3"
uuid = "34da2185-b29b-5c13-b0c7-acf172513d20"
version = "3.45.0"

[[deps.CompilerSupportLibraries_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "e66e0078-7015-5450-92f7-15fbd957f2ae"

[[deps.CondaPkg]]
deps = ["JSON3", "Markdown", "MicroMamba", "Pkg", "TOML"]
git-tree-sha1 = "75ec3b585578d855204e6671dedbb75347d57465"
uuid = "992eb4ea-22a4-4c89-a5bb-47a3300528ab"
version = "0.2.10"

[[deps.Crayons]]
git-tree-sha1 = "249fe38abf76d48563e2f4556bebd215aa317e15"
uuid = "a8cc5b0e-0ffa-5ad4-8c14-923d3ee1735f"
version = "4.1.1"

[[deps.DataAPI]]
git-tree-sha1 = "fb5f5316dd3fd4c5e7c30a24d50643b73e37cd40"
uuid = "9a962f9c-6df0-11e9-0e5d-c546b8b5ee8a"
version = "1.10.0"

[[deps.DataFrames]]
deps = ["Compat", "DataAPI", "Future", "InvertedIndices", "IteratorInterfaceExtensions", "LinearAlgebra", "Markdown", "Missings", "PooledArrays", "PrettyTables", "Printf", "REPL", "Reexport", "SortingAlgorithms", "Statistics", "TableTraits", "Tables", "Unicode"]
git-tree-sha1 = "daa21eb85147f72e41f6352a57fccea377e310a9"
uuid = "a93c6f00-e57d-5684-b7b6-d8193f3e46c0"
version = "1.3.4"

[[deps.DataStructures]]
deps = ["Compat", "InteractiveUtils", "OrderedCollections"]
git-tree-sha1 = "d1fff3a548102f48987a52a2e0d114fa97d730f0"
uuid = "864edb3b-99cc-5e75-8d2d-829cb0a9cfe8"
version = "0.18.13"

[[deps.DataValueInterfaces]]
git-tree-sha1 = "bfc1187b79289637fa0ef6d4436ebdfe6905cbd6"
uuid = "e2d170a0-9d28-54be-80f0-106bbe20a464"
version = "1.0.0"

[[deps.Dates]]
deps = ["Printf"]
uuid = "ade2ca70-3891-5945-98fb-dc099432e06a"

[[deps.DelimitedFiles]]
deps = ["Mmap"]
uuid = "8bb1440f-4735-579b-a4ab-409b98df4dab"

[[deps.Distributed]]
deps = ["Random", "Serialization", "Sockets"]
uuid = "8ba89e20-285c-5b6f-9357-94700520ee1b"

[[deps.Downloads]]
deps = ["ArgTools", "FileWatching", "LibCURL", "NetworkOptions"]
uuid = "f43a241f-c20a-4ad4-852c-f6b1247861c6"

[[deps.ExprTools]]
git-tree-sha1 = "56559bbef6ca5ea0c0818fa5c90320398a6fbf8d"
uuid = "e2ba6199-217a-4e67-a87a-7c52f15ade04"
version = "0.1.8"

[[deps.FileIO]]
deps = ["Pkg", "Requires", "UUIDs"]
git-tree-sha1 = "9267e5f50b0e12fdfd5a2455534345c4cf2c7f7a"
uuid = "5789e2e9-d7fb-5bc7-8068-2c6fae9b9549"
version = "1.14.0"

[[deps.FilePathsBase]]
deps = ["Compat", "Dates", "Mmap", "Printf", "Test", "UUIDs"]
git-tree-sha1 = "129b104185df66e408edd6625d480b7f9e9823a0"
uuid = "48062228-2e41-5def-b9a4-89aafe57970f"
version = "0.9.18"

[[deps.FileWatching]]
uuid = "7b1f6079-737a-58dc-b8bc-7a2ca5c1b5ee"

[[deps.Formatting]]
deps = ["Printf"]
git-tree-sha1 = "8339d61043228fdd3eb658d86c926cb282ae72a8"
uuid = "59287772-0a20-5a39-b81b-1366585eb4c0"
version = "0.4.2"

[[deps.Future]]
deps = ["Random"]
uuid = "9fa8497b-333b-5362-9e8d-4d0656e87820"

[[deps.InlineStrings]]
deps = ["Parsers"]
git-tree-sha1 = "61feba885fac3a407465726d0c330b3055df897f"
uuid = "842dd82b-1e85-43dc-bf29-5d0ee9dffc48"
version = "1.1.2"

[[deps.InteractiveUtils]]
deps = ["Markdown"]
uuid = "b77e0a4c-d291-57a0-90e8-8db25a27a240"

[[deps.InvertedIndices]]
git-tree-sha1 = "bee5f1ef5bf65df56bdd2e40447590b272a5471f"
uuid = "41ab1584-1d38-5bbf-9106-f11c6c58b48f"
version = "1.1.0"

[[deps.IteratorInterfaceExtensions]]
git-tree-sha1 = "a3f24677c21f5bbe9d2a714f95dcd58337fb2856"
uuid = "82899510-4779-5014-852e-03e436cf321d"
version = "1.0.0"

[[deps.JSON3]]
deps = ["Dates", "Mmap", "Parsers", "StructTypes", "UUIDs"]
git-tree-sha1 = "fd6f0cae36f42525567108a42c1c674af2ac620d"
uuid = "0f8b85d8-7281-11e9-16c2-39a750bddbf1"
version = "1.9.5"

[[deps.LazyArtifacts]]
deps = ["Artifacts", "Pkg"]
uuid = "4af54fe1-eca0-43a8-85a7-787d91b784e3"

[[deps.LibCURL]]
deps = ["LibCURL_jll", "MozillaCACerts_jll"]
uuid = "b27032c2-a3e7-50c8-80cd-2d36dbcbfd21"

[[deps.LibCURL_jll]]
deps = ["Artifacts", "LibSSH2_jll", "Libdl", "MbedTLS_jll", "Zlib_jll", "nghttp2_jll"]
uuid = "deac9b47-8bc7-5906-a0fe-35ac56dc84c0"

[[deps.LibGit2]]
deps = ["Base64", "NetworkOptions", "Printf", "SHA"]
uuid = "76f85450-5226-5b5a-8eaa-529ad045b433"

[[deps.LibSSH2_jll]]
deps = ["Artifacts", "Libdl", "MbedTLS_jll"]
uuid = "29816b5a-b9ab-546f-933c-edad1886dfa8"

[[deps.Libdl]]
uuid = "8f399da3-3557-5675-b5ff-fb832c97cbdb"

[[deps.LinearAlgebra]]
deps = ["Libdl", "libblastrampoline_jll"]
uuid = "37e2e46d-f89d-539d-b4ee-838fcccc9c8e"

[[deps.Logging]]
uuid = "56ddb016-857b-54e1-b83d-db4d58db5568"

[[deps.MacroTools]]
deps = ["Markdown", "Random"]
git-tree-sha1 = "3d3e902b31198a27340d0bf00d6ac452866021cf"
uuid = "1914dd2f-81c6-5fcd-8719-6d5c9610ff09"
version = "0.5.9"

[[deps.Markdown]]
deps = ["Base64"]
uuid = "d6f4376e-aef5-505a-96c1-9c027394607a"

[[deps.MbedTLS_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "c8ffd9c3-330d-5841-b78e-0817d7145fa1"

[[deps.MicroMamba]]
deps = ["Pkg", "Scratch"]
git-tree-sha1 = "18ae2d81035c717f9b0d92c809575266dfe73cc9"
uuid = "0b3b1443-0f03-428d-bdfb-f27f9c1191ea"
version = "0.1.8"

[[deps.Missings]]
deps = ["DataAPI"]
git-tree-sha1 = "bf210ce90b6c9eed32d25dbcae1ebc565df2687f"
uuid = "e1d29d7a-bbdc-5cf2-9ac0-f12de2c33e28"
version = "1.0.2"

[[deps.Mmap]]
uuid = "a63ad114-7e13-5084-954f-fe012c677804"

[[deps.Mocking]]
deps = ["Compat", "ExprTools"]
git-tree-sha1 = "29714d0a7a8083bba8427a4fbfb00a540c681ce7"
uuid = "78c3b35d-d492-501b-9361-3d52fe80e533"
version = "0.7.3"

[[deps.MozillaCACerts_jll]]
uuid = "14a3606d-f60d-562e-9121-12d972cd8159"

[[deps.NetworkOptions]]
uuid = "ca575930-c2e3-43a9-ace4-1e988b2c1908"

[[deps.OpenBLAS_jll]]
deps = ["Artifacts", "CompilerSupportLibraries_jll", "Libdl"]
uuid = "4536629a-c528-5b80-bd46-f80d51c5b363"

[[deps.OrderedCollections]]
git-tree-sha1 = "85f8e6578bf1f9ee0d11e7bb1b1456435479d47c"
uuid = "bac558e1-5e72-5ebc-8fee-abe8a469f55d"
version = "1.4.1"

[[deps.Parsers]]
deps = ["Dates"]
git-tree-sha1 = "0044b23da09b5608b4ecacb4e5e6c6332f833a7e"
uuid = "69de0a69-1ddd-5017-9359-2bf0b02dc9f0"
version = "2.3.2"

[[deps.Pkg]]
deps = ["Artifacts", "Dates", "Downloads", "LibGit2", "Libdl", "Logging", "Markdown", "Printf", "REPL", "Random", "SHA", "Serialization", "TOML", "Tar", "UUIDs", "p7zip_jll"]
uuid = "44cfe95a-1eb2-52ea-b672-e2afdf69b78f"

[[deps.PooledArrays]]
deps = ["DataAPI", "Future"]
git-tree-sha1 = "a6062fe4063cdafe78f4a0a81cfffb89721b30e7"
uuid = "2dfb63ee-cc39-5dd5-95bd-886bf059d720"
version = "1.4.2"

[[deps.PrettyTables]]
deps = ["Crayons", "Formatting", "Markdown", "Reexport", "Tables"]
git-tree-sha1 = "dfb54c4e414caa595a1f2ed759b160f5a3ddcba5"
uuid = "08abe8d2-0d0c-5749-adfa-8a2ac140af0d"
version = "1.3.1"

[[deps.Printf]]
deps = ["Unicode"]
uuid = "de0858da-6303-5e67-8744-51eddeeeb8d7"

[[deps.PythonCall]]
deps = ["CondaPkg", "Dates", "Libdl", "MacroTools", "Markdown", "Pkg", "Requires", "Serialization", "Tables", "UnsafePointers"]
git-tree-sha1 = "f013486c92955c59b38cb15c07ec44dcfdeb155b"
uuid = "6099a3de-0909-46bc-b1f4-468b9a2dfc0d"
version = "0.9.0"

[[deps.RData]]
deps = ["CategoricalArrays", "CodecZlib", "DataFrames", "Dates", "FileIO", "Requires", "TimeZones", "Unicode"]
git-tree-sha1 = "19e47a495dfb7240eb44dc6971d660f7e4244a72"
uuid = "df47a6cb-8c03-5eed-afd8-b6050d6c41da"
version = "0.8.3"

[[deps.RDatasets]]
deps = ["CSV", "CodecZlib", "DataFrames", "FileIO", "Printf", "RData", "Reexport"]
git-tree-sha1 = "2720e6f6afb3e562ccb70a6b62f8f308ff810333"
uuid = "ce6b1742-4840-55fa-b093-852dadbb1d8b"
version = "0.7.7"

[[deps.REPL]]
deps = ["InteractiveUtils", "Markdown", "Sockets", "Unicode"]
uuid = "3fa0cd96-eef1-5676-8a61-b3b8758bbffb"

[[deps.Random]]
deps = ["SHA", "Serialization"]
uuid = "9a3f8284-a2c9-5f02-9a11-845980a1fd5c"

[[deps.RecipesBase]]
git-tree-sha1 = "6bf3f380ff52ce0832ddd3a2a7b9538ed1bcca7d"
uuid = "3cdcf5f2-1ef4-517c-9805-6587b60abb01"
version = "1.2.1"

[[deps.Reexport]]
git-tree-sha1 = "45e428421666073eab6f2da5c9d310d99bb12f9b"
uuid = "189a3867-3050-52da-a836-e630ba90ab69"
version = "1.2.2"

[[deps.Requires]]
deps = ["UUIDs"]
git-tree-sha1 = "838a3a4188e2ded87a4f9f184b4b0d78a1e91cb7"
uuid = "ae029012-a4dd-5104-9daa-d747884805df"
version = "1.3.0"

[[deps.SHA]]
uuid = "ea8e919c-243c-51af-8825-aaa63cd721ce"

[[deps.Scratch]]
deps = ["Dates"]
git-tree-sha1 = "0b4b7f1393cff97c33891da2a0bf69c6ed241fda"
uuid = "6c6a2e73-6563-6170-7368-637461726353"
version = "1.1.0"

[[deps.SentinelArrays]]
deps = ["Dates", "Random"]
git-tree-sha1 = "db8481cf5d6278a121184809e9eb1628943c7704"
uuid = "91c51154-3ec4-41a3-a24f-3f23e20d615c"
version = "1.3.13"

[[deps.Serialization]]
uuid = "9e88b42a-f829-5b0c-bbe9-9e923198166b"

[[deps.SharedArrays]]
deps = ["Distributed", "Mmap", "Random", "Serialization"]
uuid = "1a1011a3-84de-559e-8e89-a11a2f7dc383"

[[deps.Sockets]]
uuid = "6462fe0b-24de-5631-8697-dd941f90decc"

[[deps.SortingAlgorithms]]
deps = ["DataStructures"]
git-tree-sha1 = "b3363d7460f7d098ca0912c69b082f75625d7508"
uuid = "a2af1166-a08f-5f64-846c-94a0d3cef48c"
version = "1.0.1"

[[deps.SparseArrays]]
deps = ["LinearAlgebra", "Random"]
uuid = "2f01184e-e22b-5df5-ae63-d93ebab69eaf"

[[deps.Statistics]]
deps = ["LinearAlgebra", "SparseArrays"]
uuid = "10745b16-79ce-11e8-11f9-7d13ad32a3b2"

[[deps.StructTypes]]
deps = ["Dates", "UUIDs"]
git-tree-sha1 = "d24a825a95a6d98c385001212dc9020d609f2d4f"
uuid = "856f2bd8-1eba-4b0a-8007-ebc267875bd4"
version = "1.8.1"

[[deps.TOML]]
deps = ["Dates"]
uuid = "fa267f1f-6049-4f14-aa54-33bafae1ed76"

[[deps.TableTraits]]
deps = ["IteratorInterfaceExtensions"]
git-tree-sha1 = "c06b2f539df1c6efa794486abfb6ed2022561a39"
uuid = "3783bdb8-4a98-5b6b-af9a-565f29a5fe9c"
version = "1.0.1"

[[deps.Tables]]
deps = ["DataAPI", "DataValueInterfaces", "IteratorInterfaceExtensions", "LinearAlgebra", "OrderedCollections", "TableTraits", "Test"]
git-tree-sha1 = "5ce79ce186cc678bbb5c5681ca3379d1ddae11a1"
uuid = "bd369af6-aec1-5ad0-b16a-f7cc5008161c"
version = "1.7.0"

[[deps.Tar]]
deps = ["ArgTools", "SHA"]
uuid = "a4e569a6-e804-4fa4-b0f3-eef7a1d5b13e"

[[deps.Test]]
deps = ["InteractiveUtils", "Logging", "Random", "Serialization"]
uuid = "8dfed614-e22c-5e08-85e1-65c5234f0b40"

[[deps.TimeZones]]
deps = ["Dates", "Downloads", "InlineStrings", "LazyArtifacts", "Mocking", "Printf", "RecipesBase", "Serialization", "Unicode"]
git-tree-sha1 = "0a359b0ee27e4fbc90d9b3da1f48ddc6f98a0c9e"
uuid = "f269a46b-ccf7-5d73-abea-4c690281aa53"
version = "1.7.3"

[[deps.TranscodingStreams]]
deps = ["Random", "Test"]
git-tree-sha1 = "216b95ea110b5972db65aa90f88d8d89dcb8851c"
uuid = "3bb67fe8-82b1-5028-8e26-92a6c54297fa"
version = "0.9.6"

[[deps.UUIDs]]
deps = ["Random", "SHA"]
uuid = "cf7118a7-6976-5b1a-9a39-7adc72f591a4"

[[deps.Unicode]]
uuid = "4ec0a83e-493e-50e2-b9ac-8f72acf5a8f5"

[[deps.UnsafePointers]]
git-tree-sha1 = "c81331b3b2e60a982be57c046ec91f599ede674a"
uuid = "e17b2a0c-0bdf-430a-bd0c-3a23cae4ff39"
version = "1.0.0"

[[deps.WeakRefStrings]]
deps = ["DataAPI", "InlineStrings", "Parsers"]
git-tree-sha1 = "b1be2855ed9ed8eac54e5caff2afcdb442d52c23"
uuid = "ea10d353-3f73-51f8-a26c-33c1cb351aa5"
version = "1.4.2"

[[deps.Zlib_jll]]
deps = ["Libdl"]
uuid = "83775a58-1f1d-513f-b197-d71354ab007a"

[[deps.libblastrampoline_jll]]
deps = ["Artifacts", "Libdl", "OpenBLAS_jll"]
uuid = "8e850b90-86db-534c-a0d3-1478176c7d93"

[[deps.nghttp2_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "8e850ede-7688-5339-a07c-302acd2aaf8d"

[[deps.p7zip_jll]]
deps = ["Artifacts", "Libdl"]
uuid = "3f19e933-33d8-53b3-aaab-bd5110c3b7a0"
"""

# ╔═╡ Cell order:
# ╠═e9dcc3e9-7c0f-40aa-b633-1242aacca66c
# ╠═545b2750-1bc5-11ec-1d6a-275133eec22d
# ╠═dbf0b8fc-d9d1-492a-892e-79f1ea86c345
# ╠═41f6b405-3436-4058-979e-bcf7be661e9a
# ╠═9f8ddcfe-778e-4e33-9308-c4acb409770f
# ╟─00000000-0000-0000-0000-000000000001
# ╟─00000000-0000-0000-0000-000000000002

const pyjltypetype = pynew()

function pyjltype_getitem(self::Type, k_)
    if pyistuple(k_)
        k = pyconvert(Vector{Any}, k_)
        pydel!(k_)
        Py(self{k...})
    else
        k = pyconvert(Any, k_)
        Py(self{k})
    end
end

const PYNUMPYDTYPE = IdDict{Type,Py}()

function pyjltype_numpy_dtype(self::Type)
    ans = get!(PYNUMPYDTYPE, self) do
        typestr, descr = pytypestrdescr(self)
        # unsupported type
        if typestr == ""
            return PyNULL
        end
        np = pyimport("numpy")
        # simple scalar type
        if pyisnull(descr)
            return np.dtype(typestr)
        end
        # We could juse use np.dtype(descr), but when there is padding, np.dtype(descr)
        # changes the names of the padding fields from "" to "f{N}". Using this other
        # dtype constructor avoids this issue and preserves the invariant:
        #   np.dtype(eltype(array)) == np.array(array).dtype
        names = []
        formats = []
        offsets = []
        for i = 1:fieldcount(self)
            nm = fieldname(self, i)
            push!(names, nm isa Integer ? "f$(nm-1)" : String(nm))
            ts, ds = pytypestrdescr(fieldtype(self, i))
            push!(formats, pyisnull(ds) ? ts : ds)
            push!(offsets, fieldoffset(self, i))
        end
        return np.dtype(
            pydict(
                names = pylist(names),
                formats = pylist(formats),
                offsets = pylist(offsets),
                itemsize = sizeof(self),
            ),
        )
    end
    if pyisnull(ans)
        errset(pybuiltins.AttributeError, "__numpy_dtype__")
    end
    return ans
end

function init_type()
    jl = pyjuliacallmodule
    pybuiltins.exec(
        pybuiltins.compile(
            """
$("\n"^(@__LINE__()-1))
class TypeValue(AnyValue):
    __slots__ = ()
    def __getitem__(self, k):
        return self._jl_callmethod($(pyjl_methodnum(pyjltype_getitem)), k)
    def __setitem__(self, k, v):
        raise TypeError("not supported")
    def __delitem__(self, k):
        raise TypeError("not supported")
    @property
    def __numpy_dtype__(self):
        return self._jl_callmethod($(pyjl_methodnum(pyjltype_numpy_dtype)))
""",
            @__FILE__(),
            "exec",
        ),
        jl.__dict__,
    )
    pycopy!(pyjltypetype, jl.TypeValue)
end

pyjltype(::Type) = pyjltypetype

struct pyconvert_rule_ctypessimplevalue{R,S} <: Function end

function (::pyconvert_rule_ctypessimplevalue{R,SAFE})(::Type{T}, x::Py) where {R,SAFE,T}
    Base.GC.@preserve x begin
        ptr = C.PySimpleObject_GetValue(Ptr{R}, x)
        ans = unsafe_load(ptr)
        if SAFE
            pyconvert_return(convert(T, ans))
        else
            pyconvert_tryconvert(T, ans)
        end
    end
end

const CTYPES_SIMPLE_TYPES = [
    ("char", Cchar),
    ("wchar", Cwchar_t),
    ("byte", Cchar),
    ("ubyte", Cuchar),
    ("short", Cshort),
    ("ushort", Cushort),
    ("int", Cint),
    ("uint", Cuint),
    ("long", Clong),
    ("ulong", Culong),
    ("longlong", Clonglong),
    ("ulonglong", Culonglong),
    ("size_t", Csize_t),
    ("ssize_t", Cssize_t),
    ("float", Cfloat),
    ("double", Cdouble),
    ("char_p", Ptr{Cchar}),
    ("wchar_p", Ptr{Cwchar_t}),
    ("void_p", Ptr{Cvoid}),
]

function init_ctypes()
    for (t, T) in CTYPES_SIMPLE_TYPES
        isptr = endswith(t, "_p")
        isreal = !isptr
        isnumber = isreal
        isfloat = t in ("float", "double")
        isint = isreal && !isfloat
        isuint = isint && (startswith(t, "u") || t == "size_t")

        name = "ctypes:c_$t"
        rule = pyconvert_rule_ctypessimplevalue{T,false}()
        saferule = pyconvert_rule_ctypessimplevalue{T,true}()

        t == "char_p" && pyconvert_add_rule(name, Cstring, saferule)
        t == "wchar_p" && pyconvert_add_rule(name, Cwstring, saferule)
        pyconvert_add_rule(name, T, saferule)
        isuint && pyconvert_add_rule(name, UInt, sizeof(T) ≤ sizeof(UInt) ? saferule : rule)
        isuint && pyconvert_add_rule(name, Int, sizeof(T) < sizeof(Int) ? saferule : rule)
        isint &&
            !isuint &&
            pyconvert_add_rule(name, Int, sizeof(T) ≤ sizeof(Int) ? saferule : rule)
        isint && pyconvert_add_rule(name, Integer, rule)
        isfloat && pyconvert_add_rule(name, Float64, saferule)
        isreal && pyconvert_add_rule(name, Real, rule)
        isnumber && pyconvert_add_rule(name, Number, rule)
        isptr && pyconvert_add_rule(name, Ptr, saferule)
    end
end

@testitem "@py" begin
    @testset "literals" begin
        # int
        x = @py(123)
        @test x isa Py
        @test pyis(pytype(x), pybuiltins.int)
        @test pyeq(Bool, x, 123)
        # uint
        x = @py(0x123)
        @test x isa Py
        @test pyis(pytype(x), pybuiltins.int)
        @test pyeq(Bool, x, 0x123)
        # TODO: these don't work on all platforms??
        # # int128
        # x = @py(12345678901234567890)
        # @test x isa Py
        # @test pyis(pytype(x), pybuiltins.int)
        # @test pyeq(Bool, x, 12345678901234567890)
        # # uint128
        # x = @py(0x12345678901234567890)
        # @test x isa Py
        # @test pyis(pytype(x), pybuiltins.int)
        # @test pyeq(Bool, x, 0x12345678901234567890)
        # # bigint
        # x = @py(big"1234567890123456789012345678901234567890")
        # @test x isa Py
        # @test pyis(pytype(x), pybuiltins.int)
        # @test pyeq(Bool, x, big"1234567890123456789012345678901234567890")
        # x = @py(1234567890123456789012345678901234567890)
        # @test x isa Py
        # @test pyis(pytype(x), pybuiltins.int)
        # @test pyeq(Bool, x, big"1234567890123456789012345678901234567890")
        # None
        x = @py(None)
        @test pyis(x, pybuiltins.None)
        # True
        x = @py(True)
        @test x isa Py
        @test pyis(x, pybuiltins.True)
        x = @py(true)
        @test x isa Py
        @test pyis(x, pybuiltins.True)
        # False
        x = @py(False)
        @test x isa Py
        @test pyis(x, pybuiltins.False)
        x = @py(false)
        @test x isa Py
        @test pyis(x, pybuiltins.False)
        # str
        x = @py("hello")
        @test x isa Py
        @test pyis(pytype(x), pybuiltins.str)
        @test pyeq(Bool, x, "hello")
        # float
        x = @py(1.23)
        @test x isa Py
        @test pyis(pytype(x), pybuiltins.float)
        @test pyeq(Bool, x, 1.23)
        # tuple
        x = @py tuple()
        @test x isa Py
        @test pyis(pytype(x), pybuiltins.tuple)
        @test pyeq(Bool, x, ())
        x = @py (1, 2, 3)
        @test x isa Py
        @test pyis(pytype(x), pybuiltins.tuple)
        @test pyeq(Bool, x, (1, 2, 3))
        # list
        x = @py list()
        @test x isa Py
        @test pyis(pytype(x), pybuiltins.list)
        @test pyeq(Bool, x, pylist())
        x = @py [1, 2, 3]
        @test x isa Py
        @test pyis(pytype(x), pybuiltins.list)
        @test pyeq(Bool, x, pylist([1, 2, 3]))
        # dict
        x = @py dict()
        @test x isa Py
        @test pyis(pytype(x), pybuiltins.dict)
        @test pyeq(Bool, x, pydict())
        x = @py {}
        @test x isa Py
        @test pyis(pytype(x), pybuiltins.dict)
        @test pyeq(Bool, x, pydict())
        x = @py {x = 1, y = 2}
        @test x isa Py
        @test pyis(pytype(x), pybuiltins.dict)
        @test pyeq(Bool, x, pydict(x = 1, y = 2))
        x = @py {"x":1, "y":2}
        @test x isa Py
        @test pyis(pytype(x), pybuiltins.dict)
        @test pyeq(Bool, x, pydict(x = 1, y = 2))
        # set
        x = @py set()
        @test x isa Py
        @test pyis(pytype(x), pybuiltins.set)
        @test pyeq(Bool, x, pyset())
        x = @py {1, 2, 3}
        @test x isa Py
        @test pyis(pytype(x), pybuiltins.set)
        @test pyeq(Bool, x, pyset([1, 2, 3]))
    end
    @testset "__file__" begin
        x = @py __file__
        @test x isa Py
        @test pyis(pytype(x), pybuiltins.str)
        @test pyeq(Bool, x, @__FILE__)
    end
    @testset "__line__" begin
        x = @py __line__
        @test x isa Py
        @test pyis(pytype(x), pybuiltins.int)
        @test pyeq(Bool, x, @__LINE__() - 3)
    end
    @testset "builtins" begin
        x = @py int
        @test pyis(x, pybuiltins.int)
        x = @py float
        @test pyis(x, pybuiltins.float)
        x = @py ValueError
        @test pyis(x, pybuiltins.ValueError)
    end
    @testset "variables" begin
        x = 123
        y = @py x
        @test y === x
    end
    @testset "arithmetic" begin
        x = @py 1 + 2 + 3
        @test pyeq(Bool, x, 6)
        x = @py "foo" + "bar"
        @test pyeq(Bool, x, "foobar")
        x = @py 9 - 2
        @test pyeq(Bool, x, 7)
        x = @py 2 * 3 * 4
        @test pyeq(Bool, x, 24)
        x = @py "foo" * 3
        @test pyeq(Bool, x, "foofoofoo")
        x = @py 10 / 4
        @test pyeq(Bool, x, 2.5)
        x = @py 1 << 10
        @test pyeq(Bool, x, 1024)
        x = @py -(10)
        @test pyeq(Bool, x, -10)
    end
    @testset "attrs" begin
        t = pytype("Test", (pybuiltins.object,), [])
        x = t()
        @py x.foo = "foo"
        @test pyeq(Bool, x.foo, "foo")
    end
    @testset "items" begin
        x = pylist([1, 2, 3])
        @test pyeq(Bool, @py(x[0]), 1)
        @test pyeq(Bool, @py(x[-1]), 3)
        @test pyeq(Bool, @py(x[0:2]), pylist([1, 2]))
        @py x[1] = 0
        @test pyeq(Bool, x, pylist([1, 0, 3]))
    end
    @testset "assign" begin
        @py x = 12
        @test x isa Py
        @test pyis(pytype(x), pybuiltins.int)
        @test pyeq(Bool, x, 12)
    end
    @testset "@jl" begin
        x = @py @jl "foo"^3
        @test x == "foofoofoo"
    end
    @testset "begin" begin
        z = @py begin
            x = "foo"
            y = 4
            x * y
        end
        @test x isa Py
        @test pyeq(Bool, x, "foo")
        @test y isa Py
        @test pyeq(Bool, y, 4)
        @test z isa Py
        @test pyeq(Bool, z, "foofoofoofoo")
    end
    @testset "import" begin
        @py import sys
        @test pyis(sys, pyimport("sys"))
        @py import sys as _sys
        @test pyis(_sys, sys)
        @py import sys as _sys2, sys as _sys3
        @test pyis(_sys2, sys)
        @test pyis(_sys3, sys)
        @py import sys: version_info
        @test pyis(version_info, sys.version_info)
        @py import sys: modules as _mods, version_info as _ver
        @test pyis(_mods, sys.modules)
        @test pyis(_ver, sys.version_info)
    end
    @testset "short-circuit" begin
        x = @py 3 && pylist([1, 2])
        @test pyeq(Bool, x, pylist([1, 2]))
        x = @py None && True
        @test pyis(x, pybuiltins.None)
        x = @py None || 0 || pyset()
        @test pyeq(Bool, x, pyset())
        x = @py pydict() || 8 || ""
        @test pyeq(Bool, x, 8)
    end
    @testset "if" begin
        x = @py if 1 == 2
            "a"
        end
        @test x isa Py
        @test pyis(x, pybuiltins.None)
        x = @py if 1 < 2
            "a"
        end
        @test x isa Py
        @test pyeq(Bool, x, "a")
        x = @py if 1 == 2
            "a"
        else
            "b"
        end
        @test x isa Py
        @test pyeq(Bool, x, "b")
        x = @py if 1 < 2
            "a"
        else
            "b"
        end
        @test x isa Py
        @test pyeq(Bool, x, "a")
        x = @py if 1 == 2
            "a"
        elseif 1 < 2
            "b"
        end
        @test x isa Py
        @test pyeq(Bool, x, "b")
        x = @py if 1 < 2
            "a"
        elseif 2 < 3
            "b"
        end
        @test x isa Py
        @test pyeq(Bool, x, "a")
        x = @py if 1 == 2
            "a"
        elseif 2 == 3
            "b"
        end
        @test x isa Py
        @test pyis(x, pybuiltins.None)
    end
    @testset "for" begin
        x = pydict(x = 1, y = 2)
        y = pylist()
        @py for k in x
            y.append(k)
        end
        @test pyeq(Bool, y, pylist(["x", "y"]))
    end
    @testset "while" begin
        x = pylist([1, 2, 3, 4])
        y = pylist()
        @py while len(x) > 2
            y.append(x.pop())
        end
        @test pyeq(Bool, x, pylist([1, 2]))
        @test pyeq(Bool, y, pylist([4, 3]))
    end
    @testset "string interpolation" begin
        x = @py """$(None)$(True)$("foo"*2)"""
        @test pyeq(Bool, x, "NoneTruefoofoo")
    end
end

"""
    module PythonCall.GIL

Handling the Python Global Interpreter Lock.

See [`lock`](@ref), [`@lock`](@ref), [`unlock`](@ref) and [`@unlock`](@ref).

!!! warning

    Multi-threading support is experimental and can change without notice.
"""
module GIL

using ..C: C

if Base.VERSION ≥ v"1.11"
    eval(
        Expr(
            :public,
            :lock,
            Symbol("@lock"),
            :unlock,
            Symbol("@unlock"),
        ),
    )
end


"""
    lock(f)

Lock the GIL, compute `f()`, unlock the GIL, then return the result of `f()`.

Use this to run Python code from threads that do not currently hold the GIL, such as new
threads. Since the main Julia thread holds the GIL by default, you will need to
[`unlock`](@ref) the GIL before using this function.

See [`@lock`](@ref) for the macro form.

!!! warning

    This function is experimental. Its semantics may be changed without notice.
"""
function lock(f)
    state = C.PyGILState_Ensure()
    try
        f()
    finally
        C.PyGILState_Release(state)
    end
end

"""
    @lock expr

Lock the GIL, compute `expr`, unlock the GIL, then return the result of `expr`.

Use this to run Python code from threads that do not currently hold the GIL, such as new
threads. Since the main Julia thread holds the GIL by default, you will need to
[`@unlock`](@ref) the GIL before using this function.

The macro equivalent of [`lock`](@ref).

!!! warning

    This macro is experimental. Its semantics may be changed without notice.
"""
macro lock(expr)
    quote
        state = C.PyGILState_Ensure()
        try
            $(esc(expr))
        finally
            C.PyGILState_Release(state)
        end
    end
end

"""
    unlock(f)

Unlock the GIL, compute `f()`, re-lock the GIL, then return the result of `f()`.

Use this to run non-Python code with the GIL unlocked, so allowing another thread to run
Python code. That other thread can be a Julia thread, which must lock the GIL using
[`lock`](@ref).

See [`@unlock`](@ref) for the macro form.

!!! warning

    This function is experimental. Its semantics may be changed without notice.
"""
function unlock(f)
    state = C.PyEval_SaveThread()
    try
        f()
    finally
        C.PyEval_RestoreThread(state)
    end
end

"""
    @unlock expr

Unlock the GIL, compute `expr`, re-lock the GIL, then return the result of `expr`.

Use this to run non-Python code with the GIL unlocked, so allowing another thread to run
Python code. That other thread can be a Julia thread, which must lock the GIL using
[`@lock`](@ref).

The macro equivalent of [`unlock`](@ref).

!!! warning

    This macro is experimental. Its semantics may be changed without notice.
"""
macro unlock(expr)
    quote
        state = C.PyEval_SaveThread()
        try
            $(esc(expr))
        finally
            C.PyEval_RestoreThread(state)
        end
    end
end

end

"""
    module NumpyDates

Provides datetimes and timedeltas compatible with Numpy.

See: [`DateTime64`](@ref), [`InlineDateTime64`](@ref), [`TimeDelta64`](@ref) and
[`InlineTimeDelta64`](@ref).

These can generally be converted to/from their respective types in the `Dates` stdlib.
"""
module NumpyDates

using Dates: Dates, value

export Unit,
    YEARS,
    MONTHS,
    WEEKS,
    DAYS,
    HOURS,
    MINUTES,
    SECONDS,
    MILLISECONDS,
    MICROSECONDS,
    NANOSECONDS,
    PICOSECONDS,
    FEMTOSECONDS,
    ATTOSECONDS,
    AbstractDateTime64,
    InlineDateTime64,
    DateTime64,
    AbstractTimeDelta64,
    InlineTimeDelta64,
    TimeDelta64

include("common.jl")
include("Unit.jl")
include("AbstractDateTime64.jl")
include("InlineDateTime64.jl")
include("DateTime64.jl")
include("AbstractTimeDelta64.jl")
include("InlineTimeDelta64.jl")
include("TimeDelta64.jl")

end

using Documenter, PythonCall

include("customdocs.jl")

# include the changelog in the docs (called release notes there)
changelog = read("CHANGELOG.md", String)
changelog = replace(changelog, "# Changelog" => "# Release Notes")
write("docs/src/releasenotes.md", changelog)

makedocs(
    sitename = "PythonCall & JuliaCall",
    modules = [PythonCall],
    format = Documenter.HTML(assets = ["assets/favicon.ico"]),
    warnonly = [:missing_docs], # avoid raising error when docs are missing
    pages = [
        "Home" => "index.md",
        "The Julia module PythonCall" =>
            ["Guide" => "pythoncall.md", "Reference" => "pythoncall-reference.md"],
        "The Python module JuliaCall" =>
            ["Guide" => "juliacall.md", "Reference" => "juliacall-reference.md"],
        "Conversion" => [
            "Julia to Python" => "conversion-to-python.md",
            "Python to Julia" => "conversion-to-julia.md",
        ],
        "compat.md",
        "faq.md",
        "releasenotes.md",
    ],
)

deploydocs(repo = raw"github.com/JuliaPy/PythonCall.jl.git", push_preview = true)

module Utils

using Preferences: @load_preference

function getpref(::Type{T}, prefname, envname, default = nothing) where {T}
    ans = @load_preference(prefname, nothing)
    ans === nothing || return checkpref(T, ans)::T
    ans = get(ENV, envname, "")
    isempty(ans) || return checkpref(T, ans)::T
    return default
end

checkpref(::Type{String}, x) = error("invalid preference of type $(type(x)), expecting a string")
checkpref(::Type{String}, x::AbstractString) = convert(String, x)

# Specific preference functions
getpref_exe() = getpref(String, "exe", "JULIA_PYTHONCALL_EXE", "/usr/bin/python")
getpref_lib() = getpref(String, "lib", "JULIA_PYTHONCALL_LIB", nothing)
getpref_pickle() = getpref(String, "pickle", "JULIA_PYTHONCALL_PICKLE", "pickle")

function explode_union(T)
    @nospecialize T

    # unpack unionall
    S = T
    vars = []
    while S isa UnionAll
        pushfirst!(vars, S.var)
        S = S.body
    end

    if S isa Union
        Us = Any[explode_union(S.a)..., explode_union(S.b)...]
        Any[foldl((body, var) -> UnionAll(var, body), vars, init = U) for U in Us]
    elseif S == Union{}
        Any[]
    else
        Any[T]
    end
end

"""
    pointer_from_obj(x)

Returns `(p, c)` where `Base.pointer_from_objref(p) === x`.

The pointer remains valid provided the object `c` is not garbage collected.
"""
function pointer_from_obj(o::T) where {T}
    if T.mutable
        c = o
        p = Base.pointer_from_objref(o)
    else
        c = Ref{Any}(o)
        p = unsafe_load(Ptr{Ptr{Cvoid}}(Base.pointer_from_objref(c)))
    end
    p, c
end

"""
    ExtraNewline(x)

An object that displays the same as `x` but with an extra newline in text/plain.
"""
struct ExtraNewline{T}
    value::T
end
Base.show(io::IO, m::MIME, x::ExtraNewline) = show(io, m, x.value)
Base.show(io::IO, m::MIME"text/csv", x::ExtraNewline) = show(io, m, x.value)
Base.show(io::IO, m::MIME"text/tab-separated-values", x::ExtraNewline) =
    show(io, m, x.value)
Base.show(io::IO, m::MIME"text/plain", x::ExtraNewline) =
    (show(io, m, x.value); println(io))
Base.showable(m::MIME, x::ExtraNewline) = showable(m, x.value)

const ALL_MIMES = [
    "text/plain",
    "text/html",
    "text/markdown",
    "text/json",
    "text/latex",
    "text/xml",
    "text/csv",
    "application/javascript",
    "application/pdf",
    "application/ogg",
    "image/jpeg",
    "image/png",
    "image/svg+xml",
    "image/gif",
    "image/webp",
    "image/tiff",
    "image/bmp",
    "audio/aac",
    "audio/mpeg",
    "audio/ogg",
    "audio/opus",
    "audio/webm",
    "audio/wav",
    "audio/midi",
    "audio/x-midi",
    "video/mpeg",
    "video/ogg",
    "video/webm",
]

function mimes_for(x)
    @nospecialize x
    # default mimes we always try
    mimes = copy(ALL_MIMES)
    # look for mimes on show methods for this type
    for meth in methods(show, Tuple{IO,MIME,typeof(x)}).ms
        mimetype = _unwrap_unionall(meth.sig).parameters[3]
        mimetype isa DataType || continue
        mimetype <: MIME || continue
        mime = string(mimetype.parameters[1])
        push!(mimes, mime)
    end
    return mimes
end

@generated _typeintersect(::Type{T1}, ::Type{T2}) where {T1,T2} = typeintersect(T1, T2)

@generated _type_ub(::Type{T}) where {T} = begin
    S = T
    while S isa UnionAll
        S = S{S.var.ub}
    end
    S
end

@generated _type_lb(::Type{T}) where {T} = begin
    R = _unwrap_unionall(T)
    if R isa DataType
        S = T
        while S isa UnionAll
            S = S{S.var in R.parameters ? S.var.lb : S.var.ub}
        end
        S
    else
        _type_ub(T)
    end
end

@generated function _unwrap_unionall(::Type{T}) where {T}
    R = T
    while R isa UnionAll
        R = R.body
    end
    R
end

@generated _promote_type_bounded(::Type{S}, ::Type{T}, ::Type{B}) where {S,T,B} = begin
    S <: B || error("require S <: B")
    T <: B || error("require T <: B")
    if B isa Union
        return Union{
            _promote_type_bounded(typeintersect(S, B.a), typeintersect(T, B.a), B.a),
            _promote_type_bounded(typeintersect(S, B.b), typeintersect(T, B.b), B.b),
        }
    else
        R = promote_type(S, T)
        if R <: B
            return R
        else
            R = typeintersect(typejoin(S, T), B)
            if R <: B
                return R
            else
                return B
            end
        end
    end
end

@generated _promote_type_bounded(
    ::Type{T1},
    ::Type{T2},
    ::Type{T3},
    ::Type{B},
) where {T1,T2,T3,B} = _promote_type_bounded(_promote_type_bounded(T1, T2, B), T3, B)

# TODO: what is the best way?
ismutablearray(x::Array) = true
ismutablearray(x::AbstractArray) = begin
    p = parent(x)
    p === x ? false : ismutablearray(p)
end

islittleendian() =
    Base.ENDIAN_BOM == 0x04030201 ? true : Base.ENDIAN_BOM == 0x01020304 ? false : error()

isflagset(flags, mask) = (flags & mask) == mask

size_to_fstrides(elsz::Integer, sz::Tuple{Vararg{Integer}}) =
    isempty(sz) ? () : (elsz, size_to_fstrides(elsz * sz[1], sz[2:end])...)

size_to_cstrides(elsz::Integer, sz::Tuple{Vararg{Integer}}) =
    isempty(sz) ? () : (size_to_cstrides(elsz * sz[end], sz[1:end-1])..., elsz)

struct StaticString{T,N} <: AbstractString
    codeunits::NTuple{N,T}
    StaticString{T,N}(codeunits::NTuple{N,T}) where {T,N} = new{T,N}(codeunits)
end

function Base.String(x::StaticString{T,N}) where {T,N}
    ts = x.codeunits
    n = N
    while n > 0 && iszero(ts[n])
        n -= 1
    end
    cs = T[ts[i] for i = 1:n]
    transcode(String, cs)
end

function Base.convert(::Type{StaticString{T,N}}, x::AbstractString) where {T,N}
    ts = transcode(T, convert(String, x))
    n = length(ts)
    n > N && throw(InexactError(:convert, StaticString{T,N}, x))
    n > 0 && iszero(ts[n]) && throw(InexactError(:convert, StaticString{T,N}, x))
    z = zero(T)
    cs = ntuple(i -> i > n ? z : @inbounds(ts[i]), N)
    StaticString{T,N}(cs)
end

StaticString{T,N}(x::AbstractString) where {T,N} = convert(StaticString{T,N}, x)

Base.ncodeunits(x::StaticString{T,N}) where {T,N} = N

Base.codeunit(x::StaticString, i::Integer) = x.codeunits[i]

Base.codeunit(x::StaticString{T}) where {T} = T

function Base.isvalid(x::StaticString{UInt8,N}, i::Int) where {N}
    if i < 1 || i > N
        return false
    end
    cs = x.codeunits
    c = @inbounds cs[i]
    if all(iszero, (cs[j] for j = i:N))
        return false
    elseif (c & 0x80) == 0x00
        return true
    elseif (c & 0x40) == 0x00
        return false
    elseif (c & 0x20) == 0x00
        return @inbounds (i ≤ N - 1) && ((cs[i+1] & 0xC0) == 0x80)
    elseif (c & 0x10) == 0x00
        return @inbounds (i ≤ N - 2) &&
                         ((cs[i+1] & 0xC0) == 0x80) &&
                         ((cs[i+2] & 0xC0) == 0x80)
    elseif (c & 0x08) == 0x00
        return @inbounds (i ≤ N - 3) &&
                         ((cs[i+1] & 0xC0) == 0x80) &&
                         ((cs[i+2] & 0xC0) == 0x80) &&
                         ((cs[i+3] & 0xC0) == 0x80)
    else
        return false
    end
    return false
end

function Base.iterate(x::StaticString{UInt8,N}, i::Int = 1) where {N}
    i > N && return
    cs = x.codeunits
    c = @inbounds cs[i]
    if all(iszero, (cs[j] for j = i:N))
        return
    elseif (c & 0x80) == 0x00
        return (reinterpret(Char, UInt32(c) << 24), i + 1)
    elseif (c & 0x40) == 0x00
        nothing
    elseif (c & 0x20) == 0x00
        if @inbounds (i ≤ N - 1) && ((cs[i+1] & 0xC0) == 0x80)
            return (
                reinterpret(Char, (UInt32(cs[i]) << 24) | (UInt32(cs[i+1]) << 16)),
                i + 2,
            )
        end
    elseif (c & 0x10) == 0x00
        if @inbounds (i ≤ N - 2) && ((cs[i+1] & 0xC0) == 0x80) && ((cs[i+2] & 0xC0) == 0x80)
            return (
                reinterpret(
                    Char,
                    (UInt32(cs[i]) << 24) |
                    (UInt32(cs[i+1]) << 16) |
                    (UInt32(cs[i+2]) << 8),
                ),
                i + 3,
            )
        end
    elseif (c & 0x08) == 0x00
        if @inbounds (i ≤ N - 3) &&
                     ((cs[i+1] & 0xC0) == 0x80) &&
                     ((cs[i+2] & 0xC0) == 0x80) &&
                     ((cs[i+3] & 0xC0) == 0x80)
            return (
                reinterpret(
                    Char,
                    (UInt32(cs[i]) << 24) |
                    (UInt32(cs[i+1]) << 16) |
                    (UInt32(cs[i+2]) << 8) |
                    UInt32(cs[i+3]),
                ),
                i + 4,
            )
        end
    end
    throw(StringIndexError(x, i))
end

function Base.isvalid(x::StaticString{UInt32,N}, i::Int) where {N}
    i < 1 && return false
    cs = x.codeunits
    return !all(iszero, (cs[j] for j = i:N))
end

function Base.iterate(x::StaticString{UInt32,N}, i::Int = 1) where {N}
    i > N && return
    cs = x.codeunits
    c = @inbounds cs[i]
    if all(iszero, (cs[j] for j = i:N))
        return
    else
        return (Char(c), i + 1)
    end
end

end

"""
    abstract type AbstractDateTime64 <: Dates.TimeType

Supertype for [`DateTime64`](@ref) and [`InlineDateTime64`](@ref).
"""
abstract type AbstractDateTime64 <: Dates.TimeType end

function Dates.DateTime(d::AbstractDateTime64)
    isnan(d) && error("Cannot convert NaT to DateTime")
    v = value(d)
    u, _ = unit = unitpair(d)
    b = Dates.DateTime(1970)
    if u > MONTHS
        v, _ = rescale(v, unit, MILLISECONDS)
        b + Dates.Millisecond(v)
    else
        v, _ = rescale(v, unit, MONTHS)
        b + Dates.Month(v)
    end
end

function Dates.Date(d::AbstractDateTime64)
    isnan(d) && error("Cannot convert NaT to Date")
    Dates.Date(Dates.DateTime(d))
end

Base.convert(::Type{Dates.DateTime}, d::AbstractDateTime64) = Dates.DateTime(d)
Base.convert(::Type{Dates.Date}, d::AbstractDateTime64) = Dates.Date(d)

function Base.isnan(d::AbstractDateTime64)
    value(d) == typemin(Int64)
end

function showvalue(io::IO, d::AbstractDateTime64)
    u, m = unit = unitpair(d)
    if isnan(d)
        show(io, "NaT")
    elseif u ≤ DAYS
        d2 = Dates.Date(d)
        if value(DateTime64(d2, unit)) == value(d)
            show(io, string(d2))
        else
            show(io, value(d))
        end
    else
        d2 = Dates.DateTime(d)
        if value(DateTime64(d2, unit)) == value(d)
            show(io, string(d2))
        else
            show(io, value(d))
        end
    end
    nothing
end

function defaultunit(d::AbstractDateTime64)
    unitpair(d)
end

const pyjlvectortype = pynew()

function pyjlvector_resize(x::AbstractVector, size_::Py)
    size = pyconvertarg(Int, size_, "size")
    pydel!(size_)
    resize!(x, size)
    Py(nothing)
end

function pyjlvector_sort(x::AbstractVector, reverse_::Py, key_::Py)
    reverse = pyconvertarg(Bool, reverse_, "reverse")
    pydel!(reverse_)
    key = pyconvertarg(Any, key_, "size")
    if key === nothing
        sort!(x, rev = reverse)
        pydel!(key_)
    else
        sort!(x, rev = reverse, by = key)
    end
    Py(nothing)
end

function pyjlvector_reverse(x::AbstractVector)
    reverse!(x)
    Py(nothing)
end

function pyjlvector_clear(x::AbstractVector)
    empty!(x)
    Py(nothing)
end

function pyjlvector_reversed(x::AbstractVector)
    Py(reverse(x))
end

function pyjlvector_insert(x::AbstractVector, k_::Py, v_::Py)
    k = pyconvertarg(Int, k_, "index")
    pydel!(k_)
    a = axes(x, 1)
    k′ = k < 0 ? (last(a) + 1 + k) : (first(a) + k)
    if checkbounds(Bool, x, k′) || k′ == last(a) + 1
        v = pyconvertarg(eltype(x), v_, "value")
        insert!(x, k′, v)
        return Py(nothing)
    else
        errset(pybuiltins.IndexError, "array index out of bounds")
        return PyNULL
    end
end

function pyjlvector_append(x::AbstractVector, v_::Py)
    v = pyconvertarg(eltype(x), v_, "value")
    push!(x, v)
    Py(nothing)
end

function pyjlvector_extend(x::AbstractVector, vs_::Py)
    for v_ in vs_
        v = pyconvert(eltype(x), v_)
        push!(x, v)
    end
    pydel!(vs_)
    Py(nothing)
end

function pyjlvector_pop(x::AbstractVector, k_::Py)
    k = pyconvertarg(Int, k_, "index")
    pydel!(k_)
    a = axes(x, 1)
    k′ = k < 0 ? (last(a) + 1 + k) : (first(a) + k)
    if checkbounds(Bool, x, k′)
        if k′ == last(a)
            v = pop!(x)
        elseif k′ == first(a)
            v = popfirst!(x)
        else
            v = x[k′]
            deleteat!(x, k′)
        end
        return Py(v)
    else
        errset(pybuiltins.IndexError, "pop from empty array")
        return PyNULL
    end
end

function pyjlvector_remove(x::AbstractVector, v_::Py)
    v = @pyconvert eltype(x) v_ begin
        errset(pybuiltins.ValueError, "value not in array")
        return PyNULL
    end
    k = findfirst(==(v), x)
    if k === nothing
        errset(pybuiltins.ValueError, "value not in array")
        return PyNULL
    end
    deleteat!(x, k)
    Py(nothing)
end

function pyjlvector_index(x::AbstractVector, v_::Py)
    v = @pyconvert eltype(x) v_ begin
        errset(pybuiltins.ValueError, "value not in array")
        return PyNULL
    end
    k = findfirst(==(v), x)
    if k === nothing
        errset(pybuiltins.ValueError, "value not in array")
        return PyNULL
    end
    Py(k - first(axes(x, 1)))
end

function pyjlvector_count(x::AbstractVector, v_::Py)
    v = @pyconvert(eltype(x), v_, (return Py(0)))
    Py(count(==(v), x))
end

function init_vector()
    jl = pyjuliacallmodule
    pybuiltins.exec(
        pybuiltins.compile(
            """
$("\n"^(@__LINE__()-1))
class VectorValue(ArrayValue):
    __slots__ = ()
    def resize(self, size):
        return self._jl_callmethod($(pyjl_methodnum(pyjlvector_resize)), size)
    def sort(self, reverse=False, key=None):
        return self._jl_callmethod($(pyjl_methodnum(pyjlvector_sort)), reverse, key)
    def reverse(self):
        return self._jl_callmethod($(pyjl_methodnum(pyjlvector_reverse)))
    def clear(self):
        return self._jl_callmethod($(pyjl_methodnum(pyjlvector_clear)))
    def __reversed__(self):
        return self._jl_callmethod($(pyjl_methodnum(pyjlvector_reversed)))
    def insert(self, index, value):
        return self._jl_callmethod($(pyjl_methodnum(pyjlvector_insert)), index, value)
    def append(self, value):
        return self._jl_callmethod($(pyjl_methodnum(pyjlvector_append)), value)
    def extend(self, values):
        return self._jl_callmethod($(pyjl_methodnum(pyjlvector_extend)), values)
    def pop(self, index=-1):
        return self._jl_callmethod($(pyjl_methodnum(pyjlvector_pop)), index)
    def remove(self, value):
        return self._jl_callmethod($(pyjl_methodnum(pyjlvector_remove)), value)
    def index(self, value):
        return self._jl_callmethod($(pyjl_methodnum(pyjlvector_index)), value)
    def count(self, value):
        return self._jl_callmethod($(pyjl_methodnum(pyjlvector_count)), value)
import collections.abc
collections.abc.MutableSequence.register(VectorValue)
del collections
""",
            @__FILE__(),
            "exec",
        ),
        jl.__dict__,
    )
    pycopy!(pyjlvectortype, jl.VectorValue)
end

pyjltype(::AbstractVector) = pyjlvectortype

module CategoricalArraysExt

using PythonCall

using CategoricalArrays: CategoricalArrays

function PythonCall.Compat.aspandasvector(x::CategoricalArrays.CategoricalArray)
    codes = map(x -> x === missing ? -1 : Int(CategoricalArrays.levelcode(x)) - 1, x)
    cats = CategoricalArrays.levels(x)
    ordered = x.pool.ordered
    pyimport("pandas").Categorical.from_codes(codes, cats, ordered = ordered)
end

end

# Convert

@enum PyConvertPriority begin
    PYCONVERT_PRIORITY_WRAP = 400
    PYCONVERT_PRIORITY_ARRAY = 300
    PYCONVERT_PRIORITY_CANONICAL = 200
    PYCONVERT_PRIORITY_NORMAL = 0
    PYCONVERT_PRIORITY_FALLBACK = -100
end

# Core

"""
    Py(x)

Convert `x` to a Python object, of type `Py`.

Conversion happens according to [these rules](@ref jl2py-conversion).

Such an object supports attribute access (`obj.attr`), indexing (`obj[idx]`), calling
(`obj(arg1, arg2)`), iteration (`for x in obj`), arithmetic (`obj + obj2`) and comparison
(`obj > obj2`), among other things. These operations convert all their arguments to `Py` and
return `Py`.
"""
mutable struct Py
    ptr::Ptr{Cvoid}
    Py(::Val{:new}, ptr::Ptr) = finalizer(Core.py_finalizer, new(Ptr{Cvoid}(ptr)))
end

"""
    PyException(x)

Wraps the Python exception `x` as a Julia `Exception`.
"""
mutable struct PyException <: Exception
    _t::Py
    _v::Py
    _b::Py
    _isnormalized::Bool
end

"""
    pybuiltins

An object whose fields are the Python builtins, of type [`Py`](@ref PythonCall.Py).

For example `pybuiltins.None`, `pybuiltins.int`, `pybuiltins.ValueError`.
"""
baremodule pybuiltins end

# Wrap

"""
    PyArray{T,N,M,L,R}(x; copy=true, array=true, buffer=true)

Wrap the Python array `x` as a Julia `AbstractArray{T,N}`.

The input `x` can be `bytes`, `bytearray`, `array.array`, `numpy.ndarray` or anything satisfying the buffer protocol (if `buffer=true`) or the numpy array interface (if `array=true`).

If `copy=false` then the resulting array is guaranteed to directly wrap the data in `x`. If `copy=true` then a copy is taken if necessary to produce an array.

The type parameters are all optional, and are:
- `T`: The element type.
- `N`: The number of dimensions.
- `M`: True if the array is mutable.
- `L`: True if the array supports fast linear indexing.
- `R`: The element type of the underlying buffer. Often equal to `T`.
"""
struct PyArray{T,N,M,L,R} <: AbstractArray{T,N}
    ptr::Ptr{R}             # pointer to the data
    length::Int             # length of the array
    size::NTuple{N,Int}     # size of the array
    strides::NTuple{N,Int}  # strides (in bytes) between elements
    py::Py                  # underlying python object
    handle::Py              # the data in this array is valid as long as this handle is alive
    function PyArray{T,N,M,L,R}(
        ::Val{:new},
        ptr::Ptr{R},
        size::NTuple{N,Int},
        strides::NTuple{N,Int},
        py::Py,
        handle::Py,
    ) where {T,N,M,L,R}
        T isa Type || error("T must be a Type")
        N isa Int || error("N must be an Int")
        M isa Bool || error("M must be a Bool")
        L isa Bool || error("L must be a Bool")
        R isa DataType || error("R must be a DataType")
        new{T,N,M,L,R}(ptr, prod(size), size, strides, py, handle)
    end
end

"""
    PyDict{K=Py,V=Py}([x])

Wraps the Python dict `x` (or anything satisfying the mapping interface) as an `AbstractDict{K,V}`.

If `x` is not a Python object, it is converted to one using `pydict`.
"""
struct PyDict{K,V} <: AbstractDict{K,V}
    py::Py
    PyDict{K,V}(x = pydict()) where {K,V} = new{K,V}(ispy(x) ? Py(x) : pydict(x))
end

"""
    PyIO(x; own=false, text=missing, line_buffering=false, buflen=4096)

Wrap the Python IO stream `x` as a Julia IO stream.

When this goes out of scope and is finalized, it is automatically flushed. If `own=true` then it is also closed.

If `text=false` then `x` must be a binary stream and arbitrary binary I/O is possible.
If `text=true` then `x` must be a text stream and only UTF-8 must be written (i.e. use `print` not `write`).
If `text` is not specified then it is chosen automatically.
If `x` is a text stream and you really need a binary stream, then often `PyIO(x.buffer)` will work.

If `line_buffering=true` then output is flushed at each line.

For efficiency, reads and writes are buffered before being sent to `x`.
The size of the buffers is `buflen`.
The buffers are cleared using `flush`.
"""
mutable struct PyIO <: IO
    py::Py
    # true to close the file automatically
    own::Bool
    # true if `o` is text, false if binary
    text::Bool
    # true to flush whenever '\n' or '\r' is encountered
    line_buffering::Bool
    # true if we are definitely at the end of the file; false if we are not or don't know
    eof::Bool
    # input buffer
    ibuflen::Int
    ibuf::Vector{UInt8}
    # output buffer
    obuflen::Int
    obuf::Vector{UInt8}

    function PyIO(
        x;
        own::Bool = false,
        text::Union{Missing,Bool} = missing,
        buflen::Integer = 4096,
        ibuflen::Integer = buflen,
        obuflen::Integer = buflen,
        line_buffering::Bool = false,
    )
        if text === missing
            text = pyhasattr(x, "encoding")
        end
        buflen = convert(Int, buflen)
        buflen > 0 || error("buflen must be positive")
        ibuflen = convert(Int, ibuflen)
        ibuflen > 0 || error("ibuflen must be positive")
        obuflen = convert(Int, obuflen)
        obuflen > 0 || error("obuflen must be positive")
        new(Py(x), own, text, line_buffering, false, ibuflen, UInt8[], obuflen, UInt8[])
    end
end

"""
    PyIterable{T=Py}(x)

This object iterates over iterable Python object `x`, yielding values of type `T`.
"""
struct PyIterable{T}
    py::Py
    PyIterable{T}(x) where {T} = new{T}(Py(x))
end

"""
    PyList{T=Py}([x])

Wraps the Python list `x` (or anything satisfying the sequence interface) as an `AbstractVector{T}`.

If `x` is not a Python object, it is converted to one using `pylist`.
"""
struct PyList{T} <: AbstractVector{T}
    py::Py
    PyList{T}(x = pylist()) where {T} = new{T}(ispy(x) ? Py(x) : pylist(x))
end

"""
    PyTable(x)

Wrap `x` as a Tables.jl-compatible table.

`PyTable` is an abstract type. See [`PyPandasDataFrame`](@ref) for a concrete example.
"""
abstract type PyTable end

"""
    PyPandasDataFrame(x; [indexname::Union{Nothing,Symbol}], [columnnames::Function], [columntypes::Function])

Wraps the pandas DataFrame `x` as a Tables.jl-compatible table.

- `indexname`: The name of the column including the index. The default is `nothing`, meaning
  to exclude the index.
- `columnnames`: A function mapping the Python column name (a `Py`) to the Julia one (a
  `Symbol`). The default is `x -> Symbol(x)`.
- `columntypes`: A function taking the column name (a `Symbol`) and returning either the
  desired element type of the column, or `nothing` to indicate automatic inference.
"""
struct PyPandasDataFrame <: PyTable
    py::Py
    indexname::Union{Symbol,Nothing}
    columnnames::Function # Py -> Symbol
    columntypes::Function # Symbol -> Union{Type,Nothing}
    function PyPandasDataFrame(
        x;
        indexname::Union{Symbol,Nothing} = nothing,
        columnnames::Function = x -> Symbol(x),
        columntypes::Function = x -> nothing,
    )
        new(Py(x), indexname, columnnames, columntypes)
    end
end

"""
    PySet{T=Py}([x])

Wraps the Python set `x` (or anything satisfying the set interface) as an `AbstractSet{T}`.

If `x` is not a Python object, it is converted to one using `pyset`.
"""
struct PySet{T} <: AbstractSet{T}
    py::Py
    PySet{T}(x = pyset()) where {T} = new{T}(ispy(x) ? Py(x) : pyset(x))
end

"""
    PyObjectArray(undef, dims...)
    PyObjectArray(array)

An array of `Py`s which supports the Python buffer protocol.

Internally, the objects are stored as an array of pointers.
"""
mutable struct PyObjectArray{N} <: AbstractArray{Py,N}
    ptrs::Array{Ptr{Cvoid},N}
    function PyObjectArray{N}(::UndefInitializer, dims::NTuple{N,Integer}) where {N}
        x = new{N}(fill(C_NULL, dims))
        finalizer(JlWrap.pyobjectarray_finalizer, x)
    end
end
const PyObjectVector = PyObjectArray{1}
const PyObjectMatrix = PyObjectArray{2}

"""
    module PythonCall.C

This module provides a direct interface to the Python C API.
"""
module C

using ..Utils

using Base: @kwdef
using UnsafePointers: UnsafePtr
using Libdl:
    dlpath, dlopen, dlopen_e, dlclose, dlsym, dlsym_e, RTLD_LAZY, RTLD_DEEPBIND, RTLD_GLOBAL
using Preferences: @load_preference

# do not load CondaPkg if the exe preference is set to something else
if @load_preference("exe", "@CondaPkg") == "@CondaPkg"
    using CondaPkg: CondaPkg
end

import ..PythonCall:
    python_executable_path, python_library_path, python_library_handle, python_version

include("consts.jl")
include("pointers.jl")
include("extras.jl")
include("context.jl")
include("api.jl")

function __init__()
    init_context()
end

end

### object

pyconvert_rule_object(::Type{Py}, x::Py) = pyconvert_return(x)

### Exception

pyconvert_rule_exception(::Type{R}, x::Py) where {R<:PyException} =
    pyconvert_return(PyException(x))

### None

pyconvert_rule_none(::Type{Nothing}, x::Py) = pyconvert_return(nothing)
pyconvert_rule_none(::Type{Missing}, x::Py) = pyconvert_return(missing)

### Bool

function pyconvert_rule_bool(::Type{T}, x::Py) where {T<:Number}
    val = pybool_asbool(x)
    if T in (
        Bool,
        Int8,
        Int16,
        Int32,
        Int64,
        Int128,
        UInt8,
        UInt16,
        UInt32,
        UInt64,
        UInt128,
        BigInt,
    )
        pyconvert_return(T(val))
    else
        pyconvert_tryconvert(T, val)
    end
end

### str

pyconvert_rule_str(::Type{String}, x::Py) = pyconvert_return(pystr_asstring(x))
pyconvert_rule_str(::Type{Symbol}, x::Py) = pyconvert_return(Symbol(pystr_asstring(x)))
pyconvert_rule_str(::Type{Char}, x::Py) = begin
    s = pystr_asstring(x)
    if length(s) == 1
        pyconvert_return(first(s))
    else
        pyconvert_unconverted()
    end
end

### bytes

pyconvert_rule_bytes(::Type{Vector{UInt8}}, x::Py) =
    pyconvert_return(copy(pybytes_asvector(x)))
pyconvert_rule_bytes(::Type{Base.CodeUnits{UInt8,String}}, x::Py) =
    pyconvert_return(codeunits(pybytes_asUTF8string(x)))

### int

pyconvert_rule_int(::Type{T}, x::Py) where {T<:Number} = begin
    # first try to convert to Clonglong (or Culonglong if unsigned)
    v =
        T <: Unsigned ? C.PyLong_AsUnsignedLongLong(x) :
        C.PyLong_AsLongLong(x)
    if !iserrset_ambig(v)
        # success
        return pyconvert_tryconvert(T, v)
    elseif errmatches(pybuiltins.OverflowError)
        # overflows Clonglong or Culonglong
        errclear()
        if T in (
               Bool,
               Int8,
               Int16,
               Int32,
               Int64,
               Int128,
               UInt8,
               UInt16,
               UInt32,
               UInt64,
               UInt128,
           ) &&
           typemin(typeof(v)) ≤ typemin(T) &&
           typemax(T) ≤ typemax(typeof(v))
            # definitely overflows S, give up now
            return pyconvert_unconverted()
        else
            # try converting -> int -> str -> BigInt -> T
            x_int = pyint(x)
            x_str = pystr(String, x_int)
            pydel!(x_int)
            v = parse(BigInt, x_str)
            return pyconvert_tryconvert(T, v)
        end
    else
        # other error
        pythrow()
    end
end

### float

function pyconvert_rule_float(::Type{T}, x::Py) where {T<:Number}
    val = pyfloat_asdouble(x)
    if T in (Float16, Float32, Float64, BigFloat)
        pyconvert_return(T(val))
    else
        pyconvert_tryconvert(T, val)
    end
end

# NaN is sometimes used to represent missing data of other types
# so we allow converting it to Nothing or Missing
function pyconvert_rule_float(::Type{Nothing}, x::Py)
    val = pyfloat_asdouble(x)
    if isnan(val)
        pyconvert_return(nothing)
    else
        pyconvert_unconverted()
    end
end

function pyconvert_rule_float(::Type{Missing}, x::Py)
    val = pyfloat_asdouble(x)
    if isnan(val)
        pyconvert_return(missing)
    else
        pyconvert_unconverted()
    end
end

### complex

function pyconvert_rule_complex(::Type{T}, x::Py) where {T<:Number}
    val = pycomplex_ascomplex(x)
    if T in (Complex{Float64}, Complex{Float32}, Complex{Float16}, Complex{BigFloat})
        pyconvert_return(T(val))
    else
        pyconvert_tryconvert(T, val)
    end
end

### range

function pyconvert_rule_range(
    ::Type{R},
    x::Py,
    ::Type{StepRange{T0,S0}} = Utils._type_lb(R),
    ::Type{StepRange{T1,S1}} = Utils._type_ub(R),
) where {R<:StepRange,T0,S0,T1,S1}
    a = @pyconvert(Utils._typeintersect(Integer, T1), x.start)
    b = @pyconvert(Utils._typeintersect(Integer, S1), x.step)
    c = @pyconvert(Utils._typeintersect(Integer, T1), x.stop)
    a′, c′ = promote(a, c - oftype(c, sign(b)))
    T2 = Utils._promote_type_bounded(T0, typeof(a′), typeof(c′), T1)
    S2 = Utils._promote_type_bounded(S0, typeof(c′), S1)
    pyconvert_return(StepRange{T2,S2}(a′, b, c′))
end

function pyconvert_rule_range(
    ::Type{R},
    x::Py,
    ::Type{UnitRange{T0}} = Utils._type_lb(R),
    ::Type{UnitRange{T1}} = Utils._type_ub(R),
) where {R<:UnitRange,T0,T1}
    b = @pyconvert(Int, x.step)
    b == 1 || return pyconvert_unconverted()
    a = @pyconvert(Utils._typeintersect(Integer, T1), x.start)
    c = @pyconvert(Utils._typeintersect(Integer, T1), x.stop)
    a′, c′ = promote(a, c - oftype(c, 1))
    T2 = Utils._promote_type_bounded(T0, typeof(a′), typeof(c′), T1)
    pyconvert_return(UnitRange{T2}(a′, c′))
end

### fraction

# works for any collections.abc.Rational
function pyconvert_rule_fraction(
    ::Type{R},
    x::Py,
    ::Type{Rational{T0}} = Utils._type_lb(R),
    ::Type{Rational{T1}} = Utils._type_ub(R),
) where {R<:Rational,T0,T1}
    a = @pyconvert(Utils._typeintersect(Integer, T1), x.numerator)
    b = @pyconvert(Utils._typeintersect(Integer, T1), x.denominator)
    a, b = promote(a, b)
    T2 = Utils._promote_type_bounded(T0, typeof(a), typeof(b), T1)
    pyconvert_return(Rational{T2}(a, b))
end

# works for any collections.abc.Rational
function pyconvert_rule_fraction(::Type{T}, x::Py) where {T<:Number}
    pyconvert_tryconvert(T, @pyconvert(Rational{<:Integer}, x))
end

### collections

# Vector

function _pyconvert_rule_iterable(ans::Vector{T0}, it::Py, ::Type{T1}) where {T0,T1}
    @label again
    x_ = unsafe_pynext(it)
    if pyisnull(x_)
        pydel!(it)
        return pyconvert_return(ans)
    end
    x = @pyconvert(T1, x_)
    if x isa T0
        push!(ans, x)
        @goto again
    end
    T2 = Utils._promote_type_bounded(T0, typeof(x), T1)
    ans2 = Vector{T2}(ans)
    push!(ans2, x)
    return _pyconvert_rule_iterable(ans2, it, T1)
end

function pyconvert_rule_iterable(
    ::Type{R},
    x::Py,
    ::Type{Vector{T0}} = Utils._type_lb(R),
    ::Type{Vector{T1}} = Utils._type_ub(R),
) where {R<:Vector,T0,T1}
    it = pyiter(x)
    ans = Vector{T0}()
    return _pyconvert_rule_iterable(ans, it, T1)
end

# Set

function _pyconvert_rule_iterable(ans::Set{T0}, it::Py, ::Type{T1}) where {T0,T1}
    @label again
    x_ = unsafe_pynext(it)
    if pyisnull(x_)
        pydel!(it)
        return pyconvert_return(ans)
    end
    x = @pyconvert(T1, x_)
    if x isa T0
        push!(ans, x)
        @goto again
    end
    T2 = Utils._promote_type_bounded(T0, typeof(x), T1)
    ans2 = Set{T2}(ans)
    push!(ans2, x)
    return _pyconvert_rule_iterable(ans2, it, T1)
end

function pyconvert_rule_iterable(
    ::Type{R},
    x::Py,
    ::Type{Set{T0}} = Utils._type_lb(R),
    ::Type{Set{T1}} = Utils._type_ub(R),
) where {R<:Set,T0,T1}
    it = pyiter(x)
    ans = Set{T0}()
    return _pyconvert_rule_iterable(ans, it, T1)
end

# Dict

function _pyconvert_rule_mapping(
    ans::Dict{K0,V0},
    x::Py,
    it::Py,
    ::Type{K1},
    ::Type{V1},
) where {K0,V0,K1,V1}
    @label again
    k_ = unsafe_pynext(it)
    if pyisnull(k_)
        pydel!(it)
        return pyconvert_return(ans)
    end
    v_ = pygetitem(x, k_)
    k = @pyconvert(K1, k_)
    v = @pyconvert(V1, v_)
    if k isa K0 && v isa V0
        push!(ans, k => v)
        @goto again
    end
    K2 = Utils._promote_type_bounded(K0, typeof(k), K1)
    V2 = Utils._promote_type_bounded(V0, typeof(v), V1)
    ans2 = Dict{K2,V2}(ans)
    push!(ans2, k => v)
    return _pyconvert_rule_mapping(ans2, x, it, K1, V1)
end

function pyconvert_rule_mapping(
    ::Type{R},
    x::Py,
    ::Type{Dict{K0,V0}} = Utils._type_lb(R),
    ::Type{Dict{K1,V1}} = Utils._type_ub(R),
) where {R<:Dict,K0,V0,K1,V1}
    it = pyiter(x)
    ans = Dict{K0,V0}()
    return _pyconvert_rule_mapping(ans, x, it, K1, V1)
end

# Tuple

function pyconvert_rule_iterable(::Type{T}, xs::Py) where {T<:Tuple}
    T isa DataType || return pyconvert_unconverted()
    if T != Tuple{} &&
       Tuple{T.parameters[end]} == Base.tuple_type_tail(Tuple{T.parameters[end]})
        isvararg = true
        vartype = Base.tuple_type_head(Tuple{T.parameters[end]})
        ts = T.parameters[1:end-1]
    else
        isvararg = false
        vartype = Union{}
        ts = T.parameters
    end
    zs = Any[]
    for x in xs
        if length(zs) < length(ts)
            t = ts[length(zs)+1]
        elseif isvararg
            t = vartype
        else
            return pyconvert_unconverted()
        end
        z = @pyconvert(t, x)
        push!(zs, z)
    end
    return length(zs) < length(ts) ? pyconvert_unconverted() : pyconvert_return(T(zs))
end

for N = 0:16
    Ts = [Symbol("T", n) for n = 1:N]
    zs = [Symbol("z", n) for n = 1:N]
    # Tuple with N elements
    @eval function pyconvert_rule_iterable(::Type{Tuple{$(Ts...)}}, xs::Py) where {$(Ts...)}
        xs = pytuple(xs)
        n = pylen(xs)
        n == $N || return pyconvert_unconverted()
        $(
            (
                :($z = @pyconvert($T, pytuple_getitem(xs, $(i - 1)))) for
                (i, T, z) in zip(1:N, Ts, zs)
            )...
        )
        return pyconvert_return(($(zs...),))
    end
    # Tuple with N elements plus Vararg
    @eval function pyconvert_rule_iterable(
        ::Type{Tuple{$(Ts...),V,Vararg{V}}},
        xs::Py,
    ) where {$(Ts...),V}
        xs = pytuple(xs)
        n = pylen(xs)
        n ≥ $N || return pyconvert_unconverted()
        $(
            (
                :($z = @pyconvert($T, pytuple_getitem(xs, $(i - 1)))) for
                (i, T, z) in zip(1:N, Ts, zs)
            )...
        )
        vs = V[]
        for i = $(N + 1):n
            v = @pyconvert(V, pytuple_getitem(xs, i - 1))
            push!(vs, v)
        end
        return pyconvert_return(($(zs...), vs...))
    end
end

# Pair

function pyconvert_rule_iterable(
    ::Type{R},
    x::Py,
    ::Type{Pair{K0,V0}} = Utils._type_lb(R),
    ::Type{Pair{K1,V1}} = Utils._type_ub(R),
) where {R<:Pair,K0,V0,K1,V1}
    it = pyiter(x)
    k_ = unsafe_pynext(it)
    if pyisnull(k_)
        pydel!(it)
        pydel!(k_)
        return pyconvert_unconverted()
    end
    k = @pyconvert(K1, k_)
    v_ = unsafe_pynext(it)
    if pyisnull(v_)
        pydel!(it)
        pydel!(v_)
        return pyconvert_unconverted()
    end
    v = @pyconvert(V1, v_)
    z_ = unsafe_pynext(it)
    pydel!(it)
    if pyisnull(z_)
        pydel!(z_)
    else
        pydel!(z_)
        return pyconvert_unconverted()
    end
    K2 = Utils._promote_type_bounded(K0, typeof(k), K1)
    V2 = Utils._promote_type_bounded(V0, typeof(v), V1)
    return pyconvert_return(Pair{K2,V2}(k, v))
end

# NamedTuple

_nt_names_types(::Type) = nothing
_nt_names_types(::Type{NamedTuple}) = (nothing, nothing)
_nt_names_types(::Type{NamedTuple{names}}) where {names} = (names, nothing)
_nt_names_types(::Type{NamedTuple{names,types} where {names}}) where {types} =
    (nothing, types)
_nt_names_types(::Type{NamedTuple{names,types}}) where {names,types} = (names, types)

function pyconvert_rule_iterable(::Type{R}, x::Py) where {R<:NamedTuple}
    # this is actually strict and only converts python named tuples (i.e. tuples with a
    # _fields attribute) where the field names match those from R (if specified).
    names_types = _nt_names_types(R)
    names_types === nothing && return pyconvert_unconverted()
    names, types = names_types
    pyistuple(x) || return pyconvert_unconverted()
    names2_ = pygetattr(x, "_fields", pybuiltins.None)
    names2 = @pyconvert(names === nothing ? Tuple{Vararg{Symbol}} : typeof(names), names2_)
    pydel!(names2_)
    names === nothing || names === names2 || return pyconvert_unconverted()
    types2 = types === nothing ? NTuple{length(names2),Any} : types
    vals = @pyconvert(types2, x)
    length(vals) == length(names2) || return pyconvert_unconverted()
    types3 = types === nothing ? typeof(vals) : types
    return pyconvert_return(NamedTuple{names2,types3}(vals))
end

### datetime


function pyconvert_rule_date(::Type{Date}, x::Py)
    # datetime is a subtype of date, but we shouldn't convert datetime to Date since it's lossy
    pyisinstance(x, pydatetimetype) && return pyconvert_unconverted()
    year = pyconvert(Int, x.year)
    month = pyconvert(Int, x.month)
    day = pyconvert(Int, x.day)
    pyconvert_return(Date(year, month, day))
end

function pyconvert_rule_time(::Type{Time}, x::Py)
    pytime_isaware(x) && return pyconvert_unconverted()
    hour = pyconvert(Int, x.hour)
    minute = pyconvert(Int, x.minute)
    second = pyconvert(Int, x.second)
    microsecond = pyconvert(Int, x.microsecond)
    return pyconvert_return(
        Time(hour, minute, second, div(microsecond, 1000), mod(microsecond, 1000)),
    )
end

function pyconvert_rule_datetime(::Type{DateTime}, x::Py)
    pydatetime_isaware(x) && return pyconvert_unconverted()
    # compute the time since _base_datetime
    # this accounts for fold
    d = x - _base_pydatetime
    days = pyconvert(Int, d.days)
    seconds = pyconvert(Int, d.seconds)
    microseconds = pyconvert(Int, d.microseconds)
    pydel!(d)
    iszero(mod(microseconds, 1000)) || return pyconvert_unconverted()
    return pyconvert_return(
        _base_datetime +
        Millisecond(div(microseconds, 1000) + 1000 * (seconds + 60 * 60 * 24 * days)),
    )
end

function pyconvert_rule_timedelta(::Type{Nanosecond}, x::Py)
    days = pyconvert(Int, x.days)
    if abs(days) ≥ 106751
        # overflow
        return pyconvert_unconverted()
    end
    seconds = pyconvert(Int, x.seconds)
    microseconds = pyconvert(Int, x.microseconds)
    return Nanosecond(((days * 3600 * 24 + seconds) * 1000000 + microseconds) * 1000)
end

function pyconvert_rule_timedelta(::Type{Microsecond}, x::Py)
    days = pyconvert(Int, x.days)
    if abs(days) ≥ 106751990
        # overflow
        return pyconvert_unconverted()
    end
    seconds = pyconvert(Int, x.seconds)
    microseconds = pyconvert(Int, x.microseconds)
    return Microsecond((days * 3600 * 24 + seconds) * 1000000 + microseconds)
end

function pyconvert_rule_timedelta(::Type{Millisecond}, x::Py)
    days = pyconvert(Int, x.days)
    seconds = pyconvert(Int, x.seconds)
    microseconds = pyconvert(Int, x.microseconds)
    if mod(microseconds, 1000) != 0
        # inexact
        return pyconvert_unconverted()
    end
    return Millisecond((days * 3600 * 24 + seconds) * 1000 + div(microseconds, 1000))
end

function pyconvert_rule_timedelta(::Type{Second}, x::Py)
    days = pyconvert(Int, x.days)
    seconds = pyconvert(Int, x.seconds)
    microseconds = pyconvert(Int, x.microseconds)
    if microseconds != 0
        # inexact
        return pyconvert_unconverted()
    end
    return Second(days * 3600 * 24 + seconds)
end

@testitem "any" begin
    mutable struct Foo
        value::Int
    end
    Base.:(+)(x::Foo) = "+ $(x.value)"
    Base.:(-)(x::Foo) = "- $(x.value)"
    Base.abs(x::Foo) = "abs $(x.value)"
    Base.:(~)(x::Foo) = "~ $(x.value)"
    Base.:(+)(x::Foo, y::Foo) = "$(x.value) + $(y.value)"
    Base.:(-)(x::Foo, y::Foo) = "$(x.value) - $(y.value)"
    Base.:(*)(x::Foo, y::Foo) = "$(x.value) * $(y.value)"
    Base.:(/)(x::Foo, y::Foo) = "$(x.value) / $(y.value)"
    Base.:(÷)(x::Foo, y::Foo) = "$(x.value) ÷ $(y.value)"
    Base.:(%)(x::Foo, y::Foo) = "$(x.value) % $(y.value)"
    Base.:(^)(x::Foo, y::Foo) = "$(x.value) ^ $(y.value)"
    Base.:(<<)(x::Foo, y::Foo) = "$(x.value) << $(y.value)"
    Base.:(>>)(x::Foo, y::Foo) = "$(x.value) >> $(y.value)"
    Base.:(&)(x::Foo, y::Foo) = "$(x.value) & $(y.value)"
    Base.:(|)(x::Foo, y::Foo) = "$(x.value) | $(y.value)"
    Base.powermod(x::Foo, y::Foo, z::Foo) = "powermod($(x.value), $(y.value), $(z.value))"
    (x::Foo)(args...; kw...) = "$(x.value)($args)$(length(kw))"
    Base.getindex(x::Foo, idx...) = "$(x.value)[$idx]"
    Base.setindex!(x::Foo, v, idx...) = (x.value = v + sum(idx); x)
    Base.delete!(x::Foo, idx...) = (x.value = -sum(idx); x)
    Base.in(v::Int, x::Foo) = x.value == v
    Base.nameof(x::Foo) = "nameof $(x.value)"
    @testset "type" begin
        @test pyis(pytype(pyjl(Foo(1))), PythonCall.pyjlanytype)
        @test pyis(pytype(pyjl(nothing)), PythonCall.pyjlanytype)
        @test pyis(pytype(pyjl(missing)), PythonCall.pyjlanytype)
    end
    @testset "bool" begin
        @test pytruth(pyjl(Foo(0)))
        @test pytruth(pyjl(Foo(1)))
        @test pytruth(pyjl(nothing))
        @test pytruth(pyjl(missing))
    end
    @testset "repr" begin
        @test pyrepr(String, pyjl(missing)) == "Julia: missing"
    end
    @testset "str" begin
        @test pystr(String, pyjl(missing)) == "missing"
    end
    @testset "getattr" begin
        @test pyconvert(Int, pygetattr(pyjl(Foo(12)), "value")) === 12
    end
    @testset "setattr" begin
        x = Foo(12)
        @test x.value == 12
        pysetattr(x, "value", 34)
        @test x.value == 34
    end
    @testset "dir" begin
        @test pycontains(pydir(pyjl(Foo(99))), "value")
    end
    @testset "call" begin
        z = pyjl(Foo(1))(4, 5)
        @test pyconvert(String, z) == "1((4, 5))0"
        z = pyjl(Foo(1))(4, 5; foo = true, bar = true)
        @test pyconvert(String, z) == "1((4, 5))2"
    end
    @testset "getitem" begin
        z = pygetitem(pyjl(Foo(1)), 3)
        @test pyconvert(String, z) == "1[(3,)]"
        z = pygetitem(pyjl(Foo(1)), (4, 5))
        @test pyconvert(String, z) == "1[(4, 5)]"
    end
    @testset "setitem" begin
        z = Foo(0)
        x = pyjl(z)
        pysetitem(x, 10, 3)
        @test z.value == 13
        pysetitem(x, (10, 10), 4)
        @test z.value == 24
    end
    @testset "delitem" begin
        z = Foo(0)
        x = pyjl(z)
        pydelitem(x, 9)
        @test z.value == -9
        pydelitem(x, (3, 4))
        @test z.value == -7
    end
    @testset "contains" begin
        @test pycontains(pyjl(Foo(45)), 45)
    end
    @testset "pos" begin
        z = +(pyjl(Foo(1)))
        @test pyconvert(String, z) == "+ 1"
    end
    @testset "neg" begin
        z = -(pyjl(Foo(1)))
        @test pyconvert(String, z) == "- 1"
    end
    @testset "abs" begin
        z = abs(pyjl(Foo(1)))
        @test pyconvert(String, z) == "abs 1"
    end
    @testset "inv" begin
        z = ~(pyjl(Foo(1)))
        @test pyconvert(String, z) == "~ 1"
    end
    @testset "add" begin
        z = pyjl(Foo(1)) + pyjl(Foo(2))
        @test pyconvert(String, z) == "1 + 2"
    end
    @testset "radd" begin
        z = pyjlraw(Foo(1)) + pyjl(Foo(2))
        @test pyconvert(String, z) == "1 + 2"
    end
    @testset "sub" begin
        z = pyjl(Foo(1)) - pyjl(Foo(2))
        @test pyconvert(String, z) == "1 - 2"
    end
    @testset "rsub" begin
        z = pyjlraw(Foo(1)) - pyjl(Foo(2))
        @test pyconvert(String, z) == "1 - 2"
    end
    @testset "mul" begin
        z = pyjl(Foo(1)) * pyjl(Foo(2))
        @test pyconvert(String, z) == "1 * 2"
    end
    @testset "rmul" begin
        z = pyjlraw(Foo(1)) * pyjl(Foo(2))
        @test pyconvert(String, z) == "1 * 2"
    end
    @testset "truediv" begin
        z = pyjl(Foo(1)) / pyjl(Foo(2))
        @test pyconvert(String, z) == "1 / 2"
    end
    @testset "rtruediv" begin
        z = pyjlraw(Foo(1)) / pyjl(Foo(2))
        @test pyconvert(String, z) == "1 / 2"
    end
    @testset "floordiv" begin
        z = pyjl(Foo(1)) ÷ pyjl(Foo(2))
        @test pyconvert(String, z) == "1 ÷ 2"
    end
    @testset "rfloordiv" begin
        z = pyjlraw(Foo(1)) ÷ pyjl(Foo(2))
        @test pyconvert(String, z) == "1 ÷ 2"
    end
    @testset "mod" begin
        z = pyjl(Foo(1)) % pyjl(Foo(2))
        @test pyconvert(String, z) == "1 % 2"
    end
    @testset "rmod" begin
        z = pyjlraw(Foo(1)) % pyjl(Foo(2))
        @test pyconvert(String, z) == "1 % 2"
    end
    @testset "pow" begin
        z = pyjl(Foo(1))^pyjl(Foo(2))
        @test pyconvert(String, z) == "1 ^ 2"
    end
    @testset "rpow" begin
        z = pyjlraw(Foo(1))^pyjl(Foo(2))
        @test pyconvert(String, z) == "1 ^ 2"
    end
    @testset "lshift" begin
        z = pyjl(Foo(1)) << pyjl(Foo(2))
        @test pyconvert(String, z) == "1 << 2"
    end
    @testset "rlshift" begin
        z = pyjlraw(Foo(1)) << pyjl(Foo(2))
        @test pyconvert(String, z) == "1 << 2"
    end
    @testset "rshift" begin
        z = pyjl(Foo(1)) >> pyjl(Foo(2))
        @test pyconvert(String, z) == "1 >> 2"
    end
    @testset "rrshift" begin
        z = pyjlraw(Foo(1)) >> pyjl(Foo(2))
        @test pyconvert(String, z) == "1 >> 2"
    end
    @testset "and" begin
        z = pyjl(Foo(1)) & pyjl(Foo(2))
        @test pyconvert(String, z) == "1 & 2"
    end
    @testset "rand" begin
        z = pyjlraw(Foo(1)) & pyjl(Foo(2))
        @test pyconvert(String, z) == "1 & 2"
    end
    @testset "or" begin
        z = pyjl(Foo(1)) | pyjl(Foo(2))
        @test pyconvert(String, z) == "1 | 2"
    end
    @testset "ror" begin
        z = pyjlraw(Foo(1)) | pyjl(Foo(2))
        @test pyconvert(String, z) == "1 | 2"
    end
    @testset "pow3" begin
        z = pypow(pyjl(Foo(1)), pyjl(Foo(2)), pyjl(Foo(3)))
        @test pyconvert(String, z) == "powermod(1, 2, 3)"
    end
    @testset "rpow3" begin
        z = pyjl(Foo(2)).__rpow__(pyjl(Foo(1)), pyjl(Foo(3)))
        @test pyconvert(String, z) == "powermod(1, 2, 3)"
    end
    @testset "name" begin
        z = pyjl(Foo(135)).__name__
        @test pyconvert(String, z) == "nameof 135"
    end
    @testset "mimebundle" begin
        z = pyjl(Foo(1))._repr_mimebundle_()
        @test pyisinstance(z, pybuiltins.dict)
        @test pycontains(z, "text/plain")
    end
    @testset "display" begin
        pyjl(Foo(1))._jl_display()
        pyjl(Foo(1))._jl_display(mime = "text/plain")
    end
    @testset "help" begin
        @test_skip pyis(pyjl(Foo(1))._jl_help(), nothing)
        @test_skip pyis(pyjl(Foo(1))._jl_help(mime = "text/plain"), nothing)
    end
end

@testitem "array" setup=[Setup] begin
    @testset "type" begin
        @test pyis(pytype(pyjl(fill(nothing))), PythonCall.pyjlarraytype)
        @test pyis(pytype(pyjl([1 2; 3 4])), PythonCall.pyjlarraytype)
    end
    @testset "bool" begin
        @test !pytruth(pyjl(fill(nothing, 0, 1)))
        @test !pytruth(pyjl(fill(nothing, 1, 0)))
        @test pytruth(pyjl(fill(nothing)))
        @test pytruth(pyjl(fill(nothing, 1, 2)))
        @test pytruth(pyjl(fill(nothing, 1, 2, 3)))
    end
    @testset "ndim" begin
        @test pyeq(Bool, pyjl(fill(nothing)).ndim, 0)
        @test pyeq(Bool, pyjl(fill(nothing, 1)).ndim, 1)
        @test pyeq(Bool, pyjl(fill(nothing, 1, 1)).ndim, 2)
        @test pyeq(Bool, pyjl(fill(nothing, 1, 1, 1)).ndim, 3)
    end
    @testset "shape" begin
        @test pyeq(Bool, pyjl(fill(nothing)).shape, ())
        @test pyeq(Bool, pyjl(fill(nothing, 3)).shape, (3,))
        @test pyeq(Bool, pyjl(fill(nothing, 3, 5)).shape, (3, 5))
        @test pyeq(Bool, pyjl(fill(nothing, 3, 5, 2)).shape, (3, 5, 2))
    end
    @testset "getitem" begin
        x = pyjl([1, 2, 3, 4, 5])
        @test pyeq(Bool, x[0], 1)
        @test pyeq(Bool, x[1], 2)
        @test pyeq(Bool, x[2], 3)
        @test pyeq(Bool, x[-1], 5)
        @test pyeq(Bool, x[-2], 4)
        @test pyeq(Bool, x[-3], 3)
        @test pyjlvalue(x[pyslice(3)]) == [1, 2, 3]
        @test pyjlvalue(x[pyslice(2)]) == [1, 2]
        @test pyjlvalue(x[pyslice(1, 2)]) == [2]
        @test pyjlvalue(x[pyslice(2, 2)]) == []
        @test pyjlvalue(x[pyslice(0, -1)]) == [1, 2, 3, 4]
        @test pyjlvalue(x[pyslice(-2, nothing)]) == [4, 5]
        @test pyjlvalue(x[pyslice(0, 3, 1)]) == [1, 2, 3]
        @test pyjlvalue(x[pyslice(nothing, nothing, 2)]) == [1, 3, 5]
        @test pyjlvalue(x[pyslice(1, nothing, 2)]) == [2, 4]
        @test pyjlvalue(x[pyslice(0, nothing, 3)]) == [1, 4]
        x = pyjl([1 2; 3 4])
        @test pyeq(Bool, x[0, 0], 1)
        @test pyeq(Bool, x[0, 1], 2)
        @test pyeq(Bool, x[1, 0], 3)
        @test pyeq(Bool, x[1, 1], 4)
        @test pyjlvalue(x[1, pyslice(nothing)]) == [3, 4]
        @test pyjlvalue(x[pyslice(nothing), 1]) == [2, 4]
    end
    @testset "setitem" begin
        x = [0 0; 0 0]
        y = pyjl(x)
        y[0, 0] = 1
        @test x == [1 0; 0 0]
        y[0, 1] = 2
        @test x == [1 2; 0 0]
        y[1, 0] = 3
        @test x == [1 2; 3 0]
        y[-1, 0] = 4
        @test x == [1 2; 4 0]
        y[-2, pyslice(nothing)] = 5
        @test x == [5 5; 4 0]
        y[pyslice(nothing), -1] = 6
        @test x == [5 6; 4 6]
        y[pyslice(nothing), pyslice(nothing)] = 7
        @test x == [7 7; 7 7]
    end
    @testset "delitem" begin
        x = [1, 2, 3, 4, 5, 6, 7, 8]
        y = pyjl(x)
        pydelitem(y, 0)
        @test x == [2, 3, 4, 5, 6, 7, 8]
        pydelitem(y, 2)
        @test x == [2, 3, 5, 6, 7, 8]
        pydelitem(y, -3)
        @test x == [2, 3, 5, 7, 8]
        pydelitem(y, pyslice(1, nothing, 2))
        @test x == [2, 5, 8]
    end
    @testset "reshape" begin
        x = pyjl([1, 2, 3, 4, 5, 6, 7, 8])
        @test pyeq(Bool, x.shape, (8,))
        y = x.reshape((2, 4))
        @test pyeq(Bool, y.shape, (2, 4))
        @test pyjlvalue(y) == [1 3 5 7; 2 4 6 8]
    end
    @testset "copy" begin
        x = pyjl([1 2; 3 4])
        y = x.copy()
        @test pyis(pytype(y), PythonCall.pyjlarraytype)
        @test pyjlvalue(x) == pyjlvalue(y)
        @test typeof(pyjlvalue(x)) == typeof(pyjlvalue(y))
        @test pyjlvalue(x) !== pyjlvalue(y)
        x[0, 0] = 0
        @test pyjlvalue(x) == [0 2; 3 4]
        @test pyjlvalue(y) == [1 2; 3 4]
    end
    @testset "__array__" begin
        if Setup.devdeps
            np = pyimport("numpy")

            numeric = pyjl(Float64[1, 2, 3])
            numeric_array = numeric.__array__()
            @test pyisinstance(numeric_array, np.ndarray)
            @test pyconvert(Vector{Float64}, numeric_array) == [1.0, 2.0, 3.0]

            numeric_no_copy = numeric.__array__(copy=false)
            numeric_data = pyjlvalue(numeric)
            numeric_data[1] = 42.0
            @test pyconvert(Vector{Float64}, numeric_no_copy) == [42.0, 2.0, 3.0]

            string_array = pyjl(["a", "b"])
            string_result = string_array.__array__()
            @test pyisinstance(string_result, np.ndarray)
            @test pyconvert(Vector{String}, pybuiltins.list(string_result)) == ["a", "b"]

            err = try
                string_array.__array__(copy=false)
                nothing
            catch err
                err
            end
            @test err !== nothing
            @test err isa PythonCall.PyException
            @test pyis(err._t, pybuiltins.ValueError)
            @test occursin(
                "copy=False is not supported when collecting ArrayValue data",
                sprint(showerror, err),
            )
        else
            @test_skip Setup.devdeps
        end
    end
    @testset "array_interface" begin
        x = pyjl(Float32[1 2 3; 4 5 6]).__array_interface__
        @test pyisinstance(x, pybuiltins.dict)
        @test pyeq(Bool, x["shape"], (2, 3))
        @test pyeq(Bool, x["typestr"], "<f4")
        @test pyisinstance(x["data"], pybuiltins.tuple)
        @test pylen(x["data"]) == 2
        @test pyeq(Bool, x["strides"], (4, 8))
        @test pyeq(Bool, x["version"], 3)
    end
    @testset "array_struct" begin
        # TODO (not implemented)
        # x = pyjl(Float32[1 2 3; 4 5 6]).__array_struct__
    end
    @testset "buffer" begin
        m = pybuiltins.memoryview(pyjl(Float32[1 2 3; 4 5 6]))
        @test !pytruth(m.c_contiguous)
        @test pytruth(m.contiguous)
        @test pytruth(m.f_contiguous)
        @test pyeq(Bool, m.format, "f")
        @test pyeq(Bool, m.itemsize, 4)
        @test pyeq(Bool, m.nbytes, 4 * 6)
        @test pyeq(Bool, m.ndim, 2)
        @test !pytruth(m.readonly)
        @test pyeq(Bool, m.shape, (2, 3))
        @test pyeq(Bool, m.strides, (4, 8))
        @test pyeq(Bool, m.suboffsets, ())
        @test pyeq(Bool, m.tolist(), pylist([pylist([1, 2, 3]), pylist([4, 5, 6])]))
    end
end

@testitem "base" begin

end

@testitem "callback" begin

end

@testitem "dict" begin
    @testset "type" begin
        @test pyis(pytype(pyjl(Dict())), PythonCall.pyjldicttype)
    end
    @testset "bool" begin
        @test !pytruth(pyjl(Dict()))
        @test pytruth(pyjl(Dict("one" => 1, "two" => 2)))
    end
end

@testitem "io" begin
    @testset "type" begin
        @test pyis(pytype(pyjl(devnull)), PythonCall.pyjlbinaryiotype)
        @test pyis(pytype(pybinaryio(devnull)), PythonCall.pyjlbinaryiotype)
        @test pyis(pytype(pytextio(devnull)), PythonCall.pyjltextiotype)
    end
    @testset "bool" begin
        @test pytruth(pybinaryio(devnull))
        @test pytruth(pytextio(devnull))
    end
end

@testitem "iter" begin
    x1 = [1, 2, 3, 4, 5]
    x2 = pyjl(x1)
    x3 = pylist(x2)
    x4 = pyconvert(Vector{Int}, x3)
    @test x1 == x4
end

@testitem "module" begin
    @testset "type" begin
        @test pyis(pytype(pyjl(PythonCall)), PythonCall.pyjlmoduletype)
    end
    @testset "bool" begin
        @test pytruth(pyjl(PythonCall))
    end
    @testset "seval" begin
        m = Py(Main)
        @test pyconvert(Any, m.seval("1 + 1")) === 2 # Basic behavior
        @test pyconvert(Any, m.seval("1 + 1\n ")) === 2 # Trailing whitespace
    end
end

@testitem "number" begin
    @testset "type" begin
        @test pyis(pytype(pyjl(false)), PythonCall.pyjlintegertype)
        @test pyis(pytype(pyjl(0)), PythonCall.pyjlintegertype)
        @test pyis(pytype(pyjl(0 // 1)), PythonCall.pyjlrationaltype)
        @test pyis(pytype(pyjl(0.0)), PythonCall.pyjlrealtype)
        @test pyis(pytype(pyjl(Complex(0.0))), PythonCall.pyjlcomplextype)
    end
    @testset "bool" begin
        @test !pytruth(pyjl(false))
        @test !pytruth(pyjl(0))
        @test !pytruth(pyjl(0 // 1))
        @test !pytruth(pyjl(0.0))
        @test !pytruth(pyjl(Complex(0.0)))
        @test pytruth(pyjl(true))
        @test pytruth(pyjl(3))
        @test pytruth(pyjl(5 // 2))
        @test pytruth(pyjl(2.3))
        @test pytruth(pyjl(Complex(1.2, 3.4)))
    end
end

@testitem "objectarray" begin

end

@testitem "raw" begin

end

@testitem "set" begin
    @testset "type" begin
        @test pyis(pytype(pyjl(Set())), PythonCall.pyjlsettype)
    end
    @testset "bool" begin
        @test !pytruth(pyjl(Set()))
        @test pytruth(pyjl(Set([1, 2, 3])))
    end
end

@testitem "type" setup = [Setup] begin
    using PythonCall.NumpyDates
    @testset "type" begin
        @test pyis(pytype(pyjl(Int)), PythonCall.pyjltypetype)
    end
    @testset "bool" begin
        @test pytruth(pyjl(Int))
    end
    @testset "numpy dtype" begin
        if Setup.devdeps
            np = pyimport("numpy")

            # success cases
            @testset "$t -> $d" for (t, d) in [
                (Bool, "bool"),
                (Int8, "int8"),
                (Int16, "int16"),
                (Int32, "int32"),
                (Int64, "int64"),
                (UInt8, "uint8"),
                (UInt16, "uint16"),
                (UInt32, "uint32"),
                (UInt64, "uint64"),
                (Float16, "float16"),
                (Float32, "float32"),
                (Float64, "float64"),
                (ComplexF32, "complex64"),
                (ComplexF64, "complex128"),
                (InlineDateTime64{SECONDS}, "datetime64[s]"),
                (InlineDateTime64{(SECONDS, 5)}, "datetime64[5s]"),
                (InlineDateTime64{NumpyDates.UNBOUND_UNITS}, "datetime64"),
                (InlineTimeDelta64{MINUTES}, "timedelta64[m]"),
                (InlineTimeDelta64{(SECONDS, 5)}, "timedelta64[5s]"),
                (InlineTimeDelta64{NumpyDates.UNBOUND_UNITS}, "timedelta64"),
                (Tuple{}, pylist()),
                (Tuple{Int32, Int32}, pylist([("f0", "int32"), ("f1", "int32")])),
                (@NamedTuple{}, pylist()),
                (@NamedTuple{x::Int32, y::Int32}, pylist([("x", "int32"), ("y", "int32")])),
            ]
                @test pyeq(Bool, pygetattr(pyjl(t), "__numpy_dtype__"), np.dtype(d))
                @test pyeq(Bool, np.dtype(t), np.dtype(d))
                # test the invariant np.dtype(eltype(array)) == np.array(array).dtype
                @test isequal(np.dtype(t), np.array(t[]).dtype)
            end

            # unsupported cases
            @testset "$t -> AttributeError" for t in [
                # structs / mutables
                Pair,
                Pair{Int,Int},
                String,
                Vector{Int},
                # pointers
                Ptr{Cvoid},
                Ptr{Int},
                # PyPtr specifically should NOT be interpreted as np.dtype("O")
                PythonCall.C.PyPtr,
                # tuples containing illegal things
                Tuple{String},
                Tuple{Pair{Int,Int}},
            ]
                err = try
                    pygetattr(pyjl(t), "__numpy_dtype__")
                    nothing
                catch err
                    err
                end
                @test err isa PythonCall.PyException
                @test pyis(err.t, pybuiltins.AttributeError)
            end
        end
    end
end

@testitem "vector" begin
    @testset "type" begin
        @test pyis(pytype(pyjl([1, 2, 3, 4])), PythonCall.pyjlvectortype)
    end
    @testset "bool" begin
        @test !pytruth(pyjl([]))
        @test pytruth(pyjl([1]))
        @test pytruth(pyjl([1, 2]))
    end
    @testset "resize" begin
        x = pyjl([1, 2, 3, 4, 5])
        @test pyjlvalue(x) == [1, 2, 3, 4, 5]
        x.resize(5)
        @test pyjlvalue(x) == [1, 2, 3, 4, 5]
        x.resize(3)
        @test pyjlvalue(x) == [1, 2, 3]
        x.resize(0)
        @test pyjlvalue(x) == []
        x.resize(2)
        x[0] = 5
        x[1] = 6
        @test pyjlvalue(x) == [5, 6]
    end
    @testset "sort" begin
        x = pyjl([4, 6, 2, 3, 7, 6, 1])
        x.sort()
        @test pyjlvalue(x) == [1, 2, 3, 4, 6, 6, 7]
        x = pyjl([4, 6, 2, 3, 7, 6, 1])
        x.sort(reverse = true)
        @test pyjlvalue(x) == [7, 6, 6, 4, 3, 2, 1]
        x = pyjl([4, -6, 2, -3, 7, -6, 1])
        x.sort(key = abs)
        @test pyjlvalue(x) == [1, 2, -3, 4, -6, -6, 7]
        x = pyjl([4, -6, 2, -3, 7, -6, 1])
        x.sort(key = abs, reverse = true)
        @test pyjlvalue(x) == [7, -6, -6, 4, -3, 2, 1]
    end
    @testset "reverse" begin
        x = pyjl([1, 2, 3, 4, 5])
        x.reverse()
        @test pyjlvalue(x) == [5, 4, 3, 2, 1]
    end
    @testset "clear" begin
        x = pyjl([1, 2, 3, 4, 5])
        @test pyjlvalue(x) == [1, 2, 3, 4, 5]
        x.clear()
        @test pyjlvalue(x) == []
    end
    @testset "reversed" begin
        x = pyjl([1, 2, 3, 4, 5])
        y = pybuiltins.reversed(x)
        @test pyjlvalue(x) == [1, 2, 3, 4, 5]
        @test pyjlvalue(y) == [5, 4, 3, 2, 1]
    end
    @testset "insert" begin
        x = pyjl([1, 2, 3])
        x.insert(0, 4)
        @test pyjlvalue(x) == [4, 1, 2, 3]
        x.insert(2, 5)
        @test pyjlvalue(x) == [4, 1, 5, 2, 3]
        x.insert(5, 6)
        @test pyjlvalue(x) == [4, 1, 5, 2, 3, 6]
        x.insert(-3, 7)
        @test pyjlvalue(x) == [4, 1, 5, 7, 2, 3, 6]
        @test_throws PyException x.insert(10, 10)
    end
    @testset "append" begin
        x = pyjl([1, 2, 3])
        x.append(4)
        @test pyjlvalue(x) == [1, 2, 3, 4]
        x.append(5.0)
        @test pyjlvalue(x) == [1, 2, 3, 4, 5]
        @test_throws PyException x.append(nothing)
        @test_throws PyException x.append(1.2)
        @test_throws PyException x.append("2")
    end
    @testset "extend" begin
        x = pyjl([1, 2, 3])
        x.extend(pylist())
        @test pyjlvalue(x) == [1, 2, 3]
        x.extend(pylist([4, 5]))
        @test pyjlvalue(x) == [1, 2, 3, 4, 5]
        x.extend(pylist([6.0]))
        @test pyjlvalue(x) == [1, 2, 3, 4, 5, 6]
    end
    @testset "pop" begin
        x = pyjl([1, 2, 3, 4, 5])
        @test pyeq(Bool, x.pop(), 5)
        @test pyjlvalue(x) == [1, 2, 3, 4]
        @test pyeq(Bool, x.pop(0), 1)
        @test pyjlvalue(x) == [2, 3, 4]
        @test pyeq(Bool, x.pop(1), 3)
        @test pyjlvalue(x) == [2, 4]
        @test pyeq(Bool, x.pop(-2), 2)
        @test pyjlvalue(x) == [4]
        @test_throws PyException x.pop(10)
    end
    @testset "remove" begin
        x = pyjl([1, 3, 2, 4, 5, 3, 1])
        @test pyjlvalue(x) == [1, 3, 2, 4, 5, 3, 1]
        x.remove(3)
        @test pyjlvalue(x) == [1, 2, 4, 5, 3, 1]
        @test_throws PyException x.remove(0)
        @test_throws PyException x.remove(nothing)
        @test_throws PyException x.remove("2")
        @test pyjlvalue(x) == [1, 2, 4, 5, 3, 1]
    end
    @testset "index" begin
        x = pyjl([1, 3, 2, 4, 5, 2, 1])
        @test pyeq(Bool, x.index(1), 0)
        @test pyeq(Bool, x.index(2), 2)
        @test pyeq(Bool, x.index(3), 1)
        @test pyeq(Bool, x.index(4), 3)
        @test pyeq(Bool, x.index(5), 4)
        @test pyeq(Bool, x.index(2.0), 2)
        @test_throws PyException x.index(0)
        @test_throws PyException x.index(6)
        @test_throws PyException x.index(nothing)
        @test_throws PyException x.index("2")
    end
    @testset "count" begin
        x = pyjl([1, 2, 3, 4, 5, 1, 2, 3, 1])
        @test pyeq(Bool, x.count(0), 0)
        @test pyeq(Bool, x.count(1), 3)
        @test pyeq(Bool, x.count(2), 2)
        @test pyeq(Bool, x.count(3), 2)
        @test pyeq(Bool, x.count(4), 1)
        @test pyeq(Bool, x.count(5), 1)
        @test pyeq(Bool, x.count(2.0), 2)
        @test pyeq(Bool, x.count(nothing), 0)
        @test pyeq(Bool, x.count("2"), 0)
    end

    @testset "PyObjectArray" begin
        # https://github.com/JuliaPy/PythonCall.jl/issues/543
        # Here we check the finalizer does not error
        # We must not reuse `arr` in this code once we finalize it!
        let arr = PyObjectArray([1, 2, 3])
            finalize(arr)
        end
    end
end

const pyjuliacallmodule = pynew()
const pyJuliaError = pynew()
const CPyExc_JuliaError = Ref(C.PyNULL)

function init_juliacall()
    # ensure the 'juliacall' module exists
    # this means that Python code can do "import juliacall" and it will work regardless of
    # whether Python is embedded in Julia or vice-versa
    jl = pyjuliacallmodule
    sys = pysysmodule
    os = pyosmodule
    if C.CTX.is_embedded
        # in this case, Julia is being embedded into Python by juliacall, which already exists
        pycopy!(jl, sys.modules["juliacall"])
        @assert pystr_asstring(jl.__version__) == string(VERSION)
    elseif "juliacall" in sys.modules
        # otherwise, Python is being embedded into Julia by PythonCall, so should not exist
        error("'juliacall' module already exists")
    else
        # TODO: Is there a more robust way to import juliacall from a specific path?
        # prepend the directory containing juliacall to sys.path
        sys.path.insert(0, joinpath(ROOT_DIR, "pysrc"))
        # prevent juliacall from initialising itself
        os.environ["PYTHON_JULIACALL_INIT"] = "no"
        # import juliacall
        pycopy!(jl, pyimport("juliacall"))
        # check the version
        @assert realpath(pystr_asstring(jl.__path__[0])) ==
                realpath(joinpath(ROOT_DIR, "pysrc", "juliacall"))
        @assert pystr_asstring(jl.__version__) == string(VERSION)
        @assert !pybool_asbool(jl.CONFIG["init"])
    end
    pycopy!(pyJuliaError, jl.JuliaError)
    CPyExc_JuliaError[] = incref(getptr(pyJuliaError))
end

module PythonCall

const ROOT_DIR = dirname(@__DIR__)

include("API/API.jl")
include("Utils/Utils.jl")
include("NumpyDates/NumpyDates.jl")
include("C/C.jl")
include("GIL/GIL.jl")
include("GC/GC.jl")
include("Core/Core.jl")
include("Convert/Convert.jl")
include("PyMacro/PyMacro.jl")
include("Wrap/Wrap.jl")
include("JlWrap/JlWrap.jl")
include("Compat/Compat.jl")

# non-exported API
using .Core: PyNULL, CONFIG

# not API but used in tests
for k in [
    :pyjlanytype,
    :pyjlarraytype,
    :pyjlvectortype,
    :pyjlbinaryiotype,
    :pyjltextiotype,
    :pyjldicttype,
    :pyjlmoduletype,
    :pyjlintegertype,
    :pyjlrationaltype,
    :pyjlrealtype,
    :pyjlcomplextype,
    :pyjlsettype,
    :pyjltypetype,
]
    @eval using .JlWrap: $k
end

end

"""
    fix_qt_plugin_path()

Try to set the `QT_PLUGIN_PATH` environment variable in Python, if not already set.

This fixes the problem that Qt does not know where to find its `qt.conf` file, because it
always looks relative to `sys.executable`, which can be the Julia executable not the Python
one when using this package.

If `CONFIG.auto_fix_qt_plugin_path` is true, then this is run automatically before `PyQt4`, `PyQt5`, `PySide`, `PySide2` or `PySide6` are imported.
"""
function fix_qt_plugin_path()
    C.CTX.exe_path === nothing && return false
    e = pyosmodule.environ
    "QT_PLUGIN_PATH" in e && return false
    
    exe_dir = dirname(C.CTX.exe_path::AbstractString)
    
    # Check for Qt6 configuration first (PySide6)
    qt6conf = joinpath(exe_dir, "qt6.conf")
    if isfile(qt6conf)
        for line in eachline(qt6conf)
            m = match(r"^\s*Libraries\s*=(.*)$"i, line)
            if m !== nothing
                path = strip(m.captures[1]::AbstractString)
                path[1] == path[end] == '"' && (path = path[2:end-1])
                path = joinpath(path, "qt6", "plugins")
                if isdir(path)
                    e["QT_PLUGIN_PATH"] = realpath(path)
                    return true
                end
            end
        end
    end
    
    # Check for Qt5 configuration (PyQt4, PyQt5, PySide, PySide2)
    qtconf = joinpath(exe_dir, "qt.conf")
    if isfile(qtconf)
        for line in eachline(qtconf)
            m = match(r"^\s*prefix\s*=(.*)$"i, line)
            if m !== nothing
                path = strip(m.captures[1]::AbstractString)
                path[1] == path[end] == '"' && (path = path[2:end-1])
                path = joinpath(path, "plugins")
                if isdir(path)
                    e["QT_PLUGIN_PATH"] = realpath(path)
                    return true
                end
            end
        end
    end
    
    return false
end

# """
#     pyinteract(; force=false, sleep=0.1)

# Some Python GUIs can work interactively, meaning the GUI is available but the interactive prompt is returned (e.g. after calling `matplotlib.pyplot.ion()`).
# To use these from Julia, currently you must manually call `pyinteract()` each time you want to interact.

# Internally, this is calling the `PyOS_InputHook` asynchronously. Only one copy is run at a time unless `force` is true.

# The asynchronous task waits for `sleep` seconds before calling the hook function.
# This gives time for the next prompt to be printed and waiting for input.
# As a result, there will be a small delay before the GUI becomes interactive.
# """
# pyinteract(; force::Bool = false, sleep::Real = 0.1) =
#     if !CONFIG.inputhookrunning || force
#         CONFIG.inputhookrunning = true
#         @async begin
#             sleep > 0 && Base.sleep(sleep)
#             C.PyOS_RunInputHook()
#             CONFIG.inputhookrunning = false
#         end
#         nothing
#     end
# export pyinteract

const EVENT_LOOPS = Dict{Symbol,Base.Timer}()

const new_event_loop_callback = pynew()

function init_gui()
    if !C.CTX.is_embedded
        # define callbacks
        g = pydict()
        pyexec(
            """
     def new_event_loop_callback(g, interval=0.04):
         if g in ("pyqt4","pyqt5","pyside","pyside2","pyside6"):
             if g == "pyqt4":
                 import PyQt4.QtCore as QtCore
             elif g == "pyqt5":
                 import PyQt5.QtCore as QtCore
             elif g == "pyside":
                 import PySide.QtCore as QtCore
             elif g == "pyside2":
                 import PySide2.QtCore as QtCore
             elif g == "pyside6":
                 import PySide6.QtCore as QtCore
             instance = QtCore.QCoreApplication.instance
             AllEvents = QtCore.QEventLoop.AllEvents
             processEvents = QtCore.QCoreApplication.processEvents
             maxtime = int(interval * 1000)
             def callback():
                 app = instance()
                 if app is not None:
                     app._in_event_loop = True
                     processEvents(AllEvents, maxtime)
         elif g in ("gtk","gtk3"):
             if g == "gtk3":
                 import gi
                 if gi.get_required_version("Gtk") is None:
                     gi.require_version("Gtk", "3.0")
                 import gi.repository.Gtk as gtk
             elif g == "gtk":
                 import gtk
             events_pending = gtk.events_pending
             main_iteration = gtk.main_iteration
             def callback():
                 while events_pending():
                     main_iteration()
         elif g == "wx":
             import wx
             GetApp = wx.GetApp
             EventLoop = wx.EventLoop
             EventLoopActivator = wx.EventLoopActivator
             def callback():
                 app = GetApp()
                 if app is not None:
                     app._in_event_loop = True
                     evtloop = EventLoop()
                     ea = EventLoopActivator(evtloop)
                     Pending = evtloop.Pending
                     Dispatch = evtloop.Dispatch
                     while Pending():
                         Dispatch()
                     app.ProcessIdle()
         elif g == "tkinter":
             import tkinter, _tkinter
             flag = _tkinter.ALL_EVENTS | _tkinter.DONT_WAIT
             root = None
             def callback():
                 global root
                 new_root = tkinter._default_root
                 if new_root is not None:
                     root = new_root
                 if root is not None:
                     while root.dooneevent(flag):
                         pass
         else:
             raise ValueError("invalid event loop name: {}".format(g))
         return callback
     """,
            g,
        )
        pycopy!(new_event_loop_callback, g["new_event_loop_callback"])

        # add a hook to automatically call fix_qt_plugin_path()
        fixqthook =
            Py(() -> (PythonCall.CONFIG.auto_fix_qt_plugin_path && fix_qt_plugin_path(); nothing))
        pymodulehooks.add_hook("PyQt4", fixqthook)
        pymodulehooks.add_hook("PyQt5", fixqthook)
        pymodulehooks.add_hook("PySide", fixqthook)
        pymodulehooks.add_hook("PySide2", fixqthook)
        pymodulehooks.add_hook("PySide6", fixqthook)
    end
end

"""
    event_loop_off(g::Symbol)

Terminate the event loop `g` if it is running.
"""
function event_loop_off(g::Symbol)
    if haskey(EVENT_LOOPS, g)
        Base.close(pop!(EVENT_LOOPS, g))
    end
    return
end

"""
    event_loop_on(g::Symbol; interval=0.04, fix=false)

Activate an event loop for the GUI framework `g`, so that the framework can run in the background of a Julia session.

The event loop runs every `interval` seconds. If `fix` is true and `g` is a Qt framework, then [`fix_qt_plugin_path`](@ref PythonCall.fix_qt_plugin_path) is called.

Supported values of `g` (and the Python module they relate to) are: `:pyqt4` (PyQt4), `:pyqt5` (PyQt5), `:pyside` (PySide), `:pyside2` (PySide2), `:pyside6` (PySide6), `:gtk` (gtk), `:gtk3` (gi), `:wx` (wx), `:tkinter` (tkinter).
"""
function event_loop_on(g::Symbol; interval::Real = 0.04, fix::Bool = false)
    haskey(EVENT_LOOPS, g) && return EVENT_LOOPS[g]
    fix && g in (:pyqt4, :pyqt5, :pyside, :pyside2, :pyside6) && fix_qt_plugin_path()
    callback = new_event_loop_callback(string(g), Float64(interval))
    EVENT_LOOPS[g] = Timer(t -> callback(), 0; interval = interval)
end

function _python_input_hook()
    try
        @static if Sys.iswindows()
            # on windows, we can call yield in a loop because _kbhit() lets us know
            # when to stop
            while true
                yield()
                if ccall(:_kbhit, Cint, ()) != 0
                    break
                end
                sleep(0.01)
            end
        else
            # on other platforms, if readline is enabled, the input hook is called
            # repeatedly so the loop is not required
            yield()
        end
    catch
        return Cint(1)
    end
    return Cint(0)
end

function _set_python_input_hook()
    C.PyOS_SetInputHook(@cfunction(_python_input_hook, Cint, ()))
    return
end

function _unset_python_input_hook()
    C.PyOS_SetInputHook(C_NULL)
    return
end

const pyjlrawtype = pynew()

pyjlraw_repr(self) = Py("<jl $(repr(self))>")

pyjlraw_str(self) = Py(sprint(print, self))

pyjl_attr_py2jl(k::String) = replace(k, r"_[b]+$" => (x -> "!"^(length(x) - 1)))

pyjl_attr_jl2py(k::String) = replace(k, r"!+$" => (x -> "_" * "b"^length(x)))

function pyjlraw_getattr(self, k_::Py)
    k = Symbol(pyjl_attr_py2jl(pyconvert(String, k_)))
    pydel!(k_)
    pyjlraw(getproperty(self, k))
end

function pyjlraw_setattr(self, k_::Py, v_::Py)
    k = Symbol(pyjl_attr_py2jl(pyconvert(String, k_)))
    pydel!(k_)
    v = pyconvert(Any, v_)
    setproperty!(self, k, v)
    Py(nothing)
end

pyjlraw_dir(self) = pylist(pyjl_attr_jl2py(string(k)) for k in propertynames(self, true))

function pyjlraw_call(self, args_::Py, kwargs_::Py)
    if pylen(kwargs_) > 0
        args = pyconvert(Vector{Any}, args_)
        kwargs = pyconvert(Dict{Symbol,Any}, kwargs_)
        ans = pyjlraw(self(args...; kwargs...))
    elseif pylen(args_) > 0
        args = pyconvert(Vector{Any}, args_)
        ans = pyjlraw(self(args...))
    else
        ans = pyjlraw(self())
    end
    pydel!(args_)
    pydel!(kwargs_)
    ans
end

function pyjlraw_call_nogil(self, args_::Py, kwargs_::Py)
    if pylen(kwargs_) > 0
        args = pyconvert(Vector{Any}, args_)
        kwargs = pyconvert(Dict{Symbol,Any}, kwargs_)
        ans = pyjlraw(GIL.@unlock self(args...; kwargs...))
    elseif pylen(args_) > 0
        args = pyconvert(Vector{Any}, args_)
        ans = pyjlraw(GIL.@unlock self(args...))
    else
        ans = pyjlraw(GIL.@unlock self())
    end
    pydel!(args_)
    pydel!(kwargs_)
    ans
end

pyjlraw_len(self) = Py(length(self))

function pyjlraw_getitem(self, k_::Py)
    if pyistuple(k_)
        k = pyconvert(Vector{Any}, k_)
        pydel!(k_)
        pyjlraw(self[k...])
    else
        k = pyconvert(Any, k_)
        pyjlraw(self[k])
    end
end

function pyjlraw_setitem(self, k_::Py, v_::Py)
    v = pyconvert(Any, v_)
    if pyistuple(k_)
        k = pyconvert(Vector{Any}, k_)
        pydel!(k_)
        self[k...] = v
    else
        k = pyconvert(Any, k_)
        self[k] = v
    end
    Py(nothing)
end

function pyjlraw_delitem(self, k_::Py)
    if pyistuple(k_)
        k = pyconvert(Vector{Any}, k_)
        pydel!(k_)
        delete!(self, k...)
    else
        k = pyconvert(Any, k_)
        delete!(self, k)
    end
    Py(nothing)
end

pyjlraw_bool(self::Bool) = Py(self)
pyjlraw_bool(self) =
    (errset(pybuiltins.TypeError, "Only Julia 'Bool' can be tested for truthyness"); PyNULL)

function init_raw()
    jl = pyjuliacallmodule
    pybuiltins.exec(
        pybuiltins.compile(
            """
$("\n"^(@__LINE__()-1))
class RawValue(ValueBase):
    __slots__ = ()
    def __repr__(self):
        if self._jl_isnull():
            return "<jl NULL>"
        else:
            return self._jl_callmethod($(pyjl_methodnum(pyjlraw_repr)))
    def __str__(self):
        if self._jl_isnull():
            return "NULL"
        else:
            return self._jl_callmethod($(pyjl_methodnum(pyjlraw_str)))
    def __getattr__(self, k):
        if k.startswith("__") and k.endswith("__"):
            raise AttributeError(k)
        else:
            return self._jl_callmethod($(pyjl_methodnum(pyjlraw_getattr)), k)
    def __setattr__(self, k, v):
        try:
            ValueBase.__setattr__(self, k, v)
        except AttributeError:
            if k.startswith("__") and k.endswith("__"):
                raise
        else:
            return
        self._jl_callmethod($(pyjl_methodnum(pyjlraw_setattr)), k, v)
    def __dir__(self):
        return ValueBase.__dir__(self) + self._jl_callmethod($(pyjl_methodnum(pyjlraw_dir)))
    def __call__(self, *args, **kwargs):
        return self._jl_callmethod($(pyjl_methodnum(pyjlraw_call)), args, kwargs)
    def __len__(self):
        return self._jl_callmethod($(pyjl_methodnum(pyjlraw_len)))
    def __getitem__(self, k):
        return self._jl_callmethod($(pyjl_methodnum(pyjlraw_getitem)), k)
    def __setitem__(self, k, v):
        self._jl_callmethod($(pyjl_methodnum(pyjlraw_setitem)), k, v)
    def __delitem__(self, k):
        self._jl_callmethod($(pyjl_methodnum(pyjlraw_delitem)), k)
    def __bool__(self):
        return self._jl_callmethod($(pyjl_methodnum(pyjlraw_bool)))
    def _jl_any(self):
        '''Convert this to a juliacall.AnyValue.'''
        return self._jl_callmethod($(pyjl_methodnum(pyjl)))
    def _jl_call_nogil(self, *args, **kwargs):
        '''Call this with the given arguments but with the GIL disabled.
        
        WARNING: This function must not interact with Python at all without re-acquiring
        the GIL.
        '''
        return self._jl_callmethod($(pyjl_methodnum(pyjlraw_call_nogil)), args, kwargs)
""",
            @__FILE__(),
            "exec",
        ),
        jl.__dict__,
    )
    pycopy!(pyjlrawtype, jl.RawValue)
end

"""
    pyjlraw(v)

Create a Python object wrapping the Julia object `x`.

It has type `juliacall.RawValue`. This has a much more rigid "Julian" interface than `pyjl(v)`.
For example, accessing attributes or calling this object will always return a `RawValue`.
"""
pyjlraw(v) = pyjl(pyjlrawtype, v)

module Cjl

using ...C: C
using ...Utils: Utils
using Base: @kwdef
using UnsafePointers: UnsafePtr
using Serialization: serialize, deserialize

@kwdef struct PyJuliaValueObject
    ob_base::C.PyObject = C.PyObject()
    value::Int = 0
    weaklist::C.PyPtr = C_NULL
end

@kwdef struct PyJuliaValueObjectFT
    ob_base::C.PyObjectFT = C.PyObjectFT()
    value::Int = 0
    weaklist::C.PyPtr = C_NULL
end

const PyJuliaBase_Type = Ref(C.PyNULL)

# we store the actual julia values here
# the `value` field of `PyJuliaValueObject` indexes into here
const PYJLVALUES = []
# unused indices in PYJLVALUES; kept the same length as PYJLVALUES (extra slots
# are pushed alongside PYJLVALUES so the dealloc/finalizer path never has to
# resize this vector). Only the first PYJLFREEVALUECOUNT[] entries are valid
# free indices; the rest are placeholders.
const PYJLFREEVALUES = Int[]
const PYJLFREEVALUECOUNT = Ref(0)
# lock protecting PYJLVALUES, PYJLFREEVALUES and PYJLFREEVALUECOUNT
const PYJL_LOCK = Threads.SpinLock()

function _pyjl_new(t::C.PyPtr, ::C.PyPtr, ::C.PyPtr)
    alloc = C.PyType_GetSlot(t, C.Py_tp_alloc)
    alloc == C_NULL && return C.PyNULL
    o = ccall(alloc, C.PyPtr, (C.PyPtr, C.Py_ssize_t), t, 0)
    o == C.PyNULL && return C.PyNULL
    C.@ft UnsafePtr{PyJuliaValueObject}(o).weaklist[] = C.PyNULL
    C.@ft UnsafePtr{PyJuliaValueObject}(o).value[] = 0
    return o
end

function _pyjl_dealloc(o::C.PyPtr)
    idx = C.@ft UnsafePtr{PyJuliaValueObject}(o).value[]
    if idx != 0
        # No allocation in this critical section: PYJLFREEVALUES has been pre-sized
        # to match PYJLVALUES by PyJuliaValue_SetValue, so recording a free index is
        # just a write to an existing slot plus a counter bump. This avoids the GC-triggered
        lock(PYJL_LOCK)
        PYJLVALUES[idx] = nothing
        PYJLFREEVALUECOUNT[] += 1
        PYJLFREEVALUES[PYJLFREEVALUECOUNT[]] = idx
        unlock(PYJL_LOCK)
    end
    (C.@ft UnsafePtr{PyJuliaValueObject}(o).weaklist[!]) == C.PyNULL || C.PyObject_ClearWeakRefs(o)
    freeptr = C.PyType_GetSlot(C.Py_Type(o), C.Py_tp_free)
    freeptr == C_NULL || ccall(freeptr, Cvoid, (C.PyPtr,), o)
    nothing
end

const PYJLMETHODS = Vector{Any}()

function PyJulia_MethodNum(f)
    @nospecialize f
    push!(PYJLMETHODS, f)
    return length(PYJLMETHODS)
end

function _pyjl_isnull(o::C.PyPtr, ::C.PyPtr)
    ans = PyJuliaValue_IsNull(o) ? C.POINTERS._Py_TrueStruct : C.POINTERS._Py_FalseStruct
    C.Py_IncRef(ans)
    ans
end

function _pyjl_callmethod(o::C.PyPtr, args::C.PyPtr)
    nargs = C.PyTuple_Size(args)
    @assert nargs > 0
    num = C.PyLong_AsLongLong(C.PyTuple_GetItem(args, 0))
    num == -1 && return C.PyNULL
    f = PYJLMETHODS[num]
    # this form gets defined in jlwrap/base.jl
    return _pyjl_callmethod(f, o, args, nargs)::C.PyPtr
end

const PYJLBUFCACHE = Dict{Ptr{Cvoid},Any}()

@kwdef struct PyBufferInfo{N}
    # data
    ptr::Ptr{Cvoid}
    readonly::Bool
    # items
    itemsize::Int
    format::String
    # layout
    shape::NTuple{N,Int}
    strides::NTuple{N,Int}
    suboffsets::NTuple{N,Int} = ntuple(i -> -1, N)
end

_pyjl_get_buffer_impl(obj::C.PyPtr, buf::Ptr{C.Py_buffer}, flags::Cint, x, f) =
    _pyjl_get_buffer_impl(obj, buf, flags, f(x)::PyBufferInfo)

function _pyjl_get_buffer_impl(
    obj::C.PyPtr,
    buf::Ptr{C.Py_buffer},
    flags::Cint,
    info::PyBufferInfo{N},
) where {N}
    b = UnsafePtr(buf)
    c = []

    # not influenced by flags: obj, buf, len, itemsize, ndim
    b.obj[] = C_NULL
    b.buf[] = info.ptr
    b.itemsize[] = info.itemsize
    b.len[] = info.itemsize * prod(info.shape)
    b.ndim[] = N

    # readonly
    if !info.readonly
        b.readonly[] = 0
    elseif Utils.isflagset(flags, C.PyBUF_WRITABLE)
        C.PyErr_SetString(C.POINTERS.PyExc_BufferError, "not writable")
        return Cint(-1)
    else
        b.readonly[] = 1
    end

    # format
    if Utils.isflagset(flags, C.PyBUF_FORMAT)
        push!(c, info.format)
        b.format[] = pointer(info.format)
    else
        b.format[] = C_NULL
    end

    # shape
    if Utils.isflagset(flags, C.PyBUF_ND)
        shape = C.Py_ssize_t[info.shape...]
        push!(c, shape)
        b.shape[] = pointer(shape)
    else
        b.shape[] = C_NULL
    end

    # strides
    if Utils.isflagset(flags, C.PyBUF_STRIDES)
        strides = C.Py_ssize_t[info.strides...]
        push!(c, strides)
        b.strides[] = pointer(strides)
    elseif Utils.size_to_cstrides(info.itemsize, info.shape) == info.strides
        b.strides[] = C_NULL
    else
        C.PyErr_SetString(
            C.POINTERS.PyExc_BufferError,
            "not C contiguous and strides not requested",
        )
        return Cint(-1)
    end

    # suboffsets
    if all(==(-1), info.suboffsets)
        b.suboffsets[] = C_NULL
    elseif Utils.isflagset(flags, C.PyBUF_INDIRECT)
        suboffsets = C.Py_ssize_t[info.suboffsets...]
        push!(c, suboffsets)
        b.suboffsets[] = pointer(suboffsets)
    else
        C.PyErr_SetString(
            C.POINTERS.PyExc_BufferError,
            "indirect array and suboffsets not requested",
        )
        return Cint(-1)
    end

    # check contiguity
    if Utils.isflagset(flags, C.PyBUF_C_CONTIGUOUS)
        if Utils.size_to_cstrides(info.itemsize, info.shape) != info.strides
            C.PyErr_SetString(C.POINTERS.PyExc_BufferError, "not C contiguous")
            return Cint(-1)
        end
    end
    if Utils.isflagset(flags, C.PyBUF_F_CONTIGUOUS)
        if Utils.size_to_fstrides(info.itemsize, info.shape) != info.strides
            C.PyErr_SetString(C.POINTERS.PyExc_BufferError, "not Fortran contiguous")
            return Cint(-1)
        end
    end
    if Utils.isflagset(flags, C.PyBUF_ANY_CONTIGUOUS)
        if Utils.size_to_cstrides(info.itemsize, info.shape) != info.strides &&
           Utils.size_to_fstrides(info.itemsize, info.shape) != info.strides
            C.PyErr_SetString(C.POINTERS.PyExc_BufferError, "not contiguous")
            return Cint(-1)
        end
    end

    # internal
    cptr = Base.pointer_from_objref(c)
    PYJLBUFCACHE[cptr] = c
    b.internal[] = cptr

    # obj
    C.Py_IncRef(obj)
    b.obj[] = obj
    Cint(0)
end

function _pyjl_get_buffer(o::C.PyPtr, buf::Ptr{C.Py_buffer}, flags::Cint)
    num_ = C.PyObject_GetAttrString(o, "_jl_buffer_info")
    num_ == C_NULL && (
        C.PyErr_Clear(); C.PyErr_SetString(C.POINTERS.PyExc_BufferError, "not a buffer"); return Cint(-1)
    )
    num = C.PyLong_AsLongLong(num_)
    C.Py_DecRef(num_)
    num == -1 && return Cint(-1)
    try
        f = PYJLMETHODS[num]
        x = PyJuliaValue_GetValue(o)
        return _pyjl_get_buffer_impl(o, buf, flags, x, f)::Cint
    catch exc
        @debug "error getting the buffer" exc
        C.PyErr_SetString(
            C.POINTERS.PyExc_BufferError,
            "some error occurred getting the buffer",
        )
        return Cint(-1)
    end
end

function _pyjl_release_buffer(xo::C.PyPtr, buf::Ptr{C.Py_buffer})
    delete!(PYJLBUFCACHE, UnsafePtr(buf).internal[!])
    nothing
end

function _pyjl_reduce(self::C.PyPtr, ::C.PyPtr)
    v = _pyjl_serialize(self, C.PyNULL)
    v == C.PyNULL && return C.PyNULL
    args = C.PyTuple_New(1)
    args == C.PyNULL && (C.Py_DecRef(v); return C.PyNULL)
    err = C.PyTuple_SetItem(args, 0, v)
    err == -1 && (C.Py_DecRef(args); return C.PyNULL)
    red = C.PyTuple_New(2)
    red == C.PyNULL && (C.Py_DecRef(args); return C.PyNULL)
    err = C.PyTuple_SetItem(red, 1, args)
    err == -1 && (C.Py_DecRef(red); return C.PyNULL)
    f = C.PyObject_GetAttrString(self, "_jl_deserialize")
    f == C.PyNULL && (C.Py_DecRef(red); return C.PyNULL)
    err = C.PyTuple_SetItem(red, 0, f)
    err == -1 && (C.Py_DecRef(red); return C.PyNULL)
    return red
end

function _pyjl_serialize(self::C.PyPtr, ::C.PyPtr)
    try
        io = IOBuffer()
        serialize(io, PyJuliaValue_GetValue(self))
        b = take!(io)
        return C.PyBytes_FromStringAndSize(pointer(b), sizeof(b))
    catch e
        C.PyErr_SetString(C.POINTERS.PyExc_Exception, "error serializing this value")
        # wrap sprint in another try-catch block to prevent this function from throwing
        try
            @debug "Caught exception $(sprint(showerror, e, catch_backtrace()))"
        catch
        end
        return C.PyNULL
    end
end

function _pyjl_deserialize(t::C.PyPtr, v::C.PyPtr)
    try
        ptr = Ref{Ptr{Cchar}}()
        len = Ref{C.Py_ssize_t}()
        err = C.PyBytes_AsStringAndSize(v, ptr, len)
        err == -1 && return C.PyNULL
        io = IOBuffer(unsafe_wrap(Array, Ptr{UInt8}(ptr[]), Int(len[])))
        x = deserialize(io)
        return PyJuliaValue_New(t, x)
    catch e
        C.PyErr_SetString(C.POINTERS.PyExc_Exception, "error deserializing this value")
        # wrap sprint in another try-catch block to prevent this function from throwing
        try
            @debug "Caught exception $(sprint(showerror, e, catch_backtrace()))"
        catch
        end
        return C.PyNULL
    end
end

const _pyjlbase_name = "juliacall.ValueBase"
const _pyjlbase_isnull_name = "_jl_isnull"
const _pyjlbase_callmethod_name = "_jl_callmethod"
const _pyjlbase_reduce_name = "__reduce__"
const _pyjlbase_serialize_name = "_jl_serialize"
const _pyjlbase_deserialize_name = "_jl_deserialize"
const _pyjlbase_weaklistoffset_name = "__weaklistoffset__"
const _pyjlbase_methods = Vector{C.PyMethodDef}()
const _pyjlbase_members = Vector{C.PyMemberDef}()
const _pyjlbase_slots = Vector{C.PyType_Slot}()
const _pyjlbase_spec = fill(C.PyType_Spec())

function init_c()
    empty!(_pyjlbase_methods)
    push!(
        _pyjlbase_methods,
        C.PyMethodDef(
            name = pointer(_pyjlbase_callmethod_name),
            meth = @cfunction(_pyjl_callmethod, C.PyPtr, (C.PyPtr, C.PyPtr)),
            flags = C.Py_METH_VARARGS,
        ),
        C.PyMethodDef(
            name = pointer(_pyjlbase_isnull_name),
            meth = @cfunction(_pyjl_isnull, C.PyPtr, (C.PyPtr, C.PyPtr)),
            flags = C.Py_METH_NOARGS,
        ),
        C.PyMethodDef(
            name = pointer(_pyjlbase_reduce_name),
            meth = @cfunction(_pyjl_reduce, C.PyPtr, (C.PyPtr, C.PyPtr)),
            flags = C.Py_METH_NOARGS,
        ),
        C.PyMethodDef(
            name = pointer(_pyjlbase_serialize_name),
            meth = @cfunction(_pyjl_serialize, C.PyPtr, (C.PyPtr, C.PyPtr)),
            flags = C.Py_METH_NOARGS,
        ),
        C.PyMethodDef(
            name = pointer(_pyjlbase_deserialize_name),
            meth = @cfunction(_pyjl_deserialize, C.PyPtr, (C.PyPtr, C.PyPtr)),
            flags = C.Py_METH_O | C.Py_METH_CLASS,
        ),
        C.PyMethodDef(),
    )
    
    # Create members for weakref support
    empty!(_pyjlbase_members)
    push!(
        _pyjlbase_members,
        C.PyMemberDef(
            name = pointer(_pyjlbase_weaklistoffset_name),
            typ = C.Py_T_PYSSIZET,
            offset = (C.@ft fieldoffset(PyJuliaValueObject, 3)),
            flags = C.Py_READONLY,
        ),
        C.PyMemberDef(), # NULL terminator
    )
    
    # Create slots for PyType_Spec
    empty!(_pyjlbase_slots)
    push!(
        _pyjlbase_slots,
        C.PyType_Slot(slot = C.Py_tp_new, pfunc = @cfunction(_pyjl_new, C.PyPtr, (C.PyPtr, C.PyPtr, C.PyPtr))),
        C.PyType_Slot(slot = C.Py_tp_dealloc, pfunc = @cfunction(_pyjl_dealloc, Cvoid, (C.PyPtr,))),
        C.PyType_Slot(slot = C.Py_tp_methods, pfunc = pointer(_pyjlbase_methods)),
        C.PyType_Slot(slot = C.Py_tp_members, pfunc = pointer(_pyjlbase_members)),
        C.PyType_Slot(slot = C.Py_bf_getbuffer, pfunc = @cfunction(_pyjl_get_buffer, Cint, (C.PyPtr, Ptr{C.Py_buffer}, Cint))),
        C.PyType_Slot(slot = C.Py_bf_releasebuffer, pfunc = @cfunction(_pyjl_release_buffer, Cvoid, (C.PyPtr, Ptr{C.Py_buffer}))),
        C.PyType_Slot(), # NULL terminator
    )
    
    # Create PyType_Spec
    _pyjlbase_spec[] = C.PyType_Spec(
        name = pointer(_pyjlbase_name),
        basicsize = (C.@ft sizeof(PyJuliaValueObject)),
        flags = C.Py_TPFLAGS_BASETYPE | C.Py_TPFLAGS_HAVE_VERSION_TAG,
        slots = pointer(_pyjlbase_slots),
    )
    
    # Create type using PyType_FromSpec
    o = PyJuliaBase_Type[] = C.PyType_FromSpec(pointer(_pyjlbase_spec))
    if o == C.PyNULL
        C.PyErr_Print()
        error("Error initializing 'juliacall.ValueBase'")
    end
end

function __init__()
    init_c()
end

PyJuliaValue_IsNull(o) = Base.GC.@preserve o (C.@ft UnsafePtr{PyJuliaValueObject}(C.asptr(o)).value[]) == 0

PyJuliaValue_GetValue(o) = Base.GC.@preserve o PYJLVALUES[(C.@ft UnsafePtr{PyJuliaValueObject}(C.asptr(o)).value[])]

PyJuliaValue_SetValue(_o, @nospecialize(v)) = Base.GC.@preserve _o begin
    o = C.asptr(_o)
    idx = C.@ft UnsafePtr{PyJuliaValueObject}(o).value[]
    if idx == 0
        lock(PYJL_LOCK)
        if PYJLFREEVALUECOUNT[] == 0
            # Grow both vectors together so length(PYJLFREEVALUES) == length(PYJLVALUES)
            # is preserved. The 0 in PYJLFREEVALUES is just a placeholder
            push!(PYJLVALUES, v)
            push!(PYJLFREEVALUES, 0)
            idx = length(PYJLVALUES)
        else
            idx = PYJLFREEVALUES[PYJLFREEVALUECOUNT[]]
            PYJLFREEVALUECOUNT[] -= 1
            PYJLVALUES[idx] = v
        end
        unlock(PYJL_LOCK)
        C.@ft UnsafePtr{PyJuliaValueObject}(o).value[] = idx
    else
        PYJLVALUES[idx] = v
    end
    nothing
end

PyJuliaValue_New(_t, @nospecialize(v)) = Base.GC.@preserve _t begin
    t = C.asptr(_t)
    if C.PyType_IsSubtype(t, PyJuliaBase_Type[]) != 1
        C.PyErr_SetString(
            C.POINTERS.PyExc_TypeError,
            "Expecting a subtype of 'juliacall.ValueBase'",
        )
        return C.PyNULL
    end
    o = C.PyObject_CallObject(t, C.PyNULL)
    o == C.PyNULL && return C.PyNULL
    PyJuliaValue_SetValue(o, v)
    return o
end

end

"""
    PythonDisplay()

Like TextDisplay() but prints to Python's stdout.
"""
struct PythonDisplay <: AbstractDisplay end

function Base.display(d::PythonDisplay, m::MIME, @nospecialize(x))
    istextmime(m) || throw(MethodError(display, (d, m, x)))
    buf = IOBuffer()
    io = IOContext(buf, :limit => true)
    try
        show(io, m, x)
    catch
        throw(MethodError(display, (d, m, x)))
    end
    data = String(take!(buf))
    pyprint(data)
    return
end

function Base.display(d::PythonDisplay, @nospecialize(x))
    display(d, MIME("text/plain"), x)
end

"""
    IPythonDisplay()

For displaying multimedia with IPython's display mechanism.
"""
struct IPythonDisplay <: AbstractDisplay end

function Base.display(d::IPythonDisplay, m::MIME, @nospecialize(x))
    ipy = pyimport("IPython")
    buf = IOBuffer()
    io = IOContext(buf, :limit => true)
    dict = pydict()
    try
        show(io, m, x)
    catch
        throw(MethodError(display, (d, m, x)))
    end
    data = take!(buf)
    dict[string(m)] = istextmime(m) ? pystr_fromUTF8(data) : pybytes(data)
    ipy.display.display(dict, raw = true)
    return
end

function Base.display(d::IPythonDisplay, @nospecialize(x))
    ipy = pyimport("IPython")
    if ispy(x)
        ipy.display.display(x)
        return
    end
    buf = IOBuffer()
    io = IOContext(buf, :limit => true)
    dict = pydict()
    for m in Utils.mimes_for(x)
        try
            show(io, MIME(m), x)
        catch
            continue
        end
        data = take!(buf)
        dict[m] = istextmime(m) ? pystr_fromUTF8(data) : pybytes(data)
    end
    length(dict) == 0 && throw(MethodError(display, (d, x)))
    ipy.display.display(dict, raw = true)
    return
end

@enum PyGILState_STATE::Cint PyGILState_LOCKED = 0 PyGILState_UNLOCKED = 1

const Py_single_input = 256
const Py_file_input = 257
const Py_eval_input = 258
const Py_func_type_input = 345

const Py_LT = Cint(0)
const Py_LE = Cint(1)
const Py_EQ = Cint(2)
const Py_NE = Cint(3)
const Py_GT = Cint(4)
const Py_GE = Cint(5)

const Py_METH_VARARGS = 0x0001 # args are a tuple of arguments
const Py_METH_KEYWORDS = 0x0002  # two arguments: the varargs and the kwargs
const Py_METH_NOARGS = 0x0004  # no arguments (NULL argument pointer)
const Py_METH_O = 0x0008       # single argument (not wrapped in tuple)
const Py_METH_CLASS = 0x0010 # for class methods
const Py_METH_STATIC = 0x0020 # for static methods

const Py_T_SHORT = 0
const Py_T_INT = 1
const Py_T_LONG = 2
const Py_T_FLOAT = 3
const Py_T_DOUBLE = 4
const Py_T_STRING = 5
const Py_T_OBJECT = 6
const Py_T_CHAR = 7
const Py_T_BYTE = 8
const Py_T_UBYTE = 9
const Py_T_USHORT = 10
const Py_T_UINT = 11
const Py_T_ULONG = 12
const Py_T_STRING_INPLACE = 13
const Py_T_BOOL = 14
const Py_T_OBJECT_EX = 16
const Py_T_LONGLONG = 17 # added in Python 2.5
const Py_T_ULONGLONG = 18 # added in Python 2.5
const Py_T_PYSSIZET = 19 # added in Python 2.6
const Py_T_NONE = 20 # added in Python 3.0

const Py_READONLY = 1
const Py_READ_RESTRICTED = 2
const Py_WRITE_RESTRICTED = 4
const Py_RESTRICTED = (Py_READ_RESTRICTED | Py_WRITE_RESTRICTED)

const PyBUF_MAX_NDIM = 64

# Flags for getting buffers
const PyBUF_SIMPLE = 0x0
const PyBUF_WRITABLE = 0x0001
const PyBUF_WRITEABLE = PyBUF_WRITABLE
const PyBUF_FORMAT = 0x0004
const PyBUF_ND = 0x0008
const PyBUF_STRIDES = (0x0010 | PyBUF_ND)
const PyBUF_C_CONTIGUOUS = (0x0020 | PyBUF_STRIDES)
const PyBUF_F_CONTIGUOUS = (0x0040 | PyBUF_STRIDES)
const PyBUF_ANY_CONTIGUOUS = (0x0080 | PyBUF_STRIDES)
const PyBUF_INDIRECT = (0x0100 | PyBUF_STRIDES)

const PyBUF_CONTIG = (PyBUF_ND | PyBUF_WRITABLE)
const PyBUF_CONTIG_RO = (PyBUF_ND)

const PyBUF_STRIDED = (PyBUF_STRIDES | PyBUF_WRITABLE)
const PyBUF_STRIDED_RO = (PyBUF_STRIDES)

const PyBUF_RECORDS = (PyBUF_STRIDES | PyBUF_WRITABLE | PyBUF_FORMAT)
const PyBUF_RECORDS_RO = (PyBUF_STRIDES | PyBUF_FORMAT)

const PyBUF_FULL = (PyBUF_INDIRECT | PyBUF_WRITABLE | PyBUF_FORMAT)
const PyBUF_FULL_RO = (PyBUF_INDIRECT | PyBUF_FORMAT)

const PyBUF_READ = 0x100
const PyBUF_WRITE = 0x200

# Python 2.7
const Py_TPFLAGS_HAVE_GETCHARBUFFER = (0x00000001 << 0)
const Py_TPFLAGS_HAVE_SEQUENCE_IN = (0x00000001 << 1)
const Py_TPFLAGS_GC = 0 # was sometimes (0x00000001<<2) in Python <= 2.1
const Py_TPFLAGS_HAVE_INPLACEOPS = (0x00000001 << 3)
const Py_TPFLAGS_CHECKTYPES = (0x00000001 << 4)
const Py_TPFLAGS_HAVE_RICHCOMPARE = (0x00000001 << 5)
const Py_TPFLAGS_HAVE_WEAKREFS = (0x00000001 << 6)
const Py_TPFLAGS_HAVE_ITER = (0x00000001 << 7)
const Py_TPFLAGS_HAVE_CLASS = (0x00000001 << 8)
const Py_TPFLAGS_HAVE_INDEX = (0x00000001 << 17)
const Py_TPFLAGS_HAVE_NEWBUFFER = (0x00000001 << 21)
const Py_TPFLAGS_STRING_SUBCLASS = (0x00000001 << 27)

# Python 3.0+ has only these:
const Py_TPFLAGS_HEAPTYPE = (0x00000001 << 9)
const Py_TPFLAGS_BASETYPE = (0x00000001 << 10)
const Py_TPFLAGS_READY = (0x00000001 << 12)
const Py_TPFLAGS_READYING = (0x00000001 << 13)
const Py_TPFLAGS_HAVE_GC = (0x00000001 << 14)
const Py_TPFLAGS_HAVE_VERSION_TAG = (0x00000001 << 18)
const Py_TPFLAGS_VALID_VERSION_TAG = (0x00000001 << 19)
const Py_TPFLAGS_IS_ABSTRACT = (0x00000001 << 20)
const Py_TPFLAGS_INT_SUBCLASS = (0x00000001 << 23)
const Py_TPFLAGS_LONG_SUBCLASS = (0x00000001 << 24)
const Py_TPFLAGS_LIST_SUBCLASS = (0x00000001 << 25)
const Py_TPFLAGS_TUPLE_SUBCLASS = (0x00000001 << 26)
const Py_TPFLAGS_BYTES_SUBCLASS = (0x00000001 << 27)
const Py_TPFLAGS_UNICODE_SUBCLASS = (0x00000001 << 28)
const Py_TPFLAGS_DICT_SUBCLASS = (0x00000001 << 29)
const Py_TPFLAGS_BASE_EXC_SUBCLASS = (0x00000001 << 30)
const Py_TPFLAGS_TYPE_SUBCLASS = (0x00000001 << 31)

# only use this if we have the stackless extension
const Py_TPFLAGS_HAVE_STACKLESS_EXTENSION = (0x00000003 << 15)

const Py_hash_t = Cssize_t
const Py_ssize_t = Cssize_t

@kwdef struct Py_complex
    real::Cdouble = 0.0
    imag::Cdouble = 0.0
end

@kwdef struct PyObject
    # assumes _PyObject_HEAD_EXTRA is empty
    refcnt::Py_ssize_t = 0
    type::Ptr{Cvoid} = C_NULL # really is Ptr{PyObject} or Ptr{PyTypeObject} but Julia 1.3 and below get the layout incorrect when circular types are involved
end

@kwdef struct PyMutex
    bits::Cuchar = 0
end

@kwdef struct PyObjectFT
    tid::Csize_t = 0
    flags::Cushort = 0
    mutex::PyMutex = PyMutex()
    gc_bits::Cuchar = 0
    ref_local::Cuint = 0
    ref_shared::Py_ssize_t = 0
    type::Ptr{Cvoid} = C_NULL # really is Ptr{PyObject} or Ptr{PyTypeObject} but Julia 1.3 and below get the layout incorrect when circular types are involved
end

const PyPtr = Ptr{PyObject}
const PyNULL = PyPtr(0)

struct PyObjectRef
    ptr::PyPtr
end
ispyreftype(::Type{PyObjectRef}) = true
pyptr(o::PyObjectRef) = o.ptr
Base.unsafe_convert(::Type{PyPtr}, o::PyObjectRef) = o.ptr

@kwdef struct PyVarObject
    ob_base::PyObject = PyObject()
    size::Py_ssize_t = 0
end

@kwdef struct PyVarObjectFT
    ob_base::PyObjectFT = PyObjectFT()
    size::Py_ssize_t = 0
end

@kwdef struct PyMethodDef
    name::Cstring = C_NULL
    meth::Ptr{Cvoid} = C_NULL
    flags::Cint = 0
    doc::Cstring = C_NULL
end

@kwdef struct PyGetSetDef
    name::Cstring = C_NULL
    get::Ptr{Cvoid} = C_NULL
    set::Ptr{Cvoid} = C_NULL
    doc::Cstring = C_NULL
    closure::Ptr{Cvoid} = C_NULL
end

@kwdef struct PyMemberDef
    name::Cstring = C_NULL
    typ::Cint = 0
    offset::Py_ssize_t = 0
    flags::Cint = 0
    doc::Cstring = C_NULL
end

@kwdef struct PyNumberMethods
    add::Ptr{Cvoid} = C_NULL # (o,o)->o
    subtract::Ptr{Cvoid} = C_NULL # (o,o)->o
    multiply::Ptr{Cvoid} = C_NULL # (o,o)->o
    remainder::Ptr{Cvoid} = C_NULL # (o,o)->o
    divmod::Ptr{Cvoid} = C_NULL # (o,o)->o
    power::Ptr{Cvoid} = C_NULL # (o,o,o)->o
    negative::Ptr{Cvoid} = C_NULL # (o)->o
    positive::Ptr{Cvoid} = C_NULL # (o)->o
    absolute::Ptr{Cvoid} = C_NULL # (o)->o
    bool::Ptr{Cvoid} = C_NULL # (o)->Cint
    invert::Ptr{Cvoid} = C_NULL # (o)->o
    lshift::Ptr{Cvoid} = C_NULL # (o,o)->o
    rshift::Ptr{Cvoid} = C_NULL # (o,o)->o
    and::Ptr{Cvoid} = C_NULL # (o,o)->o
    xor::Ptr{Cvoid} = C_NULL # (o,o)->o
    or::Ptr{Cvoid} = C_NULL # (o,o)->o
    int::Ptr{Cvoid} = C_NULL # (o)->o
    _reserved::Ptr{Cvoid} = C_NULL
    float::Ptr{Cvoid} = C_NULL # (o)->o
    inplace_add::Ptr{Cvoid} = C_NULL # (o,o)->o
    inplace_subtract::Ptr{Cvoid} = C_NULL # (o,o)->o
    inplace_multiply::Ptr{Cvoid} = C_NULL # (o,o)->o
    inplace_remainder::Ptr{Cvoid} = C_NULL # (o,o)->o
    inplace_power::Ptr{Cvoid} = C_NULL # (o,o,o)->o
    inplace_lshift::Ptr{Cvoid} = C_NULL # (o,o)->o
    inplace_rshift::Ptr{Cvoid} = C_NULL # (o,o)->o
    inplace_and::Ptr{Cvoid} = C_NULL # (o,o)->o
    inplace_xor::Ptr{Cvoid} = C_NULL # (o,o)->o
    inplace_or::Ptr{Cvoid} = C_NULL # (o,o)->o
    floordivide::Ptr{Cvoid} = C_NULL # (o,o)->o
    truedivide::Ptr{Cvoid} = C_NULL # (o,o)->o
    inplace_floordivide::Ptr{Cvoid} = C_NULL # (o,o)->o
    inplace_truedivide::Ptr{Cvoid} = C_NULL # (o,o)->o
    index::Ptr{Cvoid} = C_NULL # (o)->o
    matrixmultiply::Ptr{Cvoid} = C_NULL # (o,o)->o
    inplace_matrixmultiply::Ptr{Cvoid} = C_NULL # (o,o)->o
end

@kwdef struct PySequenceMethods
    length::Ptr{Cvoid} = C_NULL # (o)->Py_ssize_t
    concat::Ptr{Cvoid} = C_NULL # (o,o)->o
    repeat::Ptr{Cvoid} = C_NULL # (o,Py_ssize_t)->o
    item::Ptr{Cvoid} = C_NULL # (o,Py_ssize_t)->o
    _was_item::Ptr{Cvoid} = C_NULL
    ass_item::Ptr{Cvoid} = C_NULL # (o,Py_ssize_t,o)->Cint
    _was_ass_slice::Ptr{Cvoid} = C_NULL
    contains::Ptr{Cvoid} = C_NULL # (o,o)->Cint
    inplace_concat::Ptr{Cvoid} = C_NULL # (o,o)->o
    inplace_repeat::Ptr{Cvoid} = C_NULL # (o,Py_ssize_t)->o
end

@kwdef struct PyMappingMethods
    length::Ptr{Cvoid} = C_NULL # (o)->Py_ssize_t
    subscript::Ptr{Cvoid} = C_NULL # (o,o)->o
    ass_subscript::Ptr{Cvoid} = C_NULL # (o,o,o)->Cint
end

@kwdef struct PyBufferProcs
    get::Ptr{Cvoid} = C_NULL # (o, Ptr{Py_buffer}, Cint) -> Cint
    release::Ptr{Cvoid} = C_NULL # (o, Ptr{Py_buffer}) -> Cvoid
end

@kwdef struct Py_buffer
    buf::Ptr{Cvoid} = C_NULL
    obj::Ptr{Cvoid} = C_NULL
    len::Py_ssize_t = 0
    itemsize::Py_ssize_t = 0
    readonly::Cint = 0
    ndim::Cint = 0
    format::Cstring = C_NULL
    shape::Ptr{Py_ssize_t} = C_NULL
    strides::Ptr{Py_ssize_t} = C_NULL
    suboffsets::Ptr{Py_ssize_t} = C_NULL
    internal::Ptr{Cvoid} = C_NULL
end

@kwdef struct PyMemoryViewObject
    ob_base::PyVarObject = PyVarObject()
    mbuf::PyPtr = PyNULL
    hash::Py_hash_t = 0
    flags::Cint = 0
    exports::Py_ssize_t = 0
    view::Py_buffer = Py_buffer()
    weakreflist::PyPtr = PyNULL
end

@kwdef struct PyMemoryViewObjectFT
    ob_base::PyVarObjectFT = PyVarObjectFT()
    mbuf::PyPtr = PyNULL
    hash::Py_hash_t = 0
    flags::Cint = 0
    exports::Py_ssize_t = 0
    view::Py_buffer = Py_buffer()
    weakreflist::PyPtr = PyNULL
end

@kwdef struct PyTypeObject
    ob_base::PyVarObject = PyVarObject()
    name::Cstring = C_NULL

    basicsize::Py_ssize_t = 0
    itemsize::Py_ssize_t = 0

    dealloc::Ptr{Cvoid} = C_NULL
    vectorcall_offset::Py_ssize_t = 0
    getattr::Ptr{Cvoid} = C_NULL
    setattr::Ptr{Cvoid} = C_NULL
    as_async::Ptr{Cvoid} = C_NULL
    repr::Ptr{Cvoid} = C_NULL

    as_number::Ptr{PyNumberMethods} = C_NULL
    as_sequence::Ptr{PySequenceMethods} = C_NULL
    as_mapping::Ptr{PyMappingMethods} = C_NULL

    hash::Ptr{Cvoid} = C_NULL
    call::Ptr{Cvoid} = C_NULL
    str::Ptr{Cvoid} = C_NULL
    getattro::Ptr{Cvoid} = C_NULL
    setattro::Ptr{Cvoid} = C_NULL

    as_buffer::Ptr{PyBufferProcs} = C_NULL

    flags::Culong = 0

    doc::Cstring = C_NULL

    traverse::Ptr{Cvoid} = C_NULL

    clear::Ptr{Cvoid} = C_NULL

    richcompare::Ptr{Cvoid} = C_NULL

    weaklistoffset::Py_ssize_t = 0

    iter::Ptr{Cvoid} = C_NULL
    iternext::Ptr{Cvoid} = C_NULL

    methods::Ptr{PyMethodDef} = C_NULL
    members::Ptr{PyMemberDef} = C_NULL
    getset::Ptr{PyGetSetDef} = C_NULL
    base::PyPtr = C_NULL
    dict::PyPtr = C_NULL
    descr_get::Ptr{Cvoid} = C_NULL
    descr_set::Ptr{Cvoid} = C_NULL
    dictoffset::Py_ssize_t = 0
    init::Ptr{Cvoid} = C_NULL
    alloc::Ptr{Cvoid} = C_NULL
    new::Ptr{Cvoid} = C_NULL
    free::Ptr{Cvoid} = C_NULL
    is_gc::Ptr{Cvoid} = C_NULL
    bases::PyPtr = C_NULL
    mro::PyPtr = C_NULL
    cache::PyPtr = C_NULL
    subclasses::PyPtr = C_NULL
    weaklist::PyPtr = C_NULL
    del::Ptr{Cvoid} = C_NULL

    version_tag::Cuint = 0

    finalize::Ptr{Cvoid} = C_NULL
    vectorcall::Ptr{Cvoid} = C_NULL

    # Python 3.12+ fields
    watched::Cuchar = 0
    
    # Python 3.13+ fields  
    versions_used::UInt16 = 0
end

@kwdef struct PySimpleObject{T}
    ob_base::PyObject = PyObject()
    value::T
end

@kwdef struct PySimpleObjectFT{T}
    ob_base::PyObjectFT = PyObjectFT()
    value::T
end

@kwdef struct PyArrayInterface
    two::Cint = 0
    nd::Cint = 0
    typekind::Cchar = 0
    itemsize::Cint = 0
    flags::Cint = 0
    shape::Ptr{Cssize_t} = C_NULL
    strides::Ptr{Cssize_t} = C_NULL
    data::Ptr{Cvoid} = C_NULL
    descr::PyPtr = C_NULL
end

const NPY_ARRAY_C_CONTIGUOUS = 0x0001
const NPY_ARRAY_F_CONTIGUOUS = 0x0002
const NPY_ARRAY_ALIGNED = 0x0100
const NPY_ARRAY_NOTSWAPPED = 0x0200
const NPY_ARRAY_WRITEABLE = 0x0400
const NPY_ARR_HAS_DESCR = 0x0800

# Python type slot constants
# From https://github.com/python/cpython/blob/main/Include/typeslots.h
const Py_bf_getbuffer = Cint(1)
const Py_bf_releasebuffer = Cint(2)
const Py_mp_ass_subscript = Cint(3)
const Py_mp_length = Cint(4)
const Py_mp_subscript = Cint(5)
const Py_nb_absolute = Cint(6)
const Py_nb_add = Cint(7)
const Py_nb_and = Cint(8)
const Py_nb_bool = Cint(9)
const Py_nb_divmod = Cint(10)
const Py_nb_float = Cint(11)
const Py_nb_floor_divide = Cint(12)
const Py_nb_index = Cint(13)
const Py_nb_inplace_add = Cint(14)
const Py_nb_inplace_and = Cint(15)
const Py_nb_inplace_floor_divide = Cint(16)
const Py_nb_inplace_lshift = Cint(17)
const Py_nb_inplace_multiply = Cint(18)
const Py_nb_inplace_or = Cint(19)
const Py_nb_inplace_power = Cint(20)
const Py_nb_inplace_remainder = Cint(21)
const Py_nb_inplace_rshift = Cint(22)
const Py_nb_inplace_subtract = Cint(23)
const Py_nb_inplace_true_divide = Cint(24)
const Py_nb_inplace_xor = Cint(25)
const Py_nb_int = Cint(26)
const Py_nb_invert = Cint(27)
const Py_nb_lshift = Cint(28)
const Py_nb_multiply = Cint(29)
const Py_nb_negative = Cint(30)
const Py_nb_or = Cint(31)
const Py_nb_positive = Cint(32)
const Py_nb_power = Cint(33)
const Py_nb_remainder = Cint(34)
const Py_nb_rshift = Cint(35)
const Py_nb_subtract = Cint(36)
const Py_nb_true_divide = Cint(37)
const Py_nb_xor = Cint(38)
const Py_sq_ass_item = Cint(39)
const Py_sq_concat = Cint(40)
const Py_sq_contains = Cint(41)
const Py_sq_inplace_concat = Cint(42)
const Py_sq_inplace_repeat = Cint(43)
const Py_sq_item = Cint(44)
const Py_sq_length = Cint(45)
const Py_sq_repeat = Cint(46)
const Py_tp_alloc = Cint(47)
const Py_tp_base = Cint(48)
const Py_tp_bases = Cint(49)
const Py_tp_call = Cint(50)
const Py_tp_clear = Cint(51)
const Py_tp_dealloc = Cint(52)
const Py_tp_del = Cint(53)
const Py_tp_descr_get = Cint(54)
const Py_tp_descr_set = Cint(55)
const Py_tp_doc = Cint(56)
const Py_tp_getattr = Cint(57)
const Py_tp_getattro = Cint(58)
const Py_tp_hash = Cint(59)
const Py_tp_init = Cint(60)
const Py_tp_is_gc = Cint(61)
const Py_tp_iter = Cint(62)
const Py_tp_iternext = Cint(63)
const Py_tp_methods = Cint(64)
const Py_tp_new = Cint(65)
const Py_tp_repr = Cint(66)
const Py_tp_richcompare = Cint(67)
const Py_tp_setattr = Cint(68)
const Py_tp_setattro = Cint(69)
const Py_tp_str = Cint(70)
const Py_tp_traverse = Cint(71)
const Py_tp_members = Cint(72)
const Py_tp_getset = Cint(73)
const Py_tp_free = Cint(74)
const Py_nb_matrix_multiply = Cint(75)
const Py_nb_inplace_matrix_multiply = Cint(76)
const Py_am_await = Cint(77)
const Py_am_aiter = Cint(78)
const Py_am_anext = Cint(79)
const Py_tp_finalize = Cint(80)
const Py_am_send = Cint(81)
const Py_tp_vectorcall = Cint(82)
const Py_tp_token = Cint(83)

# PyType_Spec and PyType_Slot structs
# From https://docs.python.org/3/c-api/type.html#c.PyType_Spec
@kwdef struct PyType_Slot
    slot::Cint = 0
    pfunc::Ptr{Cvoid} = C_NULL
end

@kwdef struct PyType_Spec
    name::Cstring = C_NULL
    basicsize::Cint = 0
    itemsize::Cint = 0
    flags::Cuint = 0
    slots::Ptr{PyType_Slot} = C_NULL
end

pyio_finalize!(io::PyIO) = begin
    C.CTX.is_initialized || return
    io.own ? close(io) : flush(io)
    return
end

ispy(io::PyIO) = true
Py(io::PyIO) = io.py

pyconvert_rule_io(::Type{PyIO}, x::Py) = pyconvert_return(PyIO(x))

"""
    PyIO(f, x; ...)

Equivalent to `f(PyIO(x; ...))` except the stream is automatically flushed or closed according to `own`.

For use in a `do` block, as in
```
PyIO(x, ...) do io
    ...
end
```
"""
function PyIO(f::Function, o; opts...)
    io = PyIO(o; opts...)
    try
        return f(io)
    finally
        pydel!(io.py)
    end
end

# If obuf is non-empty, write it to the underlying stream.
function putobuf(io::PyIO)
    if !isempty(io.obuf)
        if io.text
            # Check if there is a partial character at the end of obuf and if so then
            # do not write it.
            # get the last character
            nskip = 0
            n = length(io.obuf)
            c = io.obuf[end]
            if (c & 0xC0) == 0xC0
                # 11xxxxxx => buffer ends in a multi-byte char
                nskip = 1
            elseif ((c & 0xC0) == 0x80) && (n > 1)
                # 10xxxxxx => continuation char
                # get the second to last character
                c = io.obuf[end-1]
                if (c & 0xE0) == 0xE0
                    # 111xxxxx => buffer ends in a 3- or 4-byte char
                    nskip = 2
                elseif ((c & 0xC0) == 0x80) && (n > 2)
                    # 10xxxxxx => continuation char
                    # get the third to last character
                    c = io.obuf[end-2]
                    if (c & 0xF0) == 0xF0
                        # 1111xxxx => buffer ends in a 4-byte char
                        nskip = 3
                    end
                end
            end
            if nskip == 0
                data = pystr_fromUTF8(io.obuf)
            else
                data = pystr_fromUTF8(view(io.obuf, 1:(n-nskip)))
            end
            pydel!(@py io.write(data))
            pydel!(data)
            if nskip == 0
                empty!(io.obuf)
            else
                deleteat!(io.obuf, 1:(n-nskip))
            end
        else
            data = pybytes(io.obuf)
            pydel!(@py io.write(data))
            pydel!(data)
            empty!(io.obuf)
        end
    end
    return
end

# If ibuf is empty, read some more from the underlying stream.
# After this call, if ibuf is empty then we are at EOF.
# TODO: in binary mode, `io.readinto()` to avoid copying data
function getibuf(io::PyIO)
    if isempty(io.ibuf)
        data = @py io.read(@jl io.ibuflen)
        if io.text
            append!(io.ibuf, pystr_asUTF8vector(data))
        else
            append!(io.ibuf, pybytes_asvector(data))
        end
        pydel!(data)
    end
    return
end

function Base.flush(io::PyIO)
    putobuf(io)
    pydel!(@py io.flush())
    return
end

function Base.close(io::PyIO)
    flush(io)
    pydel!(@py io.close())
    return
end

function Base.eof(io::PyIO)
    if io.eof
        true
    elseif !isempty(io.ibuf)
        false
    else
        getibuf(io)
        io.eof = isempty(io.ibuf)
    end
end

Base.fd(io::PyIO) = pyconvert(Int, @py io.fileno())

Base.isreadable(io::PyIO) = pyconvert(Bool, @py io.readable())

Base.iswritable(io::PyIO) = pyconvert(Bool, @py io.writable())

Base.isopen(io::PyIO) = !pyconvert(Bool, @py io.closed)

function Base.unsafe_write(io::PyIO, ptr::Ptr{UInt8}, n::UInt)
    ntodo = n
    while ntodo > 0
        nroom = max(0, io.obuflen - length(io.obuf))
        if ntodo < nroom
            buf = unsafe_wrap(Array, ptr, ntodo)
            if io.line_buffering
                i = findlast(∈((0x0A, 0x0D)), buf)
                if i === nothing
                    append!(io.obuf, buf)
                else
                    append!(io.obuf, unsafe_wrap(Array, ptr, i))
                    putobuf(io)
                    append!(io.obuf, unsafe_wrap(Array, ptr + i, ntodo - i))
                end
            else
                append!(io.obuf, buf)
            end
            break
        else
            buf = unsafe_wrap(Array, ptr, nroom)
            append!(io.obuf, buf)
            putobuf(io)
            ptr += nroom
            ntodo -= nroom
        end
    end
    return n
end

function Base.write(io::PyIO, c::UInt8)
    push!(io.obuf, c)
    if (length(io.obuf) ≥ io.obuflen) || (io.line_buffering && (c == 0x0A || c == 0x0D))
        putobuf(io)
    end
    return
end

function Base.unsafe_read(io::PyIO, ptr::Ptr{UInt8}, n::UInt)
    ntodo = n
    while true
        navail = length(io.ibuf)
        if ntodo ≤ navail
            unsafe_wrap(Array, ptr, ntodo) .= splice!(io.ibuf, 1:ntodo)
            return
        else
            unsafe_wrap(Array, ptr, navail) .= io.ibuf
            ptr += navail
            ntodo -= navail
            empty!(io.ibuf)
            eof(io) && throw(EOFError())
        end
    end
    return
end

function Base.read(io::PyIO, ::Type{UInt8})
    eof(io) && throw(EOFError())
    popfirst!(io.ibuf)
end

function Base.seek(io::PyIO, pos::Integer)
    putobuf(io)
    empty!(io.ibuf)
    io.eof = false
    pydel!(@py io.seek(pos))
    return io
end

function Base.truncate(io::PyIO, pos::Integer)
    seek(io, position(io))
    pydel!(@py io.truncate(pos))
    return io
end

function Base.seekstart(io::PyIO)
    putobuf(io)
    empty!(io.ibuf)
    io.eof = false
    pydel!(@py io.seek(0))
    return io
end

function Base.seekend(io::PyIO)
    putobuf(io)
    empty!(io.ibuf)
    io.eof = false
    pydel!(@py io.seek(0, 2))
    return io
end

function Base.skip(io::PyIO, n::Integer)
    putobuf(io)
    if io.text
        if n ≥ 0
            read(io, n)
        else
            error("`skip(io, n)` for text PyIO streams only implemented for positive `n`")
        end
    else
        if 0 ≤ n ≤ io.ibuflen
            read(io, n)
        else
            pydel!(@py io.seek(@jl(n - length(io.ibuf)), 1))
            empty!(io.ibuf)
            io.eof = false
        end
    end
    return io
end

function Base.position(io::PyIO)
    putobuf(io)
    if io.text
        if isempty(io.ibuf)
            return pyconvert(Int, @py io.tell())
        else
            error(
                "`position(io)` text PyIO streams only implemented for empty input buffer (e.g. do `read(io, length(io.ibuf))` first)",
            )
        end
    else
        return pyconvert(Int, @py io.tell()) - length(io.ibuf)
    end
end

const pyjlanytype = pynew()

# pyjlany_repr(self) = Py("<jl $(repr(self))>")
function pyjlany_repr(self)
    str = repr(
        MIME("text/plain"),
        self;
        context = IOContext(devnull, :limit => true, :displaysize => (23, 80)),
    )
    # type = self isa Function ? "Function" : self isa Type ? "Type" : nameof(typeof(self))
    sep = '\n' in str ? '\n' : ' '
    Py("Julia:$sep$str")
end

# Note: string(self) doesn't always return a String
pyjlany_str(self) = Py(sprint(print, self))

function pyjlany_getattr(self, k_::Py)
    k = Symbol(pyjl_attr_py2jl(pyconvert(String, k_)))
    pydel!(k_)
    Py(getproperty(self, k))
end
pyjl_handle_error_type(::typeof(pyjlany_getattr), self, exc) = pybuiltins.AttributeError

function pyjlany_setattr(self, k_::Py, v_::Py)
    k = Symbol(pyjl_attr_py2jl(pyconvert(String, k_)))
    pydel!(k_)
    v = pyconvert(Any, v_)
    if self isa Module && !isdefined(self, k)
        # Fix for https://github.com/JuliaLang/julia/pull/54678
        @eval self (global $k = $v)
    else
        setproperty!(self, k, v)
    end
    Py(nothing)
end
pyjl_handle_error_type(::typeof(pyjlany_setattr), self, exc) = pybuiltins.AttributeError

pyjlany_dir(self) = pylist(pyjl_attr_jl2py(string(k)) for k in propertynames(self, true))

function pyjlany_call(self, args_::Py, kwargs_::Py)
    if pylen(kwargs_) > 0
        args = pyconvert(Vector{Any}, args_)
        kwargs = pyconvert(Dict{Symbol,Any}, kwargs_)
        ans = Py(self(args...; kwargs...))
    elseif pylen(args_) > 0
        args = pyconvert(Vector{Any}, args_)
        ans = Py(self(args...))
    else
        ans = Py(self())
    end
    pydel!(args_)
    pydel!(kwargs_)
    ans
end
pyjl_handle_error_type(::typeof(pyjlany_call), self, exc) =
    exc isa MethodError && exc.f === self ? pybuiltins.TypeError : PyNULL

function pyjlany_call_nogil(self, args_::Py, kwargs_::Py)
    if pylen(kwargs_) > 0
        args = pyconvert(Vector{Any}, args_)
        kwargs = pyconvert(Dict{Symbol,Any}, kwargs_)
        ans = Py(GIL.@unlock self(args...; kwargs...))
    elseif pylen(args_) > 0
        args = pyconvert(Vector{Any}, args_)
        ans = Py(GIL.@unlock self(args...))
    else
        ans = Py(GIL.@unlock self())
    end
    pydel!(args_)
    pydel!(kwargs_)
    ans
end
pyjl_handle_error_type(::typeof(pyjlany_call_nogil), self, exc) =
    exc isa MethodError && exc.f === self ? pybuiltins.TypeError : PyNULL

function pyjlany_getitem(self, k_::Py)
    if pyistuple(k_)
        k = pyconvert(Vector{Any}, k_)
        pydel!(k_)
        Py(self[k...])
    else
        k = pyconvert(Any, k_)
        Py(self[k])
    end
end
pyjl_handle_error_type(::typeof(pyjlany_getitem), self, exc) =
    exc isa BoundsError ? pybuiltins.IndexError :
    exc isa KeyError ? pybuiltins.KeyError : PyNULL

function pyjlany_setitem(self, k_::Py, v_::Py)
    v = pyconvert(Any, v_)
    if pyistuple(k_)
        k = pyconvert(Vector{Any}, k_)
        pydel!(k_)
        self[k...] = v
    else
        k = pyconvert(Any, k_)
        self[k] = v
    end
    Py(nothing)
end
pyjl_handle_error_type(::typeof(pyjlany_setitem), self, exc) =
    exc isa BoundsError ? pybuiltins.IndexError :
    exc isa KeyError ? pybuiltins.KeyError : PyNULL

function pyjlany_delitem(self, k_::Py)
    if pyistuple(k_)
        k = pyconvert(Vector{Any}, k_)
        pydel!(k_)
        delete!(self, k...)
    else
        k = pyconvert(Any, k_)
        delete!(self, k)
    end
    Py(nothing)
end
pyjl_handle_error_type(::typeof(pyjlany_delitem), self, exc) =
    exc isa BoundsError ? pybuiltins.IndexError :
    exc isa KeyError ? pybuiltins.KeyError : PyNULL

pyjlany_contains(self, v::Py) = Py(@pyconvert(eltype(self), v, return Py(false)) in self)
pyjl_handle_error_type(::typeof(pyjlany_contains), self, exc) =
    exc isa MethodError && exc.f === in ? pybuiltins.TypeError : PyNULL

struct pyjlany_op{OP}
    op::OP
end
(op::pyjlany_op)(self) = Py(op.op(self))
function (op::pyjlany_op)(self, other_::Py)
    if pyisjl(other_)
        other = pyjlvalue(other_)
        pydel!(other_)
        Py(op.op(self, other))
    else
        pybuiltins.NotImplemented
    end
end
function (op::pyjlany_op)(self, other_::Py, other2_::Py)
    if pyisjl(other_) && pyisjl(other2_)
        other = pyjlvalue(other_)
        other2 = pyjlvalue(other2_)
        pydel!(other_)
        pydel!(other2_)
        Py(op.op(self, other, other2))
    else
        pybuiltins.NotImplemented
    end
end
pyjl_handle_error_type(op::pyjlany_op, self, exc) =
    exc isa MethodError && exc.f === op.op ? pybuiltins.TypeError : PyNULL

struct pyjlany_rev_op{OP}
    op::OP
end
function (op::pyjlany_rev_op)(self, other_::Py)
    if pyisjl(other_)
        other = pyjlvalue(other_)
        pydel!(other_)
        Py(op.op(other, self))
    else
        pybuiltins.NotImplemented
    end
end
function (op::pyjlany_rev_op)(self, other_::Py, other2_::Py)
    if pyisjl(other_) && pyisjl(other2_)
        other = pyjlvalue(other_)
        other2 = pyjlvalue(other2_)
        pydel!(other_)
        pydel!(other2_)
        Py(op.op(other, self, other2))
    else
        pybuiltins.NotImplemented
    end
end
pyjl_handle_error_type(op::pyjlany_rev_op, self, exc) =
    exc isa MethodError && exc.f === op.op ? pybuiltins.TypeError : PyNULL

pyjlany_name(self) = Py(string(nameof(self)))
pyjl_handle_error_type(::typeof(pyjlany_name), self, exc) =
    exc isa MethodError && exc.f === nameof ? pybuiltins.AttributeError : PyNULL

function pyjlany_display(self, mime_::Py)
    mime = pyconvertarg(Union{Nothing,String}, mime_, "mime")
    x = Utils.ExtraNewline(self)
    if mime === nothing
        display(x)
    else
        display(mime, x)
    end
    Py(nothing)
end

function pyjlany_help(self, mime_::Py)
    mime = pyconvertarg(Union{Nothing,String}, mime_, "mime")
    doc = Docs.getdoc(self)
    if doc === nothing
        doc = Docs.doc(self)
    end
    x = Utils.ExtraNewline(doc)
    if mime === nothing
        display(x)
    else
        display(mime, x)
    end
    Py(nothing)
end

function pyjlany_mimebundle(self, include::Py, exclude::Py)
    # TODO: use include/exclude
    mimes = Utils.mimes_for(self)
    # make the bundle
    ans = pydict()
    for m in mimes
        try
            io = IOBuffer()
            show(IOContext(io, :limit => true), MIME(m), self)
            v = take!(io)
            ans[m] = vo = istextmime(m) ? pystr(String(v)) : pybytes(v)
            pydel!(vo)
        catch err
            # silently skip anything that didn't work
        end
    end
    return ans
end

function init_any()
    jl = pyjuliacallmodule
    pybuiltins.exec(
        pybuiltins.compile(
            """
$("\n"^(@__LINE__()-1))
class AnyValue(ValueBase):
    __slots__ = ()
    def __repr__(self):
        if self._jl_isnull():
            return "<jl NULL>"
        else:
            return self._jl_callmethod($(pyjl_methodnum(pyjlany_repr)))
    def __str__(self):
        if self._jl_isnull():
            return "NULL"
        else:
            return self._jl_callmethod($(pyjl_methodnum(pyjlany_str)))
    def __getattr__(self, k):
        if k.startswith("__") and k.endswith("__"):
            raise AttributeError(k)
        else:
            return self._jl_callmethod($(pyjl_methodnum(pyjlany_getattr)), k)
    def __setattr__(self, k, v):
        try:
            ValueBase.__setattr__(self, k, v)
        except AttributeError:
            if k.startswith("__") and k.endswith("__"):
                raise
        else:
            return
        self._jl_callmethod($(pyjl_methodnum(pyjlany_setattr)), k, v)
    def __dir__(self):
        return ValueBase.__dir__(self) + self._jl_callmethod($(pyjl_methodnum(pyjlany_dir)))
    def __call__(self, *args, **kwargs):
        return self._jl_callmethod($(pyjl_methodnum(pyjlany_call)), args, kwargs)
    def __bool__(self):
        return True
    def __len__(self):
        return self._jl_callmethod($(pyjl_methodnum(pyjlany_op(length))))
    def __getitem__(self, k):
        return self._jl_callmethod($(pyjl_methodnum(pyjlany_getitem)), k)
    def __setitem__(self, k, v):
        self._jl_callmethod($(pyjl_methodnum(pyjlany_setitem)), k, v)
    def __delitem__(self, k):
        self._jl_callmethod($(pyjl_methodnum(pyjlany_delitem)), k)
    def __iter__(self):
        return self._jl_callmethod($(pyjl_methodnum(pyjlany_op(Iterator))))
    def __reversed__(self):
        return self._jl_callmethod($(pyjl_methodnum(pyjlany_op(reverse))))
    def __contains__(self, v):
        return self._jl_callmethod($(pyjl_methodnum(pyjlany_contains)), v)
    def __pos__(self):
        return self._jl_callmethod($(pyjl_methodnum(pyjlany_op(+))))
    def __neg__(self):
        return self._jl_callmethod($(pyjl_methodnum(pyjlany_op(-))))
    def __abs__(self):
        return self._jl_callmethod($(pyjl_methodnum(pyjlany_op(abs))))
    def __invert__(self):
        return self._jl_callmethod($(pyjl_methodnum(pyjlany_op(~))))
    def __add__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlany_op(+))), other)
    def __sub__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlany_op(-))), other)
    def __mul__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlany_op(*))), other)
    def __truediv__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlany_op(/))), other)
    def __floordiv__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlany_op(÷))), other)
    def __mod__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlany_op(%))), other)
    def __pow__(self, other, modulo=None):
        if modulo is None:
            return self._jl_callmethod($(pyjl_methodnum(pyjlany_op(^))), other)
        else:
            return self._jl_callmethod($(pyjl_methodnum(pyjlany_op(powermod))), other, modulo)
    def __lshift__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlany_op(<<))), other)
    def __rshift__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlany_op(>>))), other)
    def __and__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlany_op(&))), other)
    def __xor__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlany_op(⊻))), other)
    def __or__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlany_op(|))), other)
    def __radd__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlany_rev_op(+))), other)
    def __rsub__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlany_rev_op(-))), other)
    def __rmul__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlany_rev_op(*))), other)
    def __rtruediv__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlany_rev_op(/))), other)
    def __rfloordiv__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlany_rev_op(÷))), other)
    def __rmod__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlany_rev_op(%))), other)
    def __rpow__(self, other, modulo=None):
        if modulo is None:
            return self._jl_callmethod($(pyjl_methodnum(pyjlany_rev_op(^))), other)
        else:
            return self._jl_callmethod($(pyjl_methodnum(pyjlany_rev_op(powermod))), other, modulo)
    def __rlshift__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlany_rev_op(<<))), other)
    def __rrshift__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlany_rev_op(>>))), other)
    def __rand__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlany_rev_op(&))), other)
    def __rxor__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlany_rev_op(⊻))), other)
    def __ror__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlany_rev_op(|))), other)
    def __eq__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlany_op(==))), other)
    def __ne__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlany_op(!=))), other)
    def __le__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlany_op(≤))), other)
    def __lt__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlany_op(<))), other)
    def __ge__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlany_op(≥))), other)
    def __gt__(self, other):
        return self._jl_callmethod($(pyjl_methodnum(pyjlany_op(>))), other)
    def __hash__(self):
        return self._jl_callmethod($(pyjl_methodnum(pyjlany_op(hash))))
    @property
    def __name__(self):
        return self._jl_callmethod($(pyjl_methodnum(pyjlany_name)))
    def _jl_raw(self):
        '''Convert this to a juliacall.RawValue.'''
        return self._jl_callmethod($(pyjl_methodnum(pyjlraw)))
    def _jl_display(self, mime=None):
        '''Display this, optionally specifying the MIME type.'''
        return self._jl_callmethod($(pyjl_methodnum(pyjlany_display)), mime)
    def _jl_help(self, mime=None):
        '''Show help for this Julia object.'''
        return self._jl_callmethod($(pyjl_methodnum(pyjlany_help)), mime)
    def _jl_call_nogil(self, *args, **kwargs):
        '''Call this with the given arguments but with the GIL disabled.
        
        WARNING: This function must not interact with Python at all without re-acquiring
        the GIL.
        '''
        return self._jl_callmethod($(pyjl_methodnum(pyjlany_call_nogil)), args, kwargs)
    def _repr_mimebundle_(self, include=None, exclude=None):
        return self._jl_callmethod($(pyjl_methodnum(pyjlany_mimebundle)), include, exclude)
""",
            @__FILE__(),
            "exec",
        ),
        jl.__dict__,
    )
    pycopy!(pyjlanytype, jl.AnyValue)
end

"""
    pyjl([t=pyjltype(x)], x)

Create a Python object wrapping the Julia object `x`.

If `x` is mutable, then mutating the returned object also mutates `x`, and vice versa.

Its Python type is normally inferred from the type of `x`, but can be specified with `t`.

For example if `x` is an `AbstractVector` then the object will have type `juliacall.VectorValue`.
This object will satisfy the Python sequence interface, so for example uses 0-up indexing.

To define a custom conversion for your type `T`, overload `pyjltype(::T)`.
"""
pyjl(v) = pyjl(pyjltype(v), v)

"""
    pyjltype(x)

The subtype of `juliacall.AnyValue` which the Julia object `x` is wrapped as by `pyjl(x)`.

Overload `pyjltype(::T)` to define a custom conversion for your type `T`.
"""
pyjltype(::Any) = pyjlanytype

# [JuliaCall API Reference](@id jl-reference)

## Constants

`````@customdoc
juliacall.Main - Constant

The Julia `Main` module, as a [`ModuleValue`](#juliacall.ModuleValue).

In interactive scripts, you can use this as the main entry-point to JuliaCall:
```python
from juliacall import Main as jl
jl.println("Hello, world!")
```

In packages, use [`newmodule`](#juliacall.newmodule) instead.
`````

The modules `Base`, `Core` and `PythonCall` are also available.

## Utilities

`````@customdoc
juliacall.convert - Function

```python
convert(T, x)
```

Convert `x` to a Julia object of type `T`.

You can use this to pass an argument to a Julia function of a specific type.
`````

`````@customdoc
juliacall.newmodule - Function

```python
newmodule(name)
```

A new module with the given name.
`````

## [Wrapper types](@id julia-wrappers)

Apart from a few fundamental immutable types, all Julia values are by default converted into
Python to some [`AnyValue`](#juliacall.AnyValue) object, which wraps the original value, but
giving it a Pythonic interface.

Subclasses of [`AnyValue`](#juliacall.AnyValue) provide additional Python semantics. For
example a Julia vector is converted to a [`VectorValue`](#juliacall.VectorValue) which
satisfies the Python sequence interface and behaves very similar to a list.

There is also a [`RawValue`](#juliacall.RawValue) object, which gives a stricter
"Julia-only" interface, documented below. These types all inherit from `ValueBase`:

- `ValueBase`
  - [`RawValue`](#juliacall.RawValue)
  - [`AnyValue`](#juliacall.AnyValue)
    - [`NumberValue`](#juliacall.NumberValue)
      - `ComplexValue`
      - `RealValue`
        - `RationalValue`
        - `IntegerValue`
    - [`ArrayValue`](#juliacall.ArrayValue)
      - [`VectorValue`](#juliacall.VectorValue)
    - [`DictValue`](#juliacall.DictValue)
    - [`SetValue`](#juliacall.SetValue)
    - [`IOValue`](#juliacall.IOValue)
      - `BinaryIOValue`
      - `TextIOValue`
    - [`ModuleValue`](#juliacall.ModuleValue)
    - [`TypeValue`](#juliacall.TypeValue)

`````@customdoc
juliacall.AnyValue - Class

Wraps any Julia object, giving it some basic Python semantics. Subtypes provide extra
semantics.

Supports `repr(x)`, `str(x)`, attributes (`x.attr`), calling (`x(a,b)`), iteration,
comparisons, `len(x)`, `a in x`, `dir(x)`.

Calling, indexing, attribute access, etc. will convert the result to a Python object
according to [this table](@ref jl2py). This is typically a builtin Python type (for
immutables) or a subtype of `AnyValue`.

Attribute access can be used to access Julia properties as well as normal class members. In
the case of a name clash, the class member will take precedence. For convenience with Julia
naming conventions, `_b` at the end of an attribute is replaced with `!` and `_bb` is
replaced with `!!`.

###### Members
- `_jl_raw()`: Convert to a [`RawValue`](#juliacall.RawValue). (See also [`pyjlraw`](@ref).)
- `_jl_display(mime=None)`: Display the object using Julia's display mechanism.
- `_jl_help(mime=None)`: Display help for the object.
- `_jl_call_nogil(*args, **kwargs)`: Call this with the GIL disabled.
`````

`````@customdoc
juliacall.NumberValue - Class

This wraps any Julia `Number` value. It is a subclass of `numbers.Number` and behaves
similar to other Python numbers.

There are also subtypes `ComplexValue`, `RealValue`, `RationalValue`, `IntegerValue` which
wrap values of the corresponding Julia types, and are subclasses of the corresponding
`numbers` ABC.
`````

`````@customdoc
juliacall.ArrayValue - Class

This wraps any Julia `AbstractArray` value. It is a subclass of
`collections.abc.Collection`.

It supports zero-up indexing, and can be indexed with integers or slices. Slicing returns a
view of the original array.

If the array is strided and its eltype is supported (i.e. `Bool`, `IntXX`, `UIntXX`,
`FloatXX`, `Complex{FloatXX}`, `Ptr{Cvoid}` or `Tuple` or `NamedTuple` of these) then it
supports the buffer protocol and the numpy array interface. This means that
`numpy.asarray(this)` will yield a view of the original array, so mutations are visible on
the original.

Otherwise, the numpy `__array__` method is supported, and this returns an array of Python
objects converted from the contents of the array. In this case, `numpy.asarray(this)` is a
copy of the original array.

###### Members
- `ndim`: The number of dimensions.
- `shape`: Tuple of lengths in each dimension.
- `copy()`: A copy of the array.
- `reshape(shape)`: A reshaped view of the array.
- `to_numpy(dtype=None, copy=True, order="K")`: Convert to a numpy array.
`````

`````@customdoc
juliacall.VectorValue - Class

This wraps any Julia `AbstractVector` value. It is a subclass of `juliacall.ArrayValue` and
`collections.abc.MutableSequence` and behaves similar to a Python `list`.

###### Members
- `resize(size)`: Change the length of the vector.
- `sort(reverse=False, key=None)`: Sort the vector in-place.
- `reverse()`: Reverse the vector.
- `clear()`: Empty the vector.
- `insert(index, value)`: Insert the value at the given index.
- `append(value)`: Append the value to the end of the vector.
- `extend(values)`: Append the values to the end of the vector.
- `pop(index=-1)`: Remove and return the item at the given index.
- `remove(value)`: Remove the first item equal to the value.
- `index(value)`: The index of the first item equal to the value.
- `count(value)`: The number of items equal to the value.
`````

`````@customdoc
juliacall.DictValue - Class
This wraps any Julia `AbstractDict` value. It is a subclass of `collections.abc.MutableMapping` and
behaves similar to a Python `dict`.
`````

`````@customdoc
juliacall.SetValue - Class
This wraps any Julia `AbstractSet` value. It is a subclass of `collections.abc.MutableSet` and
behaves similar to a Python `set`.
`````

`````@customdoc
juliacall.IOValue - Class

This wraps any Julia `IO` value. It is a subclass of `io.IOBase` and behaves like Python
files.

There are also subtypes `BinaryIOValue` and `TextIOValue`, which are subclasses of
`io.BufferedIOBase` (buffered bytes) and `io.TextIOBase` (text).
`````

`````@customdoc
juliacall.ModuleValue - Class
This wraps any Julia `Module` value.

It is the same as [`AnyValue`](#juliacall.AnyValue) except for one additional convenience
method:
- `seval([module=self], code)`: Evaluates the given code (a string) in the given module.
`````

`````@customdoc
juliacall.TypeValue - Class

This wraps any Julia `Type` value.

It is the same as [`AnyValue`](#juliacall.AnyValue) except that indexing is used to access
Julia's "curly" syntax for specifying parametric types:

```python
from juliacall import Main as jl
# equivalent to Vector{Int}() in Julia
jl.Vector[jl.Int]()
```

Some Julia types can be converted to corresponding numpy dtypes like `numpy.dtype(jl.Int)`.
Supports `Bool`, `IntXX`, `UIntXX`, `FloatXX`, `ComplexFXX`,
`NumpyDates.InlineDateTime64{unit}` and `NumpyDates.InlineTimeDelta64{unit}`, plus
`Tuple`s and `NamedTuple`s of these.
`````

`````@customdoc
juliacall.RawValue - Class

Wraps any Julia value with a rigid interface suitable for generic programming.

Supports `repr(x)`, `str(x)`, attributes (`x.attr`), calling (`x(a,b)`), `len(x)`, `dir(x)`.

This is very similar to [`AnyValue`](#juliacall.AnyValue) except that indexing, calling,
etc. will always return a `RawValue`.

Indexing with a tuple corresponds to indexing in Julia with multiple values. To index with a
single tuple, it will need to be wrapped in another tuple.

###### Members
- `_jl_any()`: Convert to a [`AnyValue`](#juliacall.AnyValue) (or subclass). (See also
  [`pyjl`](@ref).)
- `_jl_call_nogil(*args, **kwargs)`: Call this with the GIL disabled.
`````

# [PythonCall API Reference](@id py-reference)

## `Py` objects

```@docs
Py
pybuiltins
```

## Constructors

These functions construct Python objects of builtin types from Julia values.

```@docs
pybool
pycollist
pybytes
pycomplex
pydict
pyfloat
pyfrozenset
pyint
pylist
pyrange
pyrowlist
pyset
pyslice
pystr
pytuple
```

## Builtins

These functions mimic the Python builtin functions or keywords of the same name.

```@docs
pyall
pyany
pyascii
pycall
pycallable
pycompile
pycontains
pydelattr
pydelitem
pydir
pyeval
@pyeval
pyexec
@pyexec
pygetattr
pygetitem
pyhasattr
pyhasitem
pyhash
pyhelp
pyimport
pyin
pyis
pyisinstance
pyissubclass
pyiter
pylen
pynext
pyprint
pyrepr
pysetattr
pysetitem
pytype(::Any)
pywith
```

## Conversion to Julia

These functions convert Python values to Julia values, using the rules documented [here](@ref jl2py).

```@docs
pyconvert
@pyconvert
```

## Wrap Julia values

These functions explicitly wrap Julia values into Python objects, documented [here](@ref julia-wrappers).

As documented [here](@ref py2jl), Julia values are wrapped like this automatically on
conversion to Python, unless the value is immutable and has a corresponding Python type.

```@docs
pyjl
pyjlraw
pyisjl
pyjlvalue
pybinaryio
pytextio
```

## Arithmetic

These functions are equivalent to the corresponding Python arithmetic operators.

Note that the equivalent Julia operators are overloaded to call these when all arguments
are `Py` (or `Number`). Hence the following are equivalent: `Py(1)+Py(2)`, `Py(1)+2`,
`pyadd(1, 2)`, `pyadd(Py(1), Py(2))`, etc.

```@docs
pyneg
pypos
pyabs
pyinv
pyindex
pyadd
pysub
pymul
pymatmul
pypow
pyfloordiv
pytruediv
pymod
pydivmod
pylshift
pyrshift
pyand
pyxor
pyor
pyiadd
pyisub
pyimul
pyimatmul
pyipow
pyifloordiv
pyitruediv
pyimod
pyilshift
pyirshift
pyiand
pyixor
pyior
```

## Logic

These functions are equivalent to the corresponding Python logical operators.

Note that the equivalent Julia operators are overloaded to call these when all arguments
are `Py` (or `Number`). Hence the following are equivalent: `Py(1) < Py(2)`, `Py(1) < 2`,
`pylt(1, 2)`, `pylt(Py(1), Py(2))`, etc.

Note that the binary operators by default return `Py` (not `Bool`) since comparisons in
Python do not necessarily return `bool`.

```@docs
pytruth
pynot
pyeq
pyne
pyle
pylt
pyge
pygt
```

## Create classes

These functions can be used to create new Python classes where the functions are implemented
in Julia. You can instead use [`@pyeval`](@ref) etc. to create pure-Python classes.

```@docs
pytype(::Any, ::Any, ::Any)
pyfunc
pyclassmethod
pystaticmethod
pyproperty
```

## [Wrapper types](@id python-wrappers)

The following types wrap a Python object, giving it the semantics of a Julia object. For example `PyList(x)` interprets the Python sequence `x` as a Julia abstract vector.

Apart from a few fundamental immutable types, conversion from Python to Julia `Any` will return a wrapper type such as one of these, or simply `Py` if no wrapper type is suitable.

```@docs
PyList
PySet
PyDict
PyIterable
PyArray
PyIO
PyTable
PyPandasDataFrame
PyObjectArray
PyException
```

### [Custom wrappers](@id python-wrappers-custom)

Here is a minimal example of defining a wrapper type. You may add methods, fields and a
supertype to the type to specialise its behaviour. See any of the above wrapper types for
examples.

```julia
# The new type with a field for the Python object being wrapped.
struct MyType
    py::Py
end

# Says that the object is a wrapper.
ispy(x::MyType) = true

# Says how to access the underlying Python object.
Py(x::MyType) = x.py
```

## `@py` and `@pyconst`

```@docs
@py
@pyconst
```

## Multi-threading

These functions are not exported. They support multi-threading of Python and/or Julia.
See also [`juliacall.AnyValue._jl_call_nogil`](@ref julia-wrappers).

```@docs
PythonCall.GIL.lock
PythonCall.GIL.@lock
PythonCall.GIL.unlock
PythonCall.GIL.@unlock
PythonCall.GC.gc
```

## The Python interpreter

These functions are not exported. They give information about which Python interpreter is
being used.
```@docs
PythonCall.python_version
PythonCall.python_executable_path
PythonCall.python_library_path
PythonCall.python_library_handle
```

## Low-level API

The functions here are not exported. They are mostly unsafe in the sense that you can
crash Julia by using them incorrectly.

```@docs
PythonCall.pynew
PythonCall.pyisnull
PythonCall.pycopy!
PythonCall.getptr
PythonCall.pydel!
PythonCall.unsafe_pynext
```

## NumpyDates

The submodule `PythonCall.NumpyDates` provides types corresponding to Numpy's `datetime64` and `timedelta64` types. Enables conversion of these Numpy types (either as scalars or in arrays) to native Julia types.

```@docs
PythonCall.NumpyDates
PythonCall.NumpyDates.AbstractDateTime64
PythonCall.NumpyDates.InlineDateTime64
PythonCall.NumpyDates.DateTime64
PythonCall.NumpyDates.AbstractTimeDelta64
PythonCall.NumpyDates.InlineTimeDelta64
PythonCall.NumpyDates.TimeDelta64
PythonCall.NumpyDates.Unit
```

# Repository Instructions

## Running tests
- **Julia tests**: Run from the project root with `julia --project -e 'using Pkg; Pkg.test()'`. Expect a warning about the General registry being unreachable in locked-down environments; the suite still finishes (PyCall tests are marked broken/Skipped).
- **Python tests**:
  - Copy `pysrc/juliacall/juliapkg-dev.json` to `pysrc/juliacall/juliapkg.json` before running (do **not** commit this copy).
  - Execute with `uv run pytest -s --nbval ./pytest` (add `--cov=pysrc` when coverage is needed).
  - Sometimes `juliapkg` requires Julia 1.10–1.11; `juliaup` already provides 1.11.7 in this environment.

The majority of tests live in the Julia package; Python tests cover functionality that cannot be exercised from Julia (e.g., JuliaCall-specific behavior). Run both suites—typically Julia first—in whichever order makes sense.

## Meta instructions
- When you discover environment quirks, false assumptions, process fixes, or any other generally useful info, update this AGENTS.md so future coding agents have the information.

# [Conversion to Julia](@id py2jl)

## [Conversion Rules](@id py2jl-conversion)

The following table specifies the conversion rules used whenever converting a Python object to a Julia object. If the initial Python type matches the "From" column and the desired type `T` intersects with the "To" column, then that conversion is attempted. Conversions are tried in priority order, then in specificity order.

From Julia, one can convert Python objects to a desired type using `pyconvert(T, x)` for example.

From Python, the arguments to a Julia function will be converted according to these rules with `T=Any`.

| From                                                                                                         | To                                                          |
| :----------------------------------------------------------------------------------------------------------- | :---------------------------------------------------------- |
| **Top priority (wrapped values).**                                                                           |                                                             |
| `juliacall.AnyValue`                                                                                         | `Any`                                                       |
| **Very high priority (arrays).**                                                                             |                                                             |
| Objects satisfying the buffer or array interface (inc. `bytes`, `bytearray`, `array.array`, `numpy.ndarray`) | `PyArray`                                                   |
| **High priority (canonical conversions).**                                                                   |                                                             |
| `None`                                                                                                       | `Nothing`                                                   |
| `bool`                                                                                                       | `Bool`                                                      |
| `numbers.Integral` (inc. `int`)                                                                              | `Integer` (prefers `Int`, or `BigInt` on overflow)          |
| `float`                                                                                                      | `Float64`                                                   |
| `complex`                                                                                                    | `Complex{Float64}`                                          |
| `range`                                                                                                      | `StepRange`                                                 |
| `str`                                                                                                        | `String`                                                    |
| `tuple`                                                                                                      | `Tuple`                                                     |
| `collections.abc.Mapping` (inc. `dict`)                                                                      | `PyDict`                                                    |
| `collections.abc.Sequence` (inc. `list`)                                                                     | `PyList`                                                    |
| `collections.abc.Set` (inc. `set`, `frozenset`)                                                              | `PySet`                                                     |
| `io.IOBase` (includes open files)                                                                            | `PyIO`                                                      |
| `BaseException`                                                                                              | `PyException`                                               |
| `datetime.date`/`datetime.time`/`datetime.datetime`                                                          | `Date`/`Time`/`DateTime`                                    |
| `datetime.timedelta`                                                                                         | `Microsecond` (or `Millisecond` or `Second` on overflow)    |
| `numpy.intXX`/`numpy.uintXX`/`numpy.floatXX`                                                                 | `IntXX`/`UIntXX`/`FloatXX`                                  |
| `numpy.datetime64`                                                                                           | `NumpyDates.DateTime64`                                     |
| `numpy.timedelta64`                                                                                          | `NumpyDates.TimeDelta64`                                    |
| **Standard priority (other reasonable conversions).**                                                        |                                                             |
| `None`                                                                                                       | `Missing`                                                   |
| `bytes`                                                                                                      | `Vector{UInt8}`, `Vector{Int8}`, `String`                   |
| `str`                                                                                                        | `String`, `Symbol`, `Char`, `Vector{UInt8}`, `Vector{Int8}` |
| `range`                                                                                                      | `UnitRange`                                                 |
| `collections.abc.Mapping`                                                                                    | `Dict`                                                      |
| `collections.abc.Iterable`                                                                                   | `Vector`, `Set`, `Tuple`, `NamedTuple`, `Pair`              |
| `datetime.timedelta`                                                                                         | `Dates.CompoundPeriod`                                      |
| `numbers.Integral`                                                                                           | `Integer`, `Rational`, `Real`, `Number`                     |
| `numbers.Real`                                                                                               | `AbstractFloat`, `Number`, `Missing`/`Nothing` (if NaN)     |
| `numbers.Complex`                                                                                            | `Complex`, `Number`                                         |
| `ctypes.c_int` and other integers                                                                            | `Integer`, `Rational`, `Real`, `Number`                     |
| `ctypes.c_float`/`ctypes.c_double`                                                                           | `Cfloat`/`Cdouble`, `AbstractFloat`, `Real`, `Number`       |
| `ctypes.c_voidp`                                                                                             | `Ptr{Cvoid}`, `Ptr`                                         |
| `ctypes.c_char_p`                                                                                            | `Cstring`, `Ptr{Cchar}`, `Ptr`                              |
| `ctypes.c_wchar_p`                                                                                           | `Cwstring`, `Ptr{Cwchar}`, `Ptr`                            |
| `numpy.bool_`/`numpy.intXX`/`numpy.uintXX`/`numpy.floatXX`                                                   | `Bool`, `Integer`, `Rational`, `Real`, `Number`             |
| `numpy.datetime64`                                                                                           | `NumpyDates.InlineDateTime64`, `Dates.DateTime`             |
| `numpy.timedelta64`                                                                                          | `NumpyDates.InlineTimeDelta64`, `Dates.Period`              |
| Objects satisfying the buffer or array interface                                                             | `Array`, `AbstractArray`                                    |
| **Low priority (fallback to `Py`).**                                                                         |                                                             |
| Anything                                                                                                     | `Py`                                                        |
| **Bottom priority (must be explicitly specified by excluding `Py`).**                                        |                                                             |
| Objects satisfying the buffer interface                                                                      | `PyBuffer`                                                  |
| Anything                                                                                                     | `PyRef`                                                     |

See [here](@ref python-wrappers) for an explanation of the `Py*` wrapper types (`PyList`, `PyIO`, etc).

## [Custom rules](@id py2jl-conversion-custom)

To add a custom conversion rule, you must define a function to do the conversion and call
`pyconvert_add_rule` to register it.

You must not do this while precompiling, so these calls will normally be in the `__init__`
function of your module.

```@docs
PythonCall.pyconvert_add_rule
```

# Compatibility Tools

Some packages require a little extra help to work nicely with PythonCall.

Some of these are "fixes" that are silently applied for you, and some are just extra
functions to bridge a gap. We aim to keep these as minimal as possible.

## Python standard library

Whenever a Python exception is displayed by Julia, `sys.last_traceback` and friends are set. This allows the post-mortem debugger `pdb.pm()` to work. Disable by setting `PythonCall.CONFIG.auto_sys_last_traceback = false`.

## Julia standard library

Python objects can be serialised with the [`Serialization`](https://docs.julialang.org/en/v1/stdlib/Serialization/) stdlib.
This uses [`pickle`](https://docs.python.org/3/library/pickle.html) library under the hood.
You can opt into using [`dill`](https://pypi.org/project/dill/) instead by setting the `pickle` preference or the `JULIA_PYTHONCALL_PICKLE` environment variable to `"dill"`.

## Tabular data / Pandas

The abstract type [`PyTable`](@ref) is for wrapper types around Python tables, providing the
[Tables.jl](https://github.com/JuliaData/Tables.jl) interface. `PyTable(x)` is shorthand
for `pyconvert(PyTable, x)`.

The subtype [`PyPandasDataFrame`](@ref) wraps a `pandas.DataFrame`.

For example, if `x` is a `pandas.DataFrame` then `PyTable(x)` is a `PyPandasDataFrame` and
`DataFrame(PyTable(x))` is a [`DataFrame`](https://github.com/JuliaData/DataFrames.jl).

In the other direction, the following functions can be used to convert any
`Tables.jl`-compatible table to a Python table.

```@docs
pytable
```

## MatPlotLib / PyPlot / Seaborn

MatPlotLib figures can be shown with Julia's display mechanism,
like `display(fig)` or `display(mime, fig)`.

This means that if you return a figure from a Jupyter or Pluto notebook cell,
it will be shown. You can call `display(plt.gcf())` to display the current figure.

We also provide a simple MatPlotLib backend: `mpl.use("module://juliacall.matplotlib")`.
Now you can call `plt.show()` to display the figure with Julia's display mechanism.
You can specify the format like `plt.show(format="png")`.

## Python GUIs (including MatPlotLib)

### Event loops

If for example you wish to use PyPlot in interactive mode (`matplotlib.pyplot.ion()`)
then activating the correct event loop will allow it to work.

```@docs
PythonCall.event_loop_on
PythonCall.event_loop_off
```

### Qt path fix

```@docs
PythonCall.fix_qt_plugin_path
```

## IPython

The `juliacall` IPython extension adds these features to your IPython session:
- The line magic `%julia code` executes the given Julia code in-line.
- The cell magic `%%julia` executes a cell of Julia code.
- Julia's `stdout` and `stderr` are redirected to IPython.
- Calling `display(x)` from Julia will display `x` in IPython.

The extension is experimental and unstable - the API can change at any time.

You can explicitly enable the extension with `%load_ext juliacall`, but
it will automatically be loaded if `juliacall` is imported and IPython is detected.
You can disable this behavior with an [environment variable](@ref julia-config).

The `%%julia` cell magic can synchronise variables between Julia and Python by listing them
on the first line:
```python
In [1]: %load_ext juliacall

In [2]: x = 2

In [3]: y = 8

In [4]: %%julia x y z
   ...: z = "$x^$y = $(x^y)";
   ...:
   ...:

In [5]: z
Out[5]: '2^8 = 256'
```

Also see [the IPython docs](https://ipython.readthedocs.io/en/stable/config/extensions/)
for more information on extensions.

## Asynchronous Julia code (including Makie)

Asynchronous Julia code will not normally run while Python is executing, unless it is in a
separate thread.

This can be fixed by calling `jl.yield()` periodically from Python code, allowing the
Julia scheduler to run.

When working at the Python REPL, you may call `juliacall.interactive()` which will allow
Julia async code to run while the prompt is showing. This will allow interactive plots such
as Makie to work.

# The Python module JuliaCall

## Installation

It's as simple as
```bash
pip install juliacall
```

If you prefer Conda, there is a community effort to also release this on conda-forge:
```bash
conda install conda-forge::pyjuliapkg
```

Developers may wish to clone the repo (https://github.com/JuliaPy/PythonCall.jl) directly
and pip install the module in editable mode. You should add `"dev":true, "path":"../.."` to
`pysrc/juliacall/juliapkg.json` to ensure you use the development version of PythonCall
in conjunction with JuliaCall.

## Getting started

For interactive or scripting use, the simplest way to get started is:
```python
from juliacall import Main as jl
```

This loads a single variable `jl` which represents the `Main` module in Julia,
from which all of Julia's functionality is available:
```python
jl.println("Hello from Julia!")
# Hello from Julia!
x = jl.rand(range(10), 3, 5)
x._jl_display()
# 3×5 Matrix{Int64}:
#  8  1  7  0  6
#  9  2  1  4  0
#  1  8  5  4  0
import numpy
numpy.sum(x, axis=0)
# array([18, 11, 13,  8,  6], dtype=int64)
```

In this example:
- We called the `jl.println` function to print a message.
- We called the `jl.rand` function to generate an array of random integers. Note that the
  first argument is `range(10)` which is converted to `0:9` in Julia.
- We called its special `_jl_display()` to show it using Julia's display mechanism.
- We called the `numpy.sum` function to sum each column of `x`. This automatically converted
  `x` to a NumPy array. (We could have done `jl.sum(x, dims=1)` too.)

If you are writing a package which uses Julia, then to avoid polluting the global `Main`
namespace you instead should start with:
```python
import juliacall
jl = juliacall.newmodule("SomeName")
```

Julia modules have a special method `seval` which will evaluate a given piece of code given
as a string in the module. This is most frequently used to import modules:
```python
from array import array
jl.seval("using Statistics")
x = array('i', [1, 2, 3])
jl.mean(x)
# 2.0
y = array('i', [2,4,8])
jl.cor(x, y)
# 0.9819805060619657
```

What to read next:
- The main functionality of this package is in `AnyValue` objects, which represent Julia
  objects, [documented here](@ref julia-wrappers).
- If you need to install Julia packages, [read here](@ref julia-deps).
- When you call a Julia function, such as `jl.rand(...)` in the above example, its
  arguments are converted to Julia according to [this table](@ref py2jl-conversion) and
  its return value is converted to Python according to [this table](@ref jl2py-conversion).

## [Managing Julia dependencies](@id julia-deps)

By default JuliaCall manages its Julia dependencies using
[JuliaPkg](https://github.com/JuliaPy/PyJuliaPkg).

It will automatically download a suitable version of Julia if required.

A Julia environment is also created, activated and populated with any required packages.
If you are in a virtual or Conda environment, the environment is put there. Otherwise a
global environment is used at `~/.julia/environments/pyjuliapkg`.

If your project requires any Julia packages, or a particular version of Julia itself, then
create a file called `juliapkg.json` in your package. For example:
Here is an example:
```json
{
    "julia": "1.5",
    "packages": {
        "Example": {
            "uuid": "7876af07-990d-54b4-ab0e-23690620f79a",
            "version": "0.5, 0.6"
        }
    }
}
```

Alternatively you can use `add`, `rm`, etc. from JuliaPkg to edit this file.

See [JuliaPkg](https://github.com/JuliaPy/PyJuliaPkg) for more details.

### Using existing environments

It's possible to override the defaults and disable JuliaPkg entirely by setting
the `PYTHON_JULIACALL_EXE` and `PYTHON_JULIACALL_PROJECT` options (both must be
set together). This is particularly useful when using shared environments on HPC
systems that may be readonly. Note that the project set in
`PYTHON_JULIACALL_PROJECT` *must* already have PythonCall.jl installed and it
*must* match the JuliaCall version, otherwise loading Julia will fail.

## [Configuration](@id julia-config)

Some features of the Julia process, such as the optimization level or number of threads, may
be configured in two ways:
- As an `-X` argument to Python, such as `-X juliacall-optlevel=3`; or
- As an environment variable, such as `PYTHON_JULIACALL_OPTLEVEL=3`.

| `-X` option | Environment Variable | Description |
| :---------- | :------------------- | :---------- |
| `-X juliacall-home=<dir>` | `PYTHON_JULIACALL_BINDIR=<dir>` | The directory containing the julia executable. |
| `-X juliacall-check-bounds=<yes\|no\|auto>` | `PYTHON_JULIACALL_CHECK_BOUNDS=<yes\|no\|auto>` | Enable or disable bounds checking. |
| `-X juliacall-compile=<yes\|no\|all\|min>` | `PYTHON_JULIACALL_COMPILE=<yes\|no\|all\|min>` | Enable or disable JIT compilation. |
| `-X juliacall-compiled-modules=<yes\|no>` | `PYTHON_JULIACALL_COMPILED_MODULES=<yes\|no>` | Enable or disable incrementally compiling modules. |
| `-X juliacall-depwarn=<yes\|no\|error>` | `PYTHON_JULIACALL_DEPWARN=<yes\|no\|error>` | Enable or disable deprecation warnings. |
| `-X juliacall-handle-signals=<yes\|no>` | `PYTHON_JULIACALL_HANDLE_SIGNALS=<yes\|no>` | Enable or disable Julia signal handling. |
| `-X juliacall-inline=<yes\|no>` | `PYTHON_JULIACALL_INLINE=<yes\|no>` | Enable or disable inlining. |
| `-X juliacall-min-optlevel=<0\|1\|2\|3>` | `PYTHON_JULIACALL_MIN_OPTLEVEL=<0\|1\|2\|3>` | Optimization level. |
| `-X juliacall-optimize=<0\|1\|2\|3>` | `PYTHON_JULIACALL_OPTIMIZE=<0\|1\|2\|3>` | Minimum optimization level. |
| `-X juliacall-procs=<N\|auto>` | `PYTHON_JULIACALL_PROCS=<N\|auto>` | Launch N local worker process. |
| `-X juliacall-startup-file=<yes\|no>` | `PYTHON_JULIACALL_STARTUP_FILE=<yes\|no>` | Enable or disable your startup.jl file. |
| `-X juliacall-sysimage=<file>` | `PYTHON_JULIACALL_SYSIMAGE=<file>` | Use the given system image. |
| `-X juliacall-threads=<N\|auto>` | `PYTHON_JULIACALL_THREADS=<N\|auto>` | Launch N threads. |
| `-X juliacall-warn-overwrite=<yes\|no>` | `PYTHON_JULIACALL_WARN_OVERWRITE=<yes\|no>` | Enable or disable method overwrite warnings. |
| `-X juliacall-autoload-ipython-extension=<yes\|no>` | `PYTHON_JULIACALL_AUTOLOAD_IPYTHON_EXTENSION=<yes\|no>` | Enable or disable IPython extension autoloading. |
| `-X juliacall-heap-size-hint=<N>` | `PYTHON_JULIACALL_HEAP_SIZE_HINT=<N>` | Hint for initial heap size in bytes. |
| `-X juliacall-exe=<file>` | `PYTHON_JULIACALL_EXE=<file>` | Path to Julia binary to use (overrides JuliaPkg). |
| `-X juliacall-project=<dir>` | `PYTHON_JULIACALL_PROJECT=<dir>` | Path to the Julia project to use (overrides JuliaPkg). |
| `-X juliacall-lib=<file>` | `PYTHON_JULIACALL_LIB=<file>` | Path to libjulia. Set to skip the relatively slow discovery process. |
| `-X juliacall-trace-compile=<stderr\|name>` | `PYTHON_JULIACALL_TRACE_COMPILE=<stderr\|name>` | Print precompile statements. |
| `-X juliacall-trace-compile-timing` | `PYTHON_JULIACALL_TRACE_COMPILE_TIMING=<yes\|no>` | Include timings with precompile statements. |

## [Multi-threading](@id py-multi-threading)

!!! warning

    Multi-threading support is experimental and can change without notice.

From v0.9.22, JuliaCall supports multi-threading in Julia and/or Python, with some
caveats.

Most importantly, you can only call Python code while Python's
[Global Interpreter Lock (GIL)](https://docs.python.org/3/glossary.html#term-global-interpreter-lock)
is locked by the current thread. You can use JuliaCall from any Python thread, and the GIL
will be locked whenever any JuliaCall function is used. However, to leverage the benefits
of multi-threading, you can unlock the GIL while executing any Julia code that does not
interact with Python.

The simplest way to do this is using the `_jl_call_nogil` method on Julia functions to
call the function with the GIL unlocked.

```python
from concurrent.futures import ThreadPoolExecutor, wait
from juliacall import Main as jl
pool = ThreadPoolExecutor(4)
fs = [pool.submit(jl.Libc.systemsleep._jl_call_nogil, 5) for _ in range(4)]
wait(fs)
```

In the above example, we call `Libc.systemsleep(5)` on four threads. Because we
called it with `_jl_call_nogil`, the GIL was unlocked, allowing the threads to run in
parallel, taking about 5 seconds in total.

If we did not use `_jl_call_nogil` (i.e. if we did `pool.submit(jl.Libc.systemsleep, 5)`)
then the above code will take 20 seconds because the sleeps run one after another.

It is very important that any function called with `_jl_call_nogil` does not interact
with Python at all unless it re-locks the GIL first, such as by using
[PythonCall.GIL.@lock](@ref).

You can also use [multi-threading from Julia](@ref jl-multi-threading).

### Caveat: Julia's task scheduler

If you try the above example with a Julia function that yields to the task scheduler,
such as `sleep` instead of `Libc.systemsleep`, then you will likely experience a hang.

In this case, you need to yield back to Julia's scheduler periodically to allow the task
to continue. You can use the following pattern instead of `wait(fs)`:
```python
jl_yield = getattr(jl, "yield")
while True:
  # yield to Julia's task scheduler
  jl_yield()
  # wait for up to 0.1 seconds for the threads to finish
  state = wait(fs, timeout=0.1)
  # if they finished then stop otherwise try again
  if not state.not_done:
    break
```

Set the `timeout` parameter smaller to let Julia's scheduler cycle more frequently.

Future versions of JuliaCall may provide tooling to make this simpler.

### [Caveat: Signal handling](@id py-multi-threading-signal-handling)

We recommend setting [`PYTHON_JULIACALL_HANDLE_SIGNALS=yes`](@ref julia-config)
before importing JuliaCall with multiple threads.

This is because Julia intentionally causes segmentation faults as part of the GC
safepoint mechanism. If unhandled, these segfaults will result in termination of the
process. See discussion
[here](https://github.com/JuliaPy/PythonCall.jl/issues/219#issuecomment-1605087024)
for more information.

Note however that this interferes with Python's own signal handling, so for example
Ctrl-C will not raise `KeyboardInterrupt`.

Future versions of JuliaCall may make this the default behaviour when using multiple
threads.

# Benchmarks

## Benchmark 1: fill a dict

| Version | Factor | Time (microseconds) | Allocations |
| ------- | ------ | ------------------- | ----------- |
| Python | 1.0x | 280 | ? |
| PythonCall | 2.4x | 680 | 5008 |
| PythonCall + `pydel!` | 1.1x | 300 | 1008 |
| PythonCall `@py` | 1.4x | 420 | 1002 |
| PythonCall `@py` + `@pydel!` | 1.1x | 300 | 2 |
| PyCall | 5.4x | 1620 | 10987 |
| PyCall (readable but wrong) | 5.9x | 1784 | 11456 |

Python code:
```python-repl
>>> from timeit import timeit
>>> def test():
...     from random import random
...     x = {}
...     for i in range(1000):
...         x[str(i)] = i + random()
...     return x
...
>>> timeit("test()", N=1000, globals=globals())
```

PythonCall code:
```julia-repl
julia> using PythonCall, BenchmarkTools

julia> function test()
           random = pyimport("random").random
           x = pydict()
           for i in pyrange(1000)
               x[pystr(i)] = i + random()
           end
           return x
       end
test (generic function with 1 method)

julia> @benchmark test()
```

PythonCall + `pydel!` code:
```julia-repl
julia> using PythonCall, BenchmarkTools

julia> function test()
           random = pyimport("random").random
           x = pydict()
           for i in pyrange(1000)
               k = pystr(i)
               r = random()
               v = i + r
               x[k] = v
               pydel!(k)
               pydel!(r)
               pydel!(v)
               pydel!(i)
           end
           return x
       end
test (generic function with 1 method)

julia> @benchmark test()
```

PythonCall `@py` code:
```julia-repl
julia> using PythonCall, BenchmarkTools

julia> test() = @py begin
           import random: random
           x = {}
           for i in range(1000)
               x[str(i)] = i + random()
               # Uncomment for pydel! version:
               # @jl PythonCall.pydel!(i)
           end
           x
       end
test (generic function with 1 method)

julia> @benchmark test()
```

PyCall code:
```julia-repl
julia> using PyCall, BenchmarkTools

julia> function test()
           random = pyimport("random")."random"
           x = pycall(pybuiltin("dict"), PyObject)
           str = pybuiltin("str")
           for i in pycall(pybuiltin("range"), PyObject, 1000)
               set!(x, pycall(str, PyObject, i), i + pycall(random, PyObject))
           end
           return x
       end
test (generic function with 1 method)

julia> @benchmark test()
```

PyCall (readable but wrong) code:
```julia-repl
julia> using PyCall, BenchmarkTools

julia> function test()
           random = pyimport("random").random
           x = pybuiltin("dict")()
           str = pybuiltin("str")
           for i in pybuiltin("range")(1000)
               x[str(i)] = i + random()
           end
           return x
       end
test (generic function with 1 method)

julia> @benchmark test()
```

# FAQ & Troubleshooting

## [Can I use PythonCall and PyCall together?](@id faq-pycall)

Yes, you can use both PyCall and PythonCall in the same Julia session. This is platform-dependent:
- On most systems the Python interpreter used by PythonCall and PyCall must be the same (see below).
- On Windows it appears to be possible for PythonCall and PyCall to use different interpreters.

To force PythonCall to use the same Python interpreter as PyCall, set the environment variable [`JULIA_PYTHONCALL_EXE`](@ref pythoncall-config) to `"@PyCall"`. Note that this will opt out of automatic dependency management using CondaPkg.

Alternatively, to force PyCall to use the same interpreter as PythonCall, set the environment variable `PYTHON` to [`PythonCall.python_executable_path()`](@ref) and then `Pkg.build("PyCall")`. You will need to do this each time you change project, because PythonCall by default uses a different Python for each project.

## [Is PythonCall/JuliaCall thread safe?](@id faq-multi-threading)

Yes, as of v0.9.22, provided you handle the GIL correctly. See the guides for
[PythonCall](@ref jl-multi-threading) and [JuliaCall](@ref py-multi-threading).

Before, tricks such as disabling the garbage collector were required. See the
[old docs](https://juliapy.github.io/PythonCall.jl/v0.9.21/faq/#Is-PythonCall/JuliaCall-thread-safe?).

When starting a Julia REPL with multiple threads, there must be exactly one interactive thread,
to avoid triggering a segmentation fault on tab completion (issue [#586](https://github.com/JuliaPy/PythonCall.jl/issues/586)).
Check this with `Threads.nthreads(:interactive)` or `versioninfo()`, set it with `JULIA_NUM_THREADS=X,1`,
where `X` is the number of default threads, or use the Julia `--threads` CLI flag, see `julia --help`.

Related issues:
[#201](https://github.com/JuliaPy/PythonCall.jl/issues/201),
[#202](https://github.com/JuliaPy/PythonCall.jl/issues/202),
[#529](https://github.com/JuliaPy/PythonCall.jl/pull/529)

## Issues when Numpy arrays are expected

When a Julia array is passed to Python, it is wrapped as a [`ArrayValue`](#juliacall.ArrayValue).
This type satisfies the Numpy array interface and the buffer protocol, so can be used in
most places where a numpy array is valid.

However, some Python packages have functions which assume the input is an actual Numpy array.
You may see errors such as:
```
AttributeError: Julia: type Array has no field dtype
```

To fix this you can convert the array `x` to a Numpy array as follows
```julia
Py(x).to_numpy()
```

If the array is being mutated, you will need to pass the argument `copy=false`.

Related issues: [#280](https://github.com/JuliaPy/PythonCall.jl/issues/280)

## Heap corruption when using PyTorch

On some systems, you may see an error like the following when using `torch` and `juliacall`:
```text
Python(65251,0x104cf8580) malloc: Heap corruption detected, free list is damaged at 0x600001c17280
*** Incorrect guard value: 1903002876
Python(65251,0x104cf8580) malloc: *** set a breakpoint in malloc_error_break to debug
[1]    65251 abort      ipython
```

A solution is to ensure that `juliacall` is imported before `torch`.

Related issues: [#215](https://github.com/JuliaPy/PythonCall.jl/issues/215)

## `ccall requires the compiler` error when importing some Python libraries
On some systems, you may see an error like the following when import e.g. `matplotlib` before `juliacall`:

```
ERROR: `ccall` requires the compilerTraceback (most recent call last):
  File "/home/dingraha/projects/pythoncall_import_error/run.py", line 2, in <module>
    from foo import Foo
  File "/home/dingraha/projects/pythoncall_import_error/foo.py", line 4, in <module>
    import juliacall; jl = juliacall.newmodule("FooModule")
  File "/home/dingraha/projects/pythoncall_import_error/venv/lib/python3.9/site-packages/juliacall/__init__.py", line 218, in <module>
    init()
  File "/home/dingraha/projects/pythoncall_import_error/venv/lib/python3.9/site-packages/juliacall/__init__.py", line 214, in init
    raise Exception('PythonCall.jl did not start properly')
Exception: PythonCall.jl did not start properly
```

The likely problem is that the "other" Python library (`matplotlib`, whatever) is loading the system `libstdc++.so`, which isn't compatible with the `libstdc++.so` that Julia ships with.
Linux distributions with older `libstdc++` versions seem more likely to suffer from this issue.
The solution is to either:

  * use a Linux distribution with a more recent `libstdc++`
  * import `juliacall` before the other Python library, so that Julia's `libstdc++` is loaded
  * use a Python from a conda environment, which will have a newer `libstdc++` that is compatible with Julia's

Related issues: [#255](https://github.com/JuliaPy/PythonCall.jl/issues/255)

## Can I use JuliaCall to run Julia inside applications with embedded Python?

Yes, it may be possible. A good example of that is having Julia running inside the Python that is running inside Blender, as presented in [this Discourse post](https://discourse.julialang.org/t/running-julia-inside-blender-through-vscode-using-pythoncall-juliacall/96838/6).
From the point that one has JuliaCall running inside Python, if it has access to the terminal, one can even launch a Julia REPL there, and if needed connect with VSCode Julia extension to it.
The full Python script to install, launch JuliaCall, and launch a Julia REPL in Blender is [here](https://gist.github.com/cdsousa/d820d27174238c0d48e5252355584172).

## Using PythonCall.jl and CondaPkg.jl in a script

If running from a script, make sure that [CondaPkg.jl](https://github.com/JuliaPy/CondaPkg.jl) is used before [PythonCall.jl](https://github.com/JuliaPy/PythonCall.jl) to ensure proper loading of Python packages in your path. E.g.,

```julia
using CondaPkg

CondaPkg.add("numpy")

using PythonCall

np = pyimport("numpy")
```

## What versions of Python and Julia do you support?

Each release of PythonCall and JuliaCall will support and require:
- Any currently supported version of Python, [see here](https://devguide.python.org/versions/). Currently 3.10+.
- The current Julia LTS version and newer, [see here](https://julialang.org/downloads/#long_term_support_release). Currently 1.10+.

Only the latest patch release within each minor version is supported.

# PythonCall & JuliaCall

Bringing [**Python®**](https://www.python.org/) and [**Julia**](https://julialang.org/) together in seamless harmony:
- Call Python code from Julia and Julia code from Python via a symmetric interface.
- Simple syntax, so the Python code looks like Python and the Julia code looks like Julia.
- Intuitive and flexible conversions between Julia and Python: anything can be converted, you are in control.
- Fast non-copying conversion of numeric arrays in either direction: modify Python arrays (e.g. `bytes`, `array.array`, `numpy.ndarray`) from Julia or Julia arrays from Python.
- Helpful wrappers: interpret Python sequences, dictionaries, arrays, dataframes and IO streams as their Julia counterparts, and vice versa.
- Beautiful stack-traces.
- Works anywhere: tested on Windows, MacOS and Linux; 64-bit; Julia 1.10 upwards and Python 3.10 upwards.

# [Conversion to Python](@id jl2py)

## [Conversion Rules](@id jl2py-conversion)

The following table specifies the conversion rules used whenever converting a Julia object to a Python object.

From Julia, this occurs explicitly with `Py(x)` or implicitly when passing Julia objects as the argument to a Python function.
To avoid this automatic conversion, the user can convert objects explicitly, such as by calling `pylist` or `pydict`.

From Python, this occurs when converting the return value of a Julia function.

| From                                                                | To                                                      |
| :------------------------------------------------------------------ | :------------------------------------------------------ |
| Any Python object type (`Py`, `PyList`, etc.)                       | itself                                                  |
| `Nothing`                                                           | `None`                                                  |
| `Bool`                                                              | `bool`                                                  |
| `Integer`                                                           | `int`                                                   |
| `Rational{<:Integer}`                                               | `fractions.Fraction`                                    |
| `Float64`, `Float32`, `Float16`                                     | `float`                                                 |
| `Complex{Float64}`, `Complex{Float32}`, `Complex{Float16}`          | `complex`                                               |
| `AbstractString`, `AbstractChar`                                    | `str`                                                   |
| `Base.CodeUnits{UInt8}` (e.g. `b"example"`)                         | `bytes`                                                 |
| `Tuple`, `Pair`                                                     | `tuple`                                                 |
| `AbstractRange{<:Integer}`                                          | `range`                                                 |
| `Dates.Date`                                                        | `datetime.date`                                         |
| `Dates.Time`                                                        | `datetime.time`                                         |
| `Dates.DateTime`                                                    | `datetime.datetime`                                     |
| `Dates.Second`, `Dates.Millisecond`, `Dates.Microsecond`, `Dates.Nanosecond` | `datetime.timedelta`                           |
| `Number`                                                            | `juliacall.NumberValue`, `juliacall.ComplexValue`, etc. |
| `AbstractArray`                                                     | `juliacall.ArrayValue`, `juliacall.VectorValue`         |
| `AbstractDict`                                                      | `juliacall.DictValue`                                   |
| `AbstractSet`                                                       | `juliacall.SetValue`                                    |
| `IO`                                                                | `juliacall.BufferedIOValue`                             |
| `Module`                                                            | `juliacall.ModuleValue`                                 |
| `Type`                                                              | `juliacall.TypeValue`                                   |
| Anything else                                                       | `juliacall.AnyValue`                                    |

See [here](@ref julia-wrappers) for an explanation of the `juliacall.*Value` wrapper types.

## [Custom rules](@id jl2py-conversion-custom)

You may define a new conversion rule for your new type `T` by overloading `Py(::T)`.

If `T` is a wrapper type (such as `PyList`) where `Py(x)` simply returns the stored Python
object, then also define `ispy(::T) = true`.

```@docs
PythonCall.ispy
```

Alternatively, if you define a wrapper type (a subtype of
[`juliacall.AnyValue`](#juliacall.AnyValue)) then you may instead define `pyjltype(::T)` to
be that type.

```@docs
PythonCall.pyjltype
```

# The Julia module PythonCall

## Installation

This package is in the general registry, so to install just type `]` in the Julia REPL and run:

```julia-repl
pkg> add PythonCall
```

## [Getting started](@id py_getting_started)

Import the module with:

```julia-repl
julia> using PythonCall
```

By default this will initialize a conda environment in your Julia environment, install
Python into it, load the corresponding Python library and initialize an interpreter. See
[here](@ref pythoncall-config) to configure which Python to use.

Now you can interact with Python as follows:

```julia-repl
julia> re = pyimport("re")
Python: <module 're' from '[...]/lib/re.py'>

julia> words = re.findall("[a-zA-Z]+", "PythonCall.jl is very useful!")
Python: ['PythonCall', 'jl', 'is', 'very', 'useful']

julia> sentence = Py(" ").join(words)
Python: 'PythonCall jl is very useful'

julia> pyconvert(String, sentence)
"PythonCall jl is very useful"
```

In this example:
- We used [`pyimport`](@ref) to import the `re` module.
- We called its `findall` function on a pair of strings, which were automatically
  converted to Python strings (see [Conversion to Python](@ref jl2py)).
- We called [`Py`](@ref) to explicitly convert a string to a Python string, so that we
  could call its `join` method. All Python objects are of type `Py`.
- We called [`pyconvert`](@ref) to convert the Python string `sentence` to a Julia string
  (see [Conversion to Julia](@ref py2jl)).

The values `re`, `words` and `sentence` in the example are all Python objects, which have
type [`Py`](@ref) in Julia. As we have seen, these objects support attribute access (e.g.
`re.findall`) and function calls (e.g. `join(words)`). They also support indexing,
comparison and arithmetic:

```julia-repl
julia> x = pylist([3, 4, 5])
Python: [3, 4, 5]

julia> x[2] == 5
Python: True

julia> x[pyslice(0,2)] + pylist([1,2])
Python: [3, 4, 1, 2]
```

We have just seen the functions [`pylist`](@ref) (for constructing a Python list) and
[`pyslice`](@ref) (for constructing a Python slice). There are many such functions,
mirroring most of the Python builtin functions and types. The
[API Reference](@ref py-reference) documents them all.

Most of these functions are essentially Python builtins with a `py` prefix. For example
`pyint(x)` converts `x` to a Python `int` and is equivalent to `int(x)` in Python when `x`
is a Python object.

Notable exceptions are:
- [`pyconvert`](@ref) to convert a Python object to a Julia object.
- [`pyimport`](@ref) to import a Python module.
- [`pyjl`](@ref) to directly wrap a Julia object as a Python object.
- [`pywith`](@ref) to emulate the Python `with` statement.

To access the Python builtins directly, you can access the fields of [`pybuiltins`](@ref):
```julia-repl
julia> pybuiltins.None
Python: None

julia> pybuiltins.True
Python: True

julia> pybuiltins.ValueError("some error")
Python: ValueError('some error')
```

With the functions introduced so far, you have access to the vast majority of Python's
functionality.

## Executing Python scripts

A common use case is calling multiple blocks of Python code from Julia interactively. This can be accomplished in PythonCall via the [@pyexec](@ref) macro. For example, the sentence parsing application in the [Getting started](@ref py_getting_started) section could be rewritten as:

```julia-repl
julia> @pyexec """
           global re
           import re

           def my_sentence(s):
               words = re.findall("[a-zA-Z]+", s)
               sentence = " ".join(words)
               return sentence
           """ => my_sentence
Python: <function my_sentence at 0x7d83bb1b01a0>

julia> sentence = my_sentence("PythonCall.jl is very useful!")
Python: 'PythonCall jl is very useful'
```

Note the use of the `global` keyword to make the `re` package accessible in global scope, and the `=> my_sentence` syntax to create a Julia function named `my_sentence` that calls to the Python function of the same name. This syntax also supports calling to multiple functions and passing data back-and-forth:

```julia-repl
julia> @pyexec (num=10) => """
           def add(a, b):
             return a + b

           def subtract(a, b):
               return a - b

           plusone = num + 1
           """ => (add, subtract, plusone::Float64)
(add = <py function add at 0x721b001a7cc0>, subtract = <py function subtract at 0x721b001a7d70>, plusone = 11.0)

julia> add(4, 3)
Python: 7

julia> subtract(4, 3)
Python: 1

julia> plusone
11.0
```

Here we demonstrate passing a named variable, `num`, via the use of the `=>` syntax again, and returning named output, with the last element, `plusone`, being cast to a Julia object via the `::` syntax. See [@pyexec](@ref), [@pyeval](@ref), and their functional forms [pyexec](@ref) and [pyeval](@ref), for more.

## Conversion between Julia and Python

A Julia object can be converted to a Python one either explicitly (such as `Py(x)`) or
implicitly (such as the arguments when calling a Python function). Either way, it follows
the default conversion rules [here](@ref jl2py).

Most operations involving Python objects will return a `Py` and are not automatically
converted to another Julia type. Instead, you can explicitly convert using
[`pyconvert`](@ref):

```julia-repl
julia> x = pylist([3.4, 5.6])
Python: [3.4, 5.6]

julia> pyconvert(Vector, x)
2-element Vector{Float64}:
 3.4
 5.6

julia> pyconvert(Vector{Float32}, x)
2-element Vector{Float32}:
 3.4
 5.6

julia> pyconvert(Any, x)
2-element PyList{Any}:
 3.4
 5.6
```

In the above example, we converted a Python list to a Julia vector in three ways.
- `pyconvert(Vector, x)` returned a `Vector{Float64}` since all the list items are floats.
- `pyconvert(Vector{Float32}, x)` specified the element type, so the floats were converted
  to `Float32`.
- `pyconvert(Any, x)` returned a `PyList{Py}` which is a no-copy wrapper around the original
  list `x`, viewing it as a `AbstractVector{Py}`. Since it is a wrapper, mutating it
  mutates `x` and vice-versa.

See [here](@ref py2jl) for the rules regarding how `pyconvert(T, x)` works. If `x` is an
immutable scalar type (such as an `int` or `str`) then `pyconvert(Any, x)` may return the
corresponding Julia object (such as an `Integer` or `String`). Otherwise it will typically
return either a [wrapper type](@ref py-wrappers) (such as `PyList{Py}` in the above
example) or will fall back to returning a [`Py`](@ref).

## [Wrapper types](@id py-wrappers)

A wrapper is a type which wraps a Python object but provides it with the semantics of some
other Julia type.

Since it is merely wrapping a Python object, if you mutate the wrapper you also mutate the
wrapped object, and vice versa.

See [here](@ref python-wrappers) for details of all the wrapper types provided by
PythonCall.

We have already seen [`PyList`](@ref). It wraps any Python sequence (such as a list) as
a Julia vector:

```julia-repl
julia> x = pylist([3,4,5])
Python: [3, 4, 5]

julia> y = PyList{Union{Int,Nothing}}(x)
3-element PyList{Union{Nothing, Int64}}:
 3
 4
 5

julia> push!(y, nothing)
4-element PyList{Union{Nothing, Int64}}:
 3
 4
 5
  nothing

julia> append!(y, 1:2)
6-element PyList{Union{Nothing, Int64}}:
 3
 4
 5
  nothing
 1
 2

julia> x
Python: [3, 4, 5, None, 1, 2]
```

There are wrappers for other container types, such as [`PyDict`](@ref) and [`PySet`](@ref).

The wrapper [`PyArray`](@ref) provides a Julia array view of any Python array, i.e. anything
satisfying either the buffer protocol or the numpy array interface. This includes things
like `bytes`, `bytearray`, `array.array` and `numpy.ndarray`:

```julia-repl
julia> x = pyimport("array").array("i", [3, 4, 5])
Python: array('i', [3, 4, 5])

julia> y = PyArray(x)
3-element PyArray{Int32, 1, true, true, Int32}:
 3
 4
 5

julia> sum(y)
12

julia> y[1] = 0
0

julia> x
Python: array('i', [0, 4, 5])
```

It directly wraps the underlying data buffer, so array operations such as indexing are about
as fast as for an ordinary `Array`.

The [`PyIO`](@ref) wrapper type views a Python file object as a Julia IO object:

```julia-repl
julia> x = pyimport("io").StringIO()
Python: <_io.StringIO object at 0x000000006579BC70>

julia> y = PyIO(x)
PyIO(<py _io.StringIO object at 0x000000006579BC70>, false, true, false, 4096, UInt8[], 4096, UInt8[])

julia> println(y, "Hello, world!")

julia> flush(y)

julia> x.seek(0)
Python: 0

julia> x.read()
Python: 'Hello, world!\n'
```

## [Configuration](@id pythoncall-config)

By default, PythonCall uses [CondaPkg.jl](https://github.com/JuliaPy/CondaPkg.jl) to manage
its dependencies. This will install Conda and use it to create a Conda environment specific
to your current Julia project containing Python and any required Python packages.

You can configure PythonCall with the preferences listed below. These can be set either as
[Julia preferences](https://github.com/JuliaPackaging/Preferences.jl) or as environment
variables.

| Preference | Environment Variable | Description |
| ---------- | -------------------- | ----------- |
| `exe` | `JULIA_PYTHONCALL_EXE` | Path to the Python executable, or special values (see below). |
| `lib` | `JULIA_PYTHONCALL_LIB` | Path to the Python library (usually inferred automatically). |
| `pickle` | `JULIA_PYTHONCALL_PICKLE` | Pickle module to use for serialization (`pickle` or `dill`). |

The easiest way to set these preferences is with the
[`PreferenceTools`](https://github.com/cjdoris/PreferenceTools.jl)
package. For example:
```
julia> using PreferenceTools
julia> # now press ] to enter the Pkg REPL
pkg> preference add PythonCall exe=/path/to/python
```

For CondaPkg preferences (such as `backend`, `exe`, `env`), see the
[CondaPkg documentation](https://github.com/JuliaPy/CondaPkg.jl#preferences).

### Special `exe` values

The `exe` preference (or `JULIA_PYTHONCALL_EXE` environment variable) supports the following
special values:
- `@CondaPkg`: Use Python from CondaPkg (the default).
- `@PyCall`: Use the same Python as PyCall. [See here](@ref faq-pycall).
- `@venv`: Use Python from a `.venv` virtual environment in the current active project.

Otherwise, the value is interpreted as:
- An absolute path to a Python executable.
- A relative path (containing `/` or `\`) resolved relative to the current active project.
- A command name to search for in `PATH`.

### If you already have Python and required Python packages installed

```julia
ENV["JULIA_CONDAPKG_BACKEND"] = "Null"
ENV["JULIA_PYTHONCALL_EXE"] = "/path/to/python"  # optional
```

Or using preferences:
```
pkg> preference add CondaPkg backend=Null
pkg> preference add PythonCall exe=/path/to/python  # optional
```

By setting the CondaPkg backend to Null, it will never install any Conda packages. In this
case, PythonCall will use whichever Python is currently installed and in your `PATH`. You
must have already installed any Python packages that you need.

If `python` is not in your `PATH`, you will also need to set `exe` (or `JULIA_PYTHONCALL_EXE`)
to its path. Relative paths are resolved relative to the current active project.

If you also use PyCall, you can set `exe=@PyCall` to use the same Python interpreter.
[See here](@ref faq-pycall).

If you have a Python virtual environment at `.venv` in your current active project, you
can set `exe=@venv` to use it.

### If you already have a Conda environment

```julia
ENV["JULIA_CONDAPKG_BACKEND"] = "Current"
ENV["JULIA_CONDAPKG_EXE"] = "/path/to/conda"  # optional
```

Or using preferences:
```
pkg> preference add CondaPkg backend=Current
pkg> preference add CondaPkg exe=/path/to/conda  # optional
```

The Current backend to CondaPkg will use the currently activated Conda environment instead
of creating a new one.

Note that this will still install any required Conda packages into your Conda environment.
If you already have your dependencies installed and do not want the environment to be
modified, then see the previous section.

If `conda`, `mamba` or `micromamba` is not in your `PATH` you will also need to set
`JULIA_CONDAPKG_EXE` (or the CondaPkg `exe` preference) to its path.

### If you already have Conda, Mamba, MicroMamba or Pixi

```julia
ENV["JULIA_CONDAPKG_BACKEND"] = "System"  # or "SystemPixi" for Pixi
ENV["JULIA_CONDAPKG_EXE"] = "/path/to/conda"  # optional
```

Or using preferences:
```
pkg> preference add CondaPkg backend=System
pkg> preference add CondaPkg exe=/path/to/conda  # optional
```

The System (or SystemPixi) backend to CondaPkg will use your preinstalled Conda (or
Pixi) implementation instead of downloading one.

Note that this will still create a new Conda environment and install any required packages
into it. If you want to use a pre-existing Conda environment, see the previous section.

If `conda`, `mamba`, `micromamba` or `pixi` is not in your `PATH` you will also need to
set `JULIA_CONDAPKG_EXE` (or the CondaPkg `exe` preference) to its path.

## [Installing Python packages](@id python-deps)

Assuming you haven't [opted out](@ref pythoncall-config), PythonCall uses
[CondaPkg.jl](https://github.com/JuliaPy/CondaPkg.jl) to automatically install any required
Python packages.

This is as simple as
```julia-repl
julia> using CondaPkg

julia> # press ] to enter the Pkg REPL

pkg> conda add some_package
```

This creates a `CondaPkg.toml` file in the active project specifying the dependencies, just
like a `Project.toml` specifies Julia dependencies. Commit this file along with the rest of
the project so that dependencies are automatically installed for everyone using it.

To add dependencies to a Julia package, just ensure the package project is activated first.

See the [CondaPkg.jl](https://github.com/JuliaPy/CondaPkg.jl) documentation.

## Writing packages which depend on PythonCall

### Example

See [https://github.com/cjdoris/Faiss.jl](https://github.com/cjdoris/Faiss.jl) for an
example package which wraps the Python FAISS package.

### Precompilation

You must not interact with Python during module precompilation. Therefore, instead of
```julia
module MyModule
  using PythonCall
  const foo = pyimport("foo")
  bar() = foo.bar() # will crash when called
end
```
you can do the import when the module is loaded, saving the result in a `Ref`
```julia
module MyModule
  using PythonCall
  const foo = Ref{Py}()
  function __init__()
    foo[] = pyimport("foo")
  end
  bar() = foo[].bar()
end
```
or you can perform any imports dynamically
```julia
module MyModule
  using PythonCall
  bar() = pyimport("foo").bar()
end
```
or if that is too slow, you can cache the import
```julia
module MyModule
  using PythonCall
  bar() = @pyconst(pyimport("foo")).bar()
end
```
or even cache the imported function
```julia
module MyModule
  using PythonCall
  bar() = @pyconst(pyimport("foo").bar)()
end
```

### Dependencies

If your package depends on some Python packages, you must generate a `CondaPkg.toml` file.
See [Installing Python packages](@ref python-deps).

## [Multi-threading](@id jl-multi-threading)

!!! warning

    Multi-threading support is experimental and can change without notice.

From v0.9.22, PythonCall supports multi-threading in Julia and/or Python, with some
caveats.

Most importantly, you can only call Python code while Python's
[Global Interpreter Lock (GIL)](https://docs.python.org/3/glossary.html#term-global-interpreter-lock)
is locked by the current thread. Ordinarily, the GIL is locked by the main thread in Julia,
so if you want to run Python code on any other thread, you must unlock the GIL from the
main thread and then re-lock it while running any Python code on other threads.

This is made possible by the macros [`PythonCall.GIL.@unlock`](@ref) and
[`PythonCall.GIL.@lock`](@ref) or the functions [`PythonCall.GIL.unlock`](@ref) and
[`PythonCall.GIL.lock`](@ref) with this pattern:

```julia
PythonCall.GIL.@unlock Threads.@threads for i in 1:4
  PythonCall.GIL.@lock pyimport("time").sleep(5)
end
```

In the above example, we call `time.sleep(5)` four times in parallel. If Julia was
started with at least four threads (`julia -t4`) then the above code will take about
5 seconds.

Both `@unlock` and `@lock` are important. If the GIL were not unlocked, then a deadlock
would occur when attempting to lock the already-locked GIL from the threads. If the GIL
were not re-locked, then Python would crash when interacting with it.

With multiple Julia threads you need exactly one interactive thread, see the [FAQ](@ref faq-multi-threading).

You can also use [multi-threading from Python](@ref py-multi-threading).

### Caveat: Garbage collection

If Julia's GC collects any Python objects from a thread where the GIL is not currently
locked, then those Python objects will not immediately be deleted. Instead they will be
queued to be deleted in a later GC pass.

If you find you have many Python objects not being deleted, you can call
[`PythonCall.GC.gc()`](@ref) or `GC.gc()` while the GIL is locked to clear the queue.
